      subroutine sfsqd(natoms,fi,xyz,hkl,sfq)
C  Calculate structure factor from struct.dat file

      include 'arraysize.inc'
c...	passed variables
      integer natoms
      real fi(natoms_max)
c01Dec      real fi(nmax)
      double precision xyz(natoms_max,3)
c01Dec      double precision xyz(nmax,3)
      integer hkl(3)
      real sfq
      
c...	local variables
      integer i
C      complex sf
C      real angle,err
      double precision phase,pi,sfre,sfim

C      sf=cmplx(0.0,0.0)
      sfre=0.0d0
      sfim=0.0d0
      sfq=0.0
      pi=4.0d0*datan(1.0d0)

C      write(*,*) 'natoms ',natoms
      do i=1,natoms
C         write(*,'(a,i2)') 'atom #',i
        phase=0.0d0
        do j=1,3
C          write(*,'(f8.2,i4,f6.3,f8.2)') phase,hkl(j),xyz(i,j),
C     &       phase+dble(hkl(j))*xyz(i,j)
          phase=phase+dble(hkl(j))*xyz(i,j)
        enddo
C        write(*,*) 'added'
C would like to avoid any obvious offsets here so do a
C bit of work on the value of phase
C as a guide consider that the xyz will only be given to
C three decimal places          
C        err=.001*sqrt(float(hkl(1)**2+hkl(2)**2+hkl(3)**2))
C        angle=phase-aint(phase)    ! just look at the actual angle
C        if (abs(angle).lt.err) phase=0.0
C        if (abs(abs(angle)-0.5).lt.err) phase=0.5
C        sf=sf+fi(i)*exp(2.0*pi*cmplx(0,1)*phase)
        sfre=sfre+dble(fi(i))*dcos(2.0d0*pi*phase)
        sfim=sfim+dble(fi(i))*dsin(2.0d0*pi*phase)
C        if ((hkl(1).eq.-20).and.(hkl(2).eq.-20).and.
C     &      (hkl(3).eq.-19)) write(*,*) sf
C         write(*,*) 'next atom'
      enddo

C      sfq=abs(sf)**2.0
C      sfq=sqrt(sfre**2+sfim**2)
      sfq=sngl(sfre*sfre+sfim*sfim)
c0111      sfq=float(sfre*sfre+sfim*sfim)
C      write(*,*) (hkl(i),i=1,3),sfq
C      write(*,*) 'returning'
      return
      end

C Primitive library to plot graphs using PGPLOT
C SMH 24-May-1995
c Tanya Riseman Nov 2001 - March 2002


c========================================================================
      subroutine pg_init(idev, rainbow, just_erase) 
C initialize PG package for dec-windows
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      
c...	passed variables
       integer idev
       logical rainbow, just_erase

c...	functions
       integer pgopen
       
c...	local variables
      logical debug
      parameter (debug = .false.)
cDebug       integer iwhich
cMoved      integer icol1, icol2
c      integer i
c      real graytrans

      if (idev.eq.0) then
        if (.not. just_erase) ipage_lattice =  pgopen('/XSERVE')
      else if (idev.eq.1) then
        if (.not. just_erase) ipage_lattice =  pgopen('/XWIN')
      else if (idev.eq. 2) then		!! Grey scale PS
       ipage_lattice =  pgopen(FILE_PS)
	call pgbbuf()	!! begin batch buffering of output for PS
	if (debug) then
	  write (*,*) 'pg_init: PS output to ', FILE_PS(1:50)	
	endif
      else if (idev.eq.3) then		!! Color PS
        ipage_lattice =  pgopen(FILE_CPS)
	call pgbbuf()	!! begin batch buffering of output for PS
	if (debug) then
	  write (*,*) 'pg_init: PS output to ', FILE_CPS(1:50)
	endif
      else if (idev.eq. 4) then		!! Grey scale PS
        ipage_lattice =  pgopen('/NULL')
      else if (idev.eq.5) then		!! Color PS
        ipage_lattice =  pgopen('/NULL')
      endif

      if (ipage_lattice .eq. 0) then
         write (*,*) 'pg_init: ', 
     &	 'Error opening page/screen for lattice plot'
	 stop
      else	 
cDebug         write (*,*) 'pg_init: opened ipage_lattice=', ipage_lattice
	if (debug) then
          write (*,*) 'pg_init: Opening LATTICE page, ID=', 
     &		ipage_lattice, ' dev=', idev, 'just_erase=', just_erase
        endif
      endif

cDebug	call PGQID (iwhich)
cDebug	write (*,*) 'pg_init: Current window ID =', iwhich

      if (makescanplot) then
       if (idev.eq.0) then
        if (.not. just_erase) ipage_scan =  pgopen('/XSERVE')
       else if (idev.eq.1) then
        if (.not. just_erase) ipage_scan =  pgopen('/XWIN')
       else if (idev.eq. 2) then		!! Grey scale PS
         ipage_scan =  pgopen('/NULL')
       else if (idev.eq.3) then		!! Color PS
        ipage_scan =  pgopen('/NULL')
       else if (idev.eq. 4) then		!! Grey scale PS
        ipage_scan =  pgopen(FILE_scan_PS)
	call pgbbuf()	!! begin batch buffering of output for PS
	if (debug) then
	  write (*,*) 'pg_init: PS output to ', FILE_scan_PS(1:50)
	endif
       else if (idev.eq. 5) then		!! Color PS
         ipage_scan =  pgopen(FILE_scan_CPS)
	call pgbbuf()	!! begin batch buffering of output for PS
	if (debug) then
	  write (*,*) 'pg_init: PS output to ', FILE_scan_CPS(1:50)
	endif
       endif

       if (ipage_scan .eq. 0) then
         write (*,*) 'pg_init: ', 
     &	 'Error opening page/screen for scan plot'
	 stop
       else	 
cDebug         write (*,*) 'pg_init: opened ipage_scan=', ipage_scan
	if (debug) then
          write (*,*) 'pg_init: Opening SCAN page, ID=', 
     &		ipage_scan, ' dev=', idev, 'just_erase=', just_erase
        endif
       endif
      
cDebug	call PGQID (iwhich)
cDebug	write (*,*) 'pg_init: Current window ID =', iwhich

      endif
      
c pgask: If the prompt state is
c ON, PGPAGE will type ``Type RETURN for next page:'' and will wait
c for the user to type a carriage-return before starting a new page.
      call pgask(.FALSE.)

      call pgscf(1)	!! set character font to normal
      call pgslw(2)	!! set line width in units of 0.005 inch (0.13 mm)
      
c      call pgqcol(icol1, icol2)
c      write (*,*) 'pg_init: Color representation has range ',
c     &	       icol1, icol2

c...	Have to select palette after slecting the page???
      call PGSLCT(ipage_lattice)
      call select_palette(rainbow, idev)
cDebug      call check_palette('after PGSLCT(ipage_lattice)')

      return
      end

c======================================================
      subroutine select_palette(rainbow, idev)
      implicit none
      include 'spur_color.inc'

c...	passed variables
      logical rainbow
      integer idev
      
c...	local variables
      real	graytrans, colortrans
      integer 	icolor, icol1
      real 	lightness      
cDebug      real cr, cb, cg
      real	firstangle, rangeangle

c      parameter (firstangle = 120.0)		!! Red
c      parameter (rangeangle = 120.0)		!! Up to green (240 degrees)

      parameter (firstangle = 240.0)		!! Green
      parameter (rangeangle = 120.0)		!! Up to blue (360 degrees)

c      parameter (firstangle = 0.0)		!! Blue
c      parameter (rangeangle = 120.0)		!! Up to red (120 degrees)

c      parameter (firstangle = 0.0)		!! Blue
c      parameter (rangeangle = 360.0)		!! All colors

c...	Rather than hardwire the maximum color index available (99 or 255)
c...	based on the device chosen, ask PGPLOT what it thinks it is.
      call pgqcol(icol1, icol2)
cDebug      write (*,*) 'select_pallete: Color representation has range ',
cDebug     &	       icol1, icol2
cDebug      write (*,*) 'select_pallete: device = ', idev
cDebug      write (*,*) 'select_pallete: rainbow = ', rainbow
      
      if ((.not. rainbow) .or. (idev .eq. 2))  then
c...	Grey scale or B&W PS
C  	set the grayscale for color indices from 16 to 99
C  	where 16 is white and 99 is black, appropriate
C  	for a white BG (as on paper) and opposite to convention 
C  	for the XWIN viewport (a black background)
	do icolor = 16, icol2
          graytrans=1.0-float(icolor-16)/(float(icol2)-16.0)
cccc	  call PGSCR (CIndex, CRed, CGreen, CBlue)
	call pgscr(icolor,graytrans,graytrans,graytrans)
cDebug        write (*,*) 'select_palette: gray ', icolor, graytrans

cDebug	  call pgqcr(icolor, cr, cg, cb)			!! debug
cDebug	  write (*,*) 'select_palette: ', icolor,' RGB=',cr,cg,cb	!! debug

	enddo
cDebug        write (*,*) 'select_palette: gray.  Max # of shades=', icol2-16

      else	!! /xwin or color PS
          lightness = 0.5
          do icolor = 16, icol2
	  colortrans = firstangle + 
     &	    rangeangle*(1.0-float(icolor-16)/(float(icol2)-16.0) )	
ccc        call  PGSHLS (CIndex, CHue, CLightness, CSaturation)
cYuck          lightness=0.25 + 
cYuck     &	    0.5*(1.0-float(icolor-16)/(float(icol2)-16.0) )	
ccc     &	  0.25*(1.0-float(abs(icolor-(icol2-16)/2))/(float(icol2)-16.0))
	  call pgshls(icolor, colortrans, lightness, 1.0)
cDebug          write (*,*) 'select_palette: color ',
cDebug      &		   icolor, colortrans, lightness

cDebug	  call pgqcr(icolor, cr, cg, cb)
cDebug	  write (*,*) 'select_palette: ', icolor, ' RGB=', cr, cg, cb	

cDebug	  call pgqcr(icolor, cr, cg, cb)			!! debug
cdebug	  write (*,*) 'select_palette: ', icolor,' RGB=',cr,cg,cb	!! debug

	  enddo
cDebug          write (*,*) 'select_palette:color. Max # of shades=', icol2-16
      endif

      return
      end

c======================================================
      subroutine check_palette(astring)		!! for debugging
      implicit none
      include 'spur_color.inc'

c...	passed variables
c      logical rainbow
c      integer idev
      
c...	local variables
      integer 	icolor
      real cr, cb, cg
      character*(*) astring
      integer icol1
      
      call pgqcol(icol1, icol2)

        write (*,*) 'check_palette: ', astring
	do icolor = 16, icol2
	  call pgqcr(icolor, cr, cg, cb)
	  write (*,*) 'check_palette: ', icolor,' RGB=',cr,cg,cb
	enddo
        write (*,*) 'check_palette: Max # of shades=', icol2-16

      return
      end


c======================================================
      integer function select_color(value)
      implicit none
      include 'spur_color.inc'
 
c...	passed variables
      real value
      
c...	local variables
c      real	graytrans, colortrans
      integer 	icolor
cDebug      real cr, cb, cg
      
c	The color palette has already been loaded up in select_palatte.
c	Here translate a value (0 - 1) into a color index number (16 - icol2),
c	for looking up the color in the palette.
c	Palette may be in color or grey scale.
c	
	icolor = 16+int(float(icol2-16)*value)	
        call pgsci(icolor)
        select_color = icolor
	
	if (icolor .eq. 1) then
	  write (*,*) 'select_color: value = ', value, 'Index ', icolor
	  write (*,*) 'select_color: This index for desired shade', 
     &	  ' is not defined. Using ink color instead.'
	endif

cDebug	call pgqcr(icolor, cr, cg, cb)
cDebug	write (*,*) 'select_color: ', icolor, ' RGB=', cr, cg, cb	

      return
      end

cc======================================================
c      subroutine select_color(value)
c      implicit none
c      include 'spur_color.inc'
c 
cc...	passed variables
c      real value
c      
cc...	local variables
cc      real	graytrans, colortrans
c      integer 	icolor
ccDebug      real cr, cb, cg
c      
cc	The color palette has already been loaded up in select_palatte.
cc	Here translate a value (0 - 1) into a color index number (16 - icol2),
cc	for looking up the color in the palette.
cc	Palette may be in color or grey scale.
cc	
c	icolor = 16+int(float(icol2-16)*value)	
c        call pgsci(icolor)
c
ccDebug	call pgqcr(icolor, cr, cg, cb)
ccDebug	write (*,*) 'select_color: ', icolor, ' RGB=', cr, cg, cb	
c      return
c      end

c======================================================
      character*10 function name_color(code)
      implicit none
      include 'spur_color.inc'
 
c...	passed variables
      integer code
      if (code .eq. color_bkgr) then
	name_color = 'background'
      else if (code .eq. color_ink) then
	name_color = 'ink'
      else if (code .eq. color_red) then
	name_color = 'red'
      else if (code .eq. color_green) then
	name_color = 'green'
      else if (code .eq. color_blue) then
	name_color = 'blue'
      else if (code .eq. color_cyan) then
	name_color = 'cyan'
      else if (code .eq. color_magenta) then
	name_color = 'magetna'
      else if (code .eq. color_yellow) then
	name_color = 'yellow'
      else if (code .eq. color_orange) then
	name_color = 'orange'
      else if (code .eq. color_yellowgreen) then
	name_color = 'yellwgreen'
      else if (code .eq. color_greencyan) then
	name_color = 'greencyan'
      else if (code .eq. color_bluecyan) then
	name_color = 'bluecyan'
      else if (code .eq. color_bluemagenta) then
	name_color = 'bluemagnet'
      else if (code .eq. color_redmagenta) then
	name_color = 'redmagneta'
      else if (code .eq. color_darkgrey) then
	name_color = 'darkgrey'
      else if (code .eq. color_lightgrey) then
	name_color = 'lightgrey'
      endif
      return
      end


c======================================================
      subroutine place_circle(x, y, pointsize, circsize,  
     &      fillstyle, overridesize)
      implicit none
      include 'spur_color.inc'

c...	passed variables
      real x, y
      real pointsize, circsize
c      integer color
      integer fillstyle
      logical overridesize
      
c...	local variables
      real	temp
      
      if (overridesize .or. (circsize .gt. 0.0)) then
	    temp =  2.0* abs(circsize)
      else
	    temp =  2.0*circsize*pointsize
      endif

      call pgsfs(fillstyle)	!! solid=1, outline=2
c02Jan      call pgsci(color)
      call pgcirc(x, y, temp)
cDebug      write (*,*) 'place_circle: radius=', temp, 'color=', color, 
cDebug     &      overridesize

c     Add a black outline to grey/colored solid circle      
      if (fillstyle .eq. 1) then		!! solid
        call pgsfs(2)				!! outline
        call pgsci(color_ink)
        call pgcirc(x, y, temp)
      endif

      return
      end

c======================================================
      subroutine place_cross(x, y, pointsize, circsize,  
     &      overridesize)
      implicit none
      include 'spur_color.inc'

c...	passed variables
      real x, y
      real pointsize, circsize
c02Jan      integer color
      logical overridesize
      
c...	local variables
      real	temp
      real	x_vert(2), y_vert(2), x_horz(2), y_horz(2)
      
      if (overridesize .or. (circsize .gt. 0.0)) then
	    temp =  2.0* abs(circsize)
      else
	    temp =  2.0*circsize*pointsize
      endif
      
      x_vert(1) = x
      x_vert(2) = x
      y_vert(1) = y - temp
      y_vert(2) = y + temp
      x_horz(1) = x - temp
      x_horz(2) = x + temp
      y_horz(1) = y 
      y_horz(2) = y

c      write (*,*) 'place_cross: ', x, y 
c      write (*,*) ' vert:', x_vert(1), x_vert(2), y_vert(1), y_vert(2)
c      write (*,*) ' horz:', x_horz(1), x_horz(2), y_horz(1), y_horz(2)

c02Jan      call pgsci(color)
      call PGLINE (2, x_vert, y_vert)
      call PGLINE (2, x_horz, y_horz)

      return
      end

c========================================================================
c      subroutine pg_graph(x,y,sig,yc,npt)
c      implicit none
c      include 'spur_color.inc'
c
c      integer ipt,npt,maxpts
c
c      parameter (maxpts=1000)
c
c      real*8 x(npt),y(npt),sig(npt),yc(npt)
c      real*4 x_(maxpts),y_(maxpts),y_err1(maxpts),y_err2(maxpts)
c      real*4 yc_(maxpts),ymax,ymin,xlim_min,xlim_max,ylim_min,ylim_max
c
c      ymin=y(1)
c      ymax=y(1)
c
c      do ipt=1,npt      ! copy data in real*4 arrays for PGPLOT
c        x_(ipt)=x(ipt)
c        y_(ipt)=y(ipt)
c        y_err1(ipt)=y(ipt)-sig(ipt)
c        y_err2(ipt)=y(ipt)+sig(ipt)
c        yc_(ipt)=yc(ipt)
c
c        ymin=min(ymin,y_err1(ipt))
c        ymax=max(ymax,y_err2(ipt))
c      enddo
c
c      call pgrnge(x_(1),x_(npt),xlim_min,xlim_max)
c      call pgrnge(ymin,ymax,ylim_min,ylim_max)
c
c      call pgvport(0.1,0.9,0.1,0.9)
c      call pgswin(xlim_min,xlim_max,ylim_min,ylim_max)
c
c      call pgupdt
c      call pgsci(color_ink)
cc01Dec      call pgsci(1)
c      call pgbox('bcints',0.0,0,'bcints',0.0,0)
c      call pglabel('Scanning Variable (rlu or meV)','Counts',' ')
c      call pgpoint(npt,x_,y_,4)
c      call pgerry(npt,x_,y_err1,y_err2,1.0)
c      call pgline(npt,x_,yc_)
c      call pgebuf
c
c      return
c      end     

c========================================================================
      subroutine pg_close(idev, just_erase)
      implicit none
      include 'arraysize.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'

c..	passed variables
      integer idev
      logical just_erase
            
c...	local variables
      logical debug
      parameter (debug = .false.)
cDebug      integer iwhich
            
      if (ipage_lattice .ne. 0) then
        if (debug) then
	  write (*,*) 'pg_close: Closing LATTICE page, ID=', 
     &		ipage_lattice, ' dev=', idev
        endif
ccDebug	call PGQID (iwhich)
ccDebug	write (*,*) 'pg_close: Current window ID =', iwhich
        call PGSLCT(ipage_lattice)
ccDebug	call PGQID (iwhich)
ccDebug	write (*,*) 'pg_close: Current window ID =', iwhich
        if (idev.eq. 2) then		!! Grey scale PS
          call pgebuf			!! End buffering
        else if (idev.eq.3) then		!! Color PS
          call pgebuf			!! End buffering
	else
          call pgupdt		!! flush the graphics buffer
	endif
cCloses all        call pgend
	if ((just_erase) .and. 
     &  	((idev .eq. 0) .or. (idev .eq. 1))) then
          call pgeras			!! Only for xwindow and xserve
          if (debug) then
	    write (*,*) 'pg_close: erased ipage_lattice=', ipage_lattice
	  endif
       	else
          call pgclos
          if (debug) then
	    write (*,*) 'pg_close: closed ipage_lattice=', ipage_lattice
	  endif
	endif
ccDebug	call PGQID (iwhich)
ccDebug	write (*,*) 'pg_close: Current window ID =', iwhich
ccDebug        write (*,*) 'pg_close: closed ipage_lattice=', ipage_lattice
      else
        write (*,*) 'pg_close: non-existent ipage_lattice=', 
     &	ipage_lattice
      endif

      if (makescanplot) then
       if (ipage_scan .ne. 0) then
        if (debug) then
          write (*,*) 'pg_close: Closing SCAN page, ID=', ipage_scan, 
     &		' dev=', idev
        endif
ccDebug	call PGQID (iwhich)
ccDebug	write (*,*) 'pg_close: Current window ID =', iwhich
        call PGSLCT(ipage_scan)
ccDebug	call PGQID (iwhich)
ccDebug	write (*,*) 'pg_close: Current window ID =', iwhich
        if (idev.eq. 4) then		!! Grey scale PS
	  call pgebuf()	!! end batch buffering of output for PS
        else if (idev.eq. 5) then		!! Color PS
	  call pgebuf()	!! end batch buffering of output for PS
	else
          call pgupdt		!! flush the graphics buffer	
        endif
	if ((just_erase) .and. 
     &  	((idev .eq. 0) .or. (idev .eq. 1))) then
          call pgeras
          if (debug) then
            write (*,*) 'pg_close: erased ipage_scan=', ipage_scan
	  endif
	else
          call pgclos
          if (debug) then
            write (*,*) 'pg_close: closed ipage_scan=', ipage_scan
	  endif
	endif
cClosesallwindows        call pgend
ccDebug	call PGQID (iwhich)
ccDebug	write (*,*) 'pg_close: Current window ID =', iwhich
ccDebug        write (*,*) 'pg_close: closed ipage_scan=', ipage_scan
       else
        write (*,*) 'pg_close: non-existent ipage_scan=', ipage_scan
       endif
      endif
      
      return
      end



C************************************************************************
      subroutine init_pg2d(iaxis)
c...	Alternative to pgenv()
c...	Sets the aspect ratio of the paper to approx'ly A4 (8 1/2 X 11 ")
c...	in a landscape shape. Shifts the plot region over to the left,
c...	leaving room on the right for annotations later.
  
      implicit none
      include 'spur_layout.inc'
      include 'spur_color.inc'

c...	passed variables
ccc      integer  lwidth
cCommon      real	xmin,xmax,ymin,ymax
      integer  iaxis
c      logical do_grid

c...	local variables
      real	x1, x2, y1, y2

c         Change the aspect ratio of view graph to that approximating
c         A4 paper in portrait mode (aspect_ratio > 1) or landscape (<1).
c         First parameter is the width in inches. 0 means use widest possible.
cDebug      write (*,*) 'init_pg2d: aspect_ratio=',  aspect_ratio

      call PGSLCT(ipage_lattice)
      call pgpap(0, aspect_ratio)

c	set line width for the screen
c	call pgslw(lwidth)

      call pgscf(1)	!! set character font to normal
      call pgslw(2)	!! set line width in units of 0.005 inch (0.13 mm)

c	****define the window for pgplot
c		!! Shift figure over to the left. note: 0.8*(0.9-0.1) = 0.64
cLandscape        call pgsvp(0.07, 0.65, 0.177, 0.92)		!! landscape
cccc	aspect_ratio = ps_height/ ps_width
	if (aspect_ratio .gt. 1.0) then
	   portrait = .true.
cDebug           write (*,*) 'init_pg2d: Portrait'
	else
	   portrait = .false.
cDebug	   write (*,*) 'init_pg2d: landscape' 
	endif
	
cDebug      call pgsci(color_blue)
cDebug      call pgsvp(0.0, 1.0, 0.0, 1.0)
cDebug      call pgbox('bc',0.0,0,'bc',0.0,0)
cDebug      call pgsci(color_ink)

	width_plot = 0.65
	margin_plot = 0.075
	if (portrait) then
	  xmin_plot = margin_plot
	  xmax_plot = xmin_plot + width_plot
	  ymax_plot = (1.0 - margin_plot)
	  ymin_plot = ymax_plot - width_plot/aspect_ratio
	else
	  xmin_plot = margin_plot
	  xmax_plot = xmin_plot + width_plot*aspect_ratio
	  ymax_plot = (1.0 - margin_plot)
	  ymin_plot = ymax_plot - width_plot
	endif

cDebug        write (*,*) 'init_pg2d: Using portrait = ', portrait
cDebug        write (*,*) 'init_pg2d: pre-pgsvp',
cDebug     &	  xmin_plot, xmax_plot, ymin_plot, ymax_plot
        call pgsvp( xmin_plot, xmax_plot, ymin_plot, ymax_plot)

c	!! set window and adjust viewport to same aspect ratio
	call pgwnad(xmin,xmax,ymin,ymax)

	call  PGQVP (0, X1, X2, Y1, Y2)

c move this window up so title is always in approxly the same place.
c...	Turns out to be a bad idea. if very rectangular area,
c	Not enough room for the labels
	xmin_new = x1
	xmax_new = x2
	ymin_new = y1 
	ymax_new = y2
	goto 444
ccc	call pgsvp(x1, x2, (0.92 - (y2-y1)) ,0.92)

cDebug        write (*,*) 'init_pg2d: pre-pgsvp',
cDebug     &	 x1, x2, ((1.0-margin_plot) - (y2-y1)), (1.0-margin_plot)
	call pgsvp(x1, x2, ((1.0-margin_plot) - (y2-y1)), (1.0-margin_plot))
c        write (*,*) 'init_pg2d: viewport for plot',
c     &	  	xmin_plot, xmax_plot, ymin_plot, ymax_plot
	xmin_new = x1
	xmax_new = x2
	ymin_new = ((1.0-margin_plot) - (y2-y1)) 
	ymax_new = (1.0-margin_plot)
 444    continue

	call pgswin(xmin,xmax,ymin,ymax)
 
        xmin_label = xmax_plot + (0.75*margin_plot)
c02Mar        xmin_label = xmax_new + (0.25*margin_plot)
        xmax_label = 1.0 - margin_plot
        ymin_label = margin_plot
        ymax_label = ymax_plot
c02Mar        ymax_label = ymax_new

        xmin_annote = margin_plot
        xmax_annote = xmax_plot + (0.75*margin_plot)
c02Mar        xmax_annote = xmax_new
	ymin_annote = margin_plot
	ymax_annote = ymin_plot*(0.85)

c        xmin_label = xmax_new + (0.25*margin_plot)
c        xmax_label = 1 - margin_plot
c        ymin_label = ymin_plot*(0.85)
c        ymax_label = ymax_new
c
c        xmin_annote = margin_plot
c        xmax_annote = xmax_label
c	ymin_annote = margin_plot
c	ymax_annote = ymin_plot*(0.85)
c
cDebug        write (*,*) 'init_pg2d: viewport for plot',
cDebug     &	  	xmin_plot, xmax_plot, ymin_plot, ymax_plot
cDebug        write (*,*) 'init_pg2d: re-arranged viewport for plot',
cDebug     &	  	xmin_new, xmax_new, ymin_new, ymax_new
cDebug        write (*,*) 'init_pg2d: viewport for annotations',
cDebug     &		xmin_annote, xmax_annote, ymin_annote, ymax_annote
cDebug        write (*,*) 'init_pg2d: viewport for labels',
cDebug     &		xmin_label, xmax_label, ymin_label, ymax_label


c	call  PGQVP (0, X1, X2, Y1, Y2)
c	write (*,*) 'init_pgcontour: view ', X1, X2, Y1, Y2


c     IAXIS = -2 : draw no box, axes or labels;
c     IAXIS = -1 : draw box only;
c     IAXIS =  0 : draw box and label it with coordinates;
c     IAXIS =  1 : same as AXIS=0, but also draw the
c                  coordinate axes (X=0, Y=0);
c     IAXIS =  2 : same as AXIS=1, but also draw grid lines
c                  at major increments of the coordinates;
c     IAXIS = 10 : draw box and label X-axis logarithmically;
c     IAXIS = 20 : draw box and label Y-axis logarithmically;
c     IAXIS = 30 : draw box and label both axes logarithmically.
	if      (iaxis .eq. -2) then	
	  call pgbox('abcnts',0.0,0,'abcnts',0.0,0)
	else if (iaxis .eq. -1) then	
	  call pgbox('bc',0.0,0,'bc',0.0,0)
	else if (iaxis .eq. 0) then	
	  call pgbox('bcnts',0.0,0,'bcnts',0.0,0)
	else if (iaxis .eq. 1) then	
	  call pgbox('abcnts',0.0,0,'abcnts',0.0,0)
	else if (iaxis .eq. 2) then	
	  call pgbox('abcgnts',0.0,0,'abcgnts',0.0,0)
	else if (iaxis .eq. 10) then			!! x log scale
	  call pgbox('abcnts',0.0,0,'abcnts',0.0,0)
	else if (iaxis .eq. 10) then			!! x log scale
	  call pgbox('abclnts',0.0,0,'abcnts',0.0,0)
	else if (iaxis .eq. 20) then			!! y log scale
	  call pgbox('abcnts',0.0,0,'abclnts',0.0,0)
	else if (iaxis .eq. 30) then			!! x and y log scale
	  call pgbox('abclnts',0.0,0,'abclnts',0.0,0)
	endif 

      return
      end


C************************************************************************
      subroutine plot_txtinfo(thistext, this_many)
cMoved     &      , version_stamp, do_stamp)

      implicit none
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'io_files.inc'
      
c... common blocks
      real		yhere, yoff, xhere, y_sofar
      common/cb_xyprint/ yhere, yoff, xhere, y_sofar

c...	passed variables
      character*80 thistext(*)
      integer	this_many
cMoved      character*(80) version_stamp
cMoved      logical do_stamp
      
      integer		i
cMoved	integer       nuser
c      integer		nnow
      real		xch, ych, ytop
c      character*80 	text
c      character*20	nowstring
cMoved      character*20	userstring
      character*80	aline

      call pgsci(color_ink)	!! Make sure we use black ink 

cChanges      call PGQCS(0, XCH, YCH)
cChanges       yoff = 1.5* YCH

      call pgsvp( xmin_annote, xmax_annote, ymin_annote, ymax_annote)
cDebug      call pgbox('bc',0.0,0,'bc',0.0,0)
      ytop = ((ymax_annote-ymin_annote)/(xmax_annote- xmin_annote))
      ytop = ytop *aspect_ratio
      call pgswin( 0.0, 1.0, 0.0, ytop)	!! make commensurate

      call PGSCH (0.55)		!! Shrink the lettering.
      yhere = ytop
c      yhere = 1.0
      xhere = 0.0
      y_sofar = yhere 
      call PGQCS(0, XCH, YCH)		!! normalized device units
      call PGQCS(4, XCH, YCH)		!! world units
      yoff = 1.5*ych
c      yoff=yoff*(1./(ymax_annote-ymin_annote))*(xmax_annote/ymax_annote)
cWorld      yoff=yoff*(1./(ymax_annote-ymin_annote))*(xmax_annote/ymax_annote)
ccc      yoff = 3.0* YCH
ccc      yoff = 1.75* YCH
c      yoff = 1.5* YCH
      ystamp = 0.05


cDebug      write (*,*) 'plot_txtinfo: ystamp ',  ystamp
      yhere = yhere - yoff
      aline =  FILE_BUFIN(1:35)//'  '//FILE_LPI(1:35)     
      call pgtext(xhere, yhere, aline)

      do i=1, this_many
cDebug        write (*,*) 'plot_txtinfo: ', i, xhere, yhere
        yhere = yhere - yoff
         if (yhere .gt. ystamp) then
c	  if (portrait) then
	    call pgtext(xhere, yhere, thistext(i))
c	    call ('LV', -0.25, yhere, 0.0, thistext(i))
c	  else
c	    call pgmtext('RV', 2.0, yhere, 0.0, thistext(i))
c	  endif
	 endif
      enddo


      call  PGSCH (1.0)		!! Restore the lettering. and plot region
      call PGQCS(0, XCH, YCH)
        call pgsvp( xmin_plot, xmax_plot, ymin_plot, ymax_plot)
	call pgwnad(xmin,xmax,ymin,ymax)
      call pgsvp( xmin_new, xmax_new, ymin_new, ymax_new)

      return
      end

C************************************************************************
      subroutine plot_stamp(version_stamp)

      implicit none
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_warn.inc'
      
c... common blocks
      real		yhere, yoff, xhere, y_sofar
      common/cb_xyprint/ yhere, yoff, xhere, y_sofar

c...	passed variables
      character*(80) version_stamp
      
      integer		nuser
c      integer		nnow
      real		xch, ych, ytop
c      character*80 	text
c      character*20	nowstring
      character*20	userstring

      call pgsvp( xmin_annote, xmax_annote, ymin_annote, ymax_annote)
      ytop = ((ymax_annote-ymin_annote)/(xmax_annote- xmin_annote))
      ytop = ytop *aspect_ratio
      call pgswin( 0.0, 1.0, 0.0, ytop)	!! make commensurate
c02Mar14      call pgsci(color_blue)
c02Mar14       call pgbox('bc',0.0,0,'bc',0.0,0)

      call pgsci(color_ink)	!! Make sure we use black ink 
      call PGSCH (0.55)		!! Shrink the lettering.
c      call PGSCH (0.5)		!! Shrink the lettering.
      call PGQCS(0, XCH, YCH)
ccc      yoff = 1.5* YCH
      yoff = 1.5*ych
c      yoff=yoff*(1./(ymax_annote-ymin_annote))*(xmax_annote/ymax_annote)
ccc      yoff = 1.5* YCH

      ystamp = 0.05

cChanges      write (*,*) 'plot_txtinfo: portrait=', portrait 
cChanges
cChanges      if (portrait) then
cChangesc        ystamp =  -1.0*(1.0 - 1.0/aspect_ratio) + margin_plot
cChanges        ystamp =  -2.0*(1.0 - 1.0/aspect_ratio)
cChanges      else
cChangesc        ystamp =  1.0*margin_plot
cChanges        ystamp =  -2.0*margin_plot
cChanges      endif

cChanges      write (*,*) 'plot_txtinfo: ystamp ',  ystamp
      

c      call pgqinf('NOW', nowstring, nnow)
        call pgqinf('USER', userstring, nuser)

        yhere = ystamp

        call pgmtext('RV', -0.1, yhere, 1.0, userstring(1:nuser))

        call pgmtext('LV', -0.1, yhere, 0.0,  version_stamp)

      call  PGSCH (1.0)		!! Restore the lettering.

      if (warn_options .ne. 0) then	!! Print warning in big red letters
        yhere = ystamp + 4.0*yoff
        call pgsci(color_red)	
	call pgmtext('LV', -0.1, yhere, 0.0, warnstring)
        call pgsci(color_ink)	
        yhere = ystamp
      endif


      call PGQCS(0, XCH, YCH)
        call pgsvp( xmin_plot, xmax_plot, ymin_plot, ymax_plot)
	call pgwnad(xmin,xmax,ymin,ymax)
      call pgsvp( xmin_new, xmax_new, ymin_new, ymax_new)

      return
      end

C************************************************************************
      subroutine plot_labelinfo(arrin, nunique, uniqueLabel, 
     &      indxunique1, indxunique2, multiplicity,
     &	    pointsize, circsize, overridesize, rainbow)

      implicit none
      include 'arraysize.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'

c..	functions
      integer select_color      
      
c... common blocks
c      real		yhere, yoff, xhere, y_sofar
c      common/cb_xyprint/ yhere, yoff, xhere, y_sofar
      integer ntiny, nabsent, npresent, nobserved
      common /nabsences/ ntiny, nabsent, npresent, nobserved

c...	passed variables
      real arrin(m_rlv_max,m_rlv_max)
      integer nunique
      character*1 uniqueLabel(m_rlv_max,m_rlv_max)
      integer indxunique1(unique_rlv_max)
      integer indxunique2(unique_rlv_max)
      integer multiplicity(unique_rlv_max)
c      integer indxunique1(0:unique_rlv_max)
c      integer indxunique2(0:unique_rlv_max)
c      integer multiplicity(0:unique_rlv_max)
      logical overridesize, rainbow
      real circsize
      real pointsize(m_rlv_max,m_rlv_max)

c...	local variables
      integer	i, this_color
      real	xch, ych, yyhere, xxhere, yyoff, yy_sofar, yystamp
      character*40 astring
      real	yytop, arrin_max

      integer fill_solid	!!, fill_hollow
      parameter (fill_solid = 1)
c      parameter (fill_hollow = 2)

      call pgsvp( xmin_label, xmax_label, ymin_label, ymax_label)
      yytop = ((ymax_label-ymin_label)/(xmax_label- xmin_label))
      yytop = yytop *aspect_ratio
      call pgswin( 0.0, 1.0, 0.0, yytop)	!! make commensurate
c      call pgswin( 0.0, 1.0, 0.0, 1.0) 	!! make the world units be normalized   
c02Mar14      call pgsci(color_blue)
c02Mar14      call pgbox('bc',0.0,0,'bc',0.0,0)
      call pgsci(color_ink)

c      call pgsci(color_ink)	!! Make sure we use black ink 
c      call PGSCH (1.0)		!! Shrink the lettering.
      call PGSCH (0.5)		!! Shrink the lettering.

        yyhere = yytop
c        yyhere = 1.0
        yy_sofar = yyhere
        call PGQCS(4, XCH, YCH)
      yyoff = 1.5*ych
cv        call PGQCS(0, XCH, YCH)
cv      yyoff = 3.0*ych
cv      yyoff=yyoff*(1.0/(ymax_label- ymin_label))*(xmax_label/ymax_label)
c        yyoff = 1.5* YCH
ccc        yyoff = 3.0* YCH
c        yyoff = 1.75* YCH
        yystamp = yyoff
        xxhere = yyoff/2.0

c...	Write highest value and then list the normalized values after a blank line
      yyhere = yyhere - yyoff
      do i=1, nunique
        if (uniqueLabel(indxunique1(i), indxunique2(i)) .ne. '#') then
         yyhere = yyhere - yyoff
         if (yyhere .ge. yystamp) then
           this_color = select_color(
     &		 pointsize(indxunique1(i), indxunique2(i)) )
c           call select_color(
c     &		 pointsize(indxunique1(i), indxunique2(i)) )
           call place_circle(xxhere, yyhere, 
     &		 pointsize(indxunique1(i), indxunique2(i)), 0.5*ych,  
     &      		 fill_solid, overridesize)
c           call place_circle(xxhere, yyhere, 
c     &		 pointsize(indxunique1(i), indxunique2(i)), ych/2.0,  
c     &      		 fill_solid, overridesize)
cDebug	    write (*,*) 'plot_labelinfo: placing circle',
cDebug     &	    pointsize(indxunique1(i), indxunique2(i)) 
	 else
	    write (*,*) 'plot_labelinfo: skipping circle', 
     &	    pointsize(indxunique1(i), indxunique2(i)) 
     	 endif

	endif
      enddo


      yyhere = yytop
      xxhere = yyoff*2.0
cViewport      yyhere = 1.0		!! pgmtext is in viewport normalized units
      call pgsci(color_ink)	!! Make sure we use black ink 
      i = 1
      arrin_max = arrin(indxunique1(i), indxunique2(i))
      write (astring, 110) 
     &		uniqueLabel(indxunique1(i), indxunique2(i)),
     &		arrin(indxunique1(i), indxunique2(i)),
     &		multiplicity(i)
         if (yyhere .ge. yystamp) then
	    call pgtext(xxhere, yyhere, astring)
cViewport	    call pgmtext('LV', -1.0, yyhere, 0.0, astring)
c	    call pgmtext('RV', 1.0, yyhere, 0.0, astring)
cDebug	    write (*,*) 'plot_labelinfo: placing ', astring
	 else
	    write (*,*) 'plot_labelinfo: skipping ', astring
	 endif

      yyhere = yyhere - yyoff
      do i=1, nunique
        if (uniqueLabel(indxunique1(i), indxunique2(i)) .ne. '#') then
         yyhere = yyhere - yyoff
	 write (astring, 110) 
     &		uniqueLabel(indxunique1(i), indxunique2(i)),
     &		(arrin(indxunique1(i), indxunique2(i)) /arrin_max),
     &		multiplicity(i)
c02Mar	 write (astring, 110) 
c02Mar     &		uniqueLabel(indxunique1(i), indxunique2(i)),
c02Mar     &		pointsize(indxunique1(i), indxunique2(i)),
c02Marccc     &		arrin(indxunique1(i), indxunique2(i)),
c02Mar     &		multiplicity(i)
110      format(a1, 1x, g10.3, 1x, 'm=', i3)

         if (yyhere .ge. yystamp) then
	    call pgtext(xxhere, yyhere, astring)
cViewport	    call pgmtext('LV', -1.0, yyhere, 0.0, astring)
c	    call pgmtext('RV', 1.0, yyhere, 0.0, astring)
cDebug	    write (*,*) 'plot_labelinfo: placing ', astring
	 else
	    write (*,*) 'plot_labelinfo: skipping ', astring
	 endif
	endif
	if (uniqueLabel(indxunique1(i), indxunique2(i)) .eq. '-') then
	  write (*,*) 'plot_labelinfo: Hey Programmer! Sort is messed up!'
	endif
      enddo

      if (multiplicity(unique_rlv_max) .gt. 0) then
        yyhere = yyhere - yyoff
        if (yyhere .ge. yystamp) then
	  write (astring, *) '# of Absences= ', multiplicity(unique_rlv_max)
	  call pgtext(xxhere, yyhere, astring)
cViewport	  call pgmtext('LV', -2.0, yyhere, 0.0, astring)
cc	  call pgmtext('RV', 2.0, yyhere, 0.0, astring)
	else
	    write (*,*) 'plot_labelinfo: skipping ', astring
	endif
      endif

        yyhere = yyhere - yyoff
        if (yyhere .ge. yystamp) then
	  write (astring, *) '# observed= ', nobserved
	  call pgtext(xxhere, yyhere, astring)
	else
	    write (*,*) 'plot_labelinfo: skipping ', astring
	endif

      call  PGSCH (1.0)		!! Restore the lettering.
      call PGQCS(0, XCH, YCH)
        call pgsvp( xmin_plot, xmax_plot, ymin_plot, ymax_plot)
	call pgwnad(xmin,xmax,ymin,ymax)
      call pgsvp( xmin_new, xmax_new, ymin_new, ymax_new)

      return
      end

c===========================================================================
      subroutine cycle_color(icolor, base)
c...	Cycle color. 
c...	Base=3 use ink, and 2 greys.
c...	base = 15 use the PGPLOT standard colors except for ink_bkgr.
      implicit none
      include 'spur_color.inc'
      
      integer icolor, base

      if (base .eq. 3) then
	if      (mod(icolor, base) .eq. 0) then
	  call pgsci(color_ink)
	else if (mod(icolor, base) .eq. 1) then
	  call pgsci(color_darkgrey)
	else if (mod(icolor, base) .eq. 2) then
	  call pgsci(color_lightgrey)
	endif
	icolor = icolor + 1
      else if (base .eq. 15) then
	if      (mod(icolor, base) .eq. 0) then
	  call pgsci(mod((icolor+1), base))
	else if (mod(icolor, base) .eq. 1) then
	  call pgsci(mod((icolor+1), base))
	else if (mod(icolor, base) .eq. 2) then
	  call pgsci(mod((icolor+1), base))
	endif
	icolor = icolor + 1
      else
        write (*,*) 'cycle_color: Only base=3 and 15 allowed ',
     &	'presently. base=', base
      endif
      
      return
      end

c===========================================================================
c      subroutine sketch_layout()
c
c      implicit none
c      include 'arraysize.inc'
c      include 'spur_color.inc'
c      include 'spur_layout.inc'
c      
c
c      call pgsci(color_ink)  ! opposite to BG colour
c      call pgrect (xmin,xmax,ymin,ymax)
c      
c      return
c      end

c===========================================================================

      integer function cycle_marker(inum, ibase)
c...	Cycle marker code, using PGPLOT marker symbols.

      implicit none
c...	passed variables      
      integer inum, ibase
      
c...	local variables
      integer i, base

      if (ibase .le. 0)  then
c	Always return a square for stupid values.      
        cycle_marker = 0	!! square
	return
      else
        if (ibase .gt. 15) then 
          base = 15
        else      
          base = ibase
        endif
      endif
      
      i = mod(inum, base)
      if      (i .eq. 0) then
        cycle_marker = 0	!! square
      else if (i .eq. 1) then
        cycle_marker = 2	!! cross
      else if (i .eq. 2) then
        cycle_marker = 3	!! *
      else if (i .eq. 3) then
        cycle_marker = 4	!! circle
      else if (i .eq. 4) then
        cycle_marker = 5	!! x
      else if (i .eq. 5) then
        cycle_marker = 7	!! triangle
      else if (i .eq. 6) then
        cycle_marker = 10	!! squashed square
      else if (i .eq. 7) then
        cycle_marker = 11	!! diamnond
      else if (i .eq. 8) then
        cycle_marker = 12	!! star
      else if (i .eq. 9) then
        cycle_marker = 13	!! filled triangle
      else if (i .eq. 10) then
        cycle_marker = 14	!! open cross
      else if (i .eq. 11) then
        cycle_marker = 15	!! star of david
      else if (i .eq. 12) then
        cycle_marker = 16	!! filled square
      else if (i .eq. 13) then
        cycle_marker = 17	!! filled circle
      else if (i .eq. 14) then
        cycle_marker = 18	!! filled star
      end if 

cDangerous	write (*,*) 'cycle_marker: ',  inum, base, cycle_marker
      return
      end


c===========================================================================

      integer function cycle_linestyle(inum, usesolid)
c...	Cycle marker code, using PGPLOT marker symbols.
c SUBROUTINE PGSLS (LS)
c      INTEGER  LS
c
c Set the line style attribute for subsequent plotting. This
c attribute affects line primitives only; it does not affect graph
c markers, text, or area fill.
c Five different line styles are available, with the following codes:
c 1 (full line), 2 (dashed), 3 (dot-dash-dot-dash), 4 (dotted),
c 5 (dash-dot-dot-dot). The default is 1 (normal full line).

      implicit none
c...	passed variables      
      integer inum
      logical usesolid
      
c...	local variables
      integer base

      if (usesolid) then
        base = 5
        cycle_linestyle = mod(inum-1, base) + 1	!! returns 1 - 5
      else
        base = 4
        cycle_linestyle = mod(inum-1, base) + 2	!! returns 2 - 5
      endif

      return
      end


	

      subroutine lazy(npos,bpos,xyzpos,struct, noisy)
      
C-----******************************************************************MAIN0000
C-----*               *** LNS VAX VERSION 1989                         ***
C-----*               *** with new table of neutron scattering lengths ***
C-----*                                                                *MAIN0002
C-----*                   L  A  Z  Y                                   *MAIN0003
C-----*                                                                *MAIN0005
C-----******************************************************************MAIN0006
C-----*                                                                *MAIN0008
C-----* ROUTINE TO PREPARE THE INPUT FOR  P U L V E R I X              *MAIN0009
C-----* AUTHOR  K. YVON
C-----* LABORATOIRE DE CRISTALLOGRAPHIE AUX RAYONS X ,                 *MAIN0014
C-----* UNIVERSITY OF GENEVA                                           *MAIN0015
C-----* 24 QUAI ERNEST ANSERMET, CH 1211 GENEVA, SWITZERLAND           *MAIN0016
C-----* TEL 022 219355                                                 *MAIN0017
C-----******************************************************************MAIN0020
C
c Modified by Tanya Riseman, Nov. 2001, NIST Center for Neutron Research.
c to allow free format reads on some cards (CELL, ATOM) and
c and modify CONDIT's format statement so that this routine can read in
c output from WWW Lazy program. Should make it easier to edit by LPI files
c by hand. However all parameters are now required by CELL and ATOM.
c Added error catching on read statements.
c 
C Adapted and tested by Carl Adams, Oct. 1998, NIST Center for
C Neutron Research for a Linux machine with a fort77 compiler
C
C Modified by Carl Adams, Nov. 1998 to upgrade the calculation
C of atomic positions to double precision variables.
C variables effected: ts, fs

	implicit none
	include 'arraysize.inc'
      include 'io_files.inc'
	
c...	common blocks
c   	Change COMPND to a string from an integer array
      character*76 COMPND
      character*4 elemt(16)
      real FOCCU(50,16), FMULT(50,16)
      real FNEUT(16)
      real A,B,C,ALPHA,BETA,GAMMA
      real SYMSY				!! Unused in code
      integer ISYMCE, NCOMPO
      integer NA(16)
      real wl, TL,TH, AGUIN, BGUIN
      real BTEMP(50,16), DELFR(16), DELFI(16)
      integer IMAGE, ns
      character*4 norm,iano
      COMMON /INPUT/ COMPND,ELEMT,FOCCU,FMULT,FNEUT,A,B,C,ALPHA,BE
     1TA,GAMMA,SYMSY,ISYMCE,NCOMPO,NA,WL,TL,TH,NORM,IMAGE,AGUIN,BG
     2UIN,BTEMP,DELFR,DELFI,IANO,NS


      character*2 symlp
      character*1 symbr
      character*4 symwl
      COMMON /INPUTCHAR/ SYMLP,SYMBR,symwl

      double precision x(50,16),y(50,16),z(50,16)
      common /inputdoub/ x,y,z

      integer ICR,IPR,ILU
      COMMON /UNITS/ ICR,IPR,ILU

      double precision rn(3),rd(3),s1(3),s2(3),s3(3)
      COMMON /POSITNUM/ RN,RD,S1,S2,S3 

      character*45 igr
c01Dec      character*1 igr(45)
      common /POSITCHAR/ IGR

      real del1, del2
      COMMON /ANOMAL/ DEL1,DEL2

      real FNEU
      COMMON /NEU/ FNEU

      real FA(4,16),FB(4,16), FC(16)
      COMMON /SCAT/ FA,FB,FC

      integer ibravl, isystm
      common /cell/ ibravl,isystm
      
      integer IHOO,IOKO,IOOL,IHKO,IHOL,IOKL,IHHL,LAUE,ITRIG
      COMMON /EXTI/ IHOO,IOKO,IOOL,IHKO,IHOL,IOKL,IHHL,LAUE,ITRIG
      
      double precision ts(3,24),fs(3,3,24)
      COMMON /EQUO/ TS,FS

C      COMMON /BURCDP/ TSS /BURCI/ SS
      double precision tss(24,3)
      INTEGER SS(24,3,3)
      COMMON /BURC/ TSS,SS

      character*1 ip(8,3)
      COMMON /SLAS/ IP
c0111      COMMON /SLAS/ IP(8,3)



c...	functions
	logical	extractfirstword
    	logical isblank
	integer lp
	real wave
	integer ilen


c...	passed variables	
      integer npos
      real bpos(natoms_max)
      logical noisy
c changed xyzpos to double prec CPA 8-01-00
      double precision xyzpos(natoms_max,3)
      logical struct


c...	local variables
      integer IDE(50,16) 
      integer njob,igroup
      character*2 isymlp
      character*4 elemt1, asymb
c01Dec      DIMENSION FA(4,16),
c01Dec     1 FB(4,16), FC(16),
c01Nov     2 COMPND(19),
c01Dec     3 FOCCU(50,16), FMULT(50,16), FNEUT(16), NA(16),
c01Dec     4 BTEMP(50,16), DELFR(16), DELFI(16), IDE(50,16)

C change just a bit here to find the problem
      double precision xyz(3)
      integer bra
      character*4 isymwl,cen, isyb
      integer ILV, LIMIT2, LIMIT3, LIMIT4
      integer i, j, k, m, ij, ik
      integer ijob, isyst, ipnch, nc, icode, isy
      real tl1, th1, thg, ide1, b1, foccu1, ano
      integer KODLP, inorm, ng

C
      character*2 ipos(45)
      character*2 car(9),indf
      character*4 iblnk
      character*80 aline, aword, lastOK
      character*80 aError

c      BLOCK DATA
C
C  Many of these declarations need to be replaced with character statements.
C  Dimension statement is obselete.
C  length set to maximum that is going in data statements
      
C-----CONTAINS LITERAL DATA FOR LAZY                                    BLKD0001
      character*1 n3(20)
      COMMON /ND/ N3

      character*4 mw(20)
      common /WAVEL/ MW

      integer ib(8)
      common /BRAFNUM/IB 

      character*1 ct(8)
      common /BRAFCHAR/ CT 

      integer lpf(6)
      common /FLORNUM/ LPF 

      character*2 cv(6)
      common /FLORCHAR/ CV

c23456789_123456789_123456789_123456789_123456789_123456789_123456789_12
      DATA  N3(1)/'1'/, N3(2)/'2'/,  N3(3)/'3'/,  N3(4)/'4'/, 
     &      N3(5)/'5'/, N3(6)/'6'/,  N3(7)/'A'/,  N3(8)/'B'/,
     &      N3(9)/'C'/, N3(10)/'D'/, N3(11)/'M'/, N3(12)/'N'/,
     &      N3(13)/'P'/,N3(14)/'CU  '/,N3(15)/'/'/,N3(16)/'-'/,
     &      N3(17)/' '/, N3(18)/'  '/,N3(19)/'    '/,N3(20)/'SP'/

c...	Maybe problem is with n3(15)?
c?      DATA  N3(1)/1H1/, N3(2)/1H2/,  N3(3)/1H3/,  N3(4)/1H4/, 
c?     &      N3(5)/1H5/, N3(6)/1H6/,  N3(7)/1HA/,  N3(8)/1HB/,
c?     &      N3(9)/1HC/, N3(10)/1HD/, N3(11)/1HM/, N3(12)/1HN/,
c?     &      N3(13)/1HP/,N3(14)/4HCU  /,N3(15)/1H//,N3(16)/1H-/,
c?     &      N3(17)/1H /, N3(18)/2H  /,N3(19)/4H    /,N3(20)/2HSP/

c0111      DATA  N3(1)/1H1/, N3(2)/1H2/, N3(3)/1H3/, N3(4)/1H4/, N3(5)/1H5/,
c0111     1N3(6)/1H6/,N3(7)/1HA/,N3(8)/1HB/,N3(9)/1HC/,N3(10)/1HD/,N3(11)/1HM
c0111     2/,N3(12)/1HN/,N3(13)/1HP/,N3(14)/4HCU  /,N3(15)/1H//,N3(16)/1H-/,
c0111     3N3(17)/1H /, N3(18)/2H  /,N3(19)/4H    /,N3(20)/2HSP/

      DATA LPF(1)/0/,LPF(2)/1/,LPF(3)/2/,LPF(4)/3/,LPF(5)/4/,LPF(6)/0/

      DATA CV(1)/2HDS/,CV(2)/2H 1/,CV(3)/2HNE/,CV(4)/2HGN/,CV(5)/2HGH/,C
     1V(6)/2H  /

      DATA IB(1)/1/,IB(2)/1/,IB(3)/2/,IB(4)/3/,IB(5)/4/,IB(6)/5/,IB(7)/6
     1/,IB(8)/7/

      DATA CT(1)/1H /,CT(2)/1HP/,CT(3)/1HI/,CT(4)/1HR/,CT(5)/1HF/,CT(6)/
     11HA/,CT(7)/1HB/,CT(8)/1HC/

      DATA MW(1)/4HCRA1/,MW(2)/4HCRA2/,MW(3)/4HCRB /,MW(4)/4HCR  /,MW(5)
     1/4HFEA1/,MW(6)/4HFEA2/,MW(7)/4HFEB /,MW(8)/4HFE  /,MW(9)/4HCUA1/,
     2MW(10)/4HCUA2/,MW(11)/4HCUB /,MW(12)/4HCU  /,MW(13)/4HMOA1/,MW(14)
     3/4HMOA2/,MW(15)/4HMOB /,MW(16)/4HMO  /,MW(17)/4HAGA1/,MW(18)/4HAGA
     42/,MW(19)/4HAGB /,MW(20)/4HAG  /

      DATA CAR(1)/2HTI/,CAR(2)/2HAT/,CAR(3)/2HCE/,CAR(4)/2HLA/,CAR(5)/2H
     1SY/,CAR(6)/2HCO/,CAR(7)/2HSP/,CAR(8)/2HEN/,CAR(9)/2HFI/
      DATA IBLNK/4HBBBB/

C  end of data, common, and declarations -> beginning of program
C
C  default state is that lazy is able to read in the parameters
      struct=.true.

C-----SET LOGICAL UNIT NUMBERS                                          MAIN0088
C
      icr = unitlpi
      ilv = unitlpitemp
      ipr = unitlog
c...	ILU is unused
      	
c01Dec      ICR=4     ! CPA changed from 5 to 4
c01Dec      IPR=2     ! CPA changed from 6 to 2
c01DecC-CDC-IPR=61                                                            MAIN0092
c01Dec      ILU=11
c01DecC-CDC-ILU=51                                                            MAIN0094
c01Dec      ILV=12
c01DecC-CDC-ILV=52                                                            MAIN0096

C-----SET PROGRAM LIMITS                                                MAIN0097
      LIMIT2=16    ! number of atom kinds
      LIMIT3=50    ! number of atoms of one kind
      LIMIT4=24    ! number of equiv positions
C-VAX-
C-VAX-EQUIVALENCE LOGICAL UNIT NUMBERS WITH I/O FILES.
C-VAX-
C  Open input file.

      OPEN (UNIT=ICR,FILE=file_lpi,STATUS='OLD',ACCESS='SEQUENTIAL',
     1      FORM='FORMATTED',err=64)
c      OPEN (UNIT=ICR,FILE='LPI',STATUS='OLD',ACCESS='SEQUENTIAL',
c     1      FORM='FORMATTED',err=64)
      write(*,*) 'Opened: ', 'Lazy-Pulverix input (LPI) file: ',
     &		file_lpi(1:ilen(file_lpi))


C  Open temporary storage file.
            
      OPEN (UNIT=ILV,FILE=file_lpitemp,STATUS='unknown',
     1	ACCESS='SEQUENTIAL', FORM='FORMATTED',err=63)
c      OPEN (UNIT=ILV,FILE='LPS',STATUS='unknown',ACCESS='SEQUENTIAL',
c     1FORM='FORMATTED',err=63)
      write(*,*) 'Opened: ', 'Lazy-Pulverix temporary file: ',
     &		file_lpitemp(1:ilen(file_lpitemp))
     
      write (unitlog,*) 'Lazy: noisy = ', noisy

C  Open an output file for structural and reflection information.
      
C      open (unit=7,file='structinfo.out',status='unknown')
c01Dec      write(*,'(a)') 'Structural information in structinfo.out'
      write(*,*) 'Structural information in ',
     &      file_structout(1:ilen(file_structout))

C-----                                                                  MAIN0101
C-----READ INPUT FOR SEVERAL JOBS                                       MAIN0102
C-----                                                                  MAIN0103

      NJOB=0
C      WRITE (IPR,38)
C-----READ FIRST CARD OF EACH SET                                       MAIN0106
 1    READ (ICR,39,err=639) (IPOS(I),I=1,40)
C-----CHECK FOR FINISH CARD                                             MAIN0108
cDuplicative      call supper(ipos(1))		! added by Tanya Riseman, Nov 29, 2001
      IF (IPOS(1).EQ.CAR(9)) then
cDebug    	 if (noisy) then
cDebug    	   write (*,*) 'LAZY: copying FINISH Command found = ', IPOS(1), 
cDebug     &	    	' = CAR(', 9, ') = ', CAR(9), '. NJOB = ', NJOB
cDebug    	 endif
         GO TO 4
      endif
C-----COUNT NUMBER OF JOBS                                              MAIN0110
      NJOB=NJOB+1
C      WRITE (IPR,40) NJOB
      GO TO 3
C-----READ REMAINING DATA CARDS                                         MAIN0114
 2    READ (ICR,39,err=639) (IPOS(I),I=1,40)
cDuplicative      call supper(ipos(1))		! added by Tanya Riseman, Nov 29, 2001
 3    continue
C 3    WRITE (IPR,41) (IPOS(I),I=1,40)
C-----WRITE DATA CARDS TWICE ON DISK                                    MAIN0117
      WRITE (ILV,39) (IPOS(I),I=1,40)
      WRITE (ILV,39) (IPOS(I),I=1,40)
C
C-----CHECK FOR END OF JOB                                              MAIN0120
      IF (IPOS(1).NE.CAR(8)) then 
cDebug    	 if (noisy) then
cDebug    	   write (*,*) 'LAZY: copying not END Command found = ', IPOS(1), 
cDebug     &	    	' NE CAR(', 8, ') = ', CAR(8)
cDebug    	 endif
      	GO TO 2
      else
cDebug      	 if (noisy) then
cDebug    	   write (*,*) 'LAZY: copying END Command found = ', IPOS(1), 
cDebug     &	    	' = CAR(', 8, ') = ', CAR(8)
cDebug    	 endif
C        WRITE (IPR,42)
        GO TO 1
      endif
c      IF (IPOS(1).NE.CAR(8)) GO TO 2
cC      WRITE (IPR,42)
c      GO TO 1
 4    REWIND ILV
C-----                                                                  MAIN0125
C-----START CALCULATION FOR NJOB JOBS                                   MAIN0126
C-----                                                                  MAIN0127
C      WRITE (ILU) NJOB
C
C    !!big loop!!
C
      DO 37 IJOB=1,NJOB
C-----                                                                  MAIN0130
C-----SET DEFAULT VALUES                                                MAIN0131
C-----                                                                  MAIN0132
         ISYMWL=N3(14)
         SYMBR=N3(13)
         ISYMLP=N3(18)
         CEN=N3(7)
         NORM=N3(17)
         WL=1.5418
         TL1=0.
         TH1=89.
         THG=45.
         IMAGE=2
         IANO=N3(17)
C-----                                                                  MAIN0144
C-----SET PARAMETERS BACK TO ORIGINAL VALUE                             MAIN0145
C-----                                                                  MAIN0146
         LAUE=0
         ITRIG=3
         IHOO=1
         IOKO=1
         IOOL=1
         IHHL=1
         IHOL=1
         IOKL=1
         IHKO=1
         NCOMPO=1
         TH=TH1
         TL=TL1
         SYMWL=ISYMWL
         NS=0
         IGROUP=0
         ISYST=0
         ISYMCE=0
         IPNCH=0
         A=0.
C-----SET ARRAYS BACK ZERO                                              MAIN0165
         DO 5 I=1,45
            IGR(I:I)=N3(17)
c01Dec            IGR(I)=N3(17)
 5       continue
         DO 6 I=1,LIMIT2
            ELEMT(I)=IBLNK
            FNEUT(I)=0.
            DELFR(I)=0.
            DELFI(I)=0.
            FC(I)=0.
            DO 6 J=1,4
               FA(J,I)=0.
               FB(J,I)=0.
               NA(I)=0
 6       continue
         DO 7 I=1,3
            DO 7 J=1,3
               DO 7 K=1,LIMIT4
                  TS(I,K)=0.0d0 ! double precision
                  FS(I,J,K)=0.0d0
 7       CONTINUE

	aError = 'lazy: No error yet'
C
C  Beginning of calculations
C
C  FS for storage of equivalent point positions
C  -FS changed to double precision
C
C-----TRIVIAL POSITION X,Y,Z                                            MAIN0184
         FS(1,1,1)=1.0d0
         FS(2,2,1)=1.0d0
         FS(3,3,1)=1.0d0
C-----LOOP OVER ALL DATA CARDS ON FILE ILV FOR ONE SET                  MAIN0188
 8       READ (ILV,43, err=643) INDF
C-----READ FIRST RECORD TO IDENTIFY FORMAT                              MAIN0190

C  Recall CAR(J=1,9): TItle ATom CE LA SY CO SP EN FI 
    	 call supper(INDF)  	    !! convert to upper case. TR Nov, 30, 2001
         DO 9 J=1,8
            IF (INDF.NE.CAR(J)) GO TO 9
            M=J
            GO TO 10
 9       CONTINUE
C     WRITE (IPR,44) INDF
    	 if (noisy) then
	    write (*,*) 'LAZY: Error, unrecognised command ', INDF
	    write (unitlog,*) 'LAZY: Error, unrecognised command ', INDF
	 endif
         GO TO 35
C-----READ SECOND RECORD WITH CORRECT FORMAT                            MAIN0198
C  this is a computed go to statement.  Will go to the item
C  specified by integer M, these are the reading statements
C
 10      CONTINUE
    	 if (noisy) then
    	   write (unitlog,*) 'LAZY: Command found = ', INDF, 
     &	    	'=CAR(', M, ') = ', CAR(M)
    	 endif
    	 GO TO (11,12,16,18,19,23,24,26), M
C
C-----T I T L E  CARD                                                   MAIN0200
C
 11      READ (ILV, 45,err=645) COMPND
c01Nov 11      READ (ILV,45,err=645) (COMPND(I),I=1,19)
cLog    	 if (noisy) then
    	    write (unitlog,*) '.. COMPND="', COMPND(1:65), '"'
c01Nov    	    write (*,*) '.. COMPND="', (COMPND(I),I=1,19), '"'
cLog	 endif
         GO TO 8
C
C-----A T O M  CARD                                                     MAIN0203
C
C  Here is where variables really start going in
C  the symbol of element, an ID number, 8 characters for each
C  of the x,y,z cell coordinates, Debye Waller factor, and
C  occupation factor.
C 
 12      continue
    	 READ (ILV,fmt=('(5x,a75)'),err=646,end=646) aline

	 aword = ' '
    	 lastOK = 'Last part of ATOM that was OK: <NONE>'
cDebug	 write (*,*) 'lazy: pre-elemnt1: aline=', aline 
	 if (extractfirstword(aline, aword, ',')) then
cDebug	    write (*,*) 'Lazy: extractfirstword returned true'
     	    read (aword, fmt=('(A)'), err=646,end=646) ELEMT1
cOKonLinux     	    read (aword, *, err=646,end=646) ELEMT1
    	    lastOK = 'Last part of ATOM that was OK ELEMT1='//aword(1:20)
cDebug    	    write (*,*) 'Lazy: ATOM OK ELEMT1=', ELEMT1
cDebug	    write (*,*) 'mt1 = "', ELEMT1, '"', aword
	 else 
cDebug	    write (*,*) 'Lazy: extractfirstword returned false'
	    goto 646
	 endif
	 
	 if (extractfirstword(aline, aword, ',')) then
    	    if (isblank(aword)) then 
	       IDE1 = 0.0
     	    else 
	       read (aword, *, err=646,end=646) IDE1
	    endif
    	    lastOK = 'Last part of ATOM that was OK IDE1='//aword(1:20)
cDebug    	    write (*,*) 'Lazy: ATOM OK IDE1=', IDE1
	 else 
	    goto 646
	 endif
	 
	 do j = 1, 3     ! x, y, z
	   if (extractfirstword(aline, aword, ',')) then
     	     read (aword, fmt=('(8A1)'), err=646,end=646) 
     &	    	    (IP(I,J),I=1,8)
    	    lastOK = 'Last part of ATOM that was OK xyz='
     &	    	    //char(j)//' ='//aword(1:20)
cDebug    	    write (*,*) 'Lazy: ATOM OK J=', j, ' ', (IP(I,J),I=1,8)
	   else 
	     goto 646
	   endif
    	 enddo
	 
	 if (extractfirstword(aline, aword, ',')) then
    	    if (isblank(aword)) then 
	       B1 = 0.0
     	    else 
     	       read (aword, *, err=646,end=646) B1
	    endif
    	    lastOK = 'Last part of ATOM that was OK B1='//aword(1:20)
cDebug    	    write (*,*) 'Lazy: ATOM OK B1=', B1
	 else 
    	     B1 = 0.0
	     FOCCU1 = 0.0
	 endif
	 
	 if (extractfirstword(aline, aword, ',')) then
    	    if (isblank(aword)) then 
	       FOCCU1 = 0.0
     	    else 
     	       read (aword, *, err=646,end=646) FOCCU1
    	    endif
    	    lastOK = 'Last part of ATOM that was OK FOCCU1='//aword(1:20)
cDebug    	    write (*,*) 'Lazy: ATOM OK FOCCU1=', FOCCU1
	 else 
	    FOCCU1 = 0.0
	 endif

C  A blank FOCCU1 will be taken as full occupancy.
C
         IF (FOCCU1.EQ.0.) FOCCU1=1.

cLog    	 if (noisy) then
    	   write (unitlog,*) '.. ELEMT1="', ELEMT1, '" IDE1="', IDE1, '"' 
    	   write (unitlog,*) '.. X= "', (IP(I,1),I=1,8),'" Y= "', 
     &	    	    	(IP(I,2),I=1,8),'" Z= "', (IP(I,3),I=1,8),'"'
    	   write (unitlog,*) '.. B1=', B1, ' FOCCU1=', FOCCU1 
cLog	 endif
cWrong 	 READ (aline,*,err=646,end=646) ELEMT1,IDE1,
cWrong     &		((IP(I,J),I=1,8),J=1,3), B1,FOCCU1
c01Nov 12      READ (ILV,46) ELEMT1,IDE1,((IP(I,J),I=1,8),J=1,3),B1,FOCCU1
C
C  SLASH is able to handle fraction and decimal data in the IP
C
         CALL SLASH (XYZ)
C      write(*,'(3d14.8)') (xyz(j),j=1,3)
C
cMoveC  A blank FOCCU1 will be taken as full occupancy.
cMoveC
cMove         IF (FOCCU1.EQ.0.)FOCCU1=1.
C
         DO 13 I=1,NCOMPO       ! just 1 the first time
            NC=I                ! nc is index of atom kinds
C-----ADD ATOM TO SAME ATOM KIND                                        MAIN0209
            IF (ELEMT1.EQ.ELEMT(NC)) GO TO 14
 13      CONTINUE
C-----STORE ATOM AS NEW ATOMKIND                                        MAIN0212
         IF (NA(1).EQ.0) GO TO 14 ! aren't any atoms yet
         NCOMPO=NCOMPO+1        ! increase # of atom types
         NC=NCOMPO
         IF (NCOMPO.LE.LIMIT2) GO TO 14 ! check to make sure we are below limit
C     WRITE (IPR,47) LIMIT2
	 if (noisy) then
	    write (*,*) 'Lazy: ATOM Error (NCOMPO.GT.LIMIT2)', 
     &      	    NCOMPO, LIMIT2
	    write (unitlog,*) 'Lazy: ATOM Error (NCOMPO.GT.LIMIT2)', 
     &      	    NCOMPO, LIMIT2
	 endif
         GO TO 35
 14      NA(NC)=NA(NC)+1        ! NA is # of atoms of kind NC
         I=NA(NC)

         IF (NA(NC).LE.LIMIT3) GO TO 15 ! another limit check
C     WRITE (IPR,48) NA(NC),ELEMT1,LIMIT3
	 if (noisy) then
	   write (*,*) 'Lazy: ATOM Error (NA(NC).GT.LIMIT3)', 
     &	    	NC, NA(NC), LIMIT3
	   write (unitlog,*) 'Lazy: ATOM Error (NA(NC).GT.LIMIT3)', 
     &	    	NC, NA(NC), LIMIT3
	 endif
         GO TO 35

C put in x,y,z and other info for row na(nc) and column nc
      
 15      X(I,NC)=XYZ(1)  
         Y(I,NC)=XYZ(2)
         Z(I,NC)=XYZ(3)
         ELEMT(NC)=ELEMT1
         IDE(I,NC)=IDE1
         FOCCU(I,NC)=FOCCU1
         BTEMP(I,NC)=B1
         GO TO 8
C
C-----C E L L  CARD                                                     MAIN0232
 16      continue
    	 READ (ILV,fmt=('(5x,a75)'),err=649) aline
c01Nov 	 READ (aline,*,err=649,end=649)  A,B,C,ALPHA,BETA,GAMMA

    	 lastOK = 'Last part of CELL that was OK: <NONE>'
	 if (extractfirstword(aline, aword, ',')) then
cDebug	    write (*,*) 'Lazy: extractfirstword returned true'
	    read (aword, *, err=649,end=649) A
    	    lastOK = 'Last part of CELL that was OK A='//aword(1:20)
	 else 
cDebug	    write (*,*) 'Lazy: extractfirstword returned false'
	    goto 649
	 endif
	 
	 if (extractfirstword(aline, aword, ',')) then
    	    if (isblank(aword)) then 
	       B = 0.0
     	    else 
     	       read (aword, *, err=649,end=649) B
	    endif
    	    lastOK = 'Last part of ATOM that was OK B='//aword(1:20)
	 else 
	    B = 0.0
	    C = 0.0
	    ALPHA = 0.0
	    BETA = 0.0
	    GAMMA = 0.0
	 endif

	 if (extractfirstword(aline, aword, ',')) then
    	    if (isblank(aword)) then 
	       C = 0.0
     	    else 
     	       read (aword, *, err=649,end=649) C
	    endif
    	    lastOK = 'Last part of ATOM that was OK C='//aword(1:20)
	 else 
	    C = 0.0
	    ALPHA = 0.0
	    BETA = 0.0
	    GAMMA = 0.0
	 endif


	 if (extractfirstword(aline, aword, ',')) then
    	    if (isblank(aword)) then 
	       alpha = 0.0
     	    else 
     	       read (aword, *, err=649,end=649) alpha
	    endif
    	    lastOK = 'Last part of ATOM that was OK Alpha='//aword(1:20)
	 else 
	    alpha = 0.0
	    BETA = 0.0
	    GAMMA = 0.0
	 endif


	 if (extractfirstword(aline, aword, ',')) then
    	    if (isblank(aword)) then 
	       beta = 0.0
     	    else 
     	       read (aword, *, err=649,end=649) beta
	    endif
    	    lastOK = 'Last part of ATOM that was OK beta='//aword(1:20)
	 else 
	    BETA = 0.0
	    GAMMA = 0.0
	 endif

	 if (extractfirstword(aline, aword, ',')) then
    	    if (isblank(aword)) then 
	       gamma = 0.0
     	    else 
     	       read (aword, *, err=649,end=649) gamma
	    endif
    	    lastOK = 'Last part of ATOM that was OK gamma='//aword(1:20)
	 else 
	    GAMMA = 0.0
	 endif

cLog    	 if (noisy) then
    	    write (unitLog,*) '.. A=', A, ' B=', B, ' C=', C
    	    write (unitLog,*) '.. Alpha=', alpha, ' Beta=', beta, 
     &      	    ' Gamma=', gamma
cLog	 endif
c01Nov 16      READ (ILV,49) A,B,C,ALPHA,BETA,GAMMA
C I want to adapt this so it can read in the data from
C the qbuffer.buf
C     CALL QBUFIN(a,aa,h,hs,fe,ec,u,v)


C-----CRYSTAL SYSTEM                                                    MAIN0234
         ISYSTM=2               ! orthorhombic
         IF (B.NE.0.) GO TO 17
         IF (GAMMA.EQ.0.) ISYSTM=4 ! tetragonal
         IF (GAMMA.EQ.120.) ISYSTM=6 ! hexagonal (maybe rhombo)
         IF (C.EQ.0.) ISYSTM=5  ! cubic or isometric
 17      IF (BETA.NE.0.) ISYSTM=1 ! monoclinic
C
C  must be triclinic
C
         IF ((BETA.NE.0.).AND.(ALPHA.NE.0.)) ISYSTM=7

    	 if (noisy) then
    	    call reportsymmetry(ISYSTM)

c    	    if (ISYSTM .eq. 1) then
c	      write(*,*) '.. ISYSTM = ', ISYSTM, ' is monoclinic'
c    	    else if (ISYSTM .eq. 2) then
c	      write(*,*) '.. ISYSTM = ', ISYSTM, ' is orthorhombic'
c    	    else if (ISYSTM .eq. 4) then
c	      write(*,*) '.. ISYSTM = ', ISYSTM, ' is tetragonal'
c    	    else if (ISYSTM .eq. 5) then
c	      write(*,*) '.. ISYSTM = ', ISYSTM, ' is cubic or isometric'
c    	    else if (ISYSTM .eq. 6) then
c	      write(*,*) '.. ISYSTM = ', ISYSTM, ' is hexagonal (maybe rhombo)'
c    	    else if (ISYSTM .eq. 7) then
c	      write(*,*) '.. ISYSTM = ', ISYSTM, ' is triclinic'
c    	    else 
c	      write(*,*) '.. ISYSTM = ', ISYSTM, ' is unrecognized'
c	    endif
	 endif
    	 
         GO TO 8

C
C-----L A T I C E  CARD                                                 MAIN0243
C
 18    	 READ (ILV,fmt=('(6x,a74)'),err=650) aline

    	 lastOK = 'Last part of LATICE that was OK <NONE>' 
	 if (extractfirstword(aline, aword, ',')) then
     	       read (aword, FMT=('(A)'), err=650,end=650) CEN
    	    lastOK = 'Last part of LATICE that was OK CEN='//aword(1:20)
	 else 
    	    go to 650
	 endif

	 if (extractfirstword(aline, aword, ',')) then
     	    read (aword, FMT=('(A)'), err=650,end=650) SYMBR
    	    lastOK = 'Last part of LATICE that was OK SYMBR='//aword(1:20)
	 else 
    	    SYMBR = ' '     !! OK if left blank
    	    go to 650
	 endif

c01Nov 18      READ (ILV,50,err=650) CEN,SYMBR
c01Nov 18      READ (ILV,50) CEN,SYMBR
         IF (CEN.EQ.N3(9)) ISYMCE=1
cLog    	 if (noisy) then
    	    write (unitlog,*) '.. CEN="', cen, '" SYMBR= "', SYMBR, 
     &	    	    '" ISYMCE=', ISYMCE
cLog	 endif
         GO TO 8
C
C-----S Y M T R Y  CARD                                                 MAIN0247
C
 19      READ (ILV,51,err=651) IGR
c01Dec 19      READ (ILV,51,err=651) (IGR(J),J=1,45)
c01Nov 19      READ (ILV,51) (IGR(J),J=1,45)
	 call supper(IGR)
cLog    	 if (noisy) then
    	    write (unitlog,*) '.. IGR="', IGR, '"'
c01Dec    	    write (*,*) '.. IGR="', (IGR(J),J=1,45), '"'
cLog	 endif
         CALL EQVP
C  an error indicator
         IF (RN(1).EQ.999.9) then
	   if (noisy) then
	      write (*,*) 'Lazy: SYMTRY Error (RN(1).EQ.999.9)', RN(1)
	   endif
	   write (unitlog,*) 'Lazy: SYMTRY Error (RN(1).EQ.999.9)', RN(1)
    	   GO TO 35
	 endif
c01Nov         IF (RN(1).EQ.999.9) GO TO 35
         NS=NS+1
C  continue if # of equivalent postions in less than limit
         IF (NS.LE.LIMIT4) GO TO 20
C      WRITE (IPR,52) LIMIT4
c	 if (noisy) then
	   write (*,*) 'Lazy: SYMTRY Error (NS.GT.LIMIT4)', NS, LIMIT4
c	 endif
	 write (unitlog,*) 'Lazy: SYMTRY Error (NS.GT.LIMIT4)', NS, LIMIT4
         GO TO 35

C  this data will be in groups of 3
 20      DO 22 J=1,3
            IF (RD(J).EQ.0.0d0) GO TO 21 ! no fraction present
            RD(J)=RN(J)/RD(J)   ! calculate the fraction
 21         TS(J,NS)=RD(J)      ! store number in TS
            FS(1,J,NS)=S1(J)    ! put XYZ info in FS where NS is
            FS(2,J,NS)=S2(J)    ! the equivalent position #
            FS(3,J,NS)=S3(J)    ! also appears that negative signs
                                ! are associated with X,Y,Z
 22      CONTINUE
         GO TO 8                ! return to beginning of card reader
C
C-----C O N D I T  CARD                                                 MAIN0264
C
 23      READ (ILV,53,err=653) SYMWL,WL,TL,TH,NORM,IMAGE,SYMLP,
     &		IANO,IPNCH,ICODE
c01Nov 23      READ (ILV,53) SYMWL,WL,TL,TH,NORM,IMAGE,SYMLP,IANO,IPNCH,ICODE
ccc 53   FORMAT (10X,A4,F8.0,F3.0,F5.0,1X,A1,I2,A2,1X,A1,2I2)
cLog    	 if (noisy) then
    	    write (unitlog,*) '.. SYMWL="',  SYMWL, '"'    	    	! A4
    	    write (unitlog,*) '.. WL=', WL, ' TL=', TL, 'TH=', TH 	! F8.0,F3.0,F5.0
    	    write (unitlog,*) '.. NORM="', NORM, '" IMAGE=', IMAGE, 	
     &	    	    ' SYMLP= "', SYMLP, '" IANO="', IANO, '"'	! A1,I2,A2,1X,A1,
     	    write (unitlog,*) '.. IPNCH=', IPNCH, ' ICODE =', ICODE	! 2I2
cLog	 endif
C-----REPLACE BLANKS BY DEFAULT SYMBOLS                                 MAIN0266
         IPNCH=1
         ICODE=1
         IF (SYMWL.EQ. N3(19) ) SYMWL=ISYMWL
c0111         IF (SYMWL.EQ.4h    ) SYMWL=ISYMWL
         IF(TH.EQ.0.) TH=TH1
         IF(TH.GT.TH1) TH=TH1
         IF(TH.LT.TL)  TH=TL
clog    	 if (noisy) then
    	    write (unitlog,*) '.. update SYMWL="',  SYMWL, '"'
    	    write (unitlog,*) '.. update  TH=', TH 	
     	    write (unitlog,*) '.. update IPNCH=', IPNCH, ' ICODE =', ICODE
clog	 endif

         GO TO 8
C
C-----S P C G R P  CARD                                                 MAIN0272
C
C  this should essentially return the information that is in
C  the LATTICE and the SYMTRY cards: SYMBR (Bravais lattice
C  indicator), ISYMCE (Centric or Acentric)
C  ISYST (crystal system indicator) will have been picked up by
C  CELL card.
C
 24      READ (ILV,54,err=654) IGR
c01Dec 24      READ (ILV,54,err=654) (IGR(I),I=1,36)
c01Nov 24      READ (ILV,54) (IGR(I),I=1,36)
	 call supper(IGR)
cLog    	 if (noisy) then
    	    write (unitlog,*) '.. IGR="', IGR, '"'
c01Dec    	    write (*,*) '.. IGR="', (IGR(I),I=1,19), '"'
cLog	 endif
         ISYST=0
         IGROUP=1

         CALL BURZ (ISYST,ISY,ISYB,NG)
         NS=NG                  ! the number of equivalent positions
         SYMBR=ISYB
         ISYMCE=ISY
C-----MAKE ARRAY FROM BURZ COMPATIBLE WITH P U L V E R I X              MAIN0280
         DO 25 I=1,3
            DO 25 IJ=1,3
               DO 25 IK=1,NS
                  FS(I,IJ,IK)=dble(SS(IK,IJ,I))
                  TS(IJ,IK)=TSS(IK,IJ)
 25      CONTINUE

C      write(*,*) 'in LAZY:'
C      do i=1,ns
C         do j=1,3
C            write(*,*) (fs(k,j,i),k=1,3),ts(j,i)
C         enddo
C      enddo


         call printequiv(fs,ts,ns)
         
         GO TO 8
C
C-----END OF FORMAT INTERPRETATION                                      MAIN0288
C
 26      READ (ILV,43,err=743) INDF
c01Nov 26      READ (ILV,43) INDF
C-----CHECK FOR CELL AND ATOM CARD                                      MAIN0290
         IF (NA(1).NE.0) GO TO 27
C      WRITE (IPR,55)
	aError = 'Lazy: No atom card was found'
         GO TO 36
 27      IF (A.NE.0.) GO TO 28
C      WRITE (IPR,56)
	 aError = 'Lazy: No cell card was found'
         GO TO 36
C-----LORENTZ POLARISATION FACTOR                                       MAIN0297
 28      KODLP=LP(SYMLP)
C-----CENTER OF SYMMETRY AT ORIGIN                                      MAIN0299
         IF (CEN.EQ.N3(9)) ISYMCE=1
C-----WAVELENGTH                                                        MAIN0301
         IF (WL.LT.0.02) WL=WAVE(SYMWL)
C-----LIMIT UPPER SIN**2 THETA VALUE FOR GUINIER CAMERA                 MAIN0303
         IF ((KODLP.GT.2).AND.(TH.GT.45.)) TH=THG
C-----TABULAR OUTPUT FEATURE                                            MAIN0305
         IF (NORM.EQ.N3(17)) INORM=0
         IF ((IANO.EQ.N3(17)).AND.(ISYMCE.EQ.0).AND.(KODLP.NE.2)) 
     &        INORM=2
         IF (NORM.EQ.N3(7)) INORM=1
         IF (NORM.EQ.N3(12)) INORM=3
C-----DEFAULT SYMMETRY OPERATOR                                         MAIN0310
         IF (NS.EQ.0) NS=1
C-----DERIVE BRAVAIS LATTICE INDICATOR                                  MAIN0312
         IBRAVL=BRA(SYMBR)
C-----CALCULATE MULTIPLICITIES OF SPECIAL ATOM POSITIONS                MAIN0314
C -I am also calling ANOMA-> NEUTF in this routine to find the
C  scattering lengths.
         CALL MULTF(elemt,kodlp,npos,bpos,xyzpos,natoms_max)
c01Dec         CALL MULTF(elemt,kodlp,npos,bpos,xyzpos,nmax)
C  I will modify the scattering lengths here for fractional 
C  occupancy.
C      do i=1,ncompo
C         bpos(i)=bpos(i)*foccu(1,i)
C      enddo

C-----ANOMALOUS  DISPERSION INDICATOR                                   MAIN0316
         ANO=0.
         IF ((IANO.EQ.N3(17)).AND.(KODLP.NE.2)) ANO=1.
C-----CHECK CRYSTAL SYSTEM                                              MAIN0319
         IF (ISYST.EQ.0) GO TO 29
         IF (ISYST.EQ.ISYSTM) GO TO 29
C     WRITE (IPR,57)
C-----TAKE CRYSTAL SYSTEM FROM GROUP CARD                               MAIN0323
         ISYSTM=ISYST

C-----CALCULATE EXTINCTIONS,LAUE GROUP AND TRIGONAL SYMMETRY INDICATOR  MAIN0325
C  isymce indicates if lattice is centrosymmetric and ns is the number
C  sites not including Bravais lattice or inversion symmetry
 29      CALL EXTINC (ISYMCE,NS)
         IF (ISYSTM.EQ.6) ISYSTM=ITRIG ! allowance for hexagonal system

C-----RETRIEVE SCATTERING FACTORS FOR X RAY,NEUTRON AND ANOM.DISP.      MAIN0328
         DO 33 I=1,NCOMPO
            FNEU=0.
            NC=I
            DELFR(I)=0.
            ASYMB=ELEMT(NC)
            DELFI(I)=0.
            IF (KODLP.NE.2) GO TO 31
C-----RETRIEVE NEUTRON SCATTERING LENGTH                                MAIN0336
	    CALL supper(ELEMT(NC))		!! Convert to uppercase
            CALL ANOMA (SYMWL,ELEMT(NC),KODLP)
            IF (FNEU.NE.0.) GO TO 30
C     WRITE (IPR,58) ELEMT(NC)
	     aError = 'Lazy: Neutron scattering length for symbol '//
     &	      	ELEMT(NC)//' has not been found. Check ATOM command'
            GO TO 36
 30         FNEUT(NC)=foccu(1,nc)*FNEU
C     write(*,*) nc,i,fneu,foccu(1,nc),fneut(nc)
            GO TO 33
 31         IF ( ANO .EQ.0.) GO TO 32
C-----RETRIEVE ANOMALOUS DISPERSION COEFFICIENTS                        MAIN0344
            CALL ANOMA (SYMWL, ASYMB   ,KODLP)
            DELFR(NC)=DEL1
            DELFI(NC)=DEL2
C-----RETRIEVE CROMER-MANN COEFFICIENTS                                 MAIN0348
 32         CALL FSC (ASYMB,NC)
            IF (FC(NC).EQ.999.9) then
		aError = 'lazy: Error with the Cromer-Mann coefficients' 
	    	GO TO 36
	    endif
 33      CONTINUE
C-----WRITE DATA FOR FOLLOWING PROGRAM PULVR2 ON UNIT ILU               MAIN0352

C this is having some problems CPA
C      WRITE (ILU) (COMPND(I),I=1,19),A,B,C,ALPHA,BETA,GAMMA,WL,(IGR(I),I
C     1=1,36),IGROUP, SYMWL, SYMLP
C      WRITE (ILU) ISYSTM,ISYMCE,IBRAVL,NS,TL,TH,INORM,IMAGE,ANO,KODLP,NC
C     1OMPO,(NA(I),I=1,16),IHOO,IOKO,IOOL,IHHL,IHOL,IHKO,IOKL,LAUE,
C     2 IPNCH,ICODE
C     WRITE (ILU) ((TS(I,II),(FS(K,I,II),K=1,3),I=1,3),II=1,NS)
C     DO 34 M=1,NCOMPO
C        NL=NA(M)
C        WRITE (ILU) DELFR(M),DELFI(M)
C        WRITE (ILU) ELEMT(M),(FA(I,M),FB(I,M),I=1,4),FC(M),FNEUT(M)
C        WRITE (ILU) (ELEMT(M),IDE(I,M),X(I,M),Y(I,M),Z(I,M),FMULT(I,M),FOC
C     1  CU(I,M),BTEMP(I,M),I=1,NL)
C 34  CONTINUE
C      WRITE (IPR,59) IJOB
         GO TO 37
C-----SKIP RECORDS UNTIL END CARD                                       MAIN0367
 35      READ (ILV,43,err=843) INDF
c01Nov 35      READ (ILV,43) INDF
         IF (INDF.NE.CAR(8)) then
    	   if (noisy) then
    	     write (*,*) 'LAZY: not END Command found = ', INDF, 
     &	    	' NE CAR(', 8, ') = ', CAR(8)
    	   endif
    	   write (unitlog,*) 'LAZY: not END Command found = ', INDF, 
     &	    	' NE CAR(', 8, ') = ', CAR(8)
	   GO TO 35
	 endif
         READ(ILV,43,err=843) INDF
c01Nov        READ(ILV,43) INDF
 36      continue
C     WRITE (IPR,60) IJOB
	 if (noisy) then
	     write (*,*) aError
	 endif
	 write (unitlog,*) aError
         IF(NJOB.GT.1) GO TO 65
C-VAX-
C-VAX-IF ERROR, END JOB AND CLOSE AND DELETE I/O FILES
C-VAX-
C      CLOSE (UNIT=IPR,STATUS='KEEP')
C      CLOSE (UNIT=ILU,STATUS='DELETE')
         CLOSE (UNIT=ILV,STATUS='DELETE')
         CLOSE (UNIT=ICR,STATUS='KEEP')
C     close (unit=3)
          struct=.false.
c     	 if (noisy) then
    	    write (*,*) 'Lazy: Error so end job. STRUCT=', struct
c    	 endif
    	 write (unitlog,*) 'Lazy: Error so end job. STRUCT=', struct
         GO TO 70
C-VAX-
 65      CONTINUE
C-----WRITE ONE DUMMY RECORD FOR BAD JOB                                MAIN0372
         A=-1.
C      WRITE (ILU) (COMPND(I),I=1,19),A,B,C,ALPHA,BETA,GAMMA,WL,(IGR(I),I
C     1=1,36),IGROUP
 37   CONTINUE   !  end of long loop
C-----END OF DATA PREPARATION                                           MAIN0377
C      REWIND ILU
C      WRITE (IPR,61)
C-VAX-
C-VAX-CLOSE I/O FILES.
C-VAX-
      CLOSE (UNIT=ICR,STATUS='KEEP')
C      CLOSE (UNIT=IPR,STATUS='KEEP')
C      CLOSE (UNIT=ILU,STATUS='KEEP')
      CLOSE (UNIT=ILV,STATUS='DELETE')
C      close (unit=3)
C-VAX-
 70   CONTINUE

      return

 63   CLOSE (UNIT=ICR,STATUS='KEEP')
      struct=.false.
      if (noisy) then
    	 write (*,*) 'Lazy: Error opening temporary file ', 
     &		 file_lpitemp(1:ilen(file_lpitemp)) 
       	 write (*,*) 'Lazy: set flag STRUCT=', struct
      endif
      write (unitlog,*) 'Lazy: Error opening temporary file ', 
     &		 file_lpitemp(1:ilen(file_lpitemp)) 
C     close (unit=3)
      GO TO 70

 64   struct=.false.
      if (noisy) then
    	 write (*,*) 'Lazy: Error opening file ', 
     &		 file_lpi(1:ilen(file_lpi)) 
       	 write (*,*) 'Lazy: set flag STRUCT=', struct
ccc    	 write (*,*) 'Lazy: Dead end code? STRUCT=', struct
      endif
      write (unitlog,*) 'Lazy: Error opening file ', 
     &		 file_lpi(1:ilen(file_lpi)) 
      GO TO 70

C-CDC-CALL EXIT                                                         MAIN0381
C38   FORMAT (1H ,//15H START  L A Z Y//)
 38   FORMAT (1H ,//15H START  L A Z Y//
     2' VAX VERSION 1989 OF LNS ETHZ,'/
     3' for max. 2500 hkl, 16 atom kinds, 50 atoms of one type,'/
     4' including generation of files for profile plot and refinement'/
     5' Ref.: K. Yvon, W. Jeitschko and E. Parthe,'/
     6' J. Appl. Cryst. 10, 73 (1977);'/
     7' n scattering amplitudes b: V.F. Sears,'/
     8' Methods of Experimental Physics 23A, 521 (1986)'/
     9' *** b(B) = b(B11)               ***'/
     1' *** b(Pu) = b(Pu239)            ***'/
     2' *** b(Cm) = b(Cm244)            ***'/
     3' *** imaginary b parts neglected ***'//)
 39   FORMAT (40A2)
 40   FORMAT (//12H INPUT CARDS//4H JOB,I6//3H *.,8(10H*********.),1H*)
 41   FORMAT (3H * ,40A2,1H*)
 42   FORMAT (3H *.,8(10H*********.),1H*)
 43   FORMAT (A2)
 44   FORMAT (16H FORMAT LETTERS ,A2,15H NOT RECOGNIZED)
 45   FORMAT (6X,A74)
c01Nov 45   FORMAT (6X,18A4,A2)
 46   FORMAT (7X,A4,A2,3(8A1),F6.2,F5.2)
 47   FORMAT (6H ONLY ,I5,19H ATOM KINDS ALLOWED)
 48   FORMAT (I5,9H ATOMS OF,A4,15H NUMBER ALLOWED,I5)
 49   FORMAT (13X,3F8.0,3F9.0)
c01Nov 50   FORMAT (8X,A1,2X,A1)
 51   FORMAT (6X,A45)
c01Dec 51   FORMAT (6X,45A1)
 52   FORMAT (10H MORE THAN,I5,13H SYMTRY CARDS)
c01Nov Change format statement for CONDIT to match WWW Lazy version.
 53   FORMAT (10X,A4,F8.0,F3.0,F5.0,1X,A1,I2,A2,1X,A1,2I2)
c01Nov 53   FORMAT (10X,A4,F6.0,2F5.0,1X,A1,I2,A2,1X,A1,2I2)
 54   FORMAT (6X,A36)
c01Dec 54   FORMAT (6X,36A1)
 55   FORMAT (23H NO ATOM CARD WAS FOUND)
 56   FORMAT (23H NO CELL CARD WAS FOUND  )
 57   FORMAT (/12H * WARNING */,76H CRYSTAL SYSTEM SPECIFIED ON CELL CAR
     1D AND ON GROUP CARD ARE NOT CONSISTENT  )
 58   FORMAT (37H NEUTRON SCATTERING LENGTH FOR SYMBOL,2X,A4,19H HAS NOT
     1 BEEN FOUND)
 59   FORMAT (/4H JOB,I6,5H OK  /)
 60   FORMAT (/5H JOB ,I5,7H FAILED//)
 61   FORMAT (///16H END OF  L A Z Y)

      goto 999
c	Error handling so that user finds out what caused the crash.

639   write (*,*) 'LAZY: error reading in file FORMAT (40A2). NJOB=', 
     &		NJOB
      write (unitlog,*) 'LAZY: error reading in file FORMAT (40A2).', 
     &		' NJOB=', NJOB
      goto 699
643   write (*,*) 'LAZY: error reading in command. IJOB=', IJOB
      write (unitlog,*) 'LAZY: error reading in command. IJOB=', IJOB
      goto 699
645   write (*,*) 'LAZY: error reading in TITLE. IJOB=', IJOB
      write (unitlog,*) 'LAZY: error reading in TITLE. IJOB=', IJOB
      goto 699

646   write (*,*) 'LAZY: error reading in ATOM. IJOB=', IJOB   
      write (unitlog,*) 'LAZY: error reading in ATOM. IJOB=', IJOB   
      write (unitlog,*) lastOK
      write (unitlog,*) ' aword=', aword(1:20)
      write (unitlog,*) ' remander of line=', aline(1:60)
c      write (*,*) ' aline=', aline(1:60)
      goto 699

649   write (*,*) 'LAZY: error reading in CELL. IJOB=', IJOB
      write (unitlog,*) 'LAZY: error reading in CELL. IJOB=', IJOB
      write (unitlog,*) lastOK
      write (unitlog,*) ' aword=', aword(1:20)
      write (unitlog,*) ' remander of line=', aline(1:60)
      goto 699

650   write (*,*) 'LAZY: error reading in LATICE. IJOB=', IJOB
      write (unitlog,*) 'LAZY: error reading in LATICE. IJOB=', IJOB
      goto 699

651   write (*,*) 'LAZY: error reading in SYMTRY. IJOB=', IJOB
      write (unitlog,*) 'LAZY: error reading in SYMTRY. IJOB=', IJOB
      goto 699
      
653   write (*,*) 'LAZY: error reading in CONDIT. IJOB=', IJOB
      write (unitlog,*) 'LAZY: error reading in CONDIT. IJOB=', IJOB
      goto 699
      
654   write (*,*) 'LAZY: error reading in SPCGRP. IJOB=', IJOB
      write (unitlog,*) 'LAZY: error reading in SPCGRP. IJOB=', IJOB
      goto 699
      
743   write (*,*) 'LAZY: error finding nearly the END. IJOB=', IJOB
      write (unitlog,*) 'LAZY: error finding nearly the END.', 
     &		' IJOB=', IJOB
      goto 699
      
843   write (*,*) 'LAZY: error finding END. IJOB=', IJOB
      write (unitlog,*) 'LAZY: error finding END. IJOB=', IJOB
      goto 699

699   stop
      
999   continue
      END

c...	indexsort.f
c..	From numerical recipes

c=====================================================
      subroutine indexx2d(m_rlv, arrin, indx1, indx2, 
     &	      usedescending, qmax, hh, kk, ll, x, y)
c...	2d extension to indexx from numberical recipes.
c...	Indexes a 2D array arrin(,) of length m_rlv by m_rlv 
c...	i.e. outputs the arrays indx1 and indx2 (each length m_rlv**2)
c...	such that arrin(indx1(j)), indx2(j)) is in ascending order
c...	for J = 1, ... m_rlv**2 .
c...	This uses a heap sort algorthm.

      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_layout.inc'
      
c...	common blocks
      integer ntiny, nabsent, npresent, nobserved
      common /nabsences/ ntiny, nabsent, npresent, nobserved

c...	passed variables      
      integer m_rlv
      real arrin(m_rlv_max,m_rlv_max)
      integer indx1(unique_rlv_max)
      integer indx2(unique_rlv_max)
      logical usedescending
      real 	qmax
      integer hh(m_rlv_max,m_rlv_max)
      integer kk(m_rlv_max,m_rlv_max)
      integer ll(m_rlv_max,m_rlv_max)
      real 	x(m_rlv_max,m_rlv_max),y(m_rlv_max,m_rlv_max)

c...	local variables
      integer	j1, j2
      integer   j, i
      integer	l, ir
      integer	indx1temp, indx2temp
      real	atemp
      logical	debugthis
      parameter (debugthis = .false.)
            
c...	Initialize the index array, only using those 
c...	bragg peaks in the plotting range.
      j = 0
      do j1 = 1, m_rlv
         do j2 = 1, m_rlv
           if ((x(j1,j2).gt.xmin).and.(x(j1,j2).lt.xmax).and.
     &              (y(j1,j2).gt.ymin).and.(y(j1,j2).lt.ymax)) then
ccc              if (.not. absent(j1, j2)) then  
	       j = j + 1
	       indx1(j) = j1
	       indx2(j) = j2
ccc	     endif
           endif
	 enddo
      enddo
c02Jan      nobserved = j
      if (nobserved .eq. 0) then
        nobserved = j
      endif

c...	old way, using the whole array.
c      do j1 = 1, m_rlv
c         do j2 = 1, m_rlv
c	   j = (j1-1)*m_rlv + j2
c	   indx1(j) = j1
c	   indx2(j) = j2
ccDebug	   write(unitdebug, *) 'init', j, j1, j2, 
ccDebug     &	   	arrin(indx1(j), indx2(j))
c	 enddo
c      enddo

c	  WRITE (unitdebug,*) 'pre-indexx2d>>'
c	  do i = 1, m_rlv*m_rlv
c	    write (unitdebug,*) i, arrin(indx1(i), indx2(i))
cc            write (unitdebug,18) '  ', indx1(i), indx2(i), 
cc     &		hh(indx1(i), indx2(i)), kk(indx1(i), indx2(i)), 
cc     &		ll(indx1(i), indx2(i))
cc 18	    format(a, i3, i3, '(', i3, ',', i3, ',', i3,') ') 
c	  enddo
c	  write (unitdebug,*) 

cOld      if (m_rlv .eq. 1) return 
cOld         L = (m_rlv*m_rlv)/2 + 1
cOld      ir = m_rlv*m_rlv


      if (nobserved .eq. 1) return
      
      L = (nobserved)/2 + 1
      ir = nobserved
      
 10   continue
        if (L .gt. 1) then
	  L = L -1
	  indx1temp = indx1(L)
	  indx2temp = indx2(L)
	  atemp = arrin(indx1temp, indx2temp)
	else
	  indx1temp = indx1(ir)
	  indx2temp = indx2(ir)
	  atemp = arrin(indx1temp, indx2temp)
	  indx1(ir) = indx1(1)
	  indx2(ir) = indx2(1)
	  ir = ir -1
	  if (ir .eq. 1) then
	    indx1(1) = indx1temp 
	    indx2(1) = indx2temp 
	    goto 700
cccc	    return
	  endif
	endif

        i = L
        j = L + L

 20     continue
        if (j .le. ir) then
          if (j .lt. ir) then
	    if (arrin(indx1(j), indx2(j)) .lt. 
     &		arrin(indx1(j+1), indx2(j+1)) ) then
     		j = j + 1
     	    endif
	  endif
	  if (atemp .lt. arrin(indx1(j), indx2(j)) ) then
	    indx1(i) = indx1(j)
	    indx2(i) = indx2(j)
	    i = j
	    j = j + j
	  else
	    j = ir + 1
	  endif
	  goto 20
        endif             
        indx1(i) =indx1temp
        indx2(i) =indx2temp
        goto 10
	
 700  continue
      if (usedescending) then	!! swap from ascending order to decending
        do j = 1, (nobserved)/2
cOld        do j = 1, (m_rlv*m_rlv)/2
	  indx1temp = indx1(j)
	  indx1(j) =  indx1(nobserved - j + 1)
cOld	  indx1(j) =  indx1(m_rlv*m_rlv - j + 1)
	  indx1(nobserved - j + 1) = indx1temp
cOld	  indx1(m_rlv*m_rlv - j + 1) = indx1temp
	  indx2temp = indx2(j)
	  indx2(j) =  indx2(nobserved - j + 1)
cOld	  indx2(j) =  indx2(m_rlv*m_rlv - j + 1)
	  indx2(nobserved - j + 1) = indx2temp
cOld	  indx2(m_rlv*m_rlv - j + 1) = indx2temp
	enddo
      endif

	  if (debugthis) then
	    WRITE (unitdebug,*) 'post-indexx2d>>'
	    WRITE (unitdebug,*) ' usedescending =', useDescending
	    do i = 1, (nobserved)
cOld	    do i = 1, (m_rlv*m_rlv)
              write (unitdebug,17) arrin(indx1(i), indx2(i)), i, 
     &	    	indx1(i), indx2(i), 
     &		hh(indx1(i), indx2(i)), 
     &		kk(indx1(i), indx2(i)), 
     &		ll(indx1(i), indx2(i))
 17	      format('sfhkl=', g12.5, 1x, 'i=', i4, 
     &		'. indx1=', i3, ' indx2=', i3, ' (', i3, ',', i3, ',', i3,') ') 
	    enddo
	    write (unitdebug,*) 
	  endif

      return
      end
      
c===============================================================================
      subroutine unique(m_rlv, arrin, absent,  indx1, indx2, 
     &	  	indxunique1, indxunique2, multiplicity, 
     &		limlo, limhi, nunique, uniqueLabel, uniqueRank,
     &		sorttol, base, uselogscale, usedecending, hh, kk, ll)
c02Mar     &		tolerance, uselogscale, usedecending, hh, kk, ll)
c...	Return indxunique1 and  indxunique2 as an index to
c...    the first occurance of each value in arrin   
c...	nunique ss the length of indxunique1 and  indxunique2  that is used.
c...	mulitplicity(j) contains the multiplicity of the value 
c...	arrin(indxunique1(j), indxunique2(j))
c...    If logscale is false, then all entries within tolerance will
c...	be lumped together.
c...	If logscale is true, then use int(tolerance) as the base for 
c...	the logscale. All entries within the range of base**n and base**(n+1)
c...	will be lumped together,

      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'

c...	common blocks
      integer natoms
      common /atoms/ natoms
      
      integer ntiny, nabsent, npresent, nobserved
      common /nabsences/ ntiny, nabsent, npresent, nobserved

c...	passed variables
      integer m_rlv
      real arrin(m_rlv_max,m_rlv_max)
      logical absent(m_rlv_max,m_rlv_max)
cCommon      integer nabsent
      integer indx1(unique_rlv_max), indx2(unique_rlv_max)
      integer indxunique1(unique_rlv_max)
      integer indxunique2(unique_rlv_max)
      integer multiplicity(unique_rlv_max)
      real	limlo(unique_rlv_max)
      real	limhi(unique_rlv_max)
c      integer indxunique1(0:unique_rlv_max)
c      integer indxunique2(0:unique_rlv_max)
c      integer multiplicity(0:unique_rlv_max)
c      real	limlo(0:unique_rlv_max)
c      real	limhi(0:unique_rlv_max)
      integer nunique
      character*1 uniqueLabel(m_rlv_max,m_rlv_max)
      integer	uniqueRank(m_rlv_max,m_rlv_max)
c02Mar      real 	tolerance
      real 	sorttol, base
      logical 	uselogscale
      logical	useDecending
      integer hh(m_rlv_max,m_rlv_max)
      integer kk(m_rlv_max,m_rlv_max)
      integer ll(m_rlv_max,m_rlv_max)
    
c...	local variables
      integer 	j, jq
      integer   i
c      integer j1, j2
      real 	value
c02Mar      integer 	base
cccc      real	limlo, limhi
      real 	pwrhi, pwrlo      
      integer	thisrank
      integer	absentRank
      parameter (absentRank = -1)
      logical 	debugthis, debugthis2
c      parameter (debugthis = .false.)
      parameter (debugthis = .true.)
      parameter (debugthis2 = .true.)
      logical inrange
      integer istart, nmult
           
c02Mar      if (uselogscale) then
c02Mar	base = nint(abs(tolerance))
c02Mar      endif

c      debugthis = .true.
      if (debugthis) then
	write (unitdebug,*) 'unique>>'
	write (unitdebug,*) 'uselogscale=',  uselogscale
	write (unitdebug,*) 'usedecending=', usedecending
	write (unitdebug,*) 'tolerance =', sorttol
	write (unitdebug,*) 'base=', base
	write (unitdebug,*) 'nobserved=', nobserved
      endif
	write (*,*) 'nobserved=', nobserved
      
      j = 1
      nabsent = 0

c...	Last item is always the absences 
      limlo(unique_rlv_max) = 0.0
      limhi(unique_rlv_max) = 0.0
      multiplicity(unique_rlv_max) = 0
      indxunique1(unique_rlv_max) = indx1(j)	!! Not correct if no absences
      indxunique2(unique_rlv_max) = indx2(j)
      uniqueRank(indx1(j), indx2(j))  = absentRank
      inrange  = .false.
      
      do while (absent(indx1(j), indx2(j)) .and. 
     &	      (j .le. min(nobserved, unique_rlv_max) ) )
cOld      do while (absent(indx1(j), indx2(j)) .and. 
cOld     &	      (j .le. min(m_rlv*m_rlv, unique_rlv_max) ) )
        nabsent = nabsent + 1
	multiplicity(unique_rlv_max) = multiplicity(unique_rlv_max) + 1
	if (nabsent .eq. 1) then
	  !! Stores the first absence found
          indxunique1(unique_rlv_max) = indx1(j) 
          indxunique2(unique_rlv_max) = indx2(j)
	endif
        uniqueRank(indx1(j), indx2(j))  = absentRank
        if (debugthis) then
	   write (unitdebug,*) 'absences at begining of list:'
	   write (unitdebug,*)
     &      j, indx1(j), indx2(j), '...', 
     &	    unique_rlv_max, 
     &		indxunique1(unique_rlv_max), indxunique2(unique_rlv_max), '...', 
     &	    ' mult=', multiplicity(unique_rlv_max),
     &      ' rank=',   uniqueRank(indx1(j), indx2(j)),
     &      ' nabsnt = ', nabsent, absent(indx1(j), indx2(j)) 
	   write (unitdebug,*) ' '
        endif
	j = j + 1

      enddo
      if (j .gt. min(nobserved, unique_rlv_max)) goto 666
cOld      if (j .gt. min(m_rlv*m_rlv, unique_rlv_max)) goto 666
      
      jq = j
      uniqueRank(indx1(j), indx2(j))  = jq
      indxunique1(jq) = indx1(j)
      indxunique2(jq) = indx2(j)
      multiplicity(jq) = 0
      value = arrin(indx1(j), indx2(j))

       if (uselogscale) then
	  pwrlo = int(log(value)/log(base) )
c02Mar	  pwrlo = int(log(value)/log(float(base)) )
	  if (value .le. 1.0) pwrlo = pwrlo - 1
	  pwrhi = pwrlo + 1
	  limlo(jq) = base**pwrlo
	  limhi(jq) = base**pwrhi
c02Mar	  limlo(jq) = float(base)**pwrlo
c02Mar	  limhi(jq) = float(base)**pwrhi
       else
           limlo(jq) = value - sorttol
           limhi(jq) = value + sorttol
c02Mar           limlo(jq) = value - tolerance
c02Mar           limhi(jq) = value + tolerance
       endif
       inrange = ( (limlo(jq) .le. arrin(indx1(j), indx2(j))) 
     &		.and. (arrin(indx1(j), indx2(j)) .le. limhi(jq)) )

       if (debugthis) then
	    write (unitdebug,*) '... rank=', jq, 
     &	    ' limits=', limlo(jq), limhi(jq)
       endif

      do while (j .le. min(nobserved, unique_rlv_max) )
cOld      do while (j .le. min(m_rlv*m_rlv, unique_rlv_max) )

  	  do while ((inrange) .and. 
     &		(j .le. min(nobserved, unique_rlv_max) ) )	  
cOld  	  do while ((inrange) .and. 
cOld     &		(j .le. min(m_rlv*m_rlv, unique_rlv_max) ) )	  
c  	  do while ( (limlo(jq) .le. arrin(indx1(j), indx2(j))) 
c     &		.and. (arrin(indx1(j), indx2(j)) .le. limhi(jq)) )
     	    multiplicity(jq) = multiplicity(jq) + 1
            if (debugthis) then
	      write (unitdebug,*)
     &      	j, ' val=', arrin(indx1(j), indx2(j)),
     &          indx1(j), indx2(j), '...', 
     &	    	jq, indxunique1(jq), indxunique2(jq), '...', 
     &	    	' mult=', multiplicity(jq),
     &	    	' rank=',  uniqueRank(indx1(j), indx2(j)),
     &          ' nabsnt = ', nabsent, absent(indx1(j), indx2(j))    
            endif

	    j = j + 1
	    if (j .le. min(nobserved, unique_rlv_max) ) then
cOld	    if (j .le. min(m_rlv*m_rlv, unique_rlv_max) ) then
              uniqueRank(indx1(j), indx2(j))  = jq
              inrange = ( (limlo(jq) .le. arrin(indx1(j), indx2(j))) 
     &		.and.   (arrin(indx1(j), indx2(j)) .le. limhi(jq)) )
	    endif
	  enddo
	
	if (j .le. min(nobserved, unique_rlv_max)) then
cOld	if (j .le. min(m_rlv*m_rlv, unique_rlv_max)) then
	
         if  (absent(indx1(j), indx2(j))) then 
	   if (nabsent .eq. 0) then
	     !! Stores the first absence found
             indxunique1(unique_rlv_max) = indx1(j)
             indxunique2(unique_rlv_max) = indx2(j)
	   endif
           nabsent = nabsent + 1
	   multiplicity(unique_rlv_max) = multiplicity(unique_rlv_max) + 1
	   uniqueRank(indx1(j), indx2(j)) = absentRank
           if (debugthis) then
	     if (nabsent .eq. 1) then
	       write (unitdebug,*) ' '
	       write (unitdebug,*) 'absences at end of list:'
	     endif
	     write (unitdebug,*)
     &      	j, ' val=', arrin(indx1(j), indx2(j)),
     &           indx1(j), indx2(j), '...', 
     &	    	unique_rlv_max, indxunique1(unique_rlv_max),
     &		 indxunique2(unique_rlv_max), '...', 
     &	    	' mult=', multiplicity(unique_rlv_max),
     &	    	' rank=',  uniqueRank(indx1(j), indx2(j)),
     &      	' nabsnt = ', nabsent, absent(indx1(j), indx2(j))
           endif

	   j = j + 1

         else

	  jq = jq + 1
	  uniqueRank(indx1(j), indx2(j))  = jq
          indxunique1(jq) = indx1(j)
          indxunique2(jq) = indx2(j)
          multiplicity(jq) = 0
          value = arrin(indx1(j), indx2(j))
cDebug	  write (*,*) j, indx1(j), indx2(j), jq, 
cDebug     &	     indxunique1(jq), indxunique2(jq),
cDebug     &	    multiplicity(jq), uniqueRank(indx1(j), indx2(j))  
          if (uselogscale) then
	    pwrlo = int(log(value)/log(base) )
c02Mar	    pwrlo = int(log(value)/log(float(base)) )
	    if (value .le. 1.0) pwrlo = pwrlo - 1
	    pwrhi = pwrlo + 1
	    limlo(jq) = base**pwrlo
	    limhi(jq) = base**pwrhi
c02Mar	    limlo(jq) = float(base)**pwrlo
c02Mar	    limhi(jq) = float(base)**pwrhi
           else
             limlo(jq) = value - sorttol
             limhi(jq) = value + sorttol
c02Mar             limlo(jq) = value - tolerance
c02Mar             limhi(jq) = value + tolerance
          endif
          if (debugthis) then
	    write (unitdebug,*) '... rank=', jq, 
     &	    ' limits=', limlo(jq), limhi(jq)
          endif
          inrange = ( (limlo(jq) .le. arrin(indx1(j), indx2(j))) 
     &		.and. (arrin(indx1(j), indx2(j)) .le. limhi(jq)) )
	  
	 endif
	endif
	if (jq .ge. min(nobserved, unique_rlv_max)) goto 666
cOld	if (jq .ge. min(m_rlv*m_rlv, unique_rlv_max)) goto 666

      enddo

      nunique = jq
      write (*,*) 'unique: nunique, nobserved =', nunique, nobserved

c      	!! Label for intensity range.
c	!! '*' for absent.
c	!! a..z for lowest intensities (a being the very lowest).
c	!! A...Z for the highest intensities (A being the highest intensity).
c	!! # for the middle intensities when there are more than 54. 
c	!! - for did something stupid

c...	Visual verification that I did not do something stupid.
      do j = 1 + min(nobserved, unique_rlv_max), unique_rlv_max
            uniqueLabel(indx1(j), indx2(j)) = '-'
      enddo


      do j = 1, min(nobserved, unique_rlv_max)
cOld      do j = 1, min(m_rlv*m_rlv, unique_rlv_max)
          thisrank = uniqueRank(indx1(j), indx2(j))
          if (thisrank .eq. absentRank) then
            uniqueLabel(indx1(j), indx2(j)) = '*'
ccc            uniqueLabel(indx1(j), indx2(j)) = '@'
          else if (thisrank .le. min(26, nunique/2)) then
	    if (useDecending) then
	      !! rank=1 is the largest number with useDecending = .true.
              uniqueLabel(indx1(j), indx2(j)) = 
     &	      	char(ichar('A') -1 + thisrank)
	    else
	      !! rank=1 is the smallest number with useDecending = .false.
              uniqueLabel(indx1(j), indx2(j)) = 
     &	      	char(ichar('a') -1 + thisrank)
	    endif
          else if ((nunique - thisrank + 1) .le.
     &		   min(26, (nunique-nunique/2))) then
	    if (useDecending) then
	      !! rank=nquniue is the smallest number with useDecending = .true.
              uniqueLabel(indx1(j), indx2(j)) = char(ichar('a') -1 + 
     &	      		(nunique - thisrank + 1))
	    else
	      !! rank=nunique is the largest number with useDecending = .false.
              uniqueLabel(indx1(j), indx2(j)) = char(ichar('A') -1 + 
     &	      		(nunique - thisrank + 1))
	    endif
          else
            uniqueLabel(indx1(j), indx2(j)) = '#'
          endif
c	  write (*,*) 'unique: rank ', j, indx1(j), indx2(j),
c     &		   arrin(indx1(j), indx2(j)), ' "', 
c     &		  uniqueLabel(indx1(j), indx2(j)), '" ', thisrank 
      enddo

c      do j1 = 1, m_rlv
c       do j2 = 1, m_rlv
c          thisrank = uniqueRank(j1, j2)
c          if (thisrank .le. min(26, nunique/2)) then
c	    if (useDecending) then
c	      !! rank=1 is the largest number with useDecending = .true.
c              uniqueLabel(j1, j2) = char(ichar('A') -1 + thisrank)
c	    else
c	      !! rank=1 is the smallest number with useDecending = .false.
c              uniqueLabel(j1, j2) = char(ichar('a') -1 + thisrank)
c	    endif
c          else if ((nunique - thisrank + 1) .le.
c     &		   min(26, (nunique-nunique/2))) then
c	    if (useDecending) then
c	      !! rank=nquniue is the smallest number with useDecending = .true.
c              uniqueLabel(j1, j2) = char(ichar('a') -1 + 
c     &	      		(nunique - thisrank + 1))
c	    else
c	      !! rank=nunique is the largest number with useDecending = .false.
c              uniqueLabel(j1, j2) = char(ichar('A') -1 + 
c     &	      		(nunique - thisrank + 1))
c	    endif
c          else
c            uniqueLabel(j1, j2) = '#'
c          endif
c	  write (*,*) 'unique: rank ', j1, j2, arrin(j1,j2), '"', 
c     &		  uniqueLabel(j1, j2), '"', thisrank 
c        enddo
c      enddo

	  if (debugthis2) then
	    WRITE (unitdebug,*) 'post-unique>>'
	    WRITE (unitdebug,*) ' tolerance =', sorttol
	    WRITE (unitdebug,*) ' base =', base
	    WRITE (unitdebug,*) ' uselogscale = ', uselogscale
     	    WRITE (unitdebug,*) ' nunique =', nunique
	    nmult = 0
	    do i = 1, nunique
	      nmult = nmult + multiplicity(i)
	      write (unitdebug,*) multiplicity(i), ' in range ', 
     &	      		limlo(i), limhi(i)
	    enddo
	    WRITE (unitdebug,*) 'total  # of non-absent intensisties=', 
     &		    nmult
     	    WRITE (unitdebug,*) ' nabsent =', nabsent
	    WRITE (unitdebug,*) 'total  # of non-absent and ', 
     &		    'absent intensisties=', nmult+nabsent
            WRITE (unitdebug,*)
	    
	    if (nabsent .gt. 0) then 
	      istart = 0
	    else
	      istart = 1
	    endif

	    do i = istart, nunique
cNothere	     if (debugthis) then
cDebug	    write (*,*) 'unique: unformatted write to unitdebug 1'
	      write (unitdebug,*) 
     &		uniqueLabel(indxunique1(i), indxunique2(i)), i, 
     &		arrin(indxunique1(i), indxunique2(i)),
     &		' limlo =', limlo(i), ' limhi=', limhi(i), 
     &		' mult=', multiplicity(i)
cNothere	     endif
c		maybe next line causes SGI to crash.      
c	inwrite: off end of record
c	apparent state: unit 20 named SPUR_DEFAULT.debug
c	last format: (a)
c	Unit 20 is a sequential formatted internal file
cDebug	    write (*,*) 'unique: formatted write to unitdebug 2'
              write (unitdebug,18) '              ', 
     &	    	indxunique1(i), indxunique2(i), 
     &		hh(indxunique1(i), indxunique2(i)), 
     &		kk(indxunique1(i), indxunique2(i)), 
     &		ll(indxunique1(i), indxunique2(i))
 18	      format(a, i3, i3, ' (', i3, ',', i3, ',', i3,') ') 
	    enddo
	    write (unitdebug,*) 
cDebug	    write (*,*) 'unique: finished write to unitdebug 3'
	  endif
	  

      goto 999
      
 666  write (*,*) 'unique: Bug in algorthm. j, jq = ', j, jq
      stop
           
 999  return
      end

c....	spurion_routines.f

c===========================================================================
      subroutine init_vectors(a, aa, bmat, bmatuv, b, 
     &      uu, vv, uxv, uuv, vuv, u, v, uxvi, 
     &	    zetatitle, etatitle, c, angle, xstar, ystar)


      implicit none
      include 'io_files.inc'

c...	common blocks

c...	functions
      
c...	passed variables
      REAL*4 a(3),aa(3),bmat(3,3),bmatuv(3,3),b(3)
      REAL*4 uu(3),vv(3),uxv(3),uuv(3),vuv(3)
      INTEGER u(3),v(3),uxvi(3)
      character*10 zetatitle,etatitle
      real c
      real angle
C  The underlying plot and all calculations are done in AA^-1
C  the actual numbers on the graph may be changed to rlu so
C  that xworld= (x AA^-1)/xstar.  The plot will still be
C  square. 
      real xstar, ystar
      
c...	local variables
      INTEGER i
      CHARACTER*5 scale
      integer len
      character*80 aline

C********************************************************      
C  Generate and plot points in reciprocal space.

C  Convert u and v to floating point
      
 50   do i=1,3
        uu(i)=float(u(i))
        vv(i)=float(v(i))
      enddo

C  Calculate the reciprocal lattice vectors in
C  terms of Cartesian coordinates.

      call generateb(a,aa,b,c,bmat)
C      write(*,'(a31)') 'Reciprocal lattice vectors are:'
C      call displayvec(bmat)

C  Calculate the cross product (for main title)

C the answer uxv is in terms of the direct lattice vectors

      call cross(uu,vv,uxv)

      do i=1,3
         uxvi(i)=int(uxv(i))
      enddo

C put in an error trap

      if ((uxvi(1).eq.0).and.(uxvi(2).eq.0).and.(uxvi(3).eq.0)) then
         write(*,'(2a)') 'Orientation vectors are unsuitable!',
     &              ' (zero cross product)'
         call title(u,zetatitle,len)         
         write(*,'(4a)') 'Currently u=',zetatitle(1:len)
         call title(v,etatitle,len)
         write(*,'(4a)') 'Currently v=', etatitle(1:len)
c         write(*,'(4a)') 'Currently u=',zetatitle(1:len),' and v=',
c     &                    etatitle(1:len)
220      write(*,'(a,$)') 'Continue (y)/n? '
         read (*,'(a)',err=220) scale
         if (scale.eq.'n') stop
222      write(*,'(1x,a,$)') 'Enter new u (use spaces or commas): '
         read(*,*, err=222) (u(i),i=1,3)
224      write(*,'(1x,a,$)') 'Enter new v (use spaces or commas): '
         read(*,*, err=224) (v(i),i=1,3)
         go to 50 
      endif
C  Calculate the direct lattice vectors which really isn't
C  necessary.  Include amat in declarations if used.
C      call generatea(amat,bmat)
C      write(*,'(a27)') 'Direct lattice vectors are:'
C      call displayvec(amat)

C  Perform the rotational transformation to a coordinate
C  system where u // +x, u x v // +/- z, and v.y > 0.
      call transform(u,v,bmat,uuv,vuv,bmatuv)
C      write(*,'(a31)') 'Transformed reciprocal lattice vectors are:'
C      call displayvec(bmatuv)

C  What is the angle between v and eta which will appear in ytitle?

      angle=atan(vuv(1)/vuv(2))

      xstar=uuv(1)
      ystar=vuv(2)
 80   format(a80)
300   format (a,f5.3,a,f5.3,a)
      write(aline,300) 'Zeta* is ',uuv(1),' and eta* is ',
     &         vuv(2),' AA^-1.'
      write (*,80) aline
      write (unitlog,80) aline

310   format (a,a,f5.3,a,f5.3,a,  a, f5.3,a,f5.3,a)
      write (aline, 310)   'Orientation vector u is ', 
     &      '(', uuv(1),',', uuv(2), ') AA^-1  = ', 
     &      '(', uuv(1)/xstar,',', uuv(2)/ystar, ') rlu'  
      write (*,80) aline
      write (unitlog,80) aline

      write (aline, 310)   'Orientation vector v is ', 
     &      '(', vuv(1),',', vuv(2), ') AA^-1  = ', 
     &      '(', vuv(1)/xstar,',', vuv(2)/ystar, ') rlu'  
      write (*,80) aline
      write (unitlog,80) aline

      return
      end

c===========================================================================
      subroutine init_vectorlabels(rlu, u, v, zetatitle, etatitle, 
     &	xtitle, ytitle, x2title, y2title, angle, pi)

      implicit none

c...	common blocks

c...	functions

c...	passed variables
      logical rlu
      INTEGER u(3),v(3)
      character*10 zetatitle,etatitle
      CHARACTER*41 xtitle,ytitle
      CHARACTER*41 x2title,y2title
      real angle
      real pi

c...	local variables
      integer len

      
C  Produce axis labels with (hkl) and (h'k'l') of orientation vectors.
      
 60   if (rlu) then
         call title(u,zetatitle,len)
         write(xtitle,'(a22,a)') '\gz [rlu] || to ',zetatitle
         write(x2title,'(a22,a)') '\gz [\A\u-1\d] || to ',zetatitle
c         write(xtitle,'(a22,a)') '\gz (rlu) || to ',zetatitle
c         write(x2title,'(a22,a)') '\gz (\A\u-1\d) || to ',zetatitle

         call title(v,etatitle,len)
         write(ytitle,'(a15,i3,a10,a)') '\gy [rlu] ',
     &        int(180.0*angle/pi),' deg from ',etatitle
         write(y2title,'(a15,i3,a10,a)') '\gy [\A\u-1\d] ',
     &        int(180.0*angle/pi),' deg from ',etatitle
c         write(ytitle,'(a15,i3,a10,a)') '\gy (rlu) ',
c     &        int(180.0*angle/pi),' deg from ',etatitle
c         write(y2title,'(a15,i3,a10,a)') '\gy (\A\u-1\d) ',
c     &        int(180.0*angle/pi),' deg from ',etatitle
      else
         call title(u,zetatitle,len)
         write(xtitle,'(a22,a)') '\gz [\A\u-1\d] || to ',zetatitle
         write(x2title,'(a22,a)') '\gz [rlu] || to ',zetatitle
c         write(xtitle,'(a22,a)') '\gz (\A\u-1\d) || to ',zetatitle
c         write(x2title,'(a22,a)') '\gz (rlu) || to ',zetatitle
         call title(v,etatitle,len)
         write(ytitle,'(a15,i3,a10,a)') '\gy [\A\u-1\d] ',
     &        int(180.0*angle/pi),' deg from ',etatitle
         write(y2title,'(a15,i3,a10,a)') '\gy [rlu] ',
     &        int(180.0*angle/pi),' deg from ',etatitle
c          write(ytitle,'(a15,i3,a10,a)') '\gy (\A\u-1\d) ',
c     &        int(180.0*angle/pi),' deg from ',etatitle
c         write(y2title,'(a15,i3,a10,a)') '\gy (rlu) ',
c     &        int(180.0*angle/pi),' deg from ',etatitle
      endif

      return
      end

c===========================================================================
      subroutine init_scanvectors(constq, ec, es, npts, angle, 
     &      en, ei, ef, fe, h, hc, hs, nscan,
     &      mon, bmatuv, q, ki, kf, a4, a3, phimax, fail, pi, 
     &      qarr, kiarr, kfarr, qspur, 
     &      espur, qsparr, esparr, incohmon, incohana,
     &      incmonarr, incanaarr, prev)
cCommon     &      incmonarr, incanaarr, prev, xmin, xmax, ymin, ymax)
     
      implicit none
cDec01      IMPLICIT REAL (A-H,O-Z)
      include 'arraysize.inc'
      include 'spur_scan.inc'
      include 'io_files.inc'

c...	common blocks

c...	functions
      
c...	passed variables
      logical constq
      real ec, es
      integer npts
      real angle, en, ei, ef, fe
      REAL*4 h(3),hc(3),hs(3)
      integer nscan
      CHARACTER*5 mon
      REAL*4 bmatuv(3,3)
      real*4 q(3),ki(2),kf(2)
      real a4, a3
      real phimax
      logical fail
      real pi
      real*4 qarr(2,maxnpts),kiarr(2,maxnpts),kfarr(2,maxnpts)
      real qspur(2,n_spur_max,n_spur_max)
      real espur(n_spur_max,n_spur_max)
      real qsparr(2,n_spur_max,n_spur_max, maxnpts)
      real esparr(n_spur_max,n_spur_max,maxnpts)
      real*4 incohmon(2),incohana(2)
      real*4 incmonarr(2,maxnpts),incanaarr(2,maxnpts)
cCommon      real xmin, xmax, ymin, ymax
      logical prev
      
c...	local variables
      integer k, i, j, l
      real a4_1
      
C  Begin a loop for the points in the scan.

 63   do k=1,npts

C  Calculation of |ki| and |-kf| at (E,Q)
C     
C  value of en for point k         
         en=ec+(k-(float(npts)+1.0)/2.0)*es
C  value of q for point k         
         do i=1,3
            h(i)=hc(i)+(k-(float(npts)+1.0)/2.0)*hs(i)
            if (hs(i).ne.0) constq=.false.
         enddo

 65      if (mon.eq.'(MON)') then
            ei=fe
            ef=ei-en
         else
            ef=fe
            ei=ef+en
         endif

C  Calculation and text display of ki and Q and the scattering angles.

      if ((ei.le.0).or.(ef.le.0)) then
         write(*,'(2a,i2)') 'Non-positive energy at monochromator or ',
     &     'analyser.  Point# ',k
         write(*,'(2a)') 'This point and remaining points will not be',
     &     ' included.'
         write(unitlog,'(2a,i2)') 'Non-positive energy at ',
     &     'monochromator or analyser.  Point# ',k
         write(unitlog,'(2a)') 'This point and remaining points ',
     &     'will not be included.'
         nscan=k-1
         go to 510
      endif

c...	Note: calcki sets "a4_ok(pn) = .false." when scattering triangle
c...	 can not be closed. True otherwise.
      call calcki(bmatuv,h,ei,ef,q,ki,fail,a4,a3,k)

        angle4_store(k) = a4
cDebug	write (*,*) 'init_scanvectors: angle4=',k, 
cDebug     &		angle4_store(k) *180.0 /pi
	if (k .eq. 1) then
	  a4_1 = a4
	  angle4_varies = .false.
	else
	  if (a4_1 .ne. a4) angle4_varies = .true.
	endif

      if (a4.gt.phimax) then
        a4_ok(k) = .false.
 120    format (a,f6.2,a,i2,a,f6.2,a)
         write(*,120) 'A4=',180.0*a4/pi,' at point# '
     &           ,k,' exceeds limit=', (180.0*phimax/pi),'.'
         write(unitlog,120) 'A4=',180.0*a4/pi,' at point# '
     &           ,k,' exceeds limit=', (180.0*phimax/pi),'.'
c02Apr         write(*,'(a,f6.2,a,i2,a,f6.2,a)') 'A4=',180*a4/pi,' at point# '
c02Apr     &           ,k,' exceeds limit=',180*phimax/pi,'.'
c	A4_OK(k) = .false.
c      else
c        A4_OK(k) = .true.
      endif

C      write(*,'(f7.2,2xf7.2)') 180*a3/pi,180*a4/pi

C  Below is a routine that I added to calculate the Q value one would
C  obtain for a TOF type of scan (A3 and A4 fixed) as E changes 
C      phi=pi/180*88.951   ! the value of A4
C      ef=ef+6             ! the value of -E
C      call calckitof(bmat,ei,ef,h,q,phi,ki,u,v,uuv,vuv)
C  part of BT2 bkbo experiment, Nov. 1998

C  use vector arithmetic to calculate kf
      kf(1)=ki(1)-q(1)
      kf(2)=ki(2)-q(2)

C  store the scattering vectors in several arrays
      qarr(1,k)=q(1)
      qarr(2,k)=q(2)
      kiarr(1,k)=ki(1)
      kiarr(2,k)=ki(2)
      kfarr(1,k)=kf(1)
      kfarr(2,k)=kf(2)


C  Spurious scattering [first spurious peak qspur(*,1,1)=q(*)]
C  n is the number of multiple k's to calculate
      call calcspurious(ki,kf, qspur,espur)
cDec01      call calcspurious(ki,kf,n,qspur,espur)
      do i=1,n_spur_max
         do j=1,n_spur_max
            do l=1,2
               qsparr(l,i,j,k)=qspur(l,i,j)
            enddo
            esparr(i,j,k)=espur(i,j)
         enddo
      enddo

C  Spurious scattering from |ki|=|kf| i.e., scattering is
C  incoherent from the monochromator or analyser and
C  Bragg scattering from the other.  Effect will be large
C  when it matches a Bragg peak in the sample.

      call calcincoh(ki,kf,incohmon,incohana)

      do l=1,2
         incmonarr(l,k)=incohmon(l)
         incanaarr(l,k)=incohana(l)
      enddo

      if (.not. prev) then
c...	Already done at the main level. Don't override current values
C  Determine a reasonable scale for the plot using autoscale
C  routine.

C  The principal vectors which must be plotted are the Q and
C  ki and also u and v.

C      call autoscale(n*ki(1),n*ki(2),xmin,xmax,ymin,ymax)
C      call autoscale(uuv(1),uuv(2),xmin,xmax,ymin,ymax)
C      call autoscale(vuv(1),vuv(2),xmin,xmax,ymin,ymax)
      do i=1,n_spur_max
        do j=1,n_spur_max
          call autoscale(qspur(1,i,j),qspur(2,i,j))
cCommon          call autoscale(qspur(1,i,j),qspur(2,i,j),
cCommon     &                   xmin,xmax,ymin,ymax)
        enddo
      enddo

C  Prevents the plot from being excessively lopsided.
      call square()
cCommon      call square(xmin,xmax,ymin,ymax)

       endif
      enddo

      nscan=npts
 510  continue

      return
      end

c===========================================================================
      subroutine prep_elastic_spur(npts, ec, es,  fe, hc, hs, mon)
     
      implicit none
cDec01      IMPLICIT REAL (A-H,O-Z)
      include 'arraysize.inc'
      include 'spur_scan.inc'
      include 'io_files.inc'

c...	common blocks

c...	functions
      
c...	passed variables
      integer npts
      real ec, es
      real fe
      REAL*4 hc(3), hs(3)
      CHARACTER*5 mon
      
c...	local variables
      integer ii, jj, j
      real ei, ef
      real k_real, e_real
      real e_check
      real h(3)
      
C  value of en for point k         
c         en=ec+(k-(float(npts)+1.0)/2.0)*es

      n_zeroelst = 0
c23456789_123456789_123456789_123456789_123456789_123456789_123456789_12
cDebug      write (*,*) 'prep_elastic_spur: Entered'
      write (*,*) '&&& Elastic spurions within scan range at:'
      write (unitspur,*) '&&& Elastic spurions within scan range at:'
      do ii=1,n_spur_max
        do jj=1,n_spur_max
	 if (.not. (ii .eq. jj)) then
c	Elastic spurion condition: ii*ei - jj*ef = 0	
c		From calcspurious()    
          if (mon.eq.'(MON)') then
            ei=fe
	    k_real =(float(npts)+1.0)/2.0 
     &	    	+(1.0-(float(ii)/float(jj))**2)*(ei/es) -ec/es
	    e_real = ec+(k_real-(float(npts)+1.0)/2.0)*es
	    ef = ei - e_real
          else
            ef=fe
	    k_real =(float(npts)+1.0)/2.0 
     &	     	-(1.0-(float(jj)/float(ii))**2)*(ef/es) -ec/es
	    e_real = ec+(k_real-(float(npts)+1.0)/2.0)*es
	    ei = ef + e_real
          endif
	  e_check = (float(ii)**2) * ei - (float(jj)**2)*ef

            do j=1,3
               h(j)=hc(j)+(k_real-(float(npts)+1.0)/2.0)*hs(j)
            enddo

cDebug	  write (*,*) 'prep_elastistic_spur: ', ii, '*ki -', jj, '*kf',
cDebug     &	    ' elast. at k=', k_real
cDebug          write (*,*) 'prep_elastistic_spur: ', 
cDebug     &	  	ii, '^2 *ei - ', jj, '^2 * ef = 0 = ', e_check
cDebug          write (*,*) 'prep_elastistic_spur: ', 
cDebug     &	  	'ei = ', ei,  ' ef = ', ef

	  if ((k_real .ge. 1.0) .and. (k_real .le. float(npts)) ) then
	    write (*,110) ii, jj,  k_real, 
     &		    h(1), h(2), h(3), e_real 
	    write (unitspur,110) ii, jj,  k_real, 
     &		    h(1), h(2), h(3), e_real 
110 	    format (i1,'*ki - ',  i1, '*kf at scan pt= ', f7.2,
     &		' Q=(',  f6.2, ',', f6.2, ',', f6.2, ') A^-1 dE=', f7.3) 
cDebug	    write (*,*) 'Elastic spurion ', ii, '*ki -', jj, '*kf',
cDebug     &	    ' at scan point ', k_real, 
cDebug     &	    ' dE=', e_real	!! ec+(k_real-(float(npts)+1.0)/2.0)*es
cDebug          write (*,*) 'prep_elastistic_spur: ', 
cDebug     &	  	ii, '^2 *ei - ', jj, '^2 * ef = 0 = ', e_check
cDebug          write (*,*) 'prep_elastistic_spur: ', 
cDebug     &	  	'ei = ', ei,  ' ef = ', ef
cDebug	  write (*,*)
	    n_zeroelst = n_zeroelst +1
	    iscan_zerospur(n_zeroelst) = k_real
	    ii_zerospur(n_zeroelst) = ii
	    jj_zerospur(n_zeroelst) = jj
	  endif
	 endif
        enddo
      enddo

      return
      end


c=====================================================================            
      subroutine init_qrange(qmin, qmax, qlowmin, qlowmax,
     &       nscan, kiarr, kfarr, phimax)
      
      implicit none
      include 'arraysize.inc'
c      include 'io_files.inc'

c...	common blocks

c...	functions
      
c...	passed variables
      real qmin,qmax
      real qlowmin,qlowmax
      integer nscan
      real*4 kiarr(2,maxnpts),kfarr(2,maxnpts)
      real phimax

c...	local variables
      real qlow1,qlow2
      real qex

C  Calculate the maximum obtainable Q (cosine law)
C  for the first and last point of the scan

      qex=sqrt(kiarr(1,1)**2.0+kiarr(2,1)**2.0+
     &         kfarr(1,1)**2.0+kfarr(2,1)**2.0-
     &  2*sqrt(kiarr(1,1)**2.0+kiarr(2,1)**2.0)*
     &    sqrt(kfarr(1,1)**2.0+kfarr(2,1)**2.0)*cos(phimax))

      qlow1=abs(sqrt(kiarr(1,1)**2.0+kiarr(2,1)**2.0)-
     &         sqrt(kfarr(1,1)**2.0+kfarr(2,1)**2.0))

      qmin=qex
      qmax=qex

      qex=sqrt(kiarr(1,nscan)**2.0+kiarr(2,nscan)**2.0+
     &         kfarr(1,nscan)**2.0+kfarr(2,nscan)**2.0-
     &  2*sqrt(kiarr(1,nscan)**2.0+kiarr(2,nscan)**2.0)*
     &    sqrt(kfarr(1,nscan)**2.0+kfarr(2,nscan)**2.0)*cos(phimax))

      qlow2=abs(sqrt(kiarr(1,nscan)**2.0+kiarr(2,nscan)**2.0)-
     &         sqrt(kfarr(1,nscan)**2.0+kfarr(2,nscan)**2.0))

      if (qex.gt.qmax) qmax=qex
      if (qex.lt.qmin) qmin=qex

      if (qlow1.lt.qlow2) then
         qlowmin=qlow1
         qlowmax=qlow2
      else
         qlowmin=qlow2
         qlowmax=qlow1
      endif

C      write(*,'(a,f5.2)')
C     & 'With this Ei and Ef the max attainable Q is ',qmax
     
      return
      end

cc=====================================================================            
c      subroutine init_qrange_alternative(qmin, qmax, qlowmin, qlowmax,
c     &       nscan, kiarr, kfarr, phimax)
c      
c      implicit none
c      include 'arraysize.inc'
cc      include 'io_files.inc'
c
cc...	common blocks
c
cc...	functions
c      
cc...	passed variables
c      real qmin,qmax
c      real qlowmin,qlowmax
c      integer nscan
c      real*4 kiarr(2,maxnpts),kfarr(2,maxnpts)
c      real phimax
c
cc...	local variables
c      real qlow1,qlow2
c      real qex
c      integer k
c      real q_k
c      
c      do k = 1, nscan
c        q_k = sqrt(kiarr(1,k)**2.0+kiarr(2,k)**2.0+
c     &         kfarr(1,k)**2.0+kfarr(2,k)**2.0-
c     &  2*sqrt(kiarr(1,k)**2.0+kiarr(2,k)**2.0)*
c     &    sqrt(kfarr(1,k)**2.0+kfarr(2,k)**2.0)*cos(angle4_store(k)))
c	if ((.not. A4_OK(k) .and. (angle4_store(k) .lt. acos(-1.0)) then
c	  qmin = max(qmin, q_k)
c	  qlowmin = min(qlowmin, q_k)
c	endif
c      enddo
c
c
cC  Calculate the maximum obtainable Q (cosine law)
cC  for the first and last point of the scan
c
c      qex=sqrt(kiarr(1,1)**2.0+kiarr(2,1)**2.0+
c     &         kfarr(1,1)**2.0+kfarr(2,1)**2.0-
c     &  2*sqrt(kiarr(1,1)**2.0+kiarr(2,1)**2.0)*
c     &    sqrt(kfarr(1,1)**2.0+kfarr(2,1)**2.0)*cos(phimax))
c
c      qlow1=abs(sqrt(kiarr(1,1)**2.0+kiarr(2,1)**2.0)-
c     &         sqrt(kfarr(1,1)**2.0+kfarr(2,1)**2.0))
c
c      qmin=qex
c      qmax=qex
c
c      qex=sqrt(kiarr(1,nscan)**2.0+kiarr(2,nscan)**2.0+
c     &         kfarr(1,nscan)**2.0+kfarr(2,nscan)**2.0-
c     &  2*sqrt(kiarr(1,nscan)**2.0+kiarr(2,nscan)**2.0)*
c     &    sqrt(kfarr(1,nscan)**2.0+kfarr(2,nscan)**2.0)*cos(phimax))
c
c      qlow2=abs(sqrt(kiarr(1,nscan)**2.0+kiarr(2,nscan)**2.0)-
c     &         sqrt(kfarr(1,nscan)**2.0+kfarr(2,nscan)**2.0))
c
c      if (qex.gt.qmax) qmax=qex
c      if (qex.lt.qmin) qmin=qex
c
c      if (qlow1.lt.qlow2) then
c         qlowmin=qlow1
c         qlowmax=qlow2
c      else
c         qlowmin=qlow2
c         qlowmax=qlow1
c      endif
c
cC      write(*,'(a,f5.2)')
cC     & 'With this Ei and Ef the max attainable Q is ',qmax
c     
c      return
c      end


c=====================================================================            
      subroutine plot_center(u, v, uuv, vuv, hklcen)
      implicit none
      include 'spur_layout.inc'

c...	common blocks

c...	functions
      
c...	passed variables
      INTEGER u(3),v(3)
      REAL*4 uuv(3),vuv(3)
      integer hklcen(3)

c...	local variables
      real xcen,ycen
      integer  nv, nu, i

C  When calculating the reciprocal lattice it should cover the range
C  of the spurions and the plot range.  This is easiest to do provided
C  that the reciprocal lattice and the plot have the same center.

      xcen=(xmax+xmin)/2.0
      ycen=(ymax+ymin)/2.0

C      xcen=0.0
C      ycen=0.0
      
C  the reciprocal lattice program will require an h-centre, k-centre,
C  and an l-centre to do this right.
C  v is the only thing that has a y-component
      nv=int(ycen/vuv(2))
C  which allows us to calculate the number of u vectors
      nu=int((xcen-vuv(1)*ycen/vuv(2))/uuv(1))

C  this is the hkl at roughly the centre of the plot

      do i=1,3
        hklcen(i)=nu*u(i)+nv*v(i)
      enddo
      
C      write(*,*) (hklcen(i),i=1,3)
      
      return
      end


cc==========================================================================
      subroutine plot_axes(uxvi, qztitle, rlu, right, axis,
cCommon     &      xmin, xmax, ymin, ymax,
     &      xtitle,ytitle, x2title,y2title, 
     &	    maintitle, xstar, ystar, 
     &      qmin, qmax, qlowmin, qlowmax, version_stamp)
C  setup the plot: axes, ticks, tick labels
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'

c...	passed variables

      INTEGER uxvi(3)
      character*10 qztitle
      logical rlu, right
      integer axis
cCommon      real xmin, xmax, ymin, ymax
      CHARACTER*41 xtitle,ytitle,maintitle
      CHARACTER*41 x2title,y2title
      real xstar,ystar
      real qmin, qmax
      real qlowmin, qlowmax
      character*(80) version_stamp

c...	local variables
      integer len
      real temp1, temp2
      
C  setup the plot: axes, ticks, tick labels

 67   CALL PGSCH (1.5)
      call pgsls(1)  ! solid line style
      call pgsci(color_ink)  ! opposite to BG colour
c01Dec      call pgsci(1)  ! opposite to BG colour
      
      call title(uxvi,qztitle,len)  ! setup main title
      if (rlu) then
         axis=-1
      else
         axis=0
      endif


      if (right) then
        call init_pg2d(axis)
cCommon        call init_pg2d(xmin, xmax, ymin, ymax, axis)
c02Jan     &              1, axis)
c02Jan        CALL pgenv (xmin, xmax, ymin, ymax,
c02Jan     &              1, axis)
        write(maintitle,'(a31,a,a1)') 'RH Scattering Plane Normal to [',
     &    qztitle(2:len-1),']'
      else  
C  Flipping xmin and xmax in the viewport gives a left-handed spectrometer.
        call init_pg2d(axis)
cCommon        call init_pg2d(xmax, xmin, ymin, ymax, axis)
c02Jan        CALL pgenv (xmax, xmin, ymin, ymax, 
c02Jan     &              1, axis)
        write(maintitle,'(a31,a,a1)') 'LH Scattering Plane Normal to [',
     &    qztitle(2:len-1),']'
      endif

      if (rlu) then
	 temp1 = xmin/xstar
	 temp2 = xmax/xstar
c        call PGAXIS (OPT='N', X1, Y1, X2, Y2, V1, V2, 
c     :                   STEP=0.0, NSUB=1, DMAJL=0.0, DMAJR=0.5, 
c		FMIN=0.5, DISP=0.5, ORIENT=0)
         call pgaxis('N',xmin,ymin,xmax,ymin, temp1, temp2,
     &     0.0, 1, 0.5,0.5, 0.5, 0.5,0.0)

c	 ! now add the other units (A) on the top
         call pgsci(color_darkgrey)
c        call PGAXIS (OPT='N', X1, Y1, X2, Y2, V1, V2, 
c     :                   STEP=0.0, NSUB=1, DMAJL=0.0, DMAJR=0.5, 
c		FMIN=0.5, DISP=0.5, ORIENT=0)

c...	Let's put tick marks on both sides and the inside ones will be erased.
         call pgaxis('N',xmin,ymax,xmax,ymax, xmin, xmax,
     &     0.0, 1, 0.5, 0.5, 0.5, -0.5,0.0)
         call PGMTXT ('T', 1.5, 0.5, 0.5, x2title)
         call pgsci(color_ink)
	 
      	 temp1 = ymin/ystar
	 temp2 = ymax/ystar
c	 write (*,*) 'init_pg2d: ystar=', ystar, temp1, temp2, 
c     &	 xmin/xstar, xmax/xstar

         call pgaxis('N',xmin,ymin,xmin,ymax, temp1, temp2,
     &     0.0, 1, 0.5,0.5, 0.5, -0.75,0.0)

c	! now add the other units (A) on the right hand side
         call pgsci(color_darkgrey)
c...	Let's put tick marks on both sides and the inside ones will be erased.
         call pgaxis('N',xmax,ymin,xmax,ymax, ymin, ymax,
     &     0.0, 1, 0.5,0.5, 0.5, 0.5,0.0)
c         call PGMTXT (SIDE, DISP, COORD, FJUST, TEXT)
         call PGMTXT ('R', 2.25, 0.5, 0.5, y2title)
         call pgsci(color_ink)

c01Nov         call pgaxis('N',xmin,ymin,xmax,ymin,xmin/xstar,xmax/xstar,
c01Nov     &     0.0,1,0.0,0.5,0.5,0.5,0.0)
c01Nov         call pgaxis('N',xmin,ymin,xmin,ymax,ymin/ystar,ymax/ystar,
c01Nov     &     0.0,1,0.5,0.0,0.5,-0.75,0.0)
      else
c	 ! now add the other units (rlu) on the top
	 temp1 = xmin/xstar
	 temp2 = xmax/xstar
         call pgsci(color_darkgrey)
         call pgaxis('N',xmin,ymax,xmax,ymax, temp1, temp2,
     &     0.0, 1, 0.5, 0.5, 0.5, -0.5,0.0)
         call PGMTXT ('T', 1.5, 0.5, 0.5, x2title)
         call pgsci(color_ink)

c	! now add the other units (rlu) on the left hand side
      	 temp1 = ymin/ystar
	 temp2 = ymax/ystar
         call pgsci(color_darkgrey)
         call pgaxis('N',xmax,ymin,xmax,ymax, temp1, temp2,
     &     0.0, 1, 0.5,0.5, 0.5, 0.5,0.0)
         call PGMTXT ('R', 2.25, 0.5, 0.5, y2title)
         call pgsci(color_ink)

      endif

C  shade background in grey (note this overwrites the plot frame)
      call pgsfs(1)    ! a fill-style of 1 is solid
      call pgsci(color_lightgrey)   ! a grey colour 
c01Dec      call pgsci(60)   ! a grey colour 
      call PGRECT (xmin, xmax, ymin, ymax)

C  Blacken (or make it the background colour 0) a region of maximum
C  accessible Q (circle is still filled)
      
      call pgsci(color_bkgr)
c01Dec      call pgsci(0)
      call pgcirc(0.0,0.0,qmax)

      call pgsci(color_ink)     ! opposite BG color
c01Dec      call pgsci(1)     ! opposite BG color
      call pgsfs(2)     ! outline only
      call pgsls(2)     ! dashed line
      call pgcirc(0.0,0.0,qmin)
      call pgcirc(0.0,0.0,qlowmax)
      call pgsls(1)

C add something new, shade in grey the area of inaccessible low Q

      call pgsfs(1)    ! a fill-style of 1 is solid
      call pgsci(color_lightgrey)   ! a grey colour 
c01Dec      call pgsci(60)   ! a grey colour 
      call pgcirc(0.0,0.0,qlowmin)
      call pgsci(color_ink)
c01Dec      call pgsci(1)
      call pgsfs(2)

C  Have to redraw axes since they have overlaid by previous
C  commands.  The tick marks will be outside since PGPLOT_ENVOPT=I.

      call PGSCLP(0)    ! disable vprt clipping to ensure axes are visible 
      call pgrect (xmin,xmax,ymin,ymax)
      call pgsclp(1)    ! renable clipping
      call pgsfs(1)     ! solid fill style

C  Put on the previously determined labels.
      
c02Mar      CALL pglab (xtitle,ytitle,maintitle)
      CALL pglab (xtitle,ytitle,' ')
      call PGMTXT ('T', 3.0, 0.5, 0.5, maintitle)

c	Put on user name, time and date stamp
c02Jan      call pgiden()

ccc      call    sketch_layout()
      call    plot_stamp(version_stamp)    

C
      return
      end

cc==========================================================================
      subroutine plot_Q_ki_kf(qarr, kiarr, nscan)     
C  Plot Q, ki, kf  with a heavy line.

      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'

c...	passed variables
      real*4 qarr(2,maxnpts),kiarr(2,maxnpts)   !!,kfarr(2,maxnpts)
      integer nscan
      
c...	local variables
      integer itemp, i

C  Plot Q with a heavy line.
      
      call pgsci(color_ink)
c01Dec      call pgsci(1)
      call pgqlw(i)
      itemp = 3*i
      call pgslw(itemp)                   ! triple the thickness
c01Nov      call pgslw(3*i)                   ! triple the thickness
      CALL pgarro(0.0,0.0,qarr(1,1),qarr(2,1))
      CALL pgarro(0.0,0.0,qarr(1,nscan),qarr(2,nscan))
      call pgslw(i)


C  Plot ki and kf

      call pgsls(2)                     ! dashed line 
      CALL pgarro(0.0,0.0,kiarr(1,1),kiarr(2,1))
      CALL pgarro(kiarr(1,1),kiarr(2,1),qarr(1,1),qarr(2,1))
      call pgsls(1)

      call pgsls(2)                     ! dashed line 
      CALL pgarro(0.0,0.0,kiarr(1,nscan),kiarr(2,nscan))
      CALL pgarro(kiarr(1,nscan),kiarr(2,nscan),qarr(1,nscan),
     &            qarr(2,nscan))
      call pgsls(1)

C  End of default plot

      return
      end


c=============================================================================

      subroutine load_menuitems()
       
      implicit none
      include 'io_files.inc'
      include 'spur_menu.inc'

c...	passed variables 
      
      spurmenuitem(bit_spur) = char_spur
      spurmenuitem(bit_incoh) = char_incoh
      spurmenuitem(bit_al) = char_al
      spurmenuitem(bit_orientvec) = char_orientvec
      spurmenuitem(bit_labelvec) = char_labelvec
      spurmenuitem(bit_grid) = char_grid
      spurmenuitem(bit_mod) = char_mod

      spurmenuitem(bit_tol) = char_tol
      spurmenuitem(bit_bumpA4) = char_bumpA4
      spurmenuitem(bit_reflect) = char_reflect
cRemoved      spurmenuitem(bit_units) = char_units

      spurmenuitem(bit_zoomspur) = char_zoomspur
      spurmenuitem(bit_rescale) = char_rescale

      spurmenuitem(bit_structmenu) = char_structmenu	!! New menu
cMoved      spurmenuitem(bit_showintensities) = char_showintensities
cMoved      spurmenuitem(bit_circsize) = char_circsize
cMoved      spurmenuitem(bit_showsort) = char_showsort
cMoved      spurmenuitem(bit_sortlog) = char_sortlog
cMoved      spurmenuitem(bit_absent) = char_absent
      spurmenuitem(bit_annote) = char_annote

      spurmenuitem(bit_device) = char_device

      spurmenuitem(bit_default) = char_default
      spurmenuitem(bit_qbufout) = char_qbufout
      spurmenuitem(bit_ICP) = char_ICP
      spurmenuitem(bit_help) = char_help
      spurmenuitem(bit_quit) = char_quit
      
      return
      end

c=============================================================================

      subroutine load_menu()
       
      implicit none
      include 'io_files.inc'
      include 'spur_menu.inc'

c...	passed variables 
      
      spurmenu(bit_spur) = 
     & 'Toggle plot higher-order scattering spurions'
      spurmenu(bit_incoh) = 
     & 'Toggle plot incoherent scattering spurions'
      spurmenu(bit_al) = 
     & 'Toggle plot aluminum Ewald spheres'
      spurmenu(bit_orientvec) = 
     & 'Toggle plot u and v orientation vectors'
      spurmenu(bit_labelvec) = 
     & 'Toggle label Q, Ki and Kf wavevectors'
      spurmenu(bit_grid) = 
     & 'Toggle overlay grid on lattice plot'
      spurmenu(bit_mod) = 
     & 'Modify Q, E, and other Q-buffer values'
c     & 'Modify Q, E, and other buffer values'
      spurmenu(bit_tol) =
     & 'Change the rlv, energy spurion tolerances'
      spurmenu(bit_bumpA4) = 
     & 'BUMP! change maximum A4'
      spurmenu(bit_reflect) = 
     & 'Sf^2 for an (hkl) reflection'
cRemoved      spurmenu(bit_units) = 
cRemoved     & 'Toggle rlu - AA^-1 units'

c...	New menu item for the scan page; the spurion energy plot
      spurmenu(bit_zoomspur) = 
     & 'Zoom spurion energy plot (0,0,0,0 for auto)' 

      spurmenu(bit_rescale) = 
     & 'Rescale plot (reverse xmin and xmax for left)'

      spurmenu(bit_structmenu) = 
     & 'Presentation of structure factors menu'
c     & 'Presentation of lattice plot intensities menu'

cMoved      spurmenu(bit_showintensities) = 
cMoved     & 'Change display of Sf^2 (circles/#, grey/color)' 
ccc     & 'Change display of structure factor intensities (circles,#)' 

cMoved      spurmenu(bit_circsize) =
cMoved     & 'Change circ size (<0 vary, >0 uni, 0 no struct)'
ccc     & 'Change circ size '

cMoved      spurmenu(bit_showsort) = 
cMoved     & 'Toggle sorting of Sf^2 intensities display'
c     & 'Show sorting of intensities'

cMoved        spurmenu(bit_sortlog) = 
cMoved     & 'Select bunching S^2 = base^n or +_ tiny'
cc        spurmenu(bit_sortlog) = 
cc     & 'Bunch sorting by S^2 = base^n, rather than +_ tiny'
c      if (sortlogscale) then
c        write (spurmenu(bit_sortlog) , '(a, a, g12.5, a)') 
c     &   'Toggle logscale for S^2 sort multiplicity. ', 
c     &   '(', tolerance, ')^n.' 
c      else
c        write (spurmenu(bit_sortlog) , '(a, a, g12.5, a)') 
c     &   'Toggle logscale for S^2 sort multiplicity. ', 
c     &   '+- ', tolerance, '.' 
c      endif

cMoved      spurmenu(bit_absent) = 
cMoved     & 'Toggle hiding of the systematic absences'

      spurmenu(bit_annote) = 
     & 'Toggle display of notes next to plot'
c     & 'Toggle display of annotations next to plot'

      spurmenu(bit_device) = 
     & 'Printout/ change graphics device'

      spurmenu(bit_default) = 
     & 'Start over with defaults or new files'
c     & 'Start picture over with defaults'
      spurmenu(bit_qbufout) = 
     & 'Write out Q-buffer to a file'
c     & 'Write out to a buffer'
      spurmenu(bit_ICP) =
     & 'Generate spectrometer angles-ICP dry run'
      spurmenu(bit_help) = 
     & 'HELP!!'
      spurmenu(bit_quit) =
     & 'to quit'

      
      return
      end

c=============================================================================

      subroutine load_stndannote()
       
      implicit none
      include 'io_files.inc'
      include 'spur_menu.inc'
      include 'spur_annote.inc'

c...	passed variables 
c      character*80 stndannote(len_menu)
     
c...	local variables
      integer i
      
      nullstring = ''
      
      annoteoptions = 0
      do i = 1, bit_annote -1
        stndannote(i) = spurmenu(i)
      enddo

      do i = bit_annote, len_menu
        stndannote(i) = ' '
      enddo

      do i = len_menu + 1, max_annote
        stndannote(i) = ' '
      enddo

c...	Override with better descriptions

      stndannote(bit_spur) = 
     &'Spurions in yellow (red for elastic scattering, dE=0)'

      stndannote(bit_incoh) = 
     &'Incoh spurions from MON in cyan, ANA in blue'
c02Mar     &'Incoh spurions mon/ana(arrow) cyan(magneta)/blue(purple)'
ccc     &'Incoh spurions cyan(mon),blue(ana).Magenta/purple at peaks'

      stndannote(bit_al) = 
     &'Backgrd Al Ewald spheres in green. Red w/i tol of scan'

      stndannote(bit_orientvec) = 
     &'Xtl orientation vectors (u,v) are magenta'
     
      call set_bit(annoteoptions, bit_labelvec, 1)
      stndannote(bit_labelvec) = 
     &'Inked vectors are Q, ki, -kf at lims Ei(dash) to Ef(grey)'

c      call set_bit(annoteoptions, bit_showintensities, 1)
c      stndannote(bit_showintensities) = 
c     & 'Absences indicated by green circles. '

cccc    ' ...Show structure factor intensities (circles,#)' 
c      stndannote(bit_circsize) =
c     & '...Change circ size (<0 vary, >0 uni, 0 no struct)'

c...	debug
cDebug      do i = 1, max_annote
cDebug	write (*,*) 'load_stndannote:', i , stndannote(i)
cDebug      enddo
      
      return
      end

c=============================================================================
      subroutine load_itemvalue(tol, etol, 
cMoved     &		c, struct,
cMoved     &      gray, rainbow, plotunique, sortlogscale, tolerance, 
     &      phimax, rlu, right, selct_sp, selct_sfhkl, over,
     &	    m_rlv, nabsent, npresent, nspurtot, nelastic, nal_match,
     &	    nincohmon, nincohana, grid_style, grid_size1, grid_size2,
     &	    hide_absences)
       

      implicit none
      include 'io_files.inc'
      include 'spur_menu.inc'
      include 'spur_layout.inc'
c      include 'arraysize.inc'
c      include 'spur_scan.inc'

c...	functions
      logical bit_on
      integer ilen

c...	passed variables 
      real tol, etol, phimax
cMoved      real c, tolerance
cMoved      logical gray, rainbow
cMoved      logical plotunique, sortlogscale, struct
      logical rlu, right, over
      integer selct_sp(3)
      real	selct_sfhkl
      integer 	m_rlv, nabsent, npresent, nspurtot, nelastic
      integer  nal_match
      integer	nincohmon, nincohana
      character*1 grid_style		!!c: cartesian, o:orientation vectors
      real	grid_size1, grid_size2	!! step size in rlu, for x/u, y/v
      logical	hide_absences
      
c...    local variables
      integer i
      logical debug
      parameter (debug = .false.)
c      parameter (debug = .true.)
      
cDebug      if (debug) write (*,*) 'load_itemvalue: null strings'
      do i = 1, len_menu 
        spuritemvalue(i) = ''
      enddo
cDebug      if (debug) write (*,*) 'load_itemvalue: null strings loaded'

      write (spuritemvalue(bit_default), '(a)')  
     &      file_bufin(1:min(20,ilen(file_bufin)))
c02May      write (spuritemvalue(bit_default), '(a)')  
c02May     &      file_bufin(1:ilen(spuritemvalue))
c02Mar      write (spuritemvalue(bit_default), '(a)')  
c02Mar     &      file_bufin	
cDebug      if (debug) write (*,*)'load_itemvalue: ', 
cDebug     &      'report_menuitem(bit_default)'
      if (debug) call report_menuitem(bit_default)
      
c      if (debug) write (unitdebug, *) 'load_itemvalue: tol=', tol 
c      write (spuritemvalue(bit_tol), '(g12.5, a6)')  tol, ' AA^-1'
      write (spuritemvalue(bit_tol), '(f6.3, a5, f5.2, a4)')  
     &      tol, ' A^-1 ', etol, ' meV'	
c      write (spuritemvalue(bit_tol), '(g12.5)')  tol
cDebug      if (debug) write (*,*)'load_itemvalue: report_menuitem(bit_tol)'
      if (debug) call report_menuitem(bit_tol)
      
c      if (debug) write (unitdebug, *) 'load_itemvalue: gray=', gray 
cMoved      if (.not. struct) then
cMoved        write (spuritemvalue(bit_showintensities), *) 
cMoved     &		'No struct circles'
cMoved      else if ((gray) .and. (c .lt. 0)) then
cMoved	if (rainbow) then
cMoved          write (spuritemvalue(bit_showintensities), *)
cMoved     &		'varying colr circles'
cMoved	else
cMoved          write (spuritemvalue(bit_showintensities), *)
cMoved     &		'varying gray circles'
cMoved	endif
cMoved      else if ((gray) .and. (c .ge. 0)) then
cMoved	if (rainbow) then
cMoved          write (spuritemvalue(bit_showintensities), *) 
cMoved     &		'uniform colr circles'
cMoved        else
cMoved          write (spuritemvalue(bit_showintensities), *) 
cMoved     &		'uniform gray circles'
cMoved	endif
cMoved      else
cMoved	if (rainbow) then
cMoved          write (spuritemvalue(bit_showintensities), *) 'gray #s'
cMoved	else
cMoved          write (spuritemvalue(bit_showintensities), *) 'color #s'
cMoved	endif
cMoved      endif
cMoved      if (debug) call report_menuitem(bit_showintensities)
      
c      if (debug) write (unitdebug, *) 'bit_circsize=>', c, struct
cMoved      write (spuritemvalue(bit_circsize), 90) c, struct
cMoved 90   format( f10.3, ' struct=', L1)
c      write (spuritemvalue(bit_circsize), *) c
cMoved      if (debug) call report_menuitem(bit_circsize)

c      if (debug) write (unitdebug, *) 'load_itemvalue: plotunique', plotunique
cMoved      if (plotunique) then
cMoved        write (spuritemvalue(bit_showsort), *) 'ABC..cba labels'
cMoved      else
cMoved        write (spuritemvalue(bit_showsort), *) 'no sorting shown '
cMoved      endif
cMoved      if (debug) call report_menuitem(bit_showsort)

cMoved      if (hide_absences) then
cMoved        write (spuritemvalue(bit_absent), *) 'absences hidden'
cMoved      else
cMoved        write (spuritemvalue(bit_absent), *) 'absences crosses'
cMoved      endif
cMoved      if (debug) call report_menuitem(bit_absent)

cDebug      write (unitdebug, *) 'load_itemvalue: sort=', sortlogscale,
cDebug     &      	tolerance  
c        spurmenu(bit_sortlog) = 
c     & 'Bunch sorting by S^2 = base^n, rather than +_ tiny'
cMoved      if (sortlogscale) then
cMoved        write (spuritemvalue(bit_sortlog) , '(a, g12.5, a)') 
cMoved     &   '(', tolerance, ')^n' 
cMoved      else
cMoved        write (spuritemvalue(bit_sortlog) , '(a, g12.5)') 
cMoved     &   '+- ', tolerance 
cMoved      endif
cMoved      if (debug) call report_menuitem(bit_sortlog)

cDebug      write (unitdebug, *) 'load_itemvalue: phimax=', phimax
      write (spuritemvalue(bit_bumpa4), '(g12.5, a)') 
     &      phimax*180.0/acos(-1.0), ' degs' 
      if (debug) call report_menuitem(bit_bumpa4)

cDebug      write (unitdebug, *) 'load_itemvalue: rlu=', rlu 
cRemoved      if (rlu) then
cRemoved        write (spuritemvalue(bit_units),*) 'rlu'
cRemoved      else
cRemoved        write (spuritemvalue(bit_units),*) 'AA^-1'
cRemoved      endif
      
cDebug      write (unitdebug, *) 'load_itemvalue: right=', right
      if (auto_xmin_sc)  then 
        write (spuritemvalue(bit_zoomspur)(1:4), '(i3, 1x)') 0
      else
        write (spuritemvalue(bit_zoomspur)(1:4),'(i3,1x)') nint(xmin_sc)
cDebug	write (*,*) 'load_itemvalue: xmin_sc=', xmin_sc
      endif

      if (auto_xmax_sc)  then 
        write (spuritemvalue(bit_zoomspur)(5:8), '(i3, 1x)') 0
      else
        write (spuritemvalue(bit_zoomspur)(5:8),'(i3,1x)') nint(xmax_sc)
cDebug 	write (*,*) 'load_itemvalue: xmax_sc=', xmax_sc
      endif
      
      if (auto_ymin_sc_hs)  then 
        write (spuritemvalue(bit_zoomspur)(9:14),'(f5.1,1x)') 0.0
      else
	if (abs(ymin_sc_hs) .ge. 100.0) then
cDebug	  if (debug) write (*,*) 'load_itemvalue: ymin_sc_hs=', ymin_sc_hs
          write (spuritemvalue(bit_zoomspur)(9:14),'(i5,1x)') 
     &		  nint(ymin_sc_hs)
	else if (abs(ymax_sc_hs) .ge. 10.0) then
          write (spuritemvalue(bit_zoomspur)(9:14),'(f5.1,1x)')
     &		  ymin_sc_hs
	else
          write (spuritemvalue(bit_zoomspur)(9:14),'(f5.2,1x)')
     &	  	ymin_sc_hs
	endif
c02Mar        write (spuritemvalue(bit_zoomspur)(9:14),'(f5.1,1x)') ymin_sc_hs
      endif
      
      if (auto_ymax_sc_hs)  then 
        write (spuritemvalue(bit_zoomspur)(15:20),'(f5.1,1x)') 0.0
      else
	if (abs(ymax_sc_hs) .ge. 100.0) then
          write (spuritemvalue(bit_zoomspur)(15:20),'(i5,1x)') 
     &		  nint(ymax_sc_hs)
	else if (abs(ymax_sc_hs) .ge. 10.0) then
          write (spuritemvalue(bit_zoomspur)(15:20),'(f5.1,1x)')
     &		  ymax_sc_hs
	else
          write (spuritemvalue(bit_zoomspur)(15:20),'(f5.2,1x)')
     &	  	ymax_sc_hs
	endif
      endif
      if (debug) call report_menuitem(bit_zoomspur)

c      if      ((     auto_ymin_sc_hs) .and. (auto_ymin_sc_hs)) then
c        write (spuritemvalue(bit_zoomspur),*) 'auto auto'
c      else if ((.not.auto_ymin_sc_hs) .and. (auto_ymin_sc_hs)) then
c        write (spuritemvalue(bit_zoomspur),*) ymin_sc_hs, ' auto'
c      else if ((     auto_ymin_sc_hs) .and.(.not.auto_ymin_sc_hs)) then
c        write (spuritemvalue(bit_zoomspur),*) 'auto ', ymax_sc_hs
c      else if ((.not.auto_ymin_sc_hs).and.(.not.auto_ymin_sc_hs)) then
c        write (spuritemvalue(bit_zoomspur),*) ymin_sc_hs, ymax_sc_hs
c      endif


      if (right) then
c					      123456789_123456789_	
        write (spuritemvalue(bit_rescale),*) 'Right handed spectm'
      else
        write (spuritemvalue(bit_rescale),*) 'Left handed spectm'
      endif
      if (debug) call report_menuitem(bit_rescale)

cDebug      write (unitdebug, *) 'load_itemvalue: selct_sfhkl=', selct_sfhkl      
      write (spuritemvalue(bit_reflect), 101)
C     &      '( '(', I2, ',' I2, ',', I2, ')' )')
     &       (selct_sp(i), i = 1, 3), selct_sfhkl
101   format ('(', I2, ',', I2, ',', I2, ')=', g9.2 ) !! 5char + 6I +9=20
      if (debug) call report_menuitem(bit_reflect)

cDebug      write (unitdebug, *) 'load_itemvalue: over=', over
      if (over) then
        write (spuritemvalue(bit_labelvec),*) 'Overwrite labels'
      else
        write (spuritemvalue(bit_labelvec),*) ' '
      endif
      if (debug) call report_menuitem(bit_labelvec)

      if ( bit_on(currentoptions, bit_grid)) then
        write (spuritemvalue(bit_grid),150) grid_style, 
     &		grid_size1, grid_size2
 150    format (a1, ':', 1x,  f5.3, 1x, f5.3)
      else
        write (spuritemvalue(bit_grid),*) ' '
      endif

cDebug      write (unitdebug, *) 'load_itemvalue: qbufout='
      if ( bit_on(currentoptions, bit_qbufout)) then
        write (spuritemvalue(bit_qbufout),*) 
     &		file_bufout(1:min(20,ilen(file_bufout)))
c02May        write (spuritemvalue(bit_qbufout),*) file_bufout
      else
        write (spuritemvalue(bit_qbufout),*) 'no bufout yet'
      endif
      if (debug) call report_menuitem(bit_qbufout)
      
cDebug      write (unitdebug, *) 'load_itemvalue: icp'
      if ( bit_on(currentoptions, bit_icp)) then
        write (spuritemvalue(bit_icp),*)
     &		 file_icp(1:min(20,ilen(file_icp)))
c02May        write (spuritemvalue(bit_icp),*) file_icp
      else
        write (spuritemvalue(bit_icp),*) 'no icp yet'
      endif
      if (debug) call report_menuitem(bit_icp)

cDebug      write (unitdebug, *) 'load_itemvalue: nabsent=', nabsent
      write (spuritemvalue(bit_orientvec),205) nabsent, npresent
c02Jan      write (spuritemvalue(bit_orientvec),205) nabsent, m_rlv*m_rlv
 205   format ('nabsent=', i5, '/',   i5)     !! 8 + 1 + 5+5
c      write (spuritemvalue(bit_orientvec),*) 'nabsent=', nabsent, 
c     &         '/', m_rlv*m_rlv
cc     &		, 'ntiny=', ntiny
      if (debug) call report_menuitem(bit_orientvec)

cDebug      write (unitdebug, *) 'load_itemvalue: nspur=', nspurtot
      if ( bit_on(currentoptions, bit_spur)) then
        write (spuritemvalue(bit_spur),210) nspurtot, nelastic
 210    format ('spur=', i5, 1x,  'els=', i5)     !!5+5+1+4+5=20
c        write (spuritemvalue(bit_spur),*) 'nspur=', nspurtot, 
c     &		' nelast=', nelastic
      else
        write (spuritemvalue(bit_spur),*) ' '
      endif
      if (debug) call report_menuitem(bit_spur)

      if ( bit_on(currentoptions, bit_al)) then
        write (spuritemvalue(bit_al),*) 'nal_match=', nal_match
      else
        write (spuritemvalue(bit_al),*) ' '
      endif
cDebug      write  (unitdebug, *) 'load_itemvalue: ', spuritemvalue(bit_al)
      if (debug) call report_menuitem(bit_al)
      
      if ( bit_on(currentoptions, bit_incoh)) then
        write (spuritemvalue(bit_incoh),220) 'mon=', 
     &		nincohmon, 'ana=', nincohana
220     format (a4, i5, 1x, a4, i5)
c        write (spuritemvalue(bit_incoh),220) 'mon, ana=',
c     &		nincohmon, nincohana
c220     format (a9, i5, 1x, i5)
      else
        write (spuritemvalue(bit_incoh),*) ' '
      endif
cDebug      write  (unitdebug, *) 'load_itemvalue: ', spuritemvalue(bit_incoh)
      if (debug) call report_menuitem(bit_incoh)

      if ( bit_on(currentoptions, bit_mod)) then
        write (spuritemvalue(bit_mod),*) 'Modified' 
      else
        write (spuritemvalue(bit_mod),*) ' '
      endif

cDebug      write  (unitdebug, *) 'load_itemvalue: ', spuritemvalue(bit_mod)
      if (debug) call report_menuitem(bit_mod)


      if (debug) write (*,*) 'load_itemvalue: end of routine'

      return
      end

c=============================================================================
      subroutine report_menuitem(i)
      implicit none
      include 'io_files.inc'
      include 'spur_menu.inc'
      integer i
c      character*(*) astring
      
      write (unitdebug, *) 'report_menuitem: ', 
     &	      spurmenuitem(i),': ',  spuritemvalue(i)
      end
c=============================================================================

      subroutine display_menu(aversion, scale, spurhist) 
       
      implicit none
      include 'io_files.inc'
      include 'spur_menu.inc'
      include 'spur_warn.inc'

c...	functions
      logical bit_on
      integer ilen
      
c...	passed variables
      character*(*) aversion
      CHARACTER*2 scale
c      CHARACTER*5 scale
      integer spurhist

c...	local variables
      integer i, bit_value

c02Mar 220   write (*,'(A,$)') 'Type a command or hit <return> for options: '
c02Mar      read (*,'(a)',err=220) scale      ! read in a one character command
c      write(*,'(a,i3)') 'spurhist=',spurhist

c      call version(aversion)
c	Note: z/o in VMS fortran produces hexadecimal/octal output.      

c      write (*,'(a30, x, a24, x, a24, x, 0)') aversion,  
c     &		FILE_BUFIN, FILE_LPI,
c     &    	currentoptions
        
c02Mar      if ((scale(1:1).eq.' ') .or. (scale(1:1).eq.'?')) then

        write (*,*) aversion
        write (*,'(a25, x, a25, x, a25)') FILE_BUFIN, FILE_LPI,
     &		file_base(1:ilen(file_base))//'.<ext>'
        if (warn_options .ne. 0) write (*,'(a)') warnstring
c03Mar        write (*,'(a38, x, a38)') FILE_BUFIN, FILE_LPI  
ccc        write (*,'(a30, x, a24, x, a24)') aversion, FILE_BUFIN, FILE_LPI  
c      call display_spurhist(spurhist, 0)
c      call display_spurhist(spurhist, unitdebug)

c        write (*,*) 'currentoptions =', currentoptions, 
c     &		'addoption=', addoption
cc      write (unitdebug,*) 'currentoptions =', currentoptions 
      
        do i = 1, len_menu
	  write (*,*) spurmenuitem(i), ': ', spurmenu(i),
     &	   ' ', bit_on(currentoptions, i), bit_on(addoption, i), 
     &     ' ', spuritemvalue(i)
c	  write (*,*) spurmenuitem(i), ' :  ', spurmenu(i),
c     &	   ' ', bit_on(currentoptions, i),
c     &     ' ', spuritemvalue(i)
        enddo
222     write(*,'(a,$)') 'Command ("QQ" to quit)? '
c222     write(*,'(a,$)') 'Command ("q" to quit)? '
        read (*,'(a)',err=222) scale
c02Mar      endif

      addoption = 0
      do i =1, len_menu
c        if (spurmenuitem(i) .eq. scale(1:1)) then
        if (spurmenuitem(i) .eq. scale) then
	   call set_bit(addoption,i,1)
	   if (i .eq. bit_spur) then
	     call toggle_bit(currentoptions,i, bit_value)
	   else if (i .eq. bit_al) then
	     call toggle_bit(currentoptions,i, bit_value)
	   else if (i .eq. bit_incoh) then
	     call toggle_bit(currentoptions,i, bit_value)
	   else if (i .eq. bit_orientvec) then
	     call toggle_bit(currentoptions,i, bit_value)
	   else if (i .eq. bit_labelvec) then
	     call toggle_bit(currentoptions,i, bit_value)
	   else if (i .eq. bit_grid) then
	     call toggle_bit(currentoptions,i, bit_value)
ccc	   else if (i .eq. bit_showsort) then
ccc	     call toggle_bit(currentoptions,i, bit_value)
	   else if (i .eq. bit_annote) then
	     call toggle_bit(currentoptions,i, bit_value)
	   else
	     call set_bit(currentoptions,i,1)
	   endif
	endif
      enddo

      return
      end
     
c=============================================================================

      subroutine display_spurhist(spurhist, unit)
c...	Use UPPERCASE letters to indicate that the condition is true (bit=1)
c....   Use lowercase letters to indicate that the condition is false (bit=0)      

C     spurion on or off      2^0
C     incoherent on or off   2^1
C     aluminum on or off     2^2
C     prox (0) or all (1)    2^3
C     orient vec on or off   2^4
C     label wavevectors      2^5
C     overwrite (yes/no)     2^6
C     Systematic absences    2^7
c
c123456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789
cspurion   incohernt aluminum  nearby    orient_vc label_wav overwrite absences 


      implicit none
c...	passed variables
      integer spurhist, unit
      
c...	local variables
      integer ipwr, spurbit
      character*10 ahist(0:7)
      
      data ahist /'spurion   ', 'incohernt ', 'aluminum  ', 
     &      	  'nearby    ', 'orient_vc ', 'label_wav ', 
     & 		  'overwrite ', 'absences  '/
     
      do ipwr = 0, 7
        call bit(spurhist,ipwr,spurbit,0)
	 if (spurbit.eq.1) then
	   call supper(ahist(ipwr)) 
	 else
	   call lower(ahist(ipwr)) 
	 endif
      enddo
      if (unit .eq. 0) then
        write (*,'(8(a))') (ahist(ipwr), ipwr = 0, 7)
      else
        write (unit,'(8(a))') (ahist(ipwr), ipwr = 0, 7)
      endif

      return
      end
      
      
c=========================================================================

      subroutine cmd_spurion( m_rlv, npts, nscan, nspurtot, nspur, 
     &      qspur, espur, qsparr, esparr, kiarr, kfarr,
     &      circsize, ki, kf, zeta, eta, hh, kk, ll, 
     &      absent, replot, sp, spurtitle, 
     &      ec, es, h, hc, hs,  constq, nelastictot, noplot, bmatuv)
C  Plot, count, and record spurious Q's

      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_scan.inc'
      include 'spur_layout.inc'

c...	common blocks
      real tol, etol		!! spatial and energy tolerances		!! implicit       
      common /spur/ tol, etol

c...	functions
      logical	invert
cUnused      integer 	ilen
      
c...	passed variables
      integer  m_rlv, npts, nscan, nspurtot, nspur
      real qspur(2,n_spur_max,n_spur_max)
      real espur(n_spur_max,n_spur_max)
      real qsparr(2,n_spur_max,n_spur_max, maxnpts)
      real esparr(n_spur_max,n_spur_max,maxnpts)
      real*4 kiarr(2,maxnpts),kfarr(2,maxnpts)
      real circsize
      real ki(2),kf(2)
      real zeta(m_rlv_max,m_rlv_max),eta(m_rlv_max,m_rlv_max)
      integer hh(m_rlv_max,m_rlv_max)
      integer kk(m_rlv_max,m_rlv_max)
      integer ll(m_rlv_max,m_rlv_max)
      logical absent(m_rlv_max,m_rlv_max)
      logical replot
      integer sp(3)
      character*10 spurtitle
      real ec, es
      REAL*4 h(3),hc(3),hs(3)
      logical constq
      integer nelastictot
c      real bmat(3,3)
      real bmatuv(3,3)
      logical noplot
            
c...	local variables
      integer iscan, i, j, l
      integer ii, jj
      real bmatuv_inv(3,3)
      integer nelastic

cUnused      integer len
cUnused      character*13 a_hkl		! only integers for q
cReport      character*19 afloat_hkl
cReport      character*(80)	line_scan, line_spur, line_info
cReport      logical firstbragg
      
      write(*,*) '&&& Elastic spurions and ', 
     &	      'higher order spurions matching Bragg peaks at:'
      write(unitspur,*) '&&& All higher order spurions:'

      if (noplot) then
        do i =1, 3
	  do j = 1, 3
	    bmatuv_inv(i,j) = dble(bmatuv(i,j))
          enddo
        enddo
cOpps      if (.not. invert(3, bmatuv)) then
        if (.not. invert(3, bmatuv_inv)) then
	  write (*,*) 'cmd_spur: Error inverting bmatuv'
        endif

         nspurtot=0
         nelastictot=0
      endif
      
         do iscan=1,nscan

cReport           do j=1,3
cReport             h(j)=hc(j)+(k-(float(npts)+1.0)/2.0)*hs(j)
cReport           enddo
cReport	   write (line_scan, 115) k, ec+(k-(float(npts)+1.0)/2.0)*es, 
cReport     &		   (h(j),j=1,3) 	   
cReport115	   format ('Scan point #=', i3, ' at dE=', f7.3, 
cReport     &		' at Q=(',f6.2,1x,f6.2,1x,f6.2,')')
cReport           write (unitspur, '(a)') line_scan
cReport           write (*, '(a)') line_scan
           

C setup variables again
            do ii=1,n_spur_max
             do jj=1,n_spur_max
                  do l=1,2
                     qspur(l,ii,jj)=qsparr(l,ii,jj,iscan)
                  enddo
                  espur(ii,jj)=esparr(ii,jj,iscan)
	      enddo
	    enddo


            do l=1,2
               ki(l)=kiarr(l,iscan)
               kf(l)=kfarr(l,iscan)
            enddo

	    if (noplot) then
              call prepspur(n_spur_max, nspurtot,m_rlv,qspur,espur,
     &		 nspur, zeta, eta, hh,kk,ll,
     &		 ki,kf,absent, replot, nelastic, nelastictot, iscan)

c...		New location. Not used by plotspur or reportspur.
              nelastictot=nelastictot + nelastic
              nspurtot=nspurtot+nspur
c	      write (*,*) 'cmd_spurion: increasing nelastictot ',
c     &		       nelastictot , nelastic
c	      write (*,*) 'cmd_spurion: increasing nspurtot ',
c     &		       nspurtot , nspur
	    endif

	    if (.not. noplot) then
             call plotspur(n_spur_max, m_rlv,qspur,espur,
     &		 circsize,zeta,eta, 
     &		 ki,kf,absent, replot,  iscan)
            endif
	    
	    if (noplot) then
	      call reportspur(n_spur_max, nspurtot, nelastictot, 
     &		qspur,espur, bmatuv_inv, ec, es, h, hc, hs, nscan, iscan)
     
     	    endif

cReportC  		Print out the spurions
cReport
cReportc            if ((nspur.ne.0).and.(nspurtot.eq.0)) 
cReportc     &           write(*,'(a19)') 'Spurion matches at:'
cReport
cReport	    firstbragg = .true.
cReport            do ii=1,n_spur_max
cReport             do jj=1,n_spur_max
cReportc	        if (( ii .ne. 1) .and. (jj .ne. 1)) then
cReport	          call hkl_float(qspur(1,ii,jj), qspur(2,ii,jj), 
cReport     &		    bmatuv_inv, afloat_hkl)
cReport     		  write (line_spur, 124) ii, jj, afloat_hkl, espur(ii,jj)
cReport124		  format (1x,i2, '*Ki - ', i2, '*Kf =',1x,
cReport     &			a,' at E_spur=', f8.2)

cReport		  if ( k .eq. nint(xmin_sc)) then
cReport		    afloat_hkl_start(ii,jj) = afloat_hkl
cReport		  endif
cReport		  if ( k .eq. nint(xmax_sc)) then
cReport		    afloat_hkl_end(ii,jj) = afloat_hkl
cReport		  endif
ccReport		endif

cReport                  if (abs(espur(ii,jj)).lt. etol) then
cReport		    write (line_info,*) ' Elastic red. '
cReportc...		    Override  line_info, if there was match to a Bragg peak.		    
cReport		    if (nspur .ne. 0) then
cReport                     do i=nspurtot+1,nspurtot + nspur
cReport		      if ((ispur(i+nspurtot).eq.ii) 
cReport     &			 .and.(jspur(i+nspurtot).eq.jj)) then
cReport     			if (firstbragg) then
cReport     			  firstbragg = .false.
cReport			  write (*,*)
cReport			  write (*, '(a80)') line_scan
cReport			endif
cReport		        write (line_info,*) ' Elastic red.   Bragg'
cReport		      endif
cReport		     enddo
cReport		    endif
ccReport		report all those higher order spurions which are eleastic
cReport	            if (( ii .ne. 1) .and. (jj .ne. 1)) then
cReport                      write (*, *) line_spur(1:ilen(line_spur)), 
cReport     &		  	line_info(1:ilen(line_info))
cReport     		    endif
cReport
cReport		  else
cReport		    write (line_info,*) ' Inelst yellow.'
cReportc...		    Override  line_info, if there was match to a Bragg peak.		    
cReport		    if (nspur .ne. 0) then
cReport                     do i=nspurtot+1,nspurtot + nspur
cReport		      if ((ispur(i+nspurtot).eq.ii) 
cReport     &			 .and.(jspur(i+nspurtot).eq.jj)) then
cReport     			if (firstbragg) then
cReport     			  firstbragg = .false.
cReport			  write (*,*)
cReport			  write (*, '(a)') line_scan
cReport			endif
cReport		        write (line_info,*) ' Inelst yellow. Bragg'
ccReport		        write (line_info,*) ' Inelastic (yellow) Bragg'
cReportc		Only report those higher order spurions which hit Bragg peaks
cReport	                if (( ii .ne. 1) .and. (jj .ne. 1)) then
cReport                          write (*, *) line_spur(1:ilen(line_spur)), 
cReport     &			  	line_info(1:ilen(line_info))
cReport     			endif
cReport		      endif
cReport		     enddo
cReport		    endif
cReport		  endif
cReport
cReportc		  Write all higher order spurions to the file *.spur		  
cReport                  write (unitspur, *) line_spur(1:ilen(line_spur)), 
cReport     &		  	line_info(1:ilen(line_info))
cReport
cReport
cReport 26                 format(a, f7.3, $)
cReport 637                 format(a,f6.2,1x,f6.2,1x,f6.2,a, $)
cReport
cReport
cReport
cReport             enddo
cReport            enddo
cReport	    
cReport 24         format(1x,i2, '*Ki - ', i2, '*Kf =', $)
cReport 25         format(1x,a,a,f8.2,a,i2,$)
cMoved            nspurtot=nspurtot+nspur


cReport         write(unitspur,*) 		!! blank line between scan points
cReport         write(*,*) 		!! blank line between scan points

         enddo		!! iscan = 1, nscan
	 
cMoved         write(*,*) 		!! blank line at end of scan points

C  No spurions?
cReport	write(*,*) nspurtot, ' matches of higher order spurions ', 
cReport     &		'to Bragg peaks, out of ', n_spur_max*n_spur_max*nscan 
cReport	write(unitspur,*) nspurtot, ' matches of higher order spurions ', 
cReport     &		'to Bragg peaks, out of ', n_spur_max*n_spur_max*nscan 

cReport	write(*,*) nelastictot, ' elastic higher order spurions, ', 
cReport     &		'out of ', n_spur_max*n_spur_max*nscan 
cReport	write(unitspur,*) nelastictot, ' matches of higher order spurions, ', 
cReport     &		'out of ', n_spur_max*n_spur_max*nscan 


cReport      write(*,*) ''
cReport      write(unitspur,*) ''

c      write (*,*)  'cmd_spurion: goal points: ',
c     &	      nint(xmin_sc), nint(xmax_sc)
c            do ii=1,n_spur_max
c             do jj=1,n_spur_max
c	       write (*,*) 'cmd_spurion: labels =', ii, jj, 
c     &		 '"', afloat_hkl_start(ii,jj),
c     &		 '" "', afloat_hkl_end(ii,jj), '"'
c	     enddo
c	    enddo


      call rank_higher(nspurtot, nelastictot)
      
      return
      end


c==========================================================================
      subroutine cmd_incoherent(nscan, m_rlv, zeta, eta,
     &	kiarr, kfarr, incohmon,incohana, incmonarr, incanaarr, 
     &  hh,kk,ll,circsize,ki,kf,constq,h,incohflag,absent,replot, 
     &  npts, hc, hs, nincohmon, nincohana, pleaseplot)
C  Plot and report spurious Q's due to incoherent scattering.
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'

c...	passed variables
      integer nscan, m_rlv
      real zeta(m_rlv_max,m_rlv_max)
      real eta(m_rlv_max,m_rlv_max)
      real incohmon(2),incohana(2)
      real*4 incmonarr(2,maxnpts),incanaarr(2,maxnpts)
      real*4 kiarr(2,maxnpts),kfarr(2,maxnpts)
      integer hh(m_rlv_max,m_rlv_max)
      integer kk(m_rlv_max,m_rlv_max)
      integer ll(m_rlv_max,m_rlv_max)
      real circsize,ki(2),kf(2),h(3)
      logical constq,incohflag,replot
      logical absent(m_rlv_max,m_rlv_max)
      integer npts
      REAL*4 hc(3),hs(3)
      integer nincohmon, nincohana
      logical pleaseplot
      
c...	local variables
      integer k, l, j
      logical  flagincohmon,flagincohana
            
      write (*,*) '&&& Incoherent spurions matches at:'
      write (unitspur,*) 'Incoherent spurions matches at:'
      
         incohflag=.false.
         nincohmon = 0
         nincohana = 0
         do k=1,nscan
            do l=1,2
               incohmon(l)=incmonarr(l,k)
               incohana(l)=incanaarr(l,k)
               ki(l)=kiarr(l,k)
               kf(l)=kfarr(l,k)
            enddo
            do j=1,3
               h(j)=hc(j)+(k-(float(npts)+1.0)/2.0)*hs(j)
            enddo
            call prepincoh(m_rlv,zeta,eta,incohmon,incohana, hh,kk,ll,
     &  	circsize,ki,kf,k,constq,h,incohflag,absent, replot,
     &		nincohmon, nincohana,  flagincohmon,flagincohana)
     	    if (pleaseplot) then
              call plotincoh(m_rlv,zeta,eta,incohmon,incohana, hh,kk,ll,
     &  	circsize,ki,kf,k,constq,h,incohflag,absent, replot,
     &		nincohmon, nincohana,  flagincohmon,flagincohana)
     	    endif
        enddo
        if (.not.incohflag) then
           write(*,*) 'No incoherent spurions found.'
           write(unitspur,*) 'No incoherent spurions found.'
c           write(8,*) 'No incoherent spurions found.'
        endif

      write (*,*) 
      write (unitspur,*)


      return
      end


c==========================================================================
      subroutine cmd_aluminum(nscan, npts, minq, maxq, magq,
     &   nearby, qarr, kiarr, kfarr, 
     &	 h, hc, hs, incmonarr, incanaarr,
     &	 constq, spurhist, mon, pi, fe, phimax, plotlattice)
C  Plot aluminum Ewald spheres that are within qmax in green
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_buf.inc'
      include 'spur_color.inc'
      include 'spur_scan.inc'

c...	common blocks
      real tol, etol		!! spatial and energy tolerances		!! implicit       
      common /spur/ tol, etol

c...	functions
      character*10	name_color
      
c...	passed variables
      integer nscan, npts
c02Apr      real gal(nal)
      real minq,maxq,magq
c02Apr      integer hklal(3,nal)
      logical nearby
      real*4 qarr(2,maxnpts),kiarr(2,maxnpts),kfarr(2,maxnpts)
      REAL*4 h(3),hc(3),hs(3)
      real*4 incmonarr(2,maxnpts),incanaarr(2,maxnpts)
      logical constq
      integer spurhist
      CHARACTER*5 mon
      real pi
      real fe
      real phimax
      logical plotlattice

cInc      logical alspur
cInc      integer nal_match
      
c...	local variables
      integer i, j, jj, iscan
      integer spurbit
      real angle4, asin_angle4		!! A4 angle for Al (not sample!)
      character*10 thiscolor
      character*80 aline
c      logical angle4_OK
      logical thismatches
c      character*1 beforeOrAfter


C  Calculate the aluminum Ewald spheres.  Use text output
C  to give the one in closest proximity to current Q.

         call alewald()
c         call alewald(gal,hklal)

c...	Check min and max of q's in the scan range. (So can test Al q's later.)
 	iscan = 1
        magq=sqrt(qarr(1,iscan)**2+qarr(2,iscan)**2)
	minq=magq
	maxq=magq
        do iscan=2,nscan
          magq=sqrt(qarr(1,iscan)**2+qarr(2,iscan)**2)
          if (magq.lt.minq) minq=magq
          if (magq.gt.maxq) maxq=magq
	enddo


        write (*,*) '&&& Al Eward spheres at:'
        write (unitspur,*)'&&& Al Eward spheres at:'
C  report locations of Al Alewald spheres first, before looking for matches
        do iscan=1,nscan
          magq=sqrt(qarr(1,iscan)**2+qarr(2,iscan)**2)
	  do i = 1, nal

	    angle4 = 190.0		!! Nonsense value
c...	     AL Alewald spheres fixed in .rl.u.
c		But their A4 angle depends on Ei.	    
            if (mon.eq.'(MON)') then 
	      asin_angle4 =		!!  Laue scattering law
     &	      	0.5*gal(i)/sqrt(kiarr(1,iscan)**2+kiarr(2,iscan)**2)
            else
	      asin_angle4 =		!!  Laue scattering law
     &	      	0.5*gal(i)/sqrt(kfarr(1,iscan)**2+kfarr(2,iscan)**2)
            endif

c 	    if (i .eq. 1) then		!! debug
c              magq=sqrt(qarr(1,iscan)**2+qarr(2,iscan)**2)
c	      write (*,*) 'cmd_aluminum: i, ki= ', iscan,
c     &	     	kiarr(1,iscan), kiarr(2,iscan), '|q|=',magq 
c	      write (*,*) 'cmd_aluminum: i, kf= ', iscan,
c     &	     	kfarr(1,iscan), kfarr(2,iscan), '|q|=',magq 
c	    endif			!! debug
	    
	    if (abs(asin_angle4  ) .le. 1.0) then
	      angle4 = 360/pi* asin(asin_angle4 )
	    endif


c02Apr 541        format(a,3i1,2a,f5.2,a,$)
c02Apr            if ((gal(i).ge.(minq-.5)).and.(gal(i).le.(maxq+.5)))

	     if ( (draw_al_iscan .eq. 0) .or. 
     &	         (draw_al_iscan .eq. iscan) )  then
c	     if ( ((draw_al_iscan .eq. 0) .and. (iscan .eq. 1)) .or. 
c     &	         ((draw_al_iscan .eq. 0) .and. (iscan .eq. nscan)) .or. 
c     &	         (draw_al_iscan .eq. iscan) )  then
 
              if (angle4 .le. phimax*180.0/pi)  then
cOld                if ((gal(i) .ge. minq) .and. (gal(i) .le. maxq)) then
cOld 540             format ('Al(', 3i1, ')', ' at |Q|=', f5.2, 
cOld     &			' AA^-1 or A4= ', f6.2, 
cOld     &			' at fixed E', f4.1, 1x, a5,  ' pt#=', i3, a)
c 540             format ('Al(', 3i1, ')', ' at |Q|=', f5.2, 
c     &			' AA^-1 or A4= ', f6.2, 
c     &			' at fixed E', f4.1, 1x, a,  ' pt#=', i3, a)

c		 beforeOrAfter = '~'
cOld		 write (aline, 540) (hklal(j,i),j=1,3), gal(i), 
cOld     &		 	angle4,fe, mon, iscan,' InsideScan' 
c		 write (aline, 540) (hklal(j,i),j=1,3), gal(i), 
c     &		 	angle4,fe, mon, iscan,' Inside scan' 
		
cOld                else if (gal(i) .lt. minq)  then
c		 beforeOrAfter = '<'
cOld		 write (aline, 540) (hklal(j,i),j=1,3), gal(i), 
cOld     &		 	angle4,fe, mon,iscan, ' BeforeScan' 
c     &		 	angle4,fe, mon,iscan, ' Before scan' 
cOld                else if (gal(i) .gt. maxq) then
c		 beforeOrAfter = '>'
cOld		 write (aline, 540) (hklal(j,i),j=1,3), gal(i), 
cOld     &		 	angle4,fe, mon,iscan, ' After scan' 
cOld     		endif

cOld      	        write (*,'(a80)') aline
cOld      	        write (unitspur,'(a80)') aline

		 write (aline, 560) (hklal(j,i),j=1,3), gal(i), 
     &		 	angle4,fe, mon, 	!!beforeOrAfter,
     &			iscan, magq, angle4_store(iscan)*180.0/acos(-1.0)
 560             format ('Al(', 3i1, ')', ' |Q|=', f5.2, 
     &			'A^-1 A4=', f6.2,  ' fix E', f4.1, 
     &			 a5,  '; pt#=', i3, ' |Q|=', f6.2, 'A^-1 A4=', f6.2)

      	        write (*,'(a80)') aline
      	        write (unitspur,'(a80)') aline
              endif	      

	      if (i .eq. nal) then
	        write (*,*) ' '
	        write (unitspur,*) ' '
	      endif
	    endif
	    
	  enddo		!! i = 1, nal
	enddo		!! iscan=1,nscan
 


      write (*,*) '&&& Al spurions at:'
      write (unitspur,*)'&&& Al spurions at:'

      if ( plotlattice) then
         call pgsfs(2)          ! outline only
         call pgsls(2)          ! dashed line
      endif 		!! if ( plotlattice) then

C  check for Q matches with while loop
         nal_match = 0
         alspur=.false.
	do i = 1, nal
	  thismatches = .false.
c	  Too hard to see diff between yellowgreen and green. Try cyangreen.
c          call pgsci(color_greencyan)
c	  thiscolor = name_color(color_greencyan)
          call pgsci(color_green)
	  thiscolor = name_color(color_green)
          do iscan=1,nscan
            magq=sqrt(qarr(1,iscan)**2+qarr(2,iscan)**2)
            if (abs(gal(i)-magq).lt.tol) then
               do j=1,3
                  h(j)=hc(j)+(iscan-(float(npts)+1.0)/2.0)*hs(j)
               enddo
	       nal_match = nal_match + 1
               alspur=.true.
	       thismatches = .true.
	       iqal_ial(nal_match) = i
	       iqal_iscan(nal_match) = iscan

c                call pgsci(color_green)
c		thiscolor = name_color(color_green)
                call pgsci(color_red)
		thiscolor = name_color(color_red)


	         write (aline, 539) (hklal(j,i),j=1,3), 
     &		 iscan, (h(jj),jj=1,3), magq, thiscolor
     		 write (*,'(a80)') aline
     		 write (unitspur,'(a80)') aline
 539             format ('Al(', 3i1,
     &		   ') spurion at pt#', 
     &		   i2, ' Q=(', f5.2, ',', f5.2, ',', f5.2, ') [rlu] ', 
     &		   '|Q|=', f5.2, ' AA^-1 ', a10)
c 539             format ('Al(', 3i1,
c     &		   ') reflection matches scan pt#', 
c     &		   i2, ' Q=(', f5.2, ',', f5.2, ',', f5.2, ') [rlu] ', a)
		 
	    endif


	    angle4 = 190.0		!! Nonsense value
            if (mon.eq.'(MON)') then 
	      asin_angle4 =
     &	      	0.5*gal(i)/sqrt(kiarr(1,iscan)**2+kiarr(2,iscan)**2)
c	           angle4 = 360/pi* 		!!  Laue scattering law
c     &        asin(0.5*gal(i)/sqrt(kiarr(1,iscan)**2+kiarr(2,iscan)**2))
            else
	      asin_angle4 =
     &	      	0.5*gal(i)/sqrt(kfarr(1,iscan)**2+kfarr(2,iscan)**2)
            endif

	    if (abs(asin_angle4  ) .le. 1.0) then
	      angle4 = 360/pi* asin(asin_angle4 )
	    endif


 541        format(a,3i1,2a,f5.2,a,$)

              if (.not. (angle4 .le. phimax*180.0/pi)) then
                call pgsci(color_darkgrey)		!! Override color
		thiscolor = name_color(color_darkgrey)
 	      endif
c	      write (*,*) 'cmd_aluminum: angle4=', angle4, ' ', 
c     &		      thiscolor, phimax*180.0/pi

	  enddo		!! i = 1, nal
          if ( plotlattice) then
            call pgcirc(0.0,0.0,gal(i))
	  endif		!! if ( plotlattice) then
	enddo		!! iscan=1,nscan

            if (alspur) then 
	       spurbit = 1
	    else
	       spurbit = 0
	    endif
            call bit(spurhist,3,spurbit,1)

         if (.not.alspur) then
            write(*,*) 'Q does not match any Al scattering.'
            write(unitspur,*) 'Q does not match any Al scattering.'
         endif

ccc         nearby=.not.nearby
         nearby= alspur

      write (*,*) ' '
      write (unitspur,*) ' '
	 
      return
      end


c==========================================================================
      subroutine cmd_orientvecs(uuv, vuv)
C  Draw the u and v orientation vectors with solid, magenta lines.
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'

c...	passed variables
      REAL*4 uuv(3),vuv(3)

c...	local variables
      real xch, ych, size
      real temp1


        call pgsci(color_magenta)
c01dec        call pgsci(6)
        call pgsls(1)
C  It is possible that these vectors are much smaller than the rest
C  of the plot so check that the arrow head size is suitable.
        call PGQCS(4, XCH, YCH)         ! character size in world coor
        call pgqch(size)                ! character size in 1/40 of viewport
        if (4.0*xch.gt.sqrt(uuv(1)**2+uuv(2)**2)) then
	  temp1 = size*sqrt(uuv(1)**2+uuv(2)**2)/(2.0*xch)
          call pgsch(temp1)
	endif
c01Nov        if (4.0*xch.gt.sqrt(uuv(1)**2+uuv(2)**2))
c01Nov     &    call pgsch(size*sqrt(uuv(1)**2+uuv(2)**2)/(2.0*xch))
        CALL pgarro(0.0,0.0,uuv(1),uuv(2))
        CALL pgarro(0.0,0.0,vuv(1),vuv(2))
        call pgsci(color_ink)
c01Dec        call pgsci(1)
        call pgsch(size)                ! back to original size

      return
      end


c==========================================================================
      subroutine cmd_zoomspur(nscan) 
C  Zoom in/out of the spurion energy plot on the scan page
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_layout.inc'

c...	passed variables
      integer nscan


c220     write(*,'(a,a,$)') 'Enter spurion energy range for plot ', 
c     &		'(0,0 for auto):'
220         write(*,'(a,a,$)') 'Enter scan pnts and ', 
     &	 'spurion energy ranges (0,0,0,0 for auto):'
        read(*,*,err=220) xmin_sc, xmax_sc, ymin_sc_hs, ymax_sc_hs

      if (xmin_sc .gt. xmax_sc) goto 220
      if ((xmin_sc .lt. 1.0) .and. (xmin_sc .ne. 0.0) ) then
	write (*,*) 'cmd_zoomspur: Try again! ', 
     &		'Only positve scan ranges allowed.'
        goto 220
      endif
      if (xmax_sc .gt. nscan) then
	write (*,*) 'cmd_zoomspur: Try again! ', 
     &		'Largest allowed scan range is ', nscan
        goto 220
      endif

      if (ymin_sc_hs .gt. ymax_sc_hs) goto 220
      
      if (xmin_sc .eq. 0.0) then 
        auto_xmin_sc = .true.
      else
         auto_xmin_sc = .false.
      endif
      
      if (xmax_sc .eq. 0.0) then 
        auto_xmax_sc = .true.
      else
         auto_xmax_sc = .false.
      endif
      
      if (ymin_sc_hs .eq. 0.0) then 
        auto_ymin_sc_hs = .true.
      else
         auto_ymin_sc_hs = .false.
      endif
      
      if (ymax_sc_hs .eq. 0.0) then
        auto_ymax_sc_hs = .true.
      else
        auto_ymax_sc_hs = .false.
      endif
        
      return
      end

c==========================================================================
      subroutine cmd_rescaleplot(xstar, ystar, rlu, right, circsize)
C  Rescale the plot
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_layout.inc'

c...	passed variables
cCommon      real xmin, xmax, ymin, ymax
      real xstar,ystar
      logical rlu, right
      real circsize

c...	local variables
      real tmp

220   if (rlu) then
        write(*,'(a,$)') 'Enter xmin,xmax,ymin,ymax (in rlu): '
      else 
        write(*,'(a,$)') 'Enter xmin,xmax,ymin,ymax (in A^-1): '
      endif

        read(*,*,err=220) xmin,xmax,ymin,ymax
        if (rlu) then		!! convert to A^-1
           xmin=xmin*xstar
           xmax=xmax*xstar
           ymin=ymin*ystar
           ymax=ymax*ystar
        endif
        if (xmin.gt.xmax) then    ! if xmin > xmax then change orientation
          right=.not.right        ! of the spectrometer
          tmp=xmin
          xmin=xmax
          xmax=tmp
        endif
	
ccc      call square(xmin, xmax, ymin, ymax)
      circsize = (xmax- xmin)/120.0

cDebug      write (*,*) 'cmd_rescale: ', xmin, xmax, ymin, ymax
      
      return
      end

c==========================================================================
      subroutine cmd_showintensities_old(gray, rainbow)
C  Show numbers for the intensities instead of only circles.
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'

c...	passed variables
      logical gray, rainbow
      
c...	local variables
       integer temp

 20     write(*,'(a,a,$)') 
     &	  'SF^2 display: 0 for gray/colored circles, 1 for numbers: '
ccc     &	  'SF^2 display: Enter 0 for circles, 1 for numbers: '
        read (*,*, err=20) temp
        if (temp .le. 0) then
          gray= .true.
        else 
	  gray = .false.
        endif

120     write(*,'(a,$)') 
     &	  'SF^2 display: Enter 0 for gray, 1 for color: ' 
        read (*,*, err=120) temp
        if (temp.le.0) then
          rainbow= .false.
        else 
          rainbow= .true.
        endif

      return
      end

c==========================================================================
      subroutine cmd_circsize_old(c, struct)
C  Change the circlesize.  Also toggles 'grayscale' or can disable
C  the structure factor calculation completely in PLOTLATTICE      
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'

c...	common blocks
      integer natoms
      common /atoms/ natoms
      
c...	passed variables
      real c
      logical struct
      
c...	local variables

c 20     write(*,'(a,$)') 
c     &	 'Enter circle size scale factor (0 no structure calc): '
 20     continue
        write (*,*) 'Scheme for the circle size: '
        write (*,*) '  <0 for varying circles of varying gray... '
        write (*,*) '   0 for no structure factor ', 
     &		'(identical circles everywhere)... ' 
        write (*,*) '  >0 for uniform circles of varying gray...'
        write (*,*) 

220     write (*,'(a,$)') 'Enter circle size scale factor: '
        read (*,*,err=220) c
	
c        if (c.lt.0) then
c	   go to 20
c        endif

        if (abs(c) .le. 1.0e-5) then
          struct = .false.
cTR          struct=.not.struct
          c=1.0
	  write (*,*) 'Not using structure calculation'
cTR          write(*,'(2a)') 'Toggling Sf^2, sytematic absences ',
cTR     &      'calculation.'
        else
          struct = .true.
        endif

      return
      end

c==========================================================================
      subroutine cmd_sortlog_old(sortlogscale, tolerance)
C  Change the circlesize.  Also toggles 'grayscale' or can disable
C  the structure factor calculation completely in PLOTLATTICE      
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'

c...	common blocks
      integer natoms
      common /atoms/ natoms
      
c...	passed variables
      logical  sortlogscale
      real tolerance
      
c...	local variables

	  write (*,*) 'Intensities between base^n and base^(n+1) will',
     &	    ' have the same label.' 
          write (*,*) 'If a base of zero is entered, intensities ',
     &			' within tolerance will have the same label'
220       write(*,'(a,$)') 'Enter base (0 for none): '
          read(*,*,err=220) tolerance
	  if (tolerance .lt. 1.0) then
	     	  sortlogscale = .false.
		  tolerance = 100.0*tiny *float(natoms)
          else
	      sortlogscale = .true.
	  endif

      return
      end


c==========================================================================
      subroutine cmd_printout(idev )
C change the device number
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'

c...	passed variables
      integer idev

c...	local variables

 771 	 continue 
       write(*,*) 
       write(*,*) 'Device #   =0 for XSERVE (screen,',
     &        ' no printout)'
       write(*,*) '           =1 for XWIN (screen,',
     &        ' no printout)'

       write (*,*) '           =2 for B&W postscript file:',
     &  ' <base>_bw.ps   = lattice plot'
       write (*,*) '           =3 for color postscript file:', 
     &  ' <base>_cl.ps   = lattice plot'
       write (*,*) '           =4 for B&W postscript file:' ,
     &  ' <base>_scbw.ps = scan plot'
       write (*,*) '           =5 for color postscript file:' ,
     &  ' <base>_sccl.ps = scan plot'
       write (*,*) ' Apologies: PGPLOT can only process', 
     &       ' one PS "window" at a time.'
       write (*,*) ' To properly close a PS file, a new device ',
     &       'must be selected or quit program.'
c       write (*,*) ' Apology: You must switch to another', 
c     &       ' device or end the program to properly close a PS file.'
 220    write(*,'(a, $)') 'Enter device number (0-5)' 
       read(*,*,err=220) idev
        if ((idev.lt.0) .or. (idev.gt.5)) then
          write(*,*) 'Enter 0, 1, 2, 3, 4 or 5.'
          goto 771
        endif
   
   
   
c 771 	 continue
c         write(*,'(2a)') 'Enter device number: 0 for XSERVE (screen,',
c     &        ' no printout)'
c         write(*,'(2a)') '                     1 for XWIN (screen,',
c     &        ' no printout)'
c         write(*,'(2a)') '                     2 for BWPS (black',
c     &        ' and white postcript) of Lattice plot'
c         write(*,'(2a)') '                     3 for CPS (color',
c     &        ' postscript) of Lattice plot'
c         write(*,'(2a)') '                     4 for BWPS (black',
c     &        ' and white postcript) of Scan plot'
c         write(*,'(2a)') '                     5 for CPS (color',
c     &        ' postscript) of Scan plot'
cc         write(*,'(2a)') '                     2 for BWPS (black',
cc     &        ' and white postcript)'
cc         write(*,'(2a)') '                     3 for CPS (color',
cc     &        ' postscript)'
c220      write(*,'(a,$)') 'Number of selection: '
c         read(*,*,err=220) idev
c        if ((idev.lt.0) .or. (idev.gt.5)) then
c          write(*,*) 'Enter 0, 1, 2, 3, 4, or 5.'
c          goto 771
c        endif
cc02Jan        idev=idev-1

c        if ((idev.eq.2).or.(idev.eq.3)) then
c          write(*,*) 'Output to spurion.ps.  Use: lpr -Pn spurion.ps'
c          write(*,*) '(n is printer number) to printout after quitting'
c          write(*,*) 'spurion.'
c          write(*,*)
c        endif

      return
      end

c==========================================================================
      subroutine cmd_labelvec(kiarr, kfarr, kistrt, kistop,
     &       kfstrt, kfstop, nscan, over, spurhist)
C  label Q, ki, and kf
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_menu.inc'
      include 'spur_layout.inc'
      
c...    functions
      logical	bit_on

c...	passed variables
      real*4 kiarr(2,maxnpts),kfarr(2,maxnpts)
      real kistrt(2),kistop(2),kfstrt(2),kfstop(2)
      logical over
      integer nscan, spurhist
cCommon      real xmin, xmax, ymin, ymax

c...	local variables
      character*2 key
      integer spurbit, l
      real temp1, temp2

         do l=1,2
            kistrt(l)=kiarr(l,1)
            kistop(l)=kiarr(l,nscan)
            kfstrt(l)=kfarr(l,1)
            kfstop(l)=kfarr(l,nscan)
         enddo
	 
         if (bit_on(addoption,bit_labelvec)) then
           write(*,'(a)') 'Labelling Q, ki, and -kf.'
220        write (*,'(A,$)') 'Okay to overwrite on plot ((y)/n)? '
           read (*,'(A)',err=220) key
           if ((key.eq.'n') .or. (key.eq.'N') )then
             over=.false.      
	     spurbit = 0
             call bit(spurhist,6,spurbit,1)
           else if ((key.eq.'y') .or. (key.eq.'Y')) then
             over=.true.
	     spurbit = 1
             call bit(spurhist,6,spurbit,1)
           else
	     go to 220
           endif
         endif
	 
	 temp1 = xmax-xmin
	 temp2 = ymax-ymin
         call label(kistrt,kistop,kfstrt,kfstop, temp1, temp2,
     &        over)
c01Nov         call label(kistrt,kistop,kfstrt,kfstop,xmax-xmin,ymax-ymin,
c01Nov     &        over)


      return
      end

c==========================================================================
      subroutine cmd_annotation(unitout, version_stamp,
     &		arrin, nunique, uniqueLabel, 
     &      indxunique1, indxunique2, multiplicity,
     &	    pointsize, circsize, overridesize, rainbow)
C  Put/add sorting labels text on right hand side of graph
    
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_menu.inc'
      include 'spur_annote.inc'
      
c...    functions
      logical bit_on
      logical write_qbuf

c...	passed variables
       integer 	unitout
c02Mar       real 	c	!! now relcircsize
c02Mar       real 	relcircsize
       character*(80) version_stamp
c      character*80 annotation(*)
c      integer 	nannote
      real arrin(m_rlv_max,m_rlv_max)
      integer nunique
      character*1 uniqueLabel(m_rlv_max,m_rlv_max)
      integer indxunique1(unique_rlv_max)
      integer indxunique2(unique_rlv_max)
      integer multiplicity(unique_rlv_max)
c      integer indxunique1(0:unique_rlv_max)
c      integer indxunique2(0:unique_rlv_max)
c      integer multiplicity(0:unique_rlv_max)
      logical overridesize, rainbow
      real pointsize(m_rlv_max,m_rlv_max)
      real circsize



c...	local variables
      integer i, iwhere
      logical success

      len_annote = 0

c...	Annotate the q-buffer file
        iwhere = 1
        success =  write_qbuf( -1, 'Qbuffer', annotation(iwhere))
        iwhere = iwhere + 1
        success =  write_qbuf( -1, 'Lattice', annotation(iwhere))
        iwhere = iwhere + 1
        success =  write_qbuf( -1, 'Energy', annotation(iwhere))
        iwhere = iwhere + 1
        success =  write_qbuf( -1, 'Space', annotation(iwhere))
        iwhere = iwhere + 1
        success =  write_qbuf( -1, 'Orient', annotation(iwhere))
        iwhere = iwhere + 1
        success =  write_qbuf( -1, 'Temp/H', annotation(iwhere))
        iwhere = iwhere + 1
        success =  write_qbuf( -1, 'Time', annotation(iwhere))

        write (*,*) 'annotate_spurhist: Debug: loaded up qbuf. ',
     &      ' iwhere = ', iwhere
c        do i = 1, 7
c        	write (*,'(a79)') annotation(i)
c        enddo

      len_annote = len_annote + iwhere
      
      do i = 1, min(max_annote, len_menu)
c02Mar      do i = 1, min(max_annote, len_menu)
	if (len_annote .eq. max_annote) then
	  write (*,*) 'cmd_annote: Programmer! ', 
     &	  	'Need to lengthen array stdannote via max_annote'
	  goto 444
	endif

      
        if (bit_on(currentoptions, i) .and. 
     &		.not.(i.eq. bit_annote) ) then
	  call set_bit(annoteoptions, i, 1)
cDebug          write (*,*) 'cmd_annote: setting bit on:', i
	endif
	
 120	format (a58,2x, a20)
	if (bit_on(annoteoptions, i)) then
          len_annote = len_annote + 1

cMoved?	  if (i .eq. bit_circsize) then
cccc    ' ...Show structure factor intensities (circles,#)' 
c      stndannote(bit_circsize) =
c     & '...Change circ size (<0 vary, >0 uni, 0 no struct)'
cMoved?	    if (abs(c) .lt. 1.0e-5) then 
cMoved?              write (annotation(len_annote), 120)
cMoved?     &	     'No structure factors shown', 
cMoved?     &			  spuritemvalue(i)
cMoved?	    else if (c .lt. 0.0) then 
cMoved?              write (annotation(len_annote),120)
cMoved?     &	     'Intensity proportional to circle size and grey tone', 
cMoved?     &			  spuritemvalue(i)
cMoved?	    else	!! if (c .gt. 0.0) then 
cMoved?              write (annotation(len_annote),'(a56,4x, a20)')
cMoved?     &	     'Intensity proportional to grey tone of uniform circles', 
cMoved?     &			  spuritemvalue(i)
cMoved?            endif
cMoved?          else
            write (annotation(len_annote),'(a56,4x, a20)') 
     &			  stndannote(i), spuritemvalue(i)
cMoved?          endif

cDebug           write (*,*) 'cmd_annote: bit on:', i, 
cDebug      &		  'writing: len_annote=', len_annote
cDebug 	  write (*,*) '   ', annotation(len_annote) 
	endif 

c	if ( (stndannote(i) .ne. nullstring) .and. 
c     &		 	 bit_on(currentoptions, i) ) then
c          write (annotation(i),'(a56,4x, a20)') stndannote(i),
c     &			  spuritemvalue(i)
c        endif

      enddo

 444  continue
 
 

      if (unitout .gt. 0) then
       write (unitout,*) 'cmd_annote>>' 
        do i = 1, len_annote
          write (unitout,'(a80)') annotation(i)
        enddo
        write (unitout,*) 

      else if (unitout .eq. 0) then
cDebug       write (*,*) 'cmd_annote: len_annote=',len_annote
cDebug     &		, annoteoptions, currentoptions
        do i = 1, len_annote
          write (*,'(a80)') annotation(i)
c          write (*,'(a, i2, a60)') 'cmd_annote:', i, annotation(i)
        enddo
        write (*,*) 

      else if (unitout .lt. 0) then

      endif

cDebug      write (*,*) 'cmd_annotation:1 i, j', indxunique1(1),indxunique2(1)
      call plot_txtinfo(annotation, len_annote)
cMoved      call plot_txtinfo(annotation, len_annote, version_stamp, .true.)
cDebug      write (*,*) 'cmd_annotation:1 i, j', indxunique1(1),indxunique2(1)
      call plot_labelinfo(arrin, nunique, uniqueLabel, 
     &      indxunique1, indxunique2, multiplicity,
     &	    pointsize, circsize, overridesize, rainbow)

      return
      end


c==========================================================================
      subroutine cmd_modify()
C modify Q, E, and npts
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_modmenu.inc'
      include 'spur_buf.inc'

c...	functions
      logical bit_on

c...	passed variables
c02Mar      real ec, es
c02Mar      REAL*4 hc(3), hs(3)
c02Mar      real fe
c02Mar      integer npts
c02Mar      CHARACTER*5 mon

c...	local variables
      character*5 key
      integer i
      character*72 aline
      integer newbit

      aline = 'Modify buffer parameters.'
c     &'Modify parameters. Remember: these are not written to *.bufout!'

      current_modop = 0
      add_modop = 0

      do while (.not. bit_on(add_modop,bit_modquit)) 
        call load_mod_itemvalue()
c02Mar        call load_mod_itemvalue(ec, es, hc, hs, fe, npts, mon)
        call display_submenu(aline, key, current_modop, add_modop,
     &	      len_modmenu, modmenu, moditemvalue, modmenuitem, .true.)
c        call display_modmenu(aline, key, current_modop, add_modop,
c     &	      len_modmenu, modmenu, moditemvalue, modmenuitem)

	 call which_bit(add_modop,newbit,1)
 220	 if ((newbit .eq. 0) .or. (newbit .gt. len_modmenu)) then
	   write (*,*) 'cmd_modify: newbit is out of range ', newbit
	   goto 555
	 else
	   write (*,'(a,a)') modmenu(newbit), ' Enter value(s):'
c	   write (*,'(a,a,$)') modmenu(newbit), ' Enter value(s):'
	 endif

c...	Lattice:
         if (bit_on(add_modop,bit_lp) ) then
	   read(*,*,err=220) (qb_lattice_a(i),i=1,3)

         else if (bit_on(add_modop,bit_la) ) then
	   read(*,*,err=220) (qb_lattice_angle(i),i=1,3)

c...	Energy
         else if (bit_on(add_modop,bit_ec) ) then
	   read(*,*,err=220) qb_energy_ec

         else if (bit_on(add_modop,bit_es) ) then
	   read(*,*,err=220) qb_energy_es

         else if (bit_on(add_modop,bit_fe) ) then
	   read(*,*,err=220) qb_energy_fe

         else if (bit_on(add_modop,bit_mo) ) then
ccc	   read(*,*,err=220) qb_energy_fix;	
c	!! Toggle instead
	  if (qb_energy_fix .eq. '(MON)') then
	     qb_energy_fix  = '(ANA)'
	  else
	     qb_energy_fix  = '(MON)'
	  endif

         else if (bit_on(add_modop,bit_dm) ) then
	   read(*,*,err=220) qb_energy_dm

         else if (bit_on(add_modop,bit_da) ) then
	   read(*,*,err=220) qb_energy_da

c...	Space:
         else if (bit_on(add_modop,bit_qc) ) then
	   read(*,*,err=220) (qb_space_hc(i),i=1,3)

         else if (bit_on(add_modop,bit_qs) ) then
	   read(*,*,err=220) (qb_space_hs(i),i=1,3)

c...	Orient:
         else if (bit_on(add_modop,bit_uu) ) then
	   read(*,*,err=220) (qb_orient_u(i),i=1,3)

         else if (bit_on(add_modop,bit_vv) ) then
	   read(*,*,err=220) (qb_orient_v(i),i=1,3)

c...	Temp:
c         else if (bit_on(add_modop,bit_tc) ) then
c	   read(*,*,err=220) qb_temp_tc

         else if (bit_on(add_modop,bit_t0) ) then
	   read(*,*,err=220) qb_temp_t0
	   if (qb_temp_t0 .lt. 0) goto 220

         else if (bit_on(add_modop,bit_ts) ) then
	   read(*,*,err=220) qb_temp_incT

c...	Time:
         else if (bit_on(add_modop,bit_np) ) then
	   read(*,*,err=220) qb_time_scanpts
	   if ((qb_time_scanpts .lt. 0) .or. 
     &	       (qb_time_scanpts .gt. maxnpts)) goto 220

         else if (bit_on(add_modop,bit_modhelp) ) then 
	   call help('', 'spurion', 
     &	   'spurion MainMenu mm_ModifyMenu')
         else if (bit_on(add_modop,bit_modquit) ) then 
	 else
	   write (*,*) 'cmd_modify: Unrecognized command: "', key, '"'
         endif

c...	old menu style
c         if (bit_on(add_modop,bit_ec) ) then 
c220         write(*,'(a,$)') 'New E-center: '
c            read(*,*,err=220) ec
cc         endif

c         else if (bit_on(add_modop,bit_es) ) then 
c222         write(*,'(a,$)') 'New E-step: '
c            read(*,*, err=222) es
cc         endif

c         else if (bit_on(add_modop,bit_qc) ) then 
c224         write(*,'(a,$)') 'New Q-center: '
c            read(*,*, err=224) (hc(i),i=1,3)
cc         endif

c         else if (bit_on(add_modop,bit_qs) ) then 
c226         write(*,'(a,$)') 'New Q-step: '
c            read(*,*,err=226) (hs(i),i=1,3)
cc         endif

c         else if (bit_on(add_modop,bit_mo) ) then 
c            if (mon.eq.'(MON)') then
c               mon='(ANA)'
c            elsec
c               mon='(MON)'
c            endif
cc         endif

c         else if (bit_on(add_modop,bit_fe) ) then 
c228        write(*,'(a,$)') 'Fixed energy?  '
c           read(*,*,err=228) fe
cc         endif

c         else if (bit_on(add_modop,bit_np) ) then 
c230         write(*,'(a,$)') 'How many points? '
c            read(*,*,err=230) npts
cc         endif

c         else if (bit_on(add_modop,bit_modhelp) ) then 
cc	   call help('', 'spurion', 'spurion')
cc         endif

c         else if (bit_on(add_modop,bit_modquit) ) then 
cc	   do i = 1, len_modmenu
cc             write(unitspur,*) modmenuitem(i), ' : ', modmenu(i),
cc     &     '   ', moditemvalue(i)
cc	   enddo

c	 else
c	   write (*,*) 'cmd_modify: Unrecognized command: "', key, '"'
c         endif

 555    continue
      enddo
      
      return
      end


c==========================================================================
      subroutine cmd_selecttolerance()
C set the AA^-1 tolerence for spurion matches
    
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'

c...	common blocks
      real tol, etol		!! spatial and energy tolerances       
      common /spur/ tol, etol

c...	passed variables
c...	local variables

 480     write(*,'(a,f5.3,a,$)') 'Current rlv tolerance ',tol,
     &        ' AA^-1.  Enter new value. '
         read(*,*, err=480) tol
         if (.not.(tol .gt. 0.0)) then
            write(*,*) 'Must be a positive value.'
            go to 480
         endif
         write(unitspur,*) 'New spatial tolerance is ',tol,' AA^-1.'

 580     write(*,'(a,f5.3,a,$)') 'Current energy  tolerance ', etol,
     &        ' meV?.  Enter new value. '
         read(*,*, err=580) etol
         if (.not.(etol .gt. 0.0)) then
            write(*,*) 'Must be a positive value.'
            go to 580
         endif
         write(unitspur,*) 'New energy tolerance is ', etol,' meV?.'

      return
      end

c==========================================================================
      subroutine cmd_BumpA4( phimax, pi)
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'

c...	passed variables
      real phimax, pi

c...	local variables

 580     write(*,'(a,f5.1,a,$)') 'Current max A4 ',phimax*180.0/pi,
     &        ' degrees.  Enter new value. '
         read(*,*,err=580) phimax
         if (.not.(phimax.gt.0).or.(phimax.gt.180)) then
            write(*,*) 'Must be between 0 and 180.'
            go to 580
         endif
         write(unitspur,*) 'New A4 max is ',phimax,' degrees.'
c         write(8,*) 'New A4 max is ',phimax,' degrees.'
         phimax=pi*phimax/180.0

      return
      end


c==========================================================================
      subroutine cmd_genICPrun(mon, npts, bmatuv, h, q, hc, hs, ki, 
     &      ec, es, en, ei, ef, fe, da, dm, a2, a3, a4, a6, pi)
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'

c...	passed variables
      CHARACTER*5 mon
      integer npts
      real bmatuv(3,3),h(3),q(3)
      REAL*4 hc(3), hs(3)
      real ki(2)
      real ec, es
      real en, ei, ef, fe, da, dm
      real a2, a3, a4, a6
      real pi

c...	local variables
      integer k, j
      logical fail

       OPEN(UNIT=uniticp,FILE=file_icp,STATUS='UNKNOWN', err=660)

        write(*,*) 'Pt#  E(meV)   Qh    Qk    Ql     A2       ',
     &        'A3      A4       A6'
         write(*,*) '---  ------ ----- ----- ----- --------',
     &        ' -------- -------- --------'
        write(uniticp,*,err=666) 'Pt#  E(meV)   Qh    Qk    Ql',
     &        '     A2       A3      A4       A6'
         write(uniticp,*,err=666) '---  ------ ----- ----- ----- ',
     &        '-------- -------- -------- --------'
 484     format(i3,2x,f6.2,1x,f5.2,1x,f5.2,1x,f5.2,1x,f8.3,1x,f8.3,
     &        1x,f8.3,1x,f8.3)
c 484     format(1x,i2,2x,f6.2,1x,f5.2,1x,f5.2,1x,f5.2,1x,f8.3,1x,f8.3,
c     &        1x,f8.3,1x,f8.3)
         do k=1,npts
            en=ec+(k-(float(npts)+1.0)/2.0)*es
            do j=1,3
               h(j)=hc(j)+(k-(float(npts)+1.0)/2.0)*hs(j)
            enddo

            if (mon.eq.'(MON)') then
               ei=fe
               ef=ei-en
            else
               ef=fe
               ei=ef+en
            endif

            a2=180.0/pi*2.0*asin(pi*sqrt(k2_to_E/ei)/dm)
            a6=180.0/pi*2.0*asin(pi*sqrt(k2_to_E/ef)/da)
c02Apr            a2=180.0/pi*2.0*asin(pi*sqrt(2.072/ei)/dm)
c02Apr            a6=180.0/pi*2.0*asin(pi*sqrt(2.072/ef)/da)
            call calcki(bmatuv,h,ei,ef,q,ki,fail,a4,a3,k)
            a3=180/pi*a3
            a4=180/pi*a4
            write(*,484) k,en,(h(j),j=1,3),a2,a3,a4,a6
            write(uniticp,484,err=666) k,en,(h(j),j=1,3),a2,a3,a4,a6
         enddo

      go to 999
 660  write (*,*) 'cmd_genICPrun: Error opening file:', file_icp

      go to 999
 666  write (*,*) 'cmd_genICPrun: Error writing to file:', file_icp
 
 999  CLOSE(uniticp)

      return
      end

c==========================================================================
      subroutine cmd_selectReflection( sp, spurtitle, m_rlv, 
     &      hh, kk, ll, zeta, eta, absent, sfhkl, selct_sfhkl, 
     &	    qlow, qhigh)
C  Sf^2 printout
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'

c...	functions
c02May      logical inqrange
      
c...	passed variables
      integer sp(3)
      character*10 spurtitle
      integer m_rlv
      integer hh(m_rlv_max,m_rlv_max)
      integer kk(m_rlv_max,m_rlv_max)
      integer ll(m_rlv_max,m_rlv_max)
      REAL*4 zeta(m_rlv_max,m_rlv_max), eta(m_rlv_max,m_rlv_max)
      logical absent(m_rlv_max,m_rlv_max)
      real sfhkl(m_rlv_max,m_rlv_max), selct_sfhkl
      real qlow, qhigh

c...	local variables
      integer len, i, j
      logical firsttime

      firsttime = .true.
      
100      write(*,'(a,$)') 'h k l of desired reflection? '
C just use sp variable for double duty
         read(*,*,err=100) (sp(i),i=1,3)
         call title(sp,spurtitle,len)
C  try to match with one of the calculated points
         do i=1,m_rlv
            do j=1,m_rlv
               if ((hh(i,j).eq.sp(1)).and.(kk(i,j).eq.sp(2)).and.
     &              (ll(i,j).eq.sp(3))) goto 421
            enddo
         enddo

	 if (firsttime) then
           write (*,*) 'Possible reflections:'
           do i=1,m_rlv
             do j=1,m_rlv
c02May		if (inqrange(qlow, qhigh, zeta(i,j), eta(i,j))) then
		  if (absent(i,j)) then
		    write (*, 110) hh(i,j), kk(i,j), ll(i,j),
     &			     sfhkl(i,j), ' in range'
		  else
		    write (*, 112) hh(i,j), kk(i,j), ll(i,j), ' absent'
		  endif
cDebug		else
cDebug		  write (*, 110) hh(i,j), kk(i,j), ll(i,j), ' out range'
c02May		endif
              enddo
           enddo
110       format ('Sf^2(', I3, ',', I3, ',', I3, ')=', g12.5, a )
112       format ('Sf^2(', I3, ',', I3, ',', I3, ')=', 12x, a )
           write (*,*) ''
	   firsttime = .false.
	   goto 100
	 else
	   selct_sfhkl = -666.6
           write(*,'(3a)') 'Sorry, ',spurtitle(1:len),
     &              ' reflection does not match those generated.'
           goto 999
	 endif
	 
 421     if (absent(i,j)) then
            write(*,'(2a)') spurtitle(1:len),
     &              ' reflection is systematically absent.'
            write(unitstruct,'(2a)') spurtitle(1:len),
     &              ' reflection is systematically absent.'
c            write(7,'(2a)') spurtitle(1:len),
c     &              ' reflection is systematically absent.'
	     selct_sfhkl = 0.0
         else
            write(*,'(3a,f8.3)') 'Sf^2',spurtitle(1:len),' = ',
     &                sfhkl(i,j)
            write(unitstruct,'(3a,f8.3)') 'Sf^2',spurtitle(1:len),' = ',
     &                sfhkl(i,j)
c            write(7,'(3a,f8.3)') 'Sf^2',spurtitle(1:len),' = ',
c     &                sfhkl(i,j)
	     selct_sfhkl = sfhkl(i,j)
         endif
	 
999   return
      end



c==========================================================================
c      logical function inqrange(qlow, qhigh, zzeta, eeta)
cc...	Removed May 2002
c      implicit none
cc      include 'arraysize.inc'
c      
cc..	passed variables      
c      real qlow, qhigh
c      real zzeta
c      real eeta
c     
cc...	local variables
c      real qq
c      
c      qq = zzeta*zzeta + eeta*eeta 
c      if ((qq .ge. qlow) .and. (qq. le. qhigh)) then
c        inqrange = .true.
c      else
c        inqrange = .false.
c      endif
c      
c      return
c      end

      subroutine logscale(z1,z2,multmax,pmax,dec)
C  determine a suitable range for a truncated log scale

      implicit none
c...	functions
      integer myint
      
c...	passed variables
      integer dec,multmax,pmax
      real z1,z2

c...	local variables

C      z1=.89e-4
C      z2=.120e+3

C      write(*,'(a,g7.2,2x,g7.2)') 'min and max data range ',z1,z2
C how many decades between z1 and z2? should be at least 2 if this
C routine is called, put in a bit of overshoot tolerence      

      dec=int(log10(z2/z1)-.05)+1
C      write(*,*) dec,' decades'

C what is the multiplier that should be used for the maximum
C value?
      
      pmax=myint(log10(z2))
      multmax=int(.9+z2/10.0**pmax)
cUnused      pmin=myint(log10(z1))
cUnused      multmin=int(.1+z1/10.0**pmin)
C      write(*,*) 'maxmultiplier is ',multmax,' maxpower is ',pmax
C      write(*,*) 'minmultiplier is ',multmin,' minpower is ',pmin
C      write(*,*) 'maximum at ',float(multmax)*10.0**float(pmax)
C      write(*,*) 'minimum at ',float(multmax)*10.0**float(pmax-dec)
      return
      end

c=======================================================================
      integer function myint(x)

      implicit none
      real x
c      integer myint

      if (x.lt.0.0) then
        myint=int(aint(x+.1e-10)-1.0)
      else
        myint=int(x)
      endif

      return
      end

      subroutine pulverix(hkl,absent)
C-----******************************************************************PULV0000
C-----*          *** LNS VAX VERSION 1989 ***
C-----*          *** including modifications for profile plot
C-----*              and profile refinement
C-----*              - fo 2500 hkl ***
C-----*                                                                *
C-----*              P  U  L  V  E  R  I  X                            *
C-----*                                                                *
C-----******************************************************************
C-----*                                                                *
C-----* ROUTINE TO CALCULATE THEORETICAL POWDER PATTERNS               *
C-----* USING THE DATA FILE PREPARED BY  L  A  Z  Y                    *
C-----*                                                                *
C-----* AUTHORS                                                        *
C-----* K.YVON, W.JEITSCHKO  AND E.PARTHE                              *
C-----* modified  3.87 to prepare CPDF/PROFIL input file by P.ZOLLIKER *

      implicit none
c...	common blocks

c	Dec 4, 2001. TR. Added common block /INPUT/ so have access to ISYMCE
      character*76 COMPND
      character*4 ielmt(16)
      real FOCCU(50,16), FMULT(50,16)
      real FNEUT(16)
      real A,B,C,ALPHA,BETA,GAMMA
      real SYMSY				!! Unused in code
      integer ISYMCE, NCOMPO
      integer NA(16)
      real wl, SL,SH, AGUIN, BGUIN
      real BTEMP(50,16), DELFR(16), DELFI(16)
      integer IMAGE, ns
      character*4 norm,iano
      COMMON /INPUT/ COMPND,IELMT,FOCCU,FMULT,FNEUT,
     &		A,B,C,ALPHA,BETA,GAMMA,
     &		SYMSY,ISYMCE,NCOMPO,NA,WL,SL,SH,NORM,IMAGE,AGUIN,
     &		BGUIN,BTEMP,DELFR,DELFI,IANO,NS

      integer ibravl,isystm
      common /cell/ ibravl,isystm

      integer ihoo,ioko,iool,ihko,ihol,iokl,ihhl,ilau,itrig
      COMMON /EXTI/ IHOO,IOKO,IOOL,IHKO,IHOL,IOKL,IHHL,ILAU,ITRIG

c...	passed variables
      integer hkl(3)
      logical absent
cCommonBlock      integer ISYMCE

c...	local variables
       real xh, xk, xl 
       real testbr, facehk,  HKO, FIHKO,  FIOKL, OKL, FIHOL, HOL 
       real FIHHL, HOO,  FIHOO, FIOOL, oko, fioko, ool, temp
       integer n
       
C      integer limit1 
C      parameter (limit1=24)
C      integer yh(limit1),yk(limit1),yl(limit1)
C      real q(limit1)


C      ipr=2
      absent=.true.
C      write(*,*) 'i am in pulverix ',ibravl,isystm
C      write(*,'(a,3i3,a)') '(',hkl(1),hkl(2),hkl(3),')'
C      write(*,'(9i3)') IHOO,IOKO,IOOL,IHKO,IHOL,IOKL,IHHL,ILAU,ITRIG
      xh=float(hkl(1))
      xk=float(hkl(2))
      xl=float(hkl(3))
      
C-----OMIT HKL VALUES CORRESPONDING TO BRAVAIS LATTICE EXTINCTIONS      PULV0352
C recall: 1) primitive, 2) body-centred, 3) rhombohedral, 4) face-centred
C         5) a-centred, 6) b-centred, 7) c-centred

 32   GO TO (40,33,34,35,36,37,38), IBRAVL
 33   TESTBR=(XH+XK+XL)/2.                       ! I
      GO TO 39
 34   TESTBR=(-XH+XK+XL)/3.                      ! R
      GO TO 39
 35   FACEHK=(XH+XK)/2.                          ! F (at least h+k even)
      IF ((AINT(FACEHK)-FACEHK).NE.0.) GO TO 38  ! (to 38 from 39) if not even jump ahead
 36   TESTBR=(XK+XL)/2.                          ! A
      GO TO 39
 37   TESTBR=(XH+XL)/2.                          ! B
      GO TO 39
 38   TESTBR=(XH+XK)/2.                          ! C

 39   IF ((AINT(TESTBR)-TESTBR).NE.0.) GO TO 68  ! absent reflection

C-----OMIT HKL VALUES CORRESPONDING TO EXTINCTIONS                      PULV0366
C  these exinctions were calculted by EXTINC.F in lazy and are
C  contained in the ihko type of variables

C ihko: 1: no conditions   2,4: h+k=IHKO*n
C       3: k=2n              5: h=2n
 40   IF (XL.EQ.0.) GO TO (41,50,49,50,47), IHKO

C iokl: 1: no conditions   2,4: k+l=IOKL*n
C       3: l=2n              5: k=2n
 41   IF (XH.EQ.0.) GO TO (42,54,53,54,51), IOKL

C ihol: 1: no conditions   2,4: h+l=IHOL*n
C       3: l=2n              5: h=2n
 42   IF (XK.EQ.0.) GO TO (43,58,57,58,55), IHOL

C these next hhl conditions for cubic system don't make
C allowance for (h -h l) which is identical for these
C systems (hopefully)

C ihhl: 1: no conditions   2: l=2n
C       3: 2h+l=4n
 43   IF (abs(XH).EQ.abs(XK)) GO TO (44,59,61), IHHL

C ihkk and cubic : 1: no conditions   2: h=2n
C                  3: h+2k=4n         4: switched cubic ? was 44
      IF ((abs(XK).EQ.abs(XL)).AND.(ISYSTM.EQ.5))
     &   GO TO (44,62,63), IHHL

C added this condition which was previously missing
C ihkh and cubic : 1: no conditions   2: k=2n
C                  3: 2h+k=4n         4: switched cubic ? was 44
      IF ((abs(XH).EQ.abs(XL)).AND.(ISYSTM.EQ.5))
     &   GO TO (44,162,163), IHHL


C line 133 is an error message for an impossible condition
 44   IF (XK.EQ.0..AND.XL.EQ.0.) GO TO (45,64,133,64), IHOO
 45   IF (XH.EQ.0..AND.XL.EQ.0.) GO TO (46,65,133,65), IOKO
 46   IF (XH.EQ.0..AND.XK.EQ.0.) GO TO (67,66,66,66,133,66), IOOL
      GO TO 67

C  testing!

 47   FIHKO=XH/2.         ! h=2n condition  (hko=5)
 48   IF (AINT(FIHKO)-FIHKO) 68,41,68   ! 68 says its absent (h does not = 2n)
 49   FIHKO=XK/2.         ! k=2n condition  (hko=3)
      GO TO 48
 50   HKO=IHKO            ! h+k= hko*n      (hko=2,4)
      FIHKO=(XH+XK)/HKO
      GO TO 48

 51   FIOKL=XK/2.         ! 
 52   IF (AINT(FIOKL)-FIOKL) 68,42,68
 53   FIOKL=XL/2.
      GO TO 52
 54   OKL=IOKL
      FIOKL=(XK+XL)/OKL
      GO TO 52

 55   FIHOL=XH/2.
 56   IF (AINT(FIHOL)-FIHOL) 68,43,68
 57   FIHOL=XL/2.
      GO TO 56
 58   HOL=IHOL
      FIHOL=(XH+XL)/HOL
      GO TO 56

 59   FIHHL=XL/2.
 60   IF (AINT(FIHHL)-FIHHL) 68,44,68
 61   FIHHL=(2.*XH+XL)/4.
      GO TO 60
 62   FIHHL=XH/2.
      GO TO 60
 63   FIHHL=(2.*XL+XH)/4.   ! h and l switched for this cubic system
      GO TO 60
 162  FIHHL=XK/2.
      GO TO 60
 163  FIHHL=(2.*XH+XK)/4.   ! k and l switched for this cubic system
      GO TO 60

 64   HOO=IHOO
      FIHOO=XH/HOO
      IF (AINT(FIHOO)-FIHOO) 68,45,68
C 65   FIOKO=XK/2.    ! won't work if oko is 4 (a possibility)
 65   oko=ioko
      fioko=xk/oko
      IF (AINT(FIOKO)-FIOKO) 68,46,68
 66   OOL=IOOL
      FIOOL=XL/OOL
      IF ((AINT(FIOOL)-FIOOL).NE.0.) GO TO 68
C-----STORE HKL AND SIN2THETA VALUES OF F VALUES  TO BE CALCULATED      PULV0413
C at this point one really has a reflection
 67   absent=.false.
C      N=N+1
C-----CHECK IF NUMBER OF REFLECTIONS TOO LARGE                          PULV0415
C      IF (N.GT.LIMIT1) GO TO 72
C      Q(N)=ATEST
C      YH(N)=XH
C      YK(N)=XK
C      YL(N)=XL
C      JJ=N
C      J=JJ-1

c01Dec Zh, ZK, ZL are not initialized.
 68   IF (ILAU.EQ.2) GO TO 9
      GO TO (9,9,9,69,70,69,9), ISYSTM
 69   continue
 70   continue
c01DecC-----SKIP REFLECTIONS RELATED BY LAUE SYMMETRY                         PULV0423
c01Dec 68   IF ((ILAU.EQ.2).OR.(ZH.EQ.XK)) GO TO 9
c01Decc      GO TO (9,9,9,69,70,69,9), ISYSTM
c01Dec 69   IF ((ZH.GT.ZK).AND.(ZK.GT.0.)) GO TO 71
c01Dec      GO TO 9
c01Dec 70   IF ((ZH.GT.ZK).AND.(ZK.GT.ZL)) GO TO 71
      GO TO 9
C hmm, a little switch-aroo
 71   TEMP=XH
      XH=XK
      XK=TEMP
C back to beginning of loop
      GO TO 32
 72   continue
 73   continue
C-----PRINT HEX AND TETRAG LATTICE CONSTANTS, END OF HKL GENER.LOOP     PULV0434
  9   continue
  716 FORMAT(8F10.3)
C-----PRINT LAUE SYMMETRY                                               PULV0448
C recall isystm: 1: monoclinic  2: orthorhomic  3: trigonal
C                4: tetragonal  5: isometric    6: hexagonal    
C                7: triclinic
  804 IF (ISYSTM.LT.3) GO TO 74
      N=10     ! low Laue symmetry (really for triclinic?)
      IF (ILAU.EQ.2) N=11  ! high Laue symmetry
c01Dec      IF (LAUE.EQ.2) N=11  ! high Laue symmetry
C      WRITE (IPR,145) ITIT(N)
 74   N=12                     ! no Laue symmetry
C-----PRINT SYMMETRY CENTER                                             PULV0454
      IF (ISYMCE.EQ.1) N=13
C      WRITE (IPR,146) ITIT(N)
C-----PRINT BRAVAIS LATTICE AND EXTINCTIONS                             PULV0457
      N=IBRAVL*3-2
C      WRITE (IPR,147) JB(N),JB(N+1),JB(N+2)
 81   CONTINUE
      return
C-----
C-CDC-CALL EXIT                                                         PULV0825

 133  write(*,194)
      write(*,*) 'finished pulverix'
      return

C-----                                                                  PULV0826
 138  FORMAT (   ///,23H START  P U L V E R I X     )
 139  FORMAT (/39H B Y E  B Y E  L A Z Y  P U L V E R I X  )
 140  FORMAT (4H JOB  ,I5,40H IS BAD DUE TO ERROR IN PREVIOUS PROGRAM,/1
     16H GO TO NEXT JOB ,//)
 141  FORMAT (1H //////)
 142  FORMAT (4H JOB,I5/ )
 143  FORMAT (/2X,9H DIAMETER,F9.4,3H MM,/2X,60H ANGLE BETWEEN NORMAL TO
     1 PLANE OF SPECIMEN AND INCIDENT BEAM,F7.2,5H DEG.,/2X,27H D-SPACIN
     2G OF MONOCHROMATOR,F7.3,9H ANGSTROM)
 144  FORMAT ( /12H SPACE GROUP,A4,22H GIVEN ON SPCGRP-CARD ,36A1)
 145  FORMAT (/1X,A4,14H LAUE SYMMETRY)
 146  FORMAT (/10H THERE IS ,A2,30H SYMMETRY CENTRE AT THE ORIGIN)
 147  FORMAT (/1X,3A4,16H BRAVAIS LATTICE)
 148  FORMAT ( /41H CONDITIONS LIMITING POSSIBLE REFLECTIONS  /)
 174  FORMAT (19H HKO WITH H=2N ONLY)
 175  FORMAT (19H HKO WITH K=2N ONLY)
 176  FORMAT (14H HKO WITH H+K=,I1,6HN ONLY)
 177  FORMAT (19H OKL WITH K=2N ONLY)
 210  FORMAT (19H OKL WITH L=2N ONLY)
 178  FORMAT (14H OKL WITH K+L=,I1,6HN ONLY)
 179  FORMAT (19H HOL WITH H=2N ONLY)
 180  FORMAT (19H HOL WITH L=2N ONLY)
 181  FORMAT (14H HOL WITH H+L=,I1,6HN ONLY)
 182  FORMAT (19H HHL WITH L=2N ONLY)
 183  FORMAT (22H HHL WITH 2H+L=4N ONLY)
 184  FORMAT (12H HOO WITH H=,I1,6HN ONLY)
 185  FORMAT (19H OKO WITH K=2N ONLY)
 186  FORMAT (12H OOL WITH L=,I1,6HN ONLY)
 187  FORMAT (/21H MONOCLINIC STRUCTURE)
 188  FORMAT (/20H TRICLINIC STRUCTURE)
 189  FORMAT (/23H ORTHORHOMBIC STRUCTURE)
 190  FORMAT (/19H TRIGONAL STRUCTURE)
 191  FORMAT (/21H TETRAGONAL STRUCTURE)
 192  FORMAT (/16H CUBIC STRUCTURE)
 193  FORMAT (/20H HEXAGONAL STRUCTURE)
 194  FORMAT(/53H SOMETHING VERY BAD HAPPENED. CALL THE AUTHORS PLEASE)
 208  FORMAT(10H HKL  NONE)
 209  FORMAT(21H HKL WITH K+L=2N ONLY)
 215  FORMAT(21H HKL WITH H+L=2N ONLY)
 211  FORMAT(21H HKL WITH H+K=2N ONLY)
 212  FORMAT(40H HKL WITH H,K,L ALL EVEN OR ALL ODD ONLY )
 213  FORMAT(23H HKL WITH H+K+L=2N ONLY)
 214  FORMAT(24H HKL WITH -H+K+L=3N ONLY)
C220  FORMAT(4I5)
 220  FORMAT(5I5)
      END

c		plotspur.f
c===================================================

      subroutine rank_higher(nspurtot, nelastictot)
      implicit none
      include 'arraysize.inc'
      include 'spur_scan.inc'

c...	passed variables
      integer nspurtot, nelastictot
      
c...	local variables
      integer ihigh, ii, jj, i
      logical firstmatch

c...	Higher order spurions which hit bragg peaks.
	ihigh = 0
	do ii = 1, n_spur_max
	  do jj = 1, n_spur_max
	    firstmatch = .true.
	    do i = 1, nspurtot
	      if ((ii .eq. ispur(i))  .and. (jj .eq. jspur(i))) then
		if (firstmatch) then
	          ihigh = ihigh + 1
		  firstmatch = .false.
		endif
	        rankspot(i) = ihigh
c	        write (*,*) 'rank_higher: Bragg ', i,
c     &		   ispur(i), jspur(i), ihigh, rankspot(i)
	      endif
	    enddo
	  enddo
	enddo
	n_rankspot = ihigh
	
c	do i = 1, nspurtot
c	  write (*,*) 'rank_higher: Bragg ', i,
c     &		   ispot(i), jspot(i), rankspot(i)
c	enddo

c...	Higher order spurions which are elastic.
	ihigh = 0
	do ii = 1, n_spur_max
	  do jj = 1, n_spur_max
	    firstmatch = .true.
	    do i = 1, nelastictot
	      if ((ii .eq. ielst(i))  .and. (jj .eq. jelst(i))) then
		if (firstmatch) then
	          ihigh = ihigh + 1
		  firstmatch = .false.
		endif
	        rankelst(i) = ihigh
c	        write (*,*) 'rank_higher: Elastic ', i,
c     &		   ielst(i), jelst(i), ihigh, rankelst(i)
	      endif
	    enddo
	  enddo
	enddo
	n_rankelst = ihigh

c	do i = 1, nelastictot
c	  write (*,*) 'rank_higher: Elastic ', i,
c     &		   ielst(i), jelst(i), rankelst(i)
c	enddo


      
      return
      end

c===================================================
      subroutine prepspur(nn_spur, nspurtot,
     &	mm_rlv,qspur,espur,nspur,
     &  zeta,eta,hh,kk,ll,
     &  ki,kf,absent,replot, nelastic, nelastictot, iscan)

C  Prepare spurious Q's for plotting

      implicit none
      include 'arraysize.inc'
      include 'spur_color.inc'
      include 'spur_scan.inc'
      include 'io_files.inc'
      
c...	common blocks
      real tol, etol		!! spatial and energy tolerances   		
      common /spur/ tol, etol

c...	passed variables
      integer nn_spur		!!  = n_spur_max
      integer  nspurtot, mm_rlv
      real qspur(2,n_spur_max,n_spur_max)
      real espur(n_spur_max,n_spur_max)
      integer nspur
      real ki(2),kf(2)
      real zeta(m_rlv_max,m_rlv_max),eta(m_rlv_max,m_rlv_max)
      integer hh(m_rlv_max,m_rlv_max)
      integer kk(m_rlv_max,m_rlv_max)
      integer ll(m_rlv_max,m_rlv_max)
      logical absent(m_rlv_max,m_rlv_max)
      logical replot
      integer nelastic		
      integer nelastictot
      integer iscan
      character*80 aline

c...	local variables
      integer i,j,k,l
      integer iwhere
      
C  Count the number of spurion matches

c      write (*,*) 'plotspur: nn_spur = ', nn_spur
      nspur=0
      nelastic=0

      do i=1,nn_spur
        do j=1,nn_spur

C  Don't include the primary scattering as spurious.
          
          if ((i.ne.1).or.(j.ne.1)) then

C  Elastic spurions in red, others in yellow
c...		Exclude case of i=j
            
            if ((abs(espur(i,j)) .lt. etol) .and. (i .ne. j)) then

	      if (nelastic+nelastictot+1 .gt. n_spurbragg_max) goto 670
	      nelastic = nelastic + 1
ccc	      nelastictot = nelastictot + 1
	
	      iwhere = nelastic+nelastictot
              ielst(iwhere)=i
              jelst(iwhere)=j
              scanpt_elst(iwhere)=iscan	!! where in the scan
            else
cPlot              call pgsci(color_yellow)			!! yellow: inelastic
            endif

C  Show i*ki and -j*kf leading to spurious process.  There will
C  be overlaps and colour based on the earlier elastic condition.   

C  Now check to see if the spurious process matches a reciprocal
C  lattice point.
            do k=1,mm_rlv
              do l=1,mm_rlv
                if ((abs(zeta(k,l)-qspur(1,i,j)).lt.tol).and.
     &              (abs(eta(k,l)-qspur(2,i,j)).lt.tol).and.
     &               .not.absent(k,l)) then

		  if (nspur+nspurtot+1 .gt. n_spurbragg_max) goto 680

C  For a match increase the count by 1.
                  nspur=nspur+1

C  Record the spurion indicies (i and j) and the (hkl) of the
C  reciprocal lattice point.

		  iwhere = nspur+nspurtot
C...  		Show i*ki and -j*kf leading to spurious process.
		  ispur(iwhere)=i	!! higher spurion index 
                  jspur(iwhere)=j	!! higher spurion index

c...		Prepare q=(h,k,l) info for the lattice plot page
                  hspur(iwhere)=hh(k,l)
                  kspur(iwhere)=kk(k,l)
                  lspur(iwhere)=ll(k,l)

c...		Prepare stuff for scan plot page (new, March 2002)
                  ispot(iwhere)=k	!! Bragg index
                  jspot(iwhere)=l	!! Bragg index
                  scanpt_spot(iwhere)=iscan	!! where in the scan

cDon'tNeed                  int_spot(nspur+nspurtot)=sfhkl(k,l)	!! Bragg intens.

                endif
C  If no match just skip to the next reciprocal lattice point.
              enddo
            enddo

          endif
        enddo
      enddo

      goto 999

670   write (aline,*)  nelastictot, '# of elastic spurions', 
     &		' exceeds array length n_spurbragg_max', n_spurbragg_max
      write (unitlog,*) aline
      write (unitspur,*)  aline
      goto 999

680   write (aline,*)  nspurtot, '# of spurions matching Bragg peaks', 
     &		' exceeds array length n_spurbragg_max', n_spurbragg_max
      write (unitlog,*) aline
      write (unitspur,*)  aline

999   return
      end


c===============================================================================
      subroutine plotspur(nn_spur,
     &	mm_rlv,qspur,espur, circsize,
     &  zeta,eta,
     &  ki,kf,absent,replot, iscan)

C  Plot spurious Q's that have been prepared

      implicit none
      include 'arraysize.inc'
      include 'spur_color.inc'
      include 'spur_scan.inc'
      
c...	common blocks
      real tol, etol		!! spatial and energy tolerances   		
      common /spur/ tol, etol

c...	passed variables
      integer nn_spur		!!  = n_spur_max
      integer   mm_rlv
      real qspur(2,n_spur_max,n_spur_max)
      real espur(n_spur_max,n_spur_max)
      real circsize
      real ki(2),kf(2)
      real zeta(m_rlv_max,m_rlv_max),eta(m_rlv_max,m_rlv_max)
      logical absent(m_rlv_max,m_rlv_max)
      logical replot
      integer iscan

c...	local variables
      integer i,j,k,l
      real temp


      do i=1,nn_spur
        do j=1,nn_spur

C  Don't include the primary scattering as spurious.
          
          if ((i.ne.1).or.(j.ne.1)) then

C  Elastic spurions in red, others in yellow
c...	Exclude case of i=j for elastic spurions.
            
            call pgsfs(1)     ! solid fill style
            call pgsls(1)     ! solid outlines
            
            if ((abs(espur(i,j)) .lt. etol) .and. (i .ne. j)) then
              call pgsci(color_red)			!! red: elastic
            else
              call pgsci(color_yellow)			!! yellow: inelastic
            endif

	    temp = 1.1*circsize

cDebug	    write (*,*) 'plotspur: ', i, j, qspur(1,i,j),qspur(2,i,j), temp
            call pgcirc(qspur(1,i,j),qspur(2,i,j), temp)
c01Nov            call pgcirc(qspur(1,i,j),qspur(2,i,j),1.1*circsize)

C  Show i*ki and -j*kf leading to spurious process.  There will
C  be overlaps and colour based on the earlier elastic condition.   
C            call arrows(i,j,ki,kf)

C  Now check to see if the spurious process matches a reciprocal
C  lattice point.
            do k=1,mm_rlv
              do l=1,mm_rlv
                if ((abs(zeta(k,l)-qspur(1,i,j)).lt.tol).and.
     &              (abs(eta(k,l)-qspur(2,i,j)).lt.tol).and.
     &               .not.absent(k,l)) then


C  If the process matches display the arrows
                  if ((abs(espur(i,j)) .le. etol) .and. (i .ne. j))then
                     call pgsci(color_red)
                  else
                     call pgsci(color_yellow)
                  endif
                  call pgsls(2)
                  call arrows(i,j,ki,kf)

C  Plot ki and kf
                  call pgsci(color_ink)
                  call pgsls(2) ! dashed line 
                  CALL pgarro(0.0,0.0,ki(1),ki(2))
                  CALL pgarro(ki(1),ki(2),ki(1)-kf(1),ki(2)-kf(2))
                  call pgsls(1)

                endif
C  If no match just skip to the next reciprocal lattice point.
              enddo
            enddo

          endif
        enddo
      enddo

      return
      end

c=============================================================================
      subroutine reportspur(nn_spur, nspurtot, nelastictot, 
     &	qspur,espur, bmatuv_inv, ec, es, h, hc, hs, nscan, iscan)

      implicit none
      include 'arraysize.inc'
      include 'spur_color.inc'
      include 'spur_scan.inc'
      include 'spur_layout.inc'
      include 'io_files.inc'
      
c...	common blocks
      real tol, etol		!! spatial and energy tolerances   		
      common /spur/ tol, etol

c...	functions
      integer ilen

c...	passed variables
      integer nn_spur		!!  = n_spur_max
      integer  nspurtot, nelastictot
      real qspur(2,n_spur_max,n_spur_max)
      real espur(n_spur_max,n_spur_max)
      real bmatuv_inv(3,3)
      real ec, es
      REAL*4 h(3),hc(3),hs(3)
      integer nscan, iscan

c...	local variables
      integer i,j,ii, jj
      character*19 afloat_hkl
      character*(80)	line_scan, line_spur, line_info, aline
      logical firstbragg

C  		Print out the spurions


c...		Usually npts = nscan unless there was an error.
           do j=1,3
c             h(j)=hc(j)+(iscan-(float(npts)+1.0)/2.0)*hs(j)
             h(j)=hc(j)+(iscan-(float(nscan)+1.0)/2.0)*hs(j)
           enddo
	   
	   write (line_scan, 115) iscan,  
     &		   ec+(iscan-(float(nscan)+1.0)/2.0)*es, (h(j),j=1,3) 	   
c     &		   ec+(iscan-(float(npts)+1.0)/2.0)*es, (h(j),j=1,3) 	   
115	   format ('Scan point #=', i3, ' at dE=', f7.3, 
     &		' at Q=(',f6.2,1x,f6.2,1x,f6.2,')')
           write (unitspur, '(a)') line_scan
cWait!           write (*, '(a)') line_scan

	    firstbragg = .true.
	    
            do ii=1,nn_spur
             do jj=1,nn_spur
c	        if (( ii .ne. 1) .or. (jj .ne. 1)) then
	          call hkl_float(qspur(1,ii,jj), qspur(2,ii,jj), 
     &		    bmatuv_inv, afloat_hkl)
     		  write (line_spur, 124) ii, jj, afloat_hkl, espur(ii,jj)
124		  format (1x,i2, '*Ki - ', i2, '*Kf =',1x,
     &			a,' at E_spur=', f8.2)

		  if ( iscan .eq. nint(xmin_sc)) then
		    afloat_hkl_start(ii,jj) = afloat_hkl
		  endif
		  if ( iscan .eq. nint(xmax_sc)) then
		    afloat_hkl_end(ii,jj) = afloat_hkl
		  endif
c		endif

                  if (abs(espur(ii,jj)).lt. etol) then
     			if ( (firstbragg) .and. 
     &				(( ii .ne. 1) .or. (jj .ne. 1))) then
     			  firstbragg = .false.
			  write (*,*)
			  write (*, '(a80)') line_scan
			endif
		    write (line_info,*) ' Elastic red. '
c...		    Override  line_info, if there was match to a Bragg peak.		    
                     do i=1,nspurtot
		      if ((ispur(i).eq.ii) 
     &			 .and.(jspur(i).eq.jj) .and. 
     &			  (scanpt_spot(i) .eq. iscan) ) then

cMoved		    if (nspur .ne. 0) then
cMoved                     do i=nspurtot+1,nspurtot + nspur
cMoved		    if (nspur .ne. 0) then
cMoved		      if ((ispur(i+nspurtot).eq.ii) 
cMoved     &			 .and.(jspur(i+nspurtot).eq.jj) ) then

		        write (line_info,*) ' Elastic red.   Bragg'
		      endif
		     enddo
cMoved		    endif

c		report all those higher order spurions which are elastic
	            if (( ii .ne. 1) .or. (jj .ne. 1)) then
                      write (*, *) line_spur(1:ilen(line_spur)), 
     &		  	line_info(1:ilen(line_info))
     		    endif

		  else
		    write (line_info,*) ' Inelst yellow.'
c...		    Override  line_info, if there was match to a Bragg peak.
                     do i=1,nspurtot
		      if ((ispur(i).eq.ii) 
     &			 .and.(jspur(i).eq.jj) .and. 
     &			  (scanpt_spot(i) .eq. iscan) ) then

     			if (firstbragg) then
     			  firstbragg = .false.
			  write (*,*)
			  write (*, '(a)') line_scan
			endif

cMoved		    if (nspur .ne. 0) then
cMoved                     do i=nspurtot+1,nspurtot + nspur
cMoved		      if ((ispur(i+nspurtot).eq.ii) 
cMoved     &			 .and.(jspur(i+nspurtot).eq.jj)) then
		        write (line_info,*) ' Inelst yellow. Bragg'
c		        write (line_info,*) ' Inelastic (yellow) Bragg'
c		Only report those higher order spurions which hit Bragg peaks
	                if (( ii .ne. 1) .or. (jj .ne. 1)) then
c	                if (.not. (( ii .eq. 1) .and. (jj .eq. 1))) then
                          write (*, *) line_spur(1:ilen(line_spur)), 
     &			  	line_info(1:ilen(line_info))
     			endif
		      endif
		     enddo
		    endif
cMoved		  endif

c		  Write all higher order spurions to the file *.spur		  
                  write (unitspur, *) line_spur(1:ilen(line_spur)), 
     &		  	line_info(1:ilen(line_info))


             enddo
            enddo
	    
 26         format(a, f7.3, $)
 637        format(a,f6.2,1x,f6.2,1x,f6.2,a, $)
 24         format(1x,i2, '*Ki - ', i2, '*Kf =', $)
 25         format(1x,a,a,f8.2,a,i2,$)

cMoved            nspurtot=nspurtot+nspur


         write(unitspur,*) 		!! blank line between scan points
cAlready         write(*,*) 		!! blank line between scan points



C...  report if no spurions? At end of the scan, this summary.
      if (iscan .eq. nscan) then 
        write(*,*) 		!! blank line at end of scan points
	write(aline,200) nspurtot, ' matches of higher order spurions ', 
     &	 'to Bragg peaks, out of ',  n_spur_max, '^2 * ', nscan, 
     &		'=',  n_spur_max*n_spur_max*nscan
200     format (i4, a, a, i2, a, i4, a, i4)
        write (*,'(a80)') aline
        write (unitspur,'(a80)') aline
c	write(*,*) nspurtot, ' matches of higher order spurions ', 
c     &		'to Bragg peaks, out of ', n_spur_max*n_spur_max*nscan 
c	write(unitspur,*) nspurtot, ' matches of higher order spurions ', 
c     &		'to Bragg peaks, out of ', n_spur_max*n_spur_max*nscan 

	write(aline,200) nelastictot, ' elastic higher order spurions, ', 
     &		'out of ',  n_spur_max, '^2 * ', nscan, 
     &		'=',  n_spur_max*n_spur_max*nscan
        write (*,'(a80)') aline
        write (unitspur,'(a80)') aline
c	write(*,*) nelastictot, ' elastic higher order spurions, ', 
c     &		'out of ', n_spur_max*n_spur_max*nscan 
c	write(unitspur,*) nelastictot, ' matches of higher order spurions, ', 
c     &		'out of ', n_spur_max*n_spur_max*nscan 

      	write(*,*) ''
      	write(unitspur,*) ''

      endif
      
      return
      end

c	H2l_auto.F
c	Help 2 latex converter
c	Convert a VMS help file (*.hlp) to simple latex (*.tex) 
c	Reads in from a file rather than interactively.

c      testing main

        implicit none
c..	functions
	integer		trimlen, trimsemicolin
c	logical		ask_ifd
	CHARACTER*80	firstword

c	functions
	logical		makehelp2latex	

c...	local variables
        integer 	leveloff, unit, unitpath
	integer 	unitlatex, unitdvips
	integer		unitmake
c	integer		unitcom
        CHARACTER*80  	helpPATH, docpath, NODE, latexfile, basefile, os
c	CHARACTER*80	lscom, pipecom, 
c	CHARACTER*80	dvipscom
c	CHARACTER*80	execom
c	CHARACTER*132	listingcom
        CHARACTER*132  	aline
	logical		morefiles, verbose
	character*1	CTRLI
	character*10	extn
	integer		istart

      CTRLI=CHAR(9)   ! TAB

	morefiles = .true.
	verbose = .false.	!! Determines how noisy the reporting is.

c	Use leveloff = 0 for article style, with highest level \section.
c	Use leveloff = 1 for report style with highest level \chapter	
c	leveloff = 0
	leveloff = 1


	write (*,*) 'Program help2latex_auto'
	write (*,*) '  Converts VMS help files *.hlp to *.tex.'
	write (*,*) '  Creates latex.com, to be run under VMS, for *.dvi '
	write (*,*) '  Creates dvips.com, to be run under VMS, for *.ps '
	write (*,*) '  Creates Makefile_tex., to be run under Unix,', 
     &		' for *.dvi and *.ps and *.html'
	write (*,*) ' '
	write (*,*) ' File h2l.path must contain:'
	write (*,*) '   Line 1: directory path containing *.hlp files'
	write (*,*) '   Line 2: target directory path for *.tex files'
	write (*,*) '   Line 3: Operating system (vms, g77, decunix)' 
c	write (*,*) '   Line 3: dvips option (so goes to file)' 
c        write (*,*) '     E.g. "-o" for Linux'
c        write (*,*) '     E.g. " " for VMS'

c	write (*,*) ' Line 3: directory command to get list of ', 
c     &		'files, one per line'
cc        write (*,*) '   E.g. "dir/col=1/noheadings/notrailing',
cc     &		'/output=h2l.lis" for VMS'
c        write (*,*) '   E.g. "dir/col=1/noheadings/notrailing" for VMS'
c	write (*,*) '   E.g., "ls -1" for linux'
c	write (*,*) ' Line 4: redirection to file command '
c        write (*,*) '   E.g. "/output=" for VMS'
c	write (*,*) '   E.g., ">" for linux'
cc        write (*,*) '   E.g. "" for VMS'
cc	write (*,*) '   E.g., ">h2l.lis" for linux'
c	write (*,*) ' Line 5: dvips option (so goes to file)' 
c        write (*,*) '   E.g. "-o" for Linux'
c	write (*,*) ' Line 6: shell command to run file ', 
c     &		'latex.com and dvips.com'
c        write (*,*) '   E.g. "source" for Linux'
c        write (*,*) '   E.g. "@" for VMS'
	write (*,*) ' '
	write (*,*) ' Output file h2l.dat should contain a listing of ', 
     &		'all *.hlp files to be converted,'
	write (*,*) ' including the path'
        write (*,*) '   Under VMS, create h2l.dat via:'
        write (*,*) ' "dir/col=1/notrailing', 
     &		'/output=h2l.dat [tanya.for.help]*.hlp" '
c        write (*,*) ' "dir/col=1/noheadings/notrailing', 
c     &		'/output=h2l.dat [tanya.for.help]*.hlp" '
        write (*,*) '   Under unix, create h2l.dat via:'
	write (*,*) '	  "ls -1 ~/for/help > h2l.dat" '
c	write (*,*) '	"ls -1 ~/for/help/*.hlp > h2l.dat" '
       write (*,*) ' '



c	goto 105
c 100	write (*,*) 'Use leveloff = 0 for article style, ', 
c     &		'with highest level \section.'
c	write (*,*) 'Use leveloff = 1 for report style ', 
c     &		'with highest level \chapter'
c	write (*,*) 'Enter leveloff: '
c	read (*,*) leveloff
c	if (.not.((leveloff .eq.0) .or. (leveloff .eq.1))) goto 100
c 105	continue


c        call ask1d('Enter help file path>>', '80a', path)
c        call ask1d('Enter help file name, no extention>>', '80a', node)

        call new_unit(unit)
        if (unit .eq. -1) then
	  goto 666
        endif
	write (*,*) 'Opening old file h2l.dat ', unit
	open(unit, file='h2l.dat', status='old', err=666)

        call new_unit(unitpath)
        if (unitpath .eq. -1) then
	  goto 666
        endif
	write (*,*) 'Opening old file h2l.path ', unitpath
	open(unitpath, file='h2l.path', status='old', err=666)

c        call new_unit(unitcom)
c        if (unit .eq. -1) then
c	  goto 666
c        endif
c	write (*,*) 'Opening old file h2l_lis.com ', unitcom
c	open(unit, file='h2l_lis.com', status='unknown', err=666)

        call new_unit(unitmake)
        if (unitmake .eq. -1) then
	  goto 666
        endif
        write (*,*) 'Opening new file Makefile_tex ', unitmake
	open(unitmake, file='Makefile_tex.', status='unknown', err=666)

        call new_unit(unitdvips)
        if (unitdvips .eq. -1) then
	  goto 666
        endif
        write (*,*) 'Opening new file dvips.com ', unitdvips
	open(unitdvips, file='dvips.com', status='unknown', err=666)

        call new_unit(unitlatex)
        if (unitlatex .eq. -1) then
	  goto 999
        endif
        write (*,*) 'Opening new file latex.com ', unitlatex
	open(unitlatex, file='latex.com', status='unknown', err=666)

        write (*,*) ' '
	read(unitpath,'(a)') helppath
	write (*,*) 'helppath = ', helppath
	read(unitpath,'(a)') docpath
	write (*,*) 'docpath = ', docpath
	read(unitpath,'(a)') os
	write (*,*) 'os = ', os

c	read(unitpath,'(a)') lscom
c	write (*,*) 'lscom = ', lscom
c	read(unitpath,'(a)') pipecom
c	write (*,*) 'pipecom = ', pipecom
c	read(unitpath,'(a)') dvipscom
c	write (*,*) 'dvipscom = ', dvipscom
c	read(unitpath,'(a)') execom
c	write (*,*) 'execom = ', execom
        write (*,*) ' '


	istart = 1
	if ((os(1:trimlen(os)) .eq. 'vms') .or. 
     &      (os(1:trimlen(os)) .eq. 'VMS')) then
	  istart = 2
	endif

	if ((os(1:trimlen(os)) .eq. 'g77') .or. 
     &      (os(1:trimlen(os)) .eq. 'G77')) then
	  istart = 2
	endif

        if ((os(1:trimlen(os)) .eq. 'decunix') .or.
     &      (os(1:trimlen(os)) .eq. 'DECUNIX')) then
          istart = 1
        endif


c        write (*,*) 'Creating temporary file h2l_lis.com ',
c     &          '(for directory listings) using SYSTEM call.'
c	listingcom = lscom(1:trimlen(lscom))//'$'//
c     &		docpath(1:trimlen(docpath))//'*.hlp'//
c     &		pipecom(1:trimlen(pipecom))//'h2l.lis'
c	write (*,*) 'Directory command constructed is:'
c	write (*,*) listingcom
c	write 
c        write (*,*) ' '
c	write (unitcom, '(a)') listingcom(2:132)
c	call system('@h2l_lis.com ') 

c        write (*,*) 'Creating temporary file h2l.lis ',
c     &          '(for directory listings) using SYSTEM call.'
c	listingcom = lscom(1:trimlen(lscom))//'$'//
c     &		docpath(1:trimlen(docpath))//'*.hlp'//
c     &		pipecom(1:trimlen(pipecom))
cc     &		pipecom(1:trimlen(pipecom))//'h2l.lis'
c	write (*,*) 'Directory command constructed is:'
c	write (*,*) listingcom
c        write (*,*) ' '
c	call system(' '//listingcom(1:trimlen(listingcom)))

c        call new_unit(unit)
c        if (unit .eq. -1) then
c	  goto 666
c        endif
c	write (*,*) 'Opening old temporary file h2l.lis ', 
c     &		'(for directory listings)'
c	open(unit, file='h2l.lis', status='old', err=666)

	write (aline, *) 'all : process'
	write (unitmake, '(a)') aline(istart:132)
	write (unitmake, *) ' '
c	write (aline, *) 'DVIPSOPS = ', dvipscom(1:trimlen(dvipscom))
c	write (unitmake, '(a)') aline(istart:132)
c	write (aline, *) 'DVIPS = ', dvipscom(1:trimlen(dvipscom))
c	write (unitmake, '(a)') aline(istart:132)
	write (unitmake, *) ' '
	write (aline, *) 'process :'
	write (unitmake, '(a)') aline(istart:132)

c	write (unitlatex, *) 'all : latex'
c	write (unitlatex, *) ' '
c	write (unitlatex, *) '	latex :'
c
c
c	write (unitlatex, *) 'all : dvips'
c	write (unitlatex, *) ' '
c	write (unitlatex, *) 'dvips :'

	do while (morefiles) 
 	  read(unit,'(a)', err=650, end=600) aline
	  node = firstword(aline)
c	  write (*,*) 'file = ', node(1:trimlen(node))

	  if (trimlen(node) .gt. 4) then

c		File name already contains the path.
c	    basefile = node(1:(trimsemicolin(node)-4))
c	    latexfile = node(1:(trimsemicolin(node)-4))//'.tex'

	    basefile = docpath(1:trimlen(docpath))//
     &		node(1:(trimsemicolin(node)-4))
	    latexfile = docpath(1:trimlen(docpath))//
     &		node(1:(trimsemicolin(node)-4))//'.tex'
	    extn = node((trimsemicolin(node)-2):trimsemicolin(node))
	    if ((extn(1:3) .ne. 'hlp') .and.
     &          (extn(1:3) .ne. 'HLP')) then
	      write (*,*) 'SKIPPING file (wrong extension "', 
     &		extn(1:3), '") ', 
     &		node(1:trimsemicolin(node))
	      goto 500
	    endif
c           call ask1d('Enter latex file name >>', '80a', latexfile)
	
cWrong		Note: extension extn is already in the file name.
cWrong		And the path is in the filename (NODE) too!
c	    if (makehelp2latex( ' ', NODE, ' ', 
c     &		latexfile, leveloff, verbose) ) then

	    if (makehelp2latex( helpPATH, NODE, ' ', 
     &		latexfile, leveloff, verbose) ) then
	      write (aline, *) '$ latex ', basefile(1:trimlen(basefile))
	      write (unitlatex, '(a)') aline(istart:80) 
	      write (unitlatex, '(a)') aline(istart:80) 

	      write (aline, *) '$ dvips ', 
     &		basefile(1:trimlen(basefile))
	      write (unitdvips, '(a)') aline(istart:80) 
	      
	      write (aline, *) '$ ps2pdf ', 
     &		basefile(1:trimlen(basefile))
	      write (unitdvips, '(a)') aline(istart:80) 
c	      write (unitdvips, *) ' dvips ', 
c     &		dvipscom(1:trimlen(dvipscom)), ' ', 
c     &		basefile(1:trimlen(basefile))


	      write (aline, *) CTRLI, '(cd ', 
     &		docpath(1:trimlen(docpath))//'; latex ',
     &		node(1:(trimsemicolin(node)-4))//')'
c     &		//'; cd ..)'
	      write(unitmake, '(a)') aline(istart:132)
	      write(unitmake, '(a)') aline(istart:132)

c	      write (aline, *) CTRLI, 'latex ', 
c     &		basefile(1:trimlen(basefile))
cc	      write (*,*) 'makefile: ', aline(1:trimlen(aline))
c	      write(unitmake, '(a)') aline(istart:132)
c	      write(unitmake, '(a)') aline(istart:132)

c	      write (*,*) 'Executing: ', aline(1:trimlen(aline))
c	      call system(aline)

	      write (aline, *) CTRLI, '(cd ', 
     &		docpath(1:trimlen(docpath))//'; dvips -o ',
     &		node(1:(trimsemicolin(node)-4))//'.ps '//
     &		node(1:(trimsemicolin(node)-4))//')'
c     &		//'; cd ..)'
	      write(unitmake, '(a)') aline(istart:132)

	      write (aline, *) CTRLI, '(cd ', 
     &		docpath(1:trimlen(docpath))//'; ps2pdf ',
     &		node(1:(trimsemicolin(node)-4))//'.ps '//
     &		node(1:(trimsemicolin(node)-4))//'.pdf )'
c     &		//'; cd ..)'
	      write(unitmake, '(a)') aline(istart:132)

c	      write (aline, *) CTRLI, 'dvips -o ',
c     &		basefile(1:trimlen(basefile))//'.ps ',
c     &		basefile(1:trimlen(basefile))
cc	      write (aline, *) CTRLI, 'dvips $(DVIPSOPS) ', 
cc     &		basefile(1:trimlen(basefile))
ccc              write (*,*) 'makefile: ', aline(1:trimlen(aline))
c	      write(unitmake, '(a)') aline(2:132)
cc	      write (*,*) 'Executing: ', aline(1:trimlen(aline))
cc	      call system(aline)

	      write (aline, *) CTRLI, '(cd ', 
     &		docpath(1:trimlen(docpath))//'; '//
     &          'latex2html -split 0 -show_section_numbers ',
     &		node(1:(trimsemicolin(node)-4))//'.tex)'
c     &			//'; cd ..)'
	      write(unitmake, '(a)') aline(istart:132)

c	      write (aline, *) CTRLI, 'latex2html -split 0 ', 
c     &		'-show_section_numbers ', 
c     &		basefile(1:trimlen(basefile))//'.tex'
cc              write (*,*) 'makefile: ', aline(1:trimlen(aline))
c	      write(unitmake, '(a)') aline(istart:132)

	    else
		Write (*,*) 'makehelp2latex, returned error for file'
                Write (*,*) NODE
	    endif

 500	    continue
	  endif
	  goto 680

 600	  continue
	  write (*,*) 'help2latex: Last file converted.'
	  morefiles = .false.
	  goto 680

 650	  continue
	  write (*,*) 'help2latex: Error reading in next file name' 

 680	  continue 
	  write (*,*) ' '

	enddo

	close (unit)
	close (unitpath)
c	write (unitlatex, *) ' '
	close (unitlatex)
c	write (unitdvips, *) ' '
	close (unitdvips)

	write (unitmake, *) ' '
	write (aline, *) 'clean :'
	write (unitmake, '(a)') aline(istart:80)
	write (aline, *) CTRLI, '(cd ', 
     &		docpath(1:trimlen(docpath))//'; '//
     &          'rm *.aux *.toc *.log)'
c	write (aline, *) CTRLI, 'rm *.aux *.toc *.log'
	write (unitmake, '(a)') aline(istart:80)
	close (unitmake)

c	aline = execom(1:trimlen(execom))//'latex.com'
c	write (*,*) 'Executing shell command ', aline
c	call system(aline)

c	aline = execom(1:trimlen(execom))//'dvips.com'
c	write (*,*) 'Executing shell command ', aline
c	call system(aline)

	goto 999
 666	  continue
	  write (*,*) 'help2latex: Error opening file ' 

 999	continue
	end

c========================================================
      logical function makeHELP2latex ( PATH, NODE, extn, 
     &		latexfile, leveloff, verbose) 
      IMPLICIT NONE
c...	passed variables
      CHARACTER  PATH*(*), NODE*(*), extn*(*), latexfile*(*)
c      EXTERNAL LBR$OUTPUT_HELP, LIB$GET_INPUT, LIB$PUT_OUTPUT
c      INTEGER*4 LBR$OUTPUT_HELP, LIB$GET_INPUT, LIB$PUT_OUTPUT
	logical		verbose

c...	functions
      INTEGER TRIMSTART, TRIMSTOP

c...	local variables
c      INTEGER ERR
      CHARACTER*132 HELPFILE
      integer hunit, lunit, leveloff


c      write (*,*) 'HELP-STUPID: ', path
c      write (*,*) 'HELP-STUPID: ', node

	makeHELP2latex  = .false.
c      err = 1
      IF ((PATH .EQ. ' ') .AND. (NODE .EQ. '    ')) THEN
	HELPFILE = 'users'//extn
c	HELPFILE = 'users.hlp'
c	HELPFILE = 'MSRHELP:users.hlp'

      ELSE IF ((PATH .NE. ' ') .AND. (NODE .EQ. '    ')) THEN
	HELPFILE = PATH(trimstart(PATH):trimstop(PATH))//'users'//extn
c	HELPFILE = PATH(trimstart(PATH):trimstop(PATH))//'users.hlp'

      ELSE IF ((PATH .EQ. ' ') .AND. (NODE .NE. '    ')) THEN
        HELPFILE = 
     &		node(trimstart(node):trimstop(node)) // extn
c        HELPFILE = 
c     &		node(trimstart(node):trimstop(node)) // '.hlp'
cc        HELPFILE = 'MSRHELP:' // 
cc     &		node(trimstart(node):trimstop(node)) // '.hlp'

      ELSE IF ((PATH .NE. ' ') .AND. (NODE .NE. '    ')) THEN
        HELPFILE = PATH(trimstart(PATH):trimstop(PATH))//
     &          node(trimstart(node):trimstop(node)) // extn
c        HELPFILE = PATH(trimstart(PATH):trimstop(PATH))//
c     &          node(trimstart(node):trimstop(node)) // '.hlp'
      ENDIF
      
c      write (*,*) 'HELP-STUPID: ', HELPFILE(1:TRIMSTOP(HELPFILE))
c      write (*,*) 'HELP-STUPID: help not implimented'

      call new_unit(hunit)
      if (hunit .eq. -1) then
	goto 999
      endif
      write (*,*) 'makeHELP2latex: Opening ', 		!! hunit, ' ',
     &		helpfile(1:TRIMSTOP(HELPFILE))
      open(hunit, file=HELPFILE, status='old', err=666)

      call new_unit(lunit)
      if (lunit .eq. -1) then
	goto 999
      endif
      write (*,*) 'makeHELP2latex: Opening ', 		!! lunit, ' ',
     &		latexfile(1:TRIMSTOP(latexFILE))
      open(lunit, file=latexFILE, status='unknown', err=668)

      makeHELP2latex  = .true.

      goto 700
 666  write (*,*) 'Can not open help file to read ', 
     &		HELPFILE(1:TRIMSTOP(HELPFILE))
      goto 999

      goto 700
 668  write (*,*) 'Can not open output latex file ', 
     &		latexFILE(1:TRIMSTOP(latexFILE))

      goto 999

 700  continue
      call startlatex(lunit, latexfile, helpfile, leveloff)
      call help2latex(hunit, lunit, 1, leveloff, verbose)
      call endlatex(lunit)

 999  continue
      close(hunit)
      close(lunit)

      return
      END

c=======================================================================
      subroutine help2latex(hunit, lunit, level, leveloff, verbose)
      implicit none
c...	passed variables
      integer 	hunit, lunit, level, leveloff
      logical	verbose

c...	common
      character*20 topictree(10)
      integer	topicdepth
      common /tree/ topictree, topicdepth
	
c...	functions
      character*20 nextword 

c...	local variables
      logical looking
      character aline*(132)
      character*10 digits
      parameter (digits = '1234567890')
      integer idigit
      character*20 lineword
      integer len_lineword
      integer i
      integer iline
      logical haveline

      rewind (hunit)

      looking  = .true.
      iline = 0
 132  format(a132)
      topicdepth = 0
      haveline = .false.
      do while (looking)
	i = 1
        if (.not. haveline) then
c	  otherwise, line is already read in by report_help.
	  read(hunit, 132,end=600,err=555) aline
          iline = iline + 1
	endif

c	write (*,*) 'help2latex:', haveline, iline, ' ...', aline(1:40)

	idigit = index(digits,aline(1:1))
	if (idigit .eq. 0) then		!! Not a topic line, so skip it 
	  goto 556
	endif

        i = 2
	if (i .gt. len(aline)) then
	  goto 556
	endif

c 	      /* Grab topic off the line */
        lineword = nextword(aline, i, len_lineword)

	topicdepth = idigit
	if (topicdepth .gt. 10) then
	  write (*,*) 'help2latex: topic depth too large ', topicdepth 
	  return
	else
	  topictree(topicdepth) = lineword(1:len_lineword)
	endif

c        write (*,*) 'help2latex: ', iline, ' help topic is ', idigit, 
c     &		'..', lineword(1:len_lineword), '..'
	call report_section(lunit, leveloff, idigit, verbose) 
ccc     &		lineword(1:len_lineword))

	call report_help(hunit, lunit, idigit, iline, aline, haveline)

        if (iline .eq. 0) then
	  goto 999
	endif
	
	goto 556
 555    looking = .false.	
 556    continue
      enddo
 560  continue

      goto 999
 600  write (*,*) 'dohelp: End of help file.'
      iline = 0
 999  return

      end


c=======================================================================
      subroutine report_section(lunit, leveloff, level, verbose)
ccc	, topicword) 

      implicit none
c...	passed variables
      integer leveloff, level
	integer lunit
ccc      character topicword*(*) 
	logical	verbose

c...	common
      character*20 topictree(10)
      integer	topicdepth
      common /tree/ topictree, topicdepth
	
c...	functions
c	integer trimstop

c...	local variables
      integer len_branch, len_label, len_llabel
      character*200 thisbranch, sectionlabel, longlabel

      call makebranch(thisbranch, len_branch,1,10, ':', .false.)
      if (verbose) then
        write (*,*)  thisbranch(1:len_branch)
c        write (*,*) 'report_section: ', thisbranch(1:len_branch)
      endif
	
      call makebranch(longlabel, len_llabel,1,level,':', .true.)

      if (level-leveloff .eq. 0) then
c	write (lunit,*) '\chapter{', topicword, '}'
        call makebranch(sectionlabel, len_label,level,level,' ', .true.)
	write (lunit,*) '\chapter[',sectionlabel(1:len_label)
     &		,']{', longlabel(1:len_llabel), '}' 
c     &         ,'}'

      else if (level-leveloff .eq. 1) then
c	write (lunit,*) '\section{', topicword, '}'
        call makebranch(sectionlabel, len_label,level,level,' ', .true.)
	write (lunit,*) '\section[',sectionlabel(1:len_label)
     &		,']{', longlabel(1:len_llabel), '}' 
c     &		,'}'

      else if (level-leveloff .eq. 2) then
c	write (lunit,*) '\subsection{', topicword, '}'
        call makebranch(sectionlabel, len_label,level,level,' ', .true.)
	write (lunit,*) '\subsection[',sectionlabel(1:len_label)
     &		,']{', longlabel(1:len_llabel), '}' 
c     &		,'}'

      else if (level-leveloff .eq. 3) then
c	write (lunit,*) '\subsubsection{', topicword, '}'
        call makebranch(sectionlabel, len_label,level,level,' ', .true.)
	write (lunit,*) '\subsubsection[',sectionlabel(1:len_label)
     &		,']{', longlabel(1:len_llabel), '}' 
c     &		,'}'

cc	!! Now, I think, there are no deeper subsections in Latex.

      else if (level-leveloff .eq. 4) then
        call makebranch(sectionlabel, len_label,level,level,' ', .true.)
	write (lunit,*) '\paragraph[',sectionlabel(1:len_label)
     &		,']{', longlabel(1:len_llabel), '}' 
c     &		,'}'
c        call makebranch(sectionlabel, len_label,level-1,10, ' ', .true.)
c	write (lunit,*) '\subsubsection{',sectionlabel(1:len_label)
c     &		,'}'

      else if (level-leveloff .eq. 5) then
        call makebranch(sectionlabel, len_label,level,level,' ', .true.)
	write (lunit,*) '\subparagraph[',sectionlabel(1:len_label)
     &		,']{', longlabel(1:len_llabel), '}' 
c     &		,'}'
c        call makebranch(sectionlabel, len_label,level-2,10, ' ', .true.)
c	write (lunit,*) '\subsubsection{',sectionlabel(1:len_label)
c     &		,'}'

      else if (level-leveloff .eq. 6) then
        call makebranch(sectionlabel, len_label,level-1,10, ' ', .true.)
	write (lunit,*) '\subsubsection[',sectionlabel(1:len_label)
     &		,']{', longlabel(1:len_llabel), '}' 
c     &		,'}'

      else if (level-leveloff .eq. 7) then
        call makebranch(sectionlabel, len_label,level-2,10, ' ', .true.)
	write (lunit,*) '\subsubsection[',sectionlabel(1:len_label)
     &		,']{', longlabel(1:len_llabel), '}' 
c     &		,'}'

      else if (level-leveloff .eq. 8) then
        call makebranch(sectionlabel, len_label,level-3,10, ' ', .true.)
	write (lunit,*) '\subsubsection[',sectionlabel(1:len_label)
     &		,']{', longlabel(1:len_llabel), '}' 
c     &		,'}'

      else if (level-leveloff .eq. 9) then
        call makebranch(sectionlabel, len_label,level-4,10, ' ', .true.)
	write (lunit,*) '\subsubsection[',sectionlabel(1:len_label)
     &		,']{', longlabel(1:len_llabel), '}' 
c     &		,'}'

      else if (level-leveloff .eq. 10) then
        call makebranch(sectionlabel, len_label,level-5,10, ' ', .true.)
	write (lunit,*) '\subsubsection[',sectionlabel(1:len_label)
     &		,']{', longlabel(1:len_llabel), '}' 
c     &		,'}'

      endif

ccc	This won't be proper latex. And don't need links anyway.
ccc      write (lunit,*) '\label{', thisbranch(1:len_branch) , '}'
      write (lunit, *) '%', thisbranch(1:len_branch)

c	This path is now in the section label
c      write (lunit, *) '{\sl'
c      write (lunit, *) '\begin{verbatim}'
c      write (lunit, *) thisbranch(1:len_branch)
c      write (lunit, *) '\end{verbatim}'
c      write (lunit, *) '\sl}'

c      write (lunit,*) ' '

      end


c=======================================================================
      subroutine makebranch(thisbranch, len_branch, startlevel, 
     &		 maxlevel, separator, uselatex)
      implicit none
      character thisbranch*(*)
      integer len_branch, startlevel, maxlevel, itopic
      character*1 separator
      logical uselatex

c...	functions
	integer trimstop

c...	common
      character*20 topictree(10)
      integer	topicdepth
      common /tree/ topictree, topicdepth

c...	local
      integer ll, j, i, trouble
      character*12 lalatex !! 123456789012
      parameter (lalatex =    '&$#%_{}^~\<>')
 
      j = 1
      do itopic = startlevel, min(topicdepth, maxlevel)
	if ((itopic .ne. startlevel) .and. 
     &		(j+1 .le. len(thisbranch))) then
	  thisbranch(j:j) = separator
	  j = j +1
	endif
	ll = trimstop(topictree(itopic))
	if (j+ ll +1 .le. len(thisbranch)) then
	  if (useLatex) then
	   do i = 1, ll
	     trouble = index(lalatex,topictree(itopic)(i:i))
ccc	     jold = j
	     if (trouble .eq. 0) then
	        thisbranch(j:j) = topictree(itopic)(i:i)
          	j = j +1
	     else if (trouble .eq. 1) then
	        thisbranch(j:j+1) = '\&'
          	j = j +2
	     else if (trouble .eq. 2) then
	        thisbranch(j:j+1) = '\$'
          	j = j +2
	     else if (trouble .eq. 3) then
	        thisbranch(j:j+1) = '\#'
          	j = j +2
	     else if (trouble .eq. 4) then
	        thisbranch(j:j+1) = '\%'
          	j = j +2
	     else if (trouble .eq. 5) then
	        thisbranch(j:j+1) = '\_'
          	j = j +2
	     else if (trouble .eq. 6) then
	        thisbranch(j:j+1) = '\{'
          	j = j +2
	     else if (trouble .eq. 7) then
	        thisbranch(j:j+1) = '\}'
          	j = j +2
	     else if (trouble .eq. 8) then
	        thisbranch(j:j+7) = '$\wedge$'
          	j = j +8
	     else if (trouble .eq. 9) then
	        thisbranch(j:j+5) = '\tidle'
          	j = j +6
	     else if (trouble .eq. 10) then
	        thisbranch(j:j+10) = '$\setminus$'
          	j = j +11
	     else if (trouble .eq. 11) then
	        thisbranch(j:j+2) = '$<$'
          	j = j +3
	     else if (trouble .eq. 12) then
	        thisbranch(j:j+2) = '$>$'
          	j = j +3
	     endif
c	     write (*,*) 'makebranch:', jold, j, thisbranch(jold:j)
	   enddo

	  else
	    thisbranch(j:(j+ll)) = topictree(itopic)(1:ll)
	    j = j + ll 
	  endif
	endif
      enddo

      len_branch = j -1
     
      return
      end

c=======================================================================
      subroutine report_help(hunit,lunit,level, iline, aline, haveline) 
      implicit none
c...	passed variables
      integer hunit, level
	integer lunit
      integer iline
      character aline*(132)
      logical haveline

c...	common

c...	functions

c...	local variables
      logical looking
      character*10 digits
      parameter (digits = '1234567890')
      integer idigit
	
      looking  = .true.
 132  format(a132)
c 79   format(x, a79)
 80   format(a80)
c 81   format('%',a79)

      write (lunit, *) '\begin{verbatim}'
      do while (looking)
	haveline = .false.
	read(hunit, 132,end=600,err=555) aline
	haveline = .true.
        iline = iline + 1
	idigit = index(digits,aline(1:1))
	if (idigit .eq. 0) then		!! Not a topic line, so print it
	  if (aline(1:1) .ne. '!') then
	    write (lunit,80) aline(1:80)
c	  else 
cc	Doesn't work when in verbatim mode!
c	    write (lunit,81) aline(2:80)
	  endif
	  goto 556
	else if (idigit .lt. level) then !! Start of supertopic, 
cDebug          write (*,*) 'report_help: Stopping. supertopic ', idigit, 
cDebug     &		iline,  '..', aline(1:20), '..'
	  goto 555			 !! so break out of loop
	else if (idigit .gt. level) then	!! Start of subtopic, so skip
cDebug          write (*,*) 'report_help: Stopping. subtopic ', idigit, 
cDebug     &		iline, '..', aline(1:20), '..'
	  goto 555
        else
cDebug          write (*,*) 'report_help: Stopping. same level ', 
cDebug     &		level, idigit, iline,  '..', aline(1:20), '..'
	  goto 555
	endif
	
	goto 556
 555    looking = .false.	
 556    continue
      enddo
 560  continue

      goto 999
 600  write (*,*) 'report_help: End of help file.'
      iline = 0

 999  continue
      write (lunit, *) '\end{verbatim}'
      write (lunit, *) ' '
      write (lunit, *) ' '

      return

      end

c=======================================================
      character*20 function nextword(aline, apos, len_nextword)
c...	passed variables
      character aline*(*)
      integer apos, len_nextword

c...	local variables
      integer pos, i, next

      pos = apos
      do while ((aline(pos:pos) .eq. ' ') .and. (pos .lt. len(aline)) ) 
        pos = pos + 1	!! skip blanks
      enddo
      next = pos
      do while ((next.lt.len(aline)) .and. 
     &		.not.(aline(next:next).eq.' ')) 
	next = next + 1
      enddo

c	Case where there are no trailing blanks.
      if ((next .eq. len(aline) ) .and. 
     &		.not.(aline(next:next).eq.' ')) then
	next = next + 1
      endif

      if (next .eq. pos) then 
	len_nextword = 0
      else
        len_nextword = next-pos
        nextword(1:len_nextword) = aline(pos:next-1)
      endif
      apos = next

      do i = next, 20
        nextword(i:i) = ' '
      enddo

c	write (*,*) 'nextword:', len_nextword, ' ..', 
c     &		nextword(1:len_nextword), '..'

c      if (nextword(1:1) .eq. '@') then
c	write (*,*) 'nextword: AT ', len_nextword, ' ..', 
c     &		nextword(1:len_nextword), '..'
c      endif

      return
      end

c============================================
      subroutine new_UNIT(hunit)
      implicit none
      integer hunit
      logical LUOPEN

      DO 100 hunit = 30, 99
        INQUIRE(UNIT=hunit,OPENED=LUOPEN,ERR=100)
        IF(.NOT. LUOPEN) goto 110
100   CONTINUE
      WRITE (*,*) '** Unable to find an un-opened unit for file **'
      hunit = -1
      return
110   continue

      return
      end

c==========================================================
	subroutine endlatex(lunit)
	implicit none
	integer lunit

        write (lunit, *) ' '
ccc        write (lunit, *) '\backmatter'
	write (lunit, *) '\end{document}'
	end


c==========================================================
	subroutine startlatex(lunit, latexfile, helpfile, leveloff)
	implicit none
	integer lunit, leveloff
        character latexfile*(*), helpfile*(*)
c...	functions
	integer trimstop

c	Use leveloff = 0 for article style, with highest level \section.
c	Use leveloff = 1 for report style with highest level \chapter	

c	  write (lunit, *) '\documentclass[10pt,a4paper]{book}'

       if (leveloff .eq. 0) then
	  write (lunit, *) '\documentclass[10pt,a4paper]{article}'
       else if (leveloff .eq. 1) then
	  write (lunit, *) '\documentclass[10pt,a4paper]{report}'
       endif
       write (lunit, *) '\usepackage[dvips]{hyperref}'
c       write (lunit, *) '\usepackage[dvips,'
c	write (lunit, *) '% colorlinks=true,'
c	write (lunit, *) '% linkcolor=blue,'
c	write (lunit, *) '% citecolor=pinegreen,'
c	write (lunit, *) '% pdftitle={My title},'
c	write (lunit, *) '% pdfauthor={Dr Tanya M Riseman},'
c	write (lunit, *) '% pdfsubject={NIST center for Neutron Research},' 
c	write (lunit, *) '% bookmarks=true'
c	write (lunit, *) '       ]{hyperref}'


	write (lunit, *) '\begin{document}'
	write (lunit, *) '\pagestyle{headings}'
c	Set section number to 5 to go all the way to subparagraph
	write (lunit, *) '\setcounter{secnumdepth}{5}'
	write (lunit, *) '\setcounter{tocdepth}{5}'
	write (lunit, *) '\title{'
	write (lunit, *) latexfile(1:trimstop(latexfile))
        write (lunit, *) '\newline created from help file \newline'
	write (lunit, *) helpfile(1:trimstop(helpfile)), '}'
	write (lunit, *) ' '
	write (lunit, *) '\date{\today}'
	write (lunit, *) '\maketitle'
	write (lunit, *) '\tableofcontents'
	write (lunit, *) ' '
	write (lunit, *) ' '

	end

c==============================================================================
c23456789_123456789_123456789_123456789_123456789_123456789_123456789_12
        integer function trimlen(thestring)
c       Return the length of the string, ignoring trailing spaces ' '
c       and trailing zeros (from uninitialized strings).

        implicit none
        character*(*) thestring

        integer         lens
        logical         looking

        lens = len(thestring)
        trimlen = lens
        looking = .true.
        do while (looking .and. (trimlen .ge. 1))
          if ((thestring(trimlen:trimlen) .ne. ' ') .and.
     &          (ichar(thestring(trimlen:trimlen)) .ne. 0) ) then
            looking = .false.
          else
            trimlen = trimlen - 1
          endif
        enddo

        return
        end

c======================================================================
        integer function trimstart(thestring)
c Return the position of the first non-blank character of the string,
c where blanks are trailing spaces ' ' and zeros (from uninitialized strings).

        implicit none
        character*(*) thestring

        integer         lens, n

        lens = len(thestring)
        n = 1
        do while ((n .lt. lens) .and.  ((thestring(n:n) .eq. ' ') .or.
     &          (ichar(thestring(n:n)) .eq. 0) ))
          n = n + 1
        enddo

        trimstart = n

        return
        end

c======================================================================
        integer function trimstop(thestring)
c       Return the length of the string, ignoring trailing spaces ' '
c       and trailing zeros (from uninitialized strings).

        implicit none
        character*(*) thestring

        integer         n

        n = len(thestring)
        do while ((n .ge. 1) .and.  ((thestring(n:n) .eq. ' ') .or.
     &          (ichar(thestring(n:n)) .eq. 0) ))
          n = n - 1
        enddo

        trimstop = n

        return
        end

c======================================================================
        integer function trimsemicolin(thestring)
c       Return the length of the string, ignoring trailing spaces ' '
c       and trailing zeros (from uninitialized strings).
c	and trailing ";<version number>".

        implicit none
        character*(*) thestring

        integer         n, n2

        n = len(thestring)
        do while ((n .ge. 1) .and.  ((thestring(n:n) .eq. ' ') .or.
     &          (ichar(thestring(n:n)) .eq. 0) ))
          n = n - 1
        enddo

	n2 = 1
        do while ((n2 .lt. n) .and.  (thestring(n2:n2) .ne. ' ') .and.
     &          (ichar(thestring(n2:n2)) .ne. 0)  .and.
     &		(thestring(n2:n2) .ne. ';'))
          n2 = n2 + 1
        enddo

	if (thestring(n2:n2) .eq. ';') then
          n2 = n2 - 1
	endif

        trimsemicolin = n2

        return
        end


c======================================================================
        character*80 function firstword(thestring)
c       Returns the first word in thestring. 

        implicit none
        character*(*) thestring

c	functions
	integer trimstart, trimstop

c	local variables
        integer         n1, n2, nmax

	n1 = trimstart(thestring)

        n2 = n1
	nmax = trimstop(thestring)
	do while ((thestring(n2:n2) .ne. ' ') .and. (n2 .lt. nmax))
	  n2 = n2 + 1
	enddo

	firstword = thestring(n1:n2)
	
        return
        end

      subroutine calcincoh(ki,kf,incohmon,incohana)
      implicit none

c...	passed variables
      real  ki(2),kf(2)
      real incohmon(2),incohana(2)

c...	local variables      
      real ki_incoh(2),kf_incoh(2), ratio
      integer i

C  calculate the ratio of lengths of wavevectors.
      ratio=sqrt(ki(1)**2.0+ki(2)**2.0)/sqrt(kf(1)**2.0+kf(2)**2.0)
C  Calculate ki_incoh with length kf
      do i=1,2
        ki_incoh(i)=ki(i)/ratio
        kf_incoh(i)=kf(i)*ratio
        incohmon(i)=ki_incoh(i)-kf(i)
        incohana(i)=ki(i)-kf_incoh(i)
      enddo

      return
      end

c....	spurion_mod.f
c	Complete re-write to include more items from the q-buffer,
c	and with names and labels whcih better correspond. March 11, 2002
c	Routines for the modify command's sub-menu

c=============================================================================

      subroutine load_modmenuitems()
       
      implicit none
      include 'io_files.inc'
      include 'spur_modmenu.inc'

c...	passed variables 
      

c...	Old ones
      modmenuitem(bit_lp) = char_lp		!! LATTICE:
      modmenuitem(bit_la) = char_la

      modmenuitem(bit_ec) = char_ec		!! Energy:
      modmenuitem(bit_es) = char_es
      modmenuitem(bit_fe) = char_fe
      modmenuitem(bit_mo) = char_mo
      modmenuitem(bit_dm) = char_dm
      modmenuitem(bit_da) = char_da

      modmenuitem(bit_qc) = char_qc		!! Space
      modmenuitem(bit_qs) = char_qs

      modmenuitem(bit_uu) = char_uu		!! Orient
      modmenuitem(bit_vv) = char_vv

c      modmenuitem(bit_tc) = char_tc		!! Time/H:
      modmenuitem(bit_t0) = char_t0		!! Time/H:
      modmenuitem(bit_ts) = char_ts

      modmenuitem(bit_np) = char_np		!! Time

      modmenuitem(bit_modhelp) = char_modhelp
      modmenuitem(bit_modquit) = char_modquit
      
      return
      end

c=============================================================================

      subroutine load_modmenu()
       
      implicit none
      include 'io_files.inc'
      include 'spur_modmenu.inc'

c...	passed variables 
      
      modmenu(bit_lp) = 
     & 'Lattice: parameters a, b, c' 
      modmenu(bit_la) = 
     & 'Lattice: angles aa, bb, cc' 

      modmenu(bit_ec) = 
     & 'Energy: at center of scan' 
      modmenu(bit_es) = 
     & 'Energy: step' 
      modmenu(bit_fe) = 
     & 'Energy: value of fixed (MON) or (ANA)'
      modmenu(bit_mo) = 
     & 'Energy: toggle MON or ANA with E-fixed' 
      modmenu(bit_dm) = 'Energy: lattice spacing of MON'
      modmenu(bit_da) = 'Energy: lattice spacing of ANA'

      modmenu(bit_qc) = 
     & 'Space: qh qk ql at center of scan' 
      modmenu(bit_qs) = 
     & 'Space: qh qk ql step' 

      modmenu(bit_uu) = 
     & 'Orient: u=(hkl) of scattering plane' 
c...	note: Orient: Angl is unused.
      modmenu(bit_vv) = 
     & 'Orient: v=(hkl)'' of scattering plane' 


c      modmenu(bit_tc) = 
c     & 'Temp/H: center temperature T0'
      modmenu(bit_t0) = 
     & 'Temp/H: start temperature T0'
      modmenu(bit_ts) = 
     & 'Temp/H: temperature step inc-T'

      modmenu(bit_np) =
     & 'Time: number of scanned (E,Q,T) points' 

c...	Standard menu items
      modmenu(bit_modhelp) = 
     & 'HELP!!'
      modmenu(bit_modquit) =
     & 'to quit'

      
      return
      end

c=============================================================================
      subroutine load_mod_itemvalue()
cOld      subroutine load_mod_itemvalue(ec, es, hc, hs, fe, npts, mon)
       

      implicit none
      include 'io_files.inc'
      include 'spur_modmenu.inc'
      include 'spur_buf.inc'

c...	functions
c      logical bit_on

c...	passed variables 
c      real ec, es
c      REAL*4 hc(3), hs(3)
c      real fe
c      integer npts
c      CHARACTER*5 mon
      
c...    local variables
      integer i
      
      do i = 1, len_modmenu 
        moditemvalue(i) = ''
      enddo
      
      write (moditemvalue(bit_lp), 200) (qb_lattice_a(i),i=1,3)
 200  format(2(f5.2,1x), f5.2 , 1x, 'A')
      write (moditemvalue(bit_la), 210) (qb_lattice_angle(i),i=1,3)
 210  format(2(f5.1,1x), f5.1, 1x,  'Dg')

      write (moditemvalue(bit_ec), *) qb_energy_ec, ' meV'
      write (moditemvalue(bit_es), *) qb_energy_es, ' meV'
      
      write (moditemvalue(bit_fe), *) qb_energy_fe, ' meV'

      write (moditemvalue(bit_mo), *) qb_energy_fix, ' is fixed'

      write (moditemvalue(bit_da), *) qb_energy_da, ' A'
      write (moditemvalue(bit_dm), *) qb_energy_dm, ' A'

      write (moditemvalue(bit_qc), 471) (qb_space_hc(i),i=1,3)
      write (moditemvalue(bit_qs), 471) (qb_space_hs(i),i=1,3)
 471  format( '(', f4.2, ',', f4.2, ',', f4.2, ')')
  
      write (moditemvalue(bit_uu), 475) (qb_orient_u(i),i=1,3)
      write (moditemvalue(bit_vv), 475) (qb_orient_v(i),i=1,3)
 475  format( '(', i4, ',', i4, ',', i4, ')')

c      write (moditemvalue(bit_tc), *) qb_temp_T0, ' K'
      write (moditemvalue(bit_t0), *) qb_temp_T0, ' K'
      write (moditemvalue(bit_ts), *) qb_temp_incT, ' K'

      write (moditemvalue(bit_np), *) qb_time_scanpts

      return
      end

c=============================================================================

      subroutine display_submenu(aversion, key, current_thisop,
     &	 add_thisop, len_thismenu, thismenu, thisitemvalue, thismenuitem,
     &   updatecurrent) 
c      subroutine display_modmenu(aversion, key, current_modop,
c     &	 add_modop, len_modmenu, modmenu, moditemvalue, modmenuitem) 
c...	For a menu which propmpts for number to be entered, 
c...	use updatecurrent=.true.
c...	and current_thisop reflects which items have been modified.
c...	For a selection menu, where toggled items are kept track of in
c...	the variable current_thisop, use updatecurrent=.false.

      implicit none
      include 'io_files.inc'
c      include 'spur_modmenu.inc'
      include 'spur_warn.inc'

c...	functions
      logical bit_on
      integer ilen
      
c...	passed variables
      character*(*) aversion
      CHARACTER*5 key
	integer*4 current_thisop, add_thisop
	integer len_thismenu
	character*48 thismenu(*)
	character*20 thisitemvalue(*)
	character*2  thismenuitem(*)
	logical updatecurrent

c...	local variables
      integer i

c      write (*,'(A,$)') 'Type a command or hit <return> for options '
c      read (*,'(a)') key      ! read in a one character command
        
c      if ((key .eq. ' ') .or. (key .eq. '?')) then

        write (*,*) aversion
        write (*,'(a25, x, a25, x, a25)') FILE_BUFIN, FILE_LPI,
     &	 FILE_BASE(1:ilen(FILE_BASE))//'.<ext.>'
        if (warn_options .ne. 0) write (*,'(a)') warnstring

        do i = 1, len_thismenu
	  write (*,*) thismenuitem(i), ': ', thismenu(i),
     &	   ' ', bit_on(current_thisop, i), bit_on(add_thisop, i), 
     &     ' ', thisitemvalue(i)
        enddo
220     write(*,'(a,$)') 'Command ("q" to quit)? '
        read (*,'(a)',err=220) key
c      endif

      add_thisop = 0
      do i =1, len_thismenu
        if (thismenuitem(i) .eq. key) then
	   call set_bit(add_thisop,i,1)
	   if (updatecurrent) call set_bit(current_thisop,i,1)
	endif
      enddo

      return
      end
     

      subroutine plotlattice(circsize,m_rlv,x,y,h,k,l,qmax,
     &	 gray, rainbow, struct,
     &   sfhkl,absent,replot, overridesize, pointsize,               
     &	 plotunique, uniqueLabel, hide_absences, nscan, qarr)
      
C  hmax is the maximum (h00) value corresponding to maximum Q for
C  the calculation.

C  reflmax is the maximum number of reflections (currently set for
C  a cubic material.
C  nref is the actual number
      
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      
c...	common blocks
      logical warning
      common /reciplattice/ warning

      integer natoms
      common /atoms/ natoms

      integer ntiny, nabsent, npresent, nobserved
      common /nabsences/ ntiny, nabsent, npresent, nobserved

c...	functions
      integer select_color
      
c...	constants
c01Dec      integer nmax		! Now natoms_max in arraysize.inc
c01Dec     parameter (nmax=300)

c...	passed variables
      integer m_rlv
      logical struct, gray, rainbow, replot
      real x(m_rlv_max,m_rlv_max),y(m_rlv_max,m_rlv_max)
      integer h(m_rlv_max,m_rlv_max)
      integer k(m_rlv_max,m_rlv_max)
      integer l(m_rlv_max,m_rlv_max)
      real sfhkl(m_rlv_max,m_rlv_max)
      logical absent(m_rlv_max,m_rlv_max)
      real qmax
      logical overridesize
      real pointsize(m_rlv_max,m_rlv_max)

      logical 	plotUnique, hide_absences
      character*1 uniqueLabel(m_rlv_max,m_rlv_max)
      integer nscan
      real*4 qarr(2,maxnpts)
      
c...	local variables
      integer scale
c      real x1,x2,y1,y2
      integer i, j, nint
      integer hklunique(unique_rlv_max,3)
      real sfn(unique_rlv_max)
      real sfmax,sfmin
c      real zmin,zmax
c      integer mult,power,dec
      real circsize,size
      character*6 pgt
c      integer nsub

      integer itemp, this_color
c      integer color_temp
      integer pgt_len
      real	xtemp, ytemp

c      real	X1vp, X2vp, Y1vp, Y2vp
c      real	X1wrld, X2wrld, Y1wrld, Y2wrld
c      real 	xcenwrld, ycenwrld
      
      integer fill_solid, fill_hollow
      parameter (fill_solid = 1)
      parameter (fill_hollow = 2)

cDebug       write (*,*) 'plotlattice: Entry. replot=', replot
       
C      warning=.false.
C  Rescale size of circle to the q=0 scattering cross-section.

      call pgqch(size)
      if (.not.struct) go to 15

      call count_intensities(m_rlv, x, y, absent,  sfhkl, sfn, 
     &		h, k, l, hklunique, sfmin, sfmax, nint)

c	Only needed if will plot circles.
       call scale_circle(scale, sfmin, sfmax, replot, 
     &      m_rlv, pointsize, sfhkl)
       

C find the current limits of the plot window
c      call pgqwin(x1,x2,y1,y2)
c      write (*,*) 'plotlattice: x1,x2,y1,y2=', x1,x2,y1,y2

cDebug      write (*,*) 'plotlattice: xmin,xmax,ymin,ymax=', 
cDebug     &      xmin,xmax,ymin,ymax

      CALL PGSCH(1.0)

 15   continue

ccc      nobserved = 0
      do i=1,m_rlv
       do j=1,m_rlv

c	 !! only plot points inside of the plot's boundaries
         if ((x(i,j).gt.xmin).and.(x(i,j).lt.xmax).and.
     &              (y(i,j).gt.ymin).and.(y(i,j).lt.ymax)) then
ccc           nobserved = nobserved + 1
           if (.not. struct) then
C 		no struct calculated, use large white circles
cDebug              write (*,*) '*** if (.not. struct) then'
              overridesize = .true.
              call pgsci(color_ink)
	      call place_circle(x(i,j), y(i,j), pointsize(i,j), circsize,  
     &      		 fill_hollow, overridesize)

           else		!! if (.not. struct) then

	     if (absent(i,j)) then
cDebug                write (*,*) '*** if (absent(i,j)) then'
		if (.not. hide_absences) then
		  overridesize = .true.
                  call pgsci(color_yellowgreen)
	          call place_cross(x(i,j), y(i,j), 
     &			pointsize(i,j), circsize, overridesize)
		endif
             else
	      if (warning.and.
     &		     (sfhkl(i,j)/float(natoms).lt.tiny)) then
cDebug                write (*,*) '*** if (warning.and....'
                write(*,*) 'plotlattice: Nearly zero intensity marked',
     &	          ' blue at (', h(i,j), ',', k(i,j), ',', l(i,j), ')'
                write(unitlog,*) 'plotlattice: ', 
     &		  'Nearly zero intensity marked',
     &	          ' blue at (', h(i,j), ',', k(i,j), ',', l(i,j), ')'
		overridesize = .true.
                call pgsci(color_blue)
	        call place_circle(x(i,j), y(i,j), pointsize(i,j), circsize,  
     &      		 fill_hollow, overridesize)

	      else 	!! if (warning...) 
               if (gray) then		!! gray circles
cDebug                write (*,*) '*** if (gray) then	'
C		!! sets the pen colour to a grayscale
		overridesize = .false.
c02Jan		color_temp = 18+int(81.1*pointsize(i,j))
		this_color =  select_color(pointsize(i,j))
c		call select_color(pointsize(i,j))
		call place_circle(x(i,j), y(i,j), pointsize(i,j), circsize,  
     &      		 fill_solid, overridesize)
     	       else		!! grey numbers instead
cDebug                  write (*,*) '*** if (.not. gray) then	.. numbers'
     		  itemp = int(100.0*sfhkl(i,j))
		  pgt_len = 6
                  call PGNUMB (itemp, -2, 1, pgt, pgt_len)
		  this_color = select_color(pointsize(i,j))
c		  call select_color(pointsize(i,j))
c02Jan		  color_temp = 18+int(81.1*pointsize(i,j))
c02Jan     		  call pgsci(color_temp)
                  call pgptxt (x(i,j), y(i,j), 0.0, 0.5, pgt)   

	       endif

	      endif 	!! if (warning...) 

	     endif 	!! if (absent(i,j)) then

	     if (plotUnique. and. (gray)) then
	        if ((.not. absent(i,j)) .or. (.not. hide_absences)) then
c...		  Add labels for the intensities
		  xtemp = 1.0*x(i,j) + 2.5 * abs(circsize)
		  ytemp = 1.0*y(i,j) + 2.5 * abs(circsize)
     		  call pgsci(color_ink)
                  call pgptxt (xtemp, ytemp, 0.0, 0.5, 
     &			uniqueLabel(i,j) )
		endif
	     endif

           endif		!! if (.not. struct) then

         endif		!! in range of plot
       enddo
      enddo

      call pgupdt		!! flush the graphics buffer
      
      if (struct.and.warning.and.(.not.replot)) then
        write(*,*)
     &  'WARNING: # of Sf^2 < tiny (', (nabsent + ntiny), 
     &		') and systematic absences (',
     &   	nabsent, ') inconsistent.'
        write(*,*) '  Check smaller intensities marked blue.'
        write(unitlog,*)
     &  'WARNING: # of Sf^2 < tiny (', (nabsent + ntiny), 
     &		') and systematic absences (',
     &   	nabsent, ') inconsistent.'
        write(unitlog,*) '  Check smaller intensities marked blue.'
       endif
      call pgsch(size)
      return
      end



c======================================================
      subroutine count_intensities(m_rlv, x, y,absent,  sfhkl, sfn, 
     &		h, k, l, hklunique, sfmin, sfmax, nint)
c      subroutine count_intensities(xmin, xmax, ymin, ymax, m_rlv, x, y,
c     &       	absent,  sfhkl, sfn, 
cccc     &		nabsent, npresent, ntiny,
c     &		h, k, l, hklunique, sfmin, sfmax, nint)

c...	Some of this is redundent with routines in indexsort.f

      implicit none
      
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_layout.inc'

c...	common blocks
      logical warning
      common /reciplattice/ warning

      integer natoms
      common /atoms/ natoms

      integer ntiny, nabsent, npresent, nobserved
      common /nabsences/ ntiny, nabsent, npresent, nobserved

c...	passed variables
      integer m_rlv
      real x(m_rlv_max,m_rlv_max),y(m_rlv_max,m_rlv_max)
      integer h(m_rlv_max,m_rlv_max)
      integer k(m_rlv_max,m_rlv_max)
      integer l(m_rlv_max,m_rlv_max)
      real sfhkl(m_rlv_max,m_rlv_max)
      logical absent(m_rlv_max,m_rlv_max)
cCommon      real 	xmin,xmax,ymin,ymax
      integer nint
ccc      integer nabsent, npresent, ntiny
      integer hklunique(unique_rlv_max,3)
      real sfn(unique_rlv_max)
      real sfmax,sfmin

c...	local variables
      integer i,j,n, len
      integer hkltmp(3)
      character*10 hkltitle

C  determine unique intensities and sort them
      nint=0
      nabsent = 0
      npresent = 0
      nobserved = 0
      ntiny = 0
      do i=1,m_rlv
        do j=1,m_rlv
	 if ( (xmin .le. x(i,j)) .and. (x(i,j) .le. xmax) .and.
     &	      	   (ymin .le. y(i,j)) .and. (y(i,j) .le. ymax) ) then
          nobserved = nobserved + 1
          if (absent(i,j)) then
C		!! absent reflections are not counted
	    nabsent = nabsent + 1
	    go to 12
	  else
	    npresent = npresent + 1
	  endif

C also if there was a warning then it is likely there are special conditions
C these points will still be plotted but they should not be counted in the
C scaling
          
          if (warning.and.(sfhkl(i,j)/float(natoms).lt. tiny)) then
c01Dec          if (warning.and.(sfhkl(i,j)/float(natoms).lt.1.0e-5)) then
C             write(*,*) 'warning',i,j,sfhkl(i,j)/float(natoms)
	     ntiny = ntiny + 1
             go to 12
          endif

C a WHILE loop
          n=1
  13      if (n.gt.nint) go to 14          ! add a unique reflection
          if (abs(sfhkl(i,j)/sfn(n)-1.0).le.0.001) then  ! not unique
             if (h(i,j)**2+k(i,j)**2+l(i,j)**2.gt.hklunique(n,1)**2+
     &       hklunique(n,2)**2+hklunique(n,3)**2) go to 12       
             hklunique(n,1)=h(i,j)
             hklunique(n,2)=k(i,j)
             hklunique(n,3)=l(i,j)
             go to 12
          endif

          n=n+1                            ! check next unique reflection
          go to 13
  14      nint=nint+1 
  	  if (nint .gt. unique_rlv_max) then
	    write (*,*) 'coutn_intensities: Overflow nint=', nint 
	  endif
  	  if (n .gt. unique_rlv_max) then
	    write (*,*) 'coutn_intensities: Overflow n=', n
	  endif

C          write(*,*) 'unique reflection',nint
          sfn(nint)=sfhkl(i,j)
          if (nint.eq.1) then 
             sfmin=sfn(1)
             sfmax=sfn(1)
          endif
          hklunique(nint,1)=h(i,j)
          hklunique(nint,2)=k(i,j)
          hklunique(nint,3)=l(i,j)
c          list(nint)=nint                  ! used for bubble sorting

	 endif		!! check that things are in the plot range

 12       enddo
       enddo


C      call bubblefloat(nint,sfn,list)

C      write(*,*) 'initial value',sfmin
C put a redundant check in here since this thing is not working very
C well, sfn(1) value is changing ?  CPA 8-02-00
      do n=1,nint
          if ((sfn(n).lt.sfmin).and.(sfn(n)/float(natoms).ge. tiny))
c01Dec          if ((sfn(n).lt.sfmin).and.(sfn(n)/float(natoms).ge.1.0e-5))
     &       then
             sfmin=sfn(n)
          endif
          if (sfn(n).gt.sfmax) sfmax=sfn(n)
      enddo

C  Output the unique intensities and reduced hkl to structinfo.out

      write (unitstruct, *) '>>  count_intensities()'
      write(unitstruct,*) 'There are ',nobserved,' intensities', 
     & 		' in the plot range.'
      write(unitstruct,*) 'There are ',nint,' unique intensities.'
      write(unitstruct,*) 'There are ',npresent,
     &			' inspected intensities.'
      write(unitstruct,*) 'There are ',nabsent,' absent intensities.'
      if ((npresent + nabsent) .ne. nobserved) then
        write(unitstruct,*) 'Error! (npresent + nabsent) .ne. ', 
     &		'nobserved)', npresent, nabsent, nobserved
      endif
      write(unitstruct,*) 'There are ',ntiny,' nearly zero intensities.'
      
      write (*,*) '>>  count_intensities()'
      write(*,*) 'There are ',nobserved,' intensities', 
     & 		' in the plot range.'
      write(*,*) 'There are ',nint,' unique intensities.'
      write(*,*) 'There are ',npresent,' inspected intensities.'
      write(*,*) 'There are ',nabsent,' absent intensities.'
      write(*,*) 'There are ',ntiny,' nearly zero intensities.'
      if ((npresent + nabsent) .ne. nobserved) then
        write(*,*) 'Error! (npresent + nabsent) .ne. ', 
     &		'nobserved)', npresent, nabsent, nobserved
      endif
      
C  Actually if there are any more than 10 unique intensities
C  outputting them really makes no sense.
      if (nint.le.10) then
         do n=1,nint
            do j=1,3
               hkltmp(j)=hklunique(n,j)
            enddo
            call title(hkltmp,hkltitle,len)
            write(unitstruct,'(f8.3,3a)') sfn(n),' at ',hkltitle(1:len),
     &           '-type peaks.'
c            write(7,'(f8.3,3a)') sfn(n),' at ',hkltitle(1:len),
c     &           '-type peaks.'
         enddo
         write(unitstruct,*)
c         write(7,*)
      endif

       return
       end

c======================================================
      subroutine scale_circle(scale, sfmin, sfmax, replot, 
     &      m_rlv, pointsize, sfhkl)

c...	Scale the size of the circle to represent the intensity either
c...	linear or logscale.

      implicit none
      
      include 'arraysize.inc'
      include 'io_files.inc'

c...	common blocks
      logical warning
      common /reciplattice/ warning

      integer natoms
      common /atoms/ natoms

c...	passed variables
      real sfhkl(m_rlv_max,m_rlv_max)
      real pointsize(m_rlv_max,m_rlv_max)
      real sfmax,sfmin
      integer scale, m_rlv
      logical  replot

c...	local variables
      real zmin,zmax
      integer mult,power,dec, nsub
      integer  i, j

C  what sort of scaling?

      if (sfmax.eq.sfmin) then
        scale=0
C        write(*,*) sfmax,sfmin
        if (.not.replot) then 
	   write(*,*) 'All intensites identical: no scaling.'
	   write(unitlog,*) 'All intensites identical: no scaling.'
        endif
        do i=1,m_rlv
          do j=1,m_rlv
            pointsize(i,j)=sfhkl(i,j)/sfmax
          enddo
        enddo
        
      else if (sfmax/sfmin.le.100) then
        scale=1
        call linscale(sfmin,sfmax,zmin,zmax,nsub)
        if (.not.replot) then
	   write(*,'(a,f5.1,a,f5.1)') 
     &      'Truncated linear scaling from ',zmin,' to ',zmax
	   write(unitlog,'(a,f5.1,a,f5.1)') 
     &      'Truncated linear scaling from ',zmin,' to ',zmax
        endif
        do i=1,m_rlv
          do j=1,m_rlv
            pointsize(i,j)=sfhkl(i,j)/zmax
          enddo
        enddo

      else
        scale=2
        call logscale(sfmin,sfmax,mult,power,dec)
        zmax=float(mult)*10.0**float(power)
        zmin=float(mult)*10.0**float(power-dec)
        if (.not.replot) then
	  write(*,'(a,g7.2,a,g7.2)') 
     &    	'Truncated log scaling from ',zmin,' to ',zmax
	  write(unitlog,'(a,g7.2,a,g7.2)') 
     &    	'Truncated log scaling from ',zmin,' to ',zmax
        endif
        do i=1,m_rlv
          do j=1,m_rlv
            pointsize(i,j)=log10(sfhkl(i,j)/zmin)/log10(zmax/zmin)
C            if (sfhkl(i,j).gt.zmax) pointsize(i,j)=1.0
C            if (sfhkl(i,j).lt.zmin) pointsize(i,j)=0.0
          enddo
        enddo
      endif

      return
      end


C
C**********************************************************
C      
      subroutine linscale(x1,x2,xmin,xmax,nsub)

      implicit none
c...	functions
      integer myint
      
c...	passed variables
      real x1,x2,xmin,xmax
      integer nsub
      
c...	local variables
      real dif
      
C  how different are x1 and x2?  which power of 10 shows the
C  first difference?
      dif= float(myint(log10(x2-x1)))
C  first attempt at xmax is to round x2 up to the power 
C  of ten which shows up in dif
      xmax=myint(x2/10**dif+.99)*10**dif
C  and xmin is the same power rounded down
      xmin=myint(x1/10**dif)*10**dif
C  what is the best number of subdivisions?
      nsub=int((xmax-xmin)/10**dif+1e-4)

      return
      end

      subroutine prepincoh(m_rlv,zeta,eta,incohmon,incohana,
     &  hh,kk,ll,circsize,ki,kf,pn,constq,h,flagincoh,absent,replot, 
     &  nincohmon, nincohana, flagincohmon,flagincohana)

C  Spurions from incoherent processes.

      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
c      include 'spur_color.inc'
      include 'spur_scan.inc'

c...	common blocks
      real tol, etol		!! spatial and energy tolerances       
      common /spur/ tol, etol
      
c...	passed variables
      integer m_rlv
      real zeta(m_rlv_max,m_rlv_max)
      real eta(m_rlv_max,m_rlv_max)
      real incohmon(2),incohana(2)
      integer hh(m_rlv_max,m_rlv_max)
      integer kk(m_rlv_max,m_rlv_max)
      integer ll(m_rlv_max,m_rlv_max)
      real circsize,ki(2),kf(2),h(3)
      logical constq,flagincoh,replot
      logical absent(m_rlv_max,m_rlv_max)
      integer pn, nincohmon, nincohana
      logical flagincohmon,flagincohana
      
c...	local variables
      integer i,j,k
c      logical flagincohmon,flagincohana
      integer sp(3),len
      character*10 spurtitle
      logical firstmatch
      integer iincoh, ii, jj 

c      real temp1, temp2
      
C  Check to see if there is a reciprocal lattice match.


c      write (*,*) 'Incoherent spurions matches at:'
c      write (unitspur,*) 'Incoherent spurions matches at:'
      
      flagincohmon=.false.
      flagincohana=.false.
cMoved      nincohmon = 0
cMoved      nincohana = 0
      do i=1,m_rlv
        do j=1,m_rlv

          if ((abs(zeta(i,j)-incohmon(1)).lt.tol).and.
     &      (abs(eta(i,j)-incohmon(2)).lt.tol).and.
     &       .not.absent(i,j)) then
            flagincohmon=.true.
	    nincohmon = nincohmon + 1
	    
            if (replot) goto 687

            sp(1)=hh(i,j)
            sp(2)=kk(i,j)
            sp(3)=ll(i,j)
            call title(sp,spurtitle,len)
            write(*,'(4a,i2,$)') 'Incoh. spurion from ',
     &        'MON at ',spurtitle(1:len),
     &        ', scan point#',pn
            write(unitspur,'(4a,i2,$)') 'Incoh. spurion from ',
     &        'MON at ',spurtitle(1:len),
     &        ', scan point#',pn
c            write(8,'(4a,i2,$)') 'Incoh. spurion from ',
c     &        'MON at ',spurtitle(1:len),
c     &        ', point#',pn
            if (constq) then
               write(*,'(a,f6.2)') ' E=',
     &              k2_to_E*(ki(1)**2+ki(2)**2-kf(1)**2-kf(2)**2)
               write(unitspur,'(a,f6.2)') ' E=',
     &              k2_to_E*(ki(1)**2+ki(2)**2-kf(1)**2-kf(2)**2)
c02Apr               write(*,'(a,f6.2)') ' E=',
c02Apr     &              2.072*(ki(1)**2+ki(2)**2-kf(1)**2-kf(2)**2)
c02Apr               write(unitspur,'(a,f6.2)') ' E=',
c02Apr     &              2.072*(ki(1)**2+ki(2)**2-kf(1)**2-kf(2)**2)
c               write(8,'(a,f6.2)') ' E=',
c     &              2.072*(ki(1)**2+ki(2)**2-kf(1)**2-kf(2)**2)
            else
               write(*,637) ' at Q=(',(h(k),k=1,3),')'
               write(unitspur,637) ' at Q=(',(h(k),k=1,3),')'
c               write(8,637) ' at Q=(',(h(k),k=1,3),')'
 637           format(a,f6.2,1x,f6.2,1x,f6.2,a)
            endif

	    lab_incmon(nincohmon) = spurtitle
	    ispot_incmon(nincohmon) = i
	    jspot_incmon(nincohmon) = j
	    scanpt_incmon(nincohmon) = pn
          endif

 687      if ((abs(zeta(i,j)-incohana(1)).lt.tol).and.
     &       (abs(eta(i,j)-incohana(2)).lt.tol).and.
     &        .not.absent(i,j)) then
            flagincohana=.true.
	    nincohana = nincohana + 1

            if (replot) goto 697

            sp(1)=hh(i,j)
            sp(2)=kk(i,j)
            sp(3)=ll(i,j)
            call title(sp,spurtitle,len)
            write(*,'(4a,i2,$)') 'Incoh. spurion from ',
     &        'ANA at ',spurtitle(1:len),
     &        ', scan point#',pn
            write(unitspur,'(4a,i2,$)') 'Incoh. spurion from ',
     &        'ANA at ',spurtitle(1:len),
     &        ', scan point#',pn
c            write(8,'(4a,i2,$)') 'Incoh. spurion from ',
c     &        'ANA at ',spurtitle(1:len),
c     &        ', point#',pn
            if (constq) then
               write(*,'(a,f6.2)') ' E=',
     &              k2_to_E*(ki(1)**2+ki(2)**2-kf(1)**2-kf(2)**2)
               write(unitspur,'(a,f6.2)') ' E=',
     &              k2_to_E*(ki(1)**2+ki(2)**2-kf(1)**2-kf(2)**2)
c02Apr               write(*,'(a,f6.2)') ' E=',
c02Apr     &              2.072*(ki(1)**2+ki(2)**2-kf(1)**2-kf(2)**2)
c02Apr               write(unitspur,'(a,f6.2)') ' E=',
c02Apr     &              2.072*(ki(1)**2+ki(2)**2-kf(1)**2-kf(2)**2)
c               write(8,'(a,f6.2)') ' E=',
c     &              2.072*(ki(1)**2+ki(2)**2-kf(1)**2-kf(2)**2)
            else
               write(*,637) ' at Q=(',(h(k),k=1,3),')'
               write(unitspur,637) ' at Q=(',(h(k),k=1,3),')'
c               write(8,637) ' at Q=(',(h(k),k=1,3),')'
            endif
	    lab_incana(nincohana) = spurtitle
	    ispot_incana(nincohana) = i
	    jspot_incana(nincohana) = j
	    scanpt_incana(nincohana) = pn
          endif

 697    enddo
      enddo
      if (flagincohana.or.flagincohmon) flagincoh=.true.


c...	Load up "rankings"
	iincoh = 0
	do ii = 1, m_rlv
	  do jj = 1, m_rlv
	    firstmatch = .true.
	    do i = 1, nincohmon
	      if ((ii .eq. ispot_incmon(i))
     &	      .and. (jj .eq. jspot_incmon(i)) ) then
		if (firstmatch) then
	          iincoh = iincoh + 1
		  firstmatch = .false.
		endif
	        rankincmon(i) = iincoh
	      endif
	    enddo
	  enddo
	enddo
	n_rankincmon = iincoh


	iincoh = 0
	do ii = 1, m_rlv
	  do jj = 1, m_rlv
	    firstmatch = .true.
	    do i = 1, nincohana
	      if ((ii .eq. ispot_incana(i))
     &	      .and. (jj .eq. jspot_incana(i)) ) then
		if (firstmatch) then
	          iincoh = iincoh + 1
		  firstmatch = .false.
		endif
	        rankincana(i) = iincoh
	      endif
	    enddo
	  enddo
	enddo
	n_rankincana = iincoh


      return
      end

c============================================================================
      subroutine plotincoh(m_rlv,zeta,eta,incohmon,incohana,
     &  hh,kk,ll,circsize,ki,kf,pn,constq,h,flagincoh,absent,replot, 
     &  nincohmon, nincohana,  flagincohmon,flagincohana)

C  Spurions from incoherent processes.

      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'

c...	common blocks
      real tol, etol		!! spatial and energy tolerances       
      common /spur/ tol, etol
      
c...	passed variables
      integer m_rlv
      real zeta(m_rlv_max,m_rlv_max)
      real eta(m_rlv_max,m_rlv_max)
      real incohmon(2),incohana(2)
      integer hh(m_rlv_max,m_rlv_max)
      integer kk(m_rlv_max,m_rlv_max)
      integer ll(m_rlv_max,m_rlv_max)
      real circsize,ki(2),kf(2),h(3)
      logical constq,flagincoh,replot
      logical absent(m_rlv_max,m_rlv_max)
      integer pn, nincohmon, nincohana
      logical flagincohmon,flagincohana
      
c...	local variables
c      integer i,j,k
c      integer sp(3),len
c      character*10 spurtitle

      real temp1, temp2
      

c...	Now plot
      call pgsfs(1)
      call pgsls(1)

      if (flagincohmon) then
        call pgsci(color_cyan)   ! cyan
c02Mar        call pgsci(color_magenta)   ! pink/purple
c01Dec        call pgsci(6)   ! pink/purple
	temp1 = 1.1*circsize
        call pgcirc(incohmon(1),incohmon(2), temp1)
c01Nov        call pgcirc(incohmon(1),incohmon(2),1.1*circsize)
	temp1 = incohmon(1)+kf(1)
	temp2 = incohmon(2)+kf(2)
        call pgarro(temp1, temp2, incohmon(1),incohmon(2))
c01Nov        call pgarro(incohmon(1)+kf(1),incohmon(2)+kf(2),
c01Nov     &                  incohmon(1),incohmon(2))
      else
        call pgsci(color_cyan)   ! cyan
c01Dec        call pgsci(5)   ! cyan
	temp1 = 1.1*circsize
        call pgcirc(incohmon(1),incohmon(2), temp1)
c01Nov        call pgcirc(incohmon(1),incohmon(2),1.1*circsize)
      endif

      if (flagincohana) then
        call pgsci(color_bluecyan)
c02Mar        call pgsci(color_bluemagenta)
c01Dec        call pgsci(6)
	temp1 = 1.1*circsize
        call pgcirc(incohana(1),incohana(2), temp1)
c01Nov        call pgcirc(incohana(1),incohana(2),1.1*circsize)
        call pgarro(ki(1),ki(2),incohana(1),incohana(2))
      else
        call pgsci(color_bluecyan)
c01Dec        call pgsci(5)
	temp1 = 1.1*circsize
        call pgcirc(incohana(1),incohana(2),temp1)
c01Nov        call pgcirc(incohana(1),incohana(2),1.1*circsize)
      endif

c      write (*,*) 
c      write (unitspur,*)

      return
      end

      SUBROUTINE EXTINC (ISYMCE,NS)
C- I am assuming that an extinction is a systematic absence...
C
C  isymce indicates if lattice is centrosymmetric and ns is the number
C  sites not including Bravais lattice or inversion symmetry

      implicit none
c...	common blocks
      integer IHOO,IOKO,IOOL,IHKO,IHOL,IOKL,IHHL,ILAU,ITRIG
      COMMON /EXTI/ IHOO,IOKO,IOOL,IHKO,IHOL,IOKL,IHHL,ILAU,ITRIG

C      real ts(3,24), fs(3,3,24)
      double precision ts(3,24), fs(3,3,24)
      COMMON /EQUO/ TS,FS

      integer ibravl,isystm
      common /cell/ ibravl,isystm

c...	passed variables
      integer ns,isymce 

c...	local variables

C-----FINDS EXTINCTIONS, LAUE GROUP AND HEXAGONAL SYMMETRY INDICATOR    EXTI0001
C local variables
C      real q1,q2,q3,q4,poin
      double precision q1,q2,q3,q4,poin
      integer i
C      real r,s,t,x,y,z,xo,yo,zo
      double precision r,s,t,x,y,z,xo,yo,zo

      
      ILAU=1
      Q1=1.0d0/3.0d0
      Q2=1.0d0/6.0d0
      Q3=2.0d0/3.0d0
      Q4=5.0d0/6.0d0
      DO 2 I=1,NS
         POIN=0.0d0
         R=TS(1,I)           ! x-offset
         S=TS(2,I)           ! y-offset
         T=TS(3,I)           ! z-offset
         X=FS(1,1,I)*10.0d0+FS(2,1,I)*50.0d0+FS(3,1,I)*100.0d0
         Y=FS(1,2,I)*10.0d0+FS(2,2,I)*50.0d0+FS(3,2,I)*100.0d0
         Z=FS(1,3,I)*10.0d0+FS(2,3,I)*50.0d0+FS(3,3,I)*100.0d0
         XO=DABS(X)
         YO=DABS(Y)
         ZO=DABS(Z)
         IF ((R.EQ..5d0).AND.(XO.EQ.10.0d0)) IHOO=2   ! 1/2 +/- x -> h is even
         IF ((S.EQ..5d0).AND.(YO.EQ.50.0d0)) IOKO=2   ! k must be even
         IF (IOOL.GT.3) GO TO 1                  ! info from prev loop
         IF ((T.EQ..5d0).AND.(ZO.EQ.100.0d0)) IOOL=2  ! l must be even
         IF ((T.EQ.Q2).OR.(T.EQ.Q4)) IOOL=6      ! l is multiple of 6
         IF ((T.EQ.Q1).OR.(T.EQ.Q3)) IOOL=3      ! l is a multiple of 3
         IF ((T.EQ..25d0).OR.(T.EQ..75d0)) IOOL=4    ! l is a multiple of 4
 1       IF ((X.EQ.50.0d0).AND.(Y.EQ.10.0d0)) ILAU=2   ! x and y transposed
         IF ((X.EQ.-50.0d0).AND.(Y.EQ.-10.0d00)) ILAU=2

C  triggers for trigonal  x-y, y, z  or y-x, -y, -z
         IF ((X.EQ.-40.0d0).AND.(Y.EQ.10.0d0).AND.(Z.EQ.100.0d0)) 
     &     ITRIG=6
         IF ((X.EQ.40.0d0).AND.(Y.EQ.-10.0d0).AND.(Z.EQ.-100.0d0))
     &     ITRIG=6

C  if there are atoms 1/4 or 3/4 postitions, h or k is a multiple of 4
         IF (((S.EQ..25d0).OR.(S.EQ..75d0)).AND.(YO.EQ.50.0d0)) IOKO=4
         IF (((R.EQ..25d0).OR.(R.EQ..75d0)).AND.(XO.EQ.10.0d0)) IHOO=4

         X=X+R    ! combine offsets with vectors to find combos
         Y=Y+S
         Z=Z+T
C I think the following combinations are done solely to save space
C in the condtional statements.

C         X=XO+R    ! combine offsets with vectors to find combos
C         Y=YO+S
C         Z=ZO+T
         
C         write(*,*) r,s,t,x,y,z,xo,yo,zo

C         IF ((X.EQ.10.5d0).AND.(Y.EQ.50.5d0)) IHKO=2    ! 1/2+x, 1/2+y
C         IF ((X.EQ.10.5d0).AND.(Y.EQ.50.5d0)) IHKO=2    ! 1/2+x, 1/2+y
C         write(*,*) (xo.eq.10.0d0),(r.eq..5d0),
C     &      (yo.eq.50.0d0),(s.eq.5d0)
         if(((xo.eq.10.0d0).and.(r.eq..5d0)).and.
     &      ((yo.eq.50.0d0).and.(s.eq..5d0))) ihko=2  
         IF ((X.EQ.10.0d0).AND.(Y.EQ.50.5d0)) IHKO=3    ! x, 1/2+y
         IF ((X.EQ.10.25d0).AND.(Y.EQ.50.25d0)) IHKO=4  ! 1/4+x, 1/4+y
         IF ((X.EQ.10.75d0).AND.(Y.EQ.50.75d0)) IHKO=4  ! 3/4+x, 3/4+y
         IF ((X.EQ.10.5d0).AND.(Y.EQ.50.0d0)) IHKO=5  ! 1/2+x, y (?)
C         IF ((Y.EQ.50.5d0).AND.(Z.EQ.100.5d0)) IOKL=2 ! 1/2+y, 1/2+z
         if(((yo.eq.50.0d0).and.(s.eq..5d0)).and.
     &      ((zo.eq.100.0d0).and.(t.eq..5d0))) iokl=2  
         IF ((Y.EQ.50.0d0).AND.(Z.EQ.100.5d0)) IOKL=3 ! y, 1/2+z
         IF ((Y.EQ.50.25d0).AND.(Z.EQ.100.25d0)) IOKL=4 ! 1/4+y, 1/4+z
         IF ((Y.EQ.50.75d0).AND.(Z.EQ.100.75d0)) IOKL=4 ! 3/4+y, 3/4+z
         IF ((Y.EQ.50.5d0).AND.(Z.EQ.100.0d0)) IOKL=5 ! 1/2+y, z
C         IF ((X.EQ.10.5d0).AND.(Z.EQ.100.5d0)) IHOL=2  ! 1/2+x, 1/2+z
         if(((xo.eq.10.0d0).and.(r.eq..5d0)).and.
     &      ((zo.eq.100.0d0).and.(t.eq..5d0))) ihol=2  
         IF ((X.EQ.10.0d0).AND.(Z.EQ.100.5d0)) IHOL=3  ! x, 1/2+z
         IF ((X.EQ.10.25d0).AND.(Z.EQ.100.25d0)) IHOL=4 ! 1/4+x, 1/4+z
         IF ((X.EQ.10.75d0).AND.(Z.EQ.100.75d0)) IHOL=4 ! 3/4+x, 3/4+z
         IF ((X.EQ.10.5d0).AND.(Z.EQ.100.0d0)) IHOL=5   ! 1/2+x, z

         IF ((X.EQ.50.5d0).AND.(Y.EQ.10.5d0).AND.(Z.EQ.100.5d0)) IHHL=2
         IF ((X.EQ.50.0d0).AND.(Y.EQ.10.0d0).AND.(Z.EQ.100.5d0)) IHHL=2
         IF ((X.EQ.50.0d0).AND.(Y.EQ.10.0d0).AND.(Z.EQ.100.5d0)) IHHL=2
         IF ((X.EQ.50.0d0).AND.(Y.EQ.10.5d0).AND.(Z.EQ.100.25d0)) IHHL=3
         IF ((X.EQ.50.0d0).AND.(Y.EQ.10.5d0).AND.(Z.EQ.100.75d0)) IHHL=3
         IF ((X.EQ.50.75d0).AND.(Y.EQ.10.75d0).AND.(Z.EQ.100.75d0)) 
     &     IHHL=3
         IF ((X.EQ.50.75d0).AND.(Y.EQ.10.75d0).AND.(Z.EQ.100.25d0)) 
     &     IHHL=3
         IF ((X.EQ.50.25d0).AND.(Y.EQ.10.25d0).AND.(Z.EQ.100.25d0)) 
     &     IHHL=3

C-----CHECK CENTROSYMMETRIC POSITION                                    EXTI0061
         IF (ISYMCE.EQ.0) GO TO 2
         IF (POIN.EQ.-1.0d0) GO TO 2
         POIN=-1.0d0
         X=-X+R
         Y=-Y+S
         Z=-Z+T
         IF (R.NE.0.0d0) R=1.0d0-R
         IF (S.NE.0.0d0) S=1.0d0-S
         IF (T.NE.0.0d0) T=1.0d0-T
         GO TO 1
C 2    write(*,*) IHOO,IOKO,IOOL,IHKO,IHOL,IOKL,IHHL,ILAU,ITRIG
 2    continue
C      stop
      RETURN
      END

      subroutine ellipse(xc,yc,major,minor,ang)
      implicit none
c...	constants
      integer n
      parameter (n=41)
c...	passed variables
      real xc,yc,major,minor,ang

c...	local variables
      
C      integer ia(idim,jdim)
C major and minor are like radii
C
C ang is in radians

      integer i
c0111      integer i,j
      real x(n),y(n),xtrans(n),ytrans(n),x0,y0,pi
      real xrot(n),yrot(n),qang
C      write(*,*) major,minor,ang
      pi=4.0*atan(1.0)
C define coordinate of rectangle
      x0=major
      y0=minor

C      write(*,'(a,2f7.4)') 'x0,y0 ',x0,y0
      do i=1,n
         x(i)=x0*cos(2.0*pi*float(i)/float(n)) !+xc
         y(i)=y0*sin(2.0*pi*float(i)/float(n)) !+yc
         xtrans(i)=x(i)*cos(ang)-y(i)*sin(ang)
         ytrans(i)=x(i)*sin(ang)+y(i)*cos(ang)
      enddo

C xtrans and ytrans are the ellipse boundaries in Qx space in AA^-1
C units
C
C the ellipse should be rotated by the angle of Q relative to Zeta

      qang=atan(yc/xc)

      do i=1,n
         xrot(i)=cos(qang)*xtrans(i)-sin(qang)*ytrans(i)
         yrot(i)=sin(qang)*xtrans(i)+cos(qang)*ytrans(i)
      enddo

      do i=1,n
         xrot(i)=xc+xrot(i)
         yrot(i)=yc+yrot(i)
      enddo
C      call PGPIXL (IA, IDIM, JDIM, 1, 1, idim, jdim, 
C     1                   X1, X2, Y1, Y2)
      call pgpoly(n,xrot,yrot)
      return
      end

C-----------------------------------------------------------------

      subroutine ellipseproj(xc,yc,rm,arm,um)
      implicit none
      include 'spur_color.inc'

c..	constants
      integer n
      parameter (n=41)

c...	passed variables
      double precision rm(4,4),arm(3,3),um(3,3)
      real xc,yc

c...	local variables      
c0111Unused      real major,minor,ang
      double precision ap,b,c,v2,v,p1,p2
c0111Unused     double precision alfa1,alfa2
      double precision fwhmt1
C      integer ia(idim,jdim)
C major and minor are like radii
C
C ang is in radians

      integer i,j
      real yy(3,n,n)
      real xtrans(n,n),ytrans(n,n)
      real x0,y0, z0
      real pi
      real theta, phi
c0111Unused      real x(n),y(n)
      real etrans(n,n)
c0111Unused      real xrot(n),yrot(n),qang
      real temp1, temp2

C      write(*,*) major,minor,ang
      pi=4.0*atan(1.0)

      fwhmt1=1.0d0/dsqrt(8.0d0*dlog(2.0d0))
      AP=RM(1,1)-RM(1,3)*RM(1,3)/RM(3,3)
      B=RM(2,2)-RM(2,3)*RM(2,3)/RM(3,3)
      C=RM(1,3)*RM(2,3)/RM(3,3)-RM(1,2)
      V2=DATAN(2*C/(B-AP))
      V=V2/2
      P1=1/DSQRT(AP*DCOS(V)**2+B*DSIN(V)**2-C*DSIN(V2))/FWHMT1
      P2=1/DSQRT(AP*DSIN(V)**2+B*DCOS(V)**2+C*DSIN(V2))/FWHMT1

C define major axes

      x0=sqrt(2.0*log(2.0)/arm(1,1))
      y0=sqrt(2.0*log(2.0)/arm(2,2))
      z0=sqrt(2.0*log(2.0)/arm(3,3))

C parametrization of principle axes coordinates

      do i=1,n
         do j=1,n
            theta=2.0*pi*float(i)/float(n)
            phi=pi*float(j)/float(n)
            yy(1,i,j)=x0*cos(theta)*sin(phi)
            yy(2,i,j)=y0*sin(theta)*sin(phi)
            yy(3,i,j)=z0*cos(phi)
         enddo
      enddo

C transform to q's

      do i=1,n
         do j=1,n
            xtrans(i,j)=yy(1,i,j)*um(1,1)+yy(2,i,j)*um(1,2)+
     &           yy(3,i,j)*um(1,3)
            ytrans(i,j)=yy(1,i,j)*um(2,1)+yy(2,i,j)*um(2,2)+
     &           yy(3,i,j)*um(2,3)
            etrans(i,j)=yy(1,i,j)*um(3,1)+yy(2,i,j)*um(3,2)+
     &           yy(3,i,j)*um(3,3)
	    temp1 = xc+xtrans(i,j)
	    temp2 = yc+ytrans(i,j)
            call pgcirc(temp1, temp2, .002)
c01Nov            call pgcirc(xc+xtrans(i,j),yc+ytrans(i,j),.002)
         enddo
      enddo
C plot extremum points
      call pgsci(color_blue)
c01Dec      call pgsci(4)
      call pgsfs(2)
      temp1 = sngl(p1)
      temp2 = sngl(p2)
      call ellipse(xc,yc,temp1, temp2,sngl(v))
c0111      call ellipse(xc,yc,float(p1),float(p2),v)

C 1,0,0
      write(*,*) 'extrema ',xc+x0*um(1,1),yc+x0*um(1,2)
      temp1 = sngl(xc+x0*um(1,1))
      temp2 = sngl(yc+x0*um(1,2))
      call pgcirc( temp1, temp2, .1)
c0111      call pgcirc(xc+x0*um(1,1),yc+x0*um(1,2),.1)
C -1,0,0
      temp1 = sngl(xc-x0*um(1,1))
      temp2 = sngl(yc-x0*um(1,2))
      call pgcirc(temp1, temp2, .1)
c0111      call pgcirc(xc-x0*um(1,1),yc-x0*um(1,2),.1)


      return
C      call PGPIXL (IA, IDIM, JDIM, 1, 1, idim, jdim, 
C     1                   X1, X2, Y1, Y2)

C xtrans and ytrans are the ellipse boundaries in Qx space in AA^-1
C units
C
C the ellipse should be rotated by the angle of Q relative to Zeta

c0111	Due to return, this line can not be reached
c0111      qang=atan(yc/xc)

C      do i=1,n
C         xrot(i)=cos(qang)*xtrans(i)-sin(qang)*ytrans(i)
c         yrot(i)=sin(qang)*xtrans(i)+cos(qang)*ytrans(i)
c      enddo

c0111      do i=1,n
c0111         xrot(i)=xc+xrot(i)
c0111         yrot(i)=yc+yrot(i)
c0111      enddo
C      call PGPIXL (IA, IDIM, JDIM, 1, 1, idim, jdim, 
C     1                   X1, X2, Y1, Y2)
c0111      call pgpoly(n,xrot,yrot)
c0111      return
      end

      SUBROUTINE MULTF(elemt,kodlp,npos,bpos,xyzpos)
C-----CALCULATES MULTIPLICITIES OF SPECIAL POSITIONS                    MULT0001
C-----and outputs the coordiates of atoms in the unit cell--------
C to unit=unitstruct, the file *.struct

      implicit none      
      include 'arraysize.inc'
      include 'io_files.inc'
      
c...	common blocks
      character*76 COMPND
      character*4 ielmt(16)
      real FOCCU(50,16), FMULT(50,16)
      real FNEUT(16)
      real A,B,C,ALPHA,BETA,GAMMA
      real SYMSY				!! Unused in code
      integer ISYMCE, NCOMPO
      integer NA(16)
      real wl, SL,SH, AGUIN, BGUIN
      real BTEMP(50,16), DELFR(16), DELFI(16)
      integer IMAGE, ns
      character*4 norm,iano
      COMMON /INPUT/ COMPND,IELMT,FOCCU,FMULT,FNEUT,
     &		A,B,C,ALPHA,BETA,GAMMA,
     &		SYMSY,ISYMCE,NCOMPO,NA,WL,SL,SH,NORM,IMAGE,AGUIN,
     &		BGUIN,BTEMP,DELFR,DELFI,IANO,NS

c01Dec      COMMON /INPUT/ COMPND,IELMT,FOCCU,FMULT,FNEUT,A,B,C,ALPHA,BE
c01Dec     1TA,GAMMA,SYMSY,ISYMCE,NCOMPO,NA,WL,SL,SH,NORM,IMAGE,AGUIN,BG
c01Dec     2UIN,BTEMP,DELFR,DELFI,IANO,NS

      integer ibravl, isystm
      common /cell/ ibravl,isystm

      character*2 symlp
      character*1 symbr
      character*4 symwl
      COMMON /INPUTCHAR/ SYMLP,SYMBR,symwl

      double precision x(50,16),y(50,16),z(50,16)
      common /inputdoub/ x,y,z

      double precision ts(3,24),fs(3,3,24)
      COMMON /EQUO/ TS,FS

      integer ICR,IPR,ILU
      COMMON /UNITS/ ICR,IPR,ILU

      real FNEU
      common /neu/ fneu

c...	passed variables
      character*4 elemt(16)
      integer kodlp
      integer npos
      real bpos(200)
      double precision xyzpos(natoms_max,3)
c01Dec      double precision xyzpos(nmax,3)
      
c...	local variables

c01Dec      integer nmax
      double precision xyzunique(96,3)
      double precision xyz(3)
      double precision dif,dif1, anti
      double precision tsb(3)
      double precision b1(3,8)
      integer nbra,ia,ic
C      real b1(3,8)    ! this was (3,9) above ?
C      real xyzunique(96,3)
      integer nunique, natom
      logical uniflag
      integer i, j, nb
      
C ibravl is the Bravais lattice number from function BRA(SYMBR)
C which indexes (blank) P I R F A B C       
C
C nbra is the number of Bravais points
      
      DATA B1(1,1)/.0d0/,B1(2,1)/.0d0/,B1(3,1)/.0d0/,B1(1,2)/.5d0/,B1(2,
     12)/.5d0/,B1(3,2)/.5d0/,B1(1,3)/2.0d0/,B1(2,3)/1.0d0/,B1(3,3)/1.0d0
     2/,B1(1,4)/.5d0/,B1(2,4)/.5d0/,B1(3,4)/.0d0/,B1(1,5)/.0d0/,B1(2,5)/
     3.5d0/,B1(3,5)/.5d0/,B1(1,6)/.5d0/,B1(2,6)/.0d0/,B1(3,6)/.5d0/,B1(1
     4,7)/.5d0/,B1(2,7)/.5d0/,B1(3,7)/.0d0/,B1(1,8)/1.0d0/,B1(2,8)/2.0d0
     5/,B1(3,8)/2.0d0/

      do i=1,3
         b1(i,3)=b1(i,3)/3.0d0
         b1(i,8)=b1(i,8)/3.0d0
      enddo

C B1 as a matrix:  0   1/2   2/3   1/2    0    1/2   1/2   1/3
C                  0   1/2   1/3   1/2   1/2    0    1/2   2/3
C                  0   1/2   1/3    0    1/2   1/2    0    2/3

C start with no atoms
      npos=0
         
      NBRA=1
      IF (IBRAVL.GT.1) NBRA=2       ! not a primitive lattice
      IF (IBRAVL.EQ.3) NBRA=3       ! rhombohedral (oh dear!)
      IF (IBRAVL.EQ.4) NBRA=4       ! face-centred

      write (unitstruct, *) '>> multf():'

      IF (ISYMCE.NE.1) then
c        write(7,25) nbra,
c     &     ' Bravais lattice positions and non-centrosymmetric.'
        write(unitstruct,25) nbra,
     &     ' Bravais lattice positions and non-centrosymmetric.'
      else
c        write(7,25) nbra,
c     &     ' Bravais lattice positions and centrosymmetric.'
        write(unitstruct, 25) nbra,
     &     ' Bravais lattice positions and centrosymmetric.'
      endif  
 25   format(i1,a)

C      write(7,24) 'Atom','  fi  ','  X   ','  Y   ','  Z   '
C      write(7,24) '----',' ---- ','----- ','----- ','----- '
C 24   format(a4,3x,a6,4x,a6,1x,a6,1x,a6)
      
cUnused      nopos=0    ! number of positions which are occupied in the unit cell

C-----LOOP OVER ATOMKINDS                                               MULT0020
      DO 7 IC=1,NCOMPO
        NATOM=NA(IC)
        CALL ANOMA (SYMWL,ELEMT(IC),KODLP)

C-----LOOP OVER ATOMS OF ONE KIND                                       MULT0023
        DO 6 IA=1,NATOM
          nunique=1
C  put in xyz coordinates of the atom, these are now double precision
          XYZUNIQUE(1,1)=X(IA,IC)
          XYZUNIQUE(1,2)=Y(IA,IC)
          XYZUNIQUE(1,3)=Z(IA,IC)
C-----MAKE COORDINATES POSITIVE                                         MULT0028
            DO 1 I=1,3
 1            IF (XYZUNIQUE(1,I).LT.0.0d0) XYZUNIQUE(1,I)=
     &              XYZUNIQUE(1,I)+1.0d0

            FMULT(IA,IC)=0.         ! initialize multiplicity

C-----LOOP OVER EQUIVALENT POSITIONS                                    MULT0032
            DO 4 J=1,NS             ! NS from either SPCGRP or SYMTRY

C-----LOOP OVER BRAVAIS LATTICE POINTS # just calculated                MULT0034
              DO 4 NB=1,NBRA

                ANTI=1.0d0
 2              DIF=0.0d0
C-----CALCULATE ATOM COORDINATES                                        MULT0038
C loop over x,y,z   
C there is an addend of 0.00001 here that I have removed, should be
C okay for double precision
                DO 3 I=1,3
          XYZ(I)=ANTI*(TS(I,J)+FS(1,I,J)*XYZUNIQUE(1,1)+
     &               FS(2,I,J)*XYZUNIQUE(1,2)+
     &               FS(3,I,J)*XYZUNIQUE(1,3)) ! +0.00001
C  calculate the lattice Bravais vectors (TSB)

C  first Bravais lattice point, make TSB 0 vector
                  IF (NB.EQ.1) TSB(I)=B1(I,1)
C  second Bravais lattice point, TSB is equal to IBRAVL column
                  IF (NB.EQ.2) TSB(I)=B1(I,IBRAVL)
C  fourth Bravais lattice point, TSB must be (1/2 0 1/2) (fcc)
                  IF (NB.EQ.4) TSB(I)=B1(I,6)
C  third Bravais lattice point, put in appropriate TSB
                  IF ((NB.EQ.3).AND.(IBRAVL.EQ.3)) TSB(I)=B1(I,8)  ! last of R
                  IF ((NB.EQ.3).AND.(IBRAVL.EQ.4)) TSB(I)=B1(I,5)  ! 3rd of F
C-----ADD BRAVAIS LATTICE VECTORS                                       MULT0047
                  XYZ(I)=XYZ(I)+TSB(I)
C-----MAKE COORDINATES POSITIVE AND LESS THAN 1.                        MULT0049
                  IF (XYZ(I).GE.2.0d0) XYZ(I)=XYZ(I)-1.0d0
                  IF (XYZ(I).GE.1.0d0) XYZ(I)=XYZ(I)-1.0d0
                  IF (XYZ(I).LT.-1.0d0) XYZ(I)=XYZ(I)+1.0d0
                  IF (XYZ(I).LT.0.0d0) XYZ(I)=XYZ(I)+1.0d0
 3              continue

                do i=1,3
                   if ((xyz(i).ge.1.0d0).or.(xyz(i).lt.0.0d0)) 
c     &               write(7,'(a,f6.3,a2,i1,a)') 'Trouble at ',xyz(i),
     &               write(unitstruct,'(a,f6.3,a2,i1,a)') 
     &			'Trouble at ',xyz(i),
     &               '. ',i,'-th coordinate not in unit cell.'
                enddo
C-----CALCULATE NUMBER FMULT OF COINCIDING ATOMS                        MULT0053

C                nsite=nsite+1
C                write(*,17) 'Atom #',ia,' of atom kind #',ic,
C     &           ' at ',nsite,'-th position ',xyz(1),xyz(2),xyz(3)
C 17             format(a,i1,a,i1,a,i3,a,f4.2,1x,f4.2,1x,f4.2)

                uniflag=.true.
                do i=1,nunique
                   DIF=XYZ(1)-XYZUNIQUE(i,1) ! x-coordinates
                   DIF=DABS(DIF)
                   DIF1=XYZ(2)-XYZUNIQUE(i,2) ! y-coordinates
                   DIF1=DABS(DIF1)
                   DIF=DIF+DIF1
                   DIF1=XYZ(3)-XYZUNIQUE(i,3) ! z-coordinates
                   DIF1=DABS(DIF1)
                   DIF=DIF+DIF1
C  increase multiplicity by 1.
                   IF ((DIF.LT..001).and.(i.eq.1))
     &                  FMULT(IA,IC)=FMULT(IA,IC)+1.
                   if (dif.lt..001) uniflag=.false.
                enddo

                if (uniflag) then
                   nunique=nunique+1
                   do i=1,3
                      xyzunique(nunique,i)=xyz(i)
                   enddo
                endif
C-----CHECK CENTROSYMMETRICALLY RELATED ATOMS                           MULT0064
                IF (ISYMCE.NE.1) GO TO 4   ! exit loop if not centrosym
                IF (ANTI.EQ.-1.0d0) GO TO 4
                ANTI=-1.0d0
                GO TO 2                    ! change sign and count again
 4          CONTINUE
            IF (FMULT(IA,IC).NE.0.) GO TO 5
            A=-1.                          ! Problem!
            WRITE (IPR,8) IA,IC
 5          FMULT(IA,IC)=1./FMULT(IA,IC)
c            write(7,18) elemt(ic),'#',ia,
            write(unitstruct,18) elemt(ic),'#',ia,
     &        ' has multiplicity ',int(1./fmult(ia,ic)+.001),
     &        ', scattering length ',fneu,' and occupancy ',
     &          foccu(ia,ic)
 18         format(a3,a1,i1,a,i3,a,f5.3,a,f4.2,1h.)
c            write(7,19) 'There are ',nunique,' positions.'  ! at:'
            write(unitstruct,19) 'There are ',nunique,' positions.'  ! at:'
C  output as two columns to save space
C  divide by 2 and round down
            do i=1,nunique
              if (2*(i/2).ne.i) then
c                write(7,20) (xyzunique(i,j),j=1,3)
                write(unitstruct,20) (xyzunique(i,j),j=1,3)
              else
c                write(7,21) (xyzunique(i,j),j=1,3)
                write(unitstruct,21) (xyzunique(i,j),j=1,3)
              endif
               bpos(npos+i)=fneu*foccu(ia,ic)
               do j=1,3
                 xyzpos(npos+i,j)=xyzunique(i,j)
               enddo
            enddo
c            if (2*(nunique/2).ne.nunique) write(7,*)           
            if (2*(nunique/2).ne.nunique) write(unitstruct,*) 
 19         format(a,i3,a)
 20         format(f7.5,1x,f7.5,1x,f7.5,$)
 21         format(7x,f7.5,1x,f7.5,1x,f7.5)            
C 20         format(f5.3,1x,f5.3,1x,f5.3,$)
C 21         format(7x,f5.3,1x,f5.3,1x,f5.3)            
            npos=npos+nunique
 6        CONTINUE
 7      CONTINUE
        write(unitstruct,*)
c        write(7,*)

      RETURN
C                                                                       MULT0077
 8    FORMAT (22H WRONG MULTIPLICITY OF,I5,16H TH ATOM OF TYPE,I5,43H CH
     1ECK COORDINATES AND EQUIVALENT POSITIONS)
      END

      subroutine label(kistrt,kistop,kfstrt,kfstop,xscale,yscale,
     &     over)
C for putting wavevector and energy labels on plot

      implicit none
      include 'arraysize.inc'		!! only used for physical constants
      include 'spur_color.inc'
      
c... passed variables
      real kistrt(2),kistop(2),kfstrt(2),kfstop(2)
      real xscale,yscale
      logical over

c... local variables

c0111Unused      character*1 key
cNotUsed      integer maxnpts
cNotUsed      parameter (maxnpts=99)
C      integer i
      real kilab(2),qlab(2),kflabstrt(2),kflabstop(2)
      real xbox(4),ybox(4)
      real en,val,truncval
      character*10 evalue
      character*18 elabel
      integer mm,pp,nc
      real qstrt(2),qstop(2),estrt,estop
      real enrnd
      real temp1, temp2
      integer l
      
C default values
C      data over/.true./

C generate values

      do l=1,2
         qstrt(l)=kistrt(l)-kfstrt(l)
         qstop(l)=kistop(l)-kfstop(l)
      enddo

      estrt=k2_to_E*(kistrt(1)**2+kistrt(2)**2
     &		      -kfstrt(1)**2-kfstrt(2)**2)
      estop=k2_to_E*(kistop(1)**2+kistop(2)**2
     &		      -kfstop(1)**2-kfstop(2)**2)
c02Apr      estrt=2.072*(kistrt(1)**2+kistrt(2)**2-kfstrt(1)**2-kfstrt(2)**2)
c02Apr      estop=2.072*(kistop(1)**2+kistop(2)**2-kfstop(1)**2-kfstop(2)**2)


C now we need to determine which vectors to label so that the
C labels look right

C calculate the nominal positions of the labels
C for ki the label is at a lower angle

      if (atan(kistop(2)/kistop(1)).lt.
     &     atan(kistrt(2)/kistrt(1))) then
         kilab(1)=kistop(1)/2+(kistop(2)/sqrt(kistop(1)**2.+
     &        kistop(2)**2.))*xscale*.055
         kilab(2)=kistop(2)/2-(kistop(1)/sqrt(kistop(1)**2.+
     &        kistop(2)**2.))*yscale*.055
      else
         kilab(1)=kistrt(1)/2+(kistrt(2)/sqrt(kistrt(1)**2.+
     &        kistrt(2)**2.))*xscale*.055
         kilab(2)=kistrt(2)/2-(kistrt(1)/sqrt(kistrt(1)**2.+
     &        kistrt(2)**2.))*yscale*.055
      endif

C      write(*,*) 'ki ',kistrt(1),kistrt(2),' and ',yscale     
C      write(*,*) 'ki label at ',kilab(1),kilab(2)

C for Q the label is at a higher angle

      if (atan(qstop(2)/qstop(1)).gt.
     &     atan(qstrt(2)/qstrt(1))) then
         qlab(1)=qstop(1)/2.5-(qstop(2)/sqrt(qstop(1)**2.+
     &        qstop(2)**2.))*xscale*.04
         qlab(2)=qstop(2)/2.5+(qstop(1)/sqrt(qstop(1)**2.+
     &        qstop(2)**2.))*yscale*.04
      else
         qlab(1)=qstrt(1)/2.5-(qstrt(2)/sqrt(qstrt(1)**2.+
     &        qstrt(2)**2.))*xscale*.04
         qlab(2)=qstrt(2)/2.5+(qstrt(1)/sqrt(qstrt(1)**2.+
     &        qstrt(2)**2.))*yscale*.04
      endif


C for kf use the outside midpoint
      kflabstrt(1)=(kistrt(1)+qstrt(1))/2-(kfstrt(2)/
     &     sqrt(kfstrt(1)**2+kfstrt(2)**2))*xscale*.05
      kflabstrt(2)=(kistrt(2)+qstrt(2))/2+(kfstrt(1)/
     &     sqrt(kfstrt(1)**2+kfstrt(2)**2))*yscale*.05

      kflabstop(1)=(kistop(1)+qstop(1))/2-(kfstop(2)/
     &     sqrt(kfstop(1)**2+kfstop(2)**2))*xscale*.05
      kflabstop(2)=(kistop(2)+qstop(2))/2+(kfstop(1)/
     &     sqrt(kfstop(1)**2+kfstop(2)**2))*yscale*.05
      
      if (kflabstrt(1)**2+kflabstrt(2)**2.lt.
     &     kflabstop(1)**2+kflabstop(2)**2) then
         kflabstrt(1)=kflabstop(1)
         kflabstrt(2)=kflabstop(2)
      endif
      
      if (over) then
         call pgsci(color_bkgr)
c01Dec         call pgsci(0)
         call pgsfs(1)
         call PGQTXT(qlab(1),qlab(2),0.0,0.5,'\fiQ',xbox,ybox)
         call pgrect(xbox(1),xbox(3),ybox(1),ybox(3))
      endif
      call pgsci(color_ink)
c01Dec      call pgsci(1)
      call PGPTXT(qlab(1),qlab(2),0.0,0.5,'\fiQ')
      
      if (over) then
         call pgsci(color_bkgr)
c01Dec         call pgsci(0)
         call pgsfs(1)
         call PGQTXT(kilab(1),kilab(2),
     &        0.0,0.5,'\fik\fn\di\u',xbox,ybox)
         call pgrect(xbox(1),xbox(3),ybox(1),ybox(3))
      endif
      call pgsci(color_ink)
c01Dec      call pgsci(1)
      call PGPTXT(kilab(1),kilab(2),0.0,0.5,'\fik\fn\di\u')
      
      if (over) then
         call pgsci(color_bkgr)
c01Dec         call pgsci(0)
         call pgsfs(1)
         call PGQTXT(kflabstrt(1),kflabstrt(2),
     &        0.0,0.5,'\fi-k\fn\df\u',xbox,ybox)
         call pgrect(xbox(1),xbox(3),ybox(1),ybox(3))
      endif
      call pgsci(color_ink)
c01Dec      call pgsci(1)
      call PGPTXT(kflabstrt(1),kflabstrt(2),0.0,0.5,'\fi-k\fn\df\u')
      
C energy labels - these should have no more than three sig figs

      en=estrt

C     use a while style loop to find pp and mm
C     i.e. the power and the mantissa


 109  pp=1   ! assume en= m.mm * 10^pp where pp is no greater than 1
             ! i.e. en <= 99.9 meV

C  gives a value rounded off to 2-decimal places
      enrnd=aint(100.0*(en+.005*abs(en)/en))/100.0

 110  val=enrnd*(10.0**float(-pp))
C val has full decimals
      truncval=aint(val)
C truncval only the most significant figure being checked

C this means that val is very close to an integer value
      if (abs(val-truncval).le..01) go to 111
      pp=pp-1
      go to 110

 111  mm=int(truncval)
      call pgnumb(mm,pp,1,evalue,nc)
      write(elabel,'(a8,a)') '\fiE\fn=',evalue(1:nc)
      
      if (over) then
         call pgsci(color_bkgr)
c01Dec         call pgsci(0)
         call pgsfs(1)
         if (en.eq.estrt) then
            temp1 = 1.1*kistrt(1)
            temp2 = 1.1*kistrt(2)
            call PGQTXT(temp1, temp2, 0.0,0.0,elabel,xbox,ybox)
c01Nov            call PGQTXT(1.1*kistrt(1),1.1*kistrt(2),
c01Nov     &           0.0,0.0,elabel,xbox,ybox)
            call pgrect(xbox(1),xbox(3),ybox(1),ybox(3))
         else
            temp1 = 1.1*kistop(1)
            temp2 = 1.1*kistop(2)
            call PGQTXT(temp1, temp2, 0.0,0.0,elabel,xbox,ybox)
c01Nov            call PGQTXT(1.1*kistop(1),1.1*kistop(2),
c01Nov     &           0.0,0.0,elabel,xbox,ybox)
            call pgrect(xbox(1),xbox(3),ybox(1),ybox(3))
         endif

      endif
      call pgsci(color_ink)
c01Dec      call pgsci(1)
      if (en.eq.estrt) then
         temp1 = 1.1*kistrt(1)
         temp2 = 1.1*kistrt(2)
         call PGPTXT(temp1, temp2, 0.0, 0.0, elabel)
c01Nov         call PGPTXT(1.1*kistrt(1),1.1*kistrt(2),
c01Nov     &        0.0,0.0,elabel)
      else
         temp1 = 1.1*kistop(1)
         temp2 = 1.1*kistop(2)
         call PGPTXT(temp1, temp2, 0.0, 0.0, elabel)
c01Nov         call PGPTXT(1.1*kistop(1),1.1*kistop(2),
c01Nov     &        0.0,0.0,elabel)
      endif

      if ((en.ne.estop)) then
         en=estop
         go to 109
      endif
      return
      end

      real function dot(a,b)
      implicit none
      real a(3),b(3)

      dot=a(1)*b(1)+a(2)*b(2)+a(3)*b(3)
      return
      end


C***********************************************************

      subroutine cross(a,b,c)
      implicit none
      real a(3),b(3),c(3)

      c(1)=a(2)*b(3)-a(3)*b(2)
      c(2)=a(3)*b(1)-a(1)*b(3)
      c(3)=a(1)*b(2)-a(2)*b(1)

      return
      end

C**********************************************************

      subroutine MMMULT (a, b, m, n, o, c)

C  Multiplies a matrix by a matrix
C     equation:   C(i,j) = A(i,l) * B(l,j)
C   dimensions:  m x n   m x o    o x n

      implicit none
      integer m, n, o, i, j, l
      real a(m,o), b(o,n), c(m,n)

      do i=1,m
        do j=1,n
          c(i,j)=0.0
        enddo
      enddo
      
      do 110 i = 1, m
        do 120 j = 1, n
          do 130 l= 1, o
            c(i,j) = c(i,j) + a(i,l)*b(l,j)
 130      continue
 120    continue
 110  continue

      return
      end

C**************************************************************

      subroutine MVMULT (amat, vin, m, n, vout)

C  Multiplies a vector by a matrix
C     equation:   VOUT(i) = AMAT(i,j) * VIN(j)
C   dimensions:     m         m x n       n

      implicit none
      integer m, n, i, j
      real amat(m,n), vin(n), vout(m)

      do 10 i = 1, m
        vout(i) = 0.0
 10   continue

      do 110 j = 1, n
        do 120 i = 1, m
          vout(i) = vout(i) + amat(i,j)*vin(j)
 120    continue
 110  continue

      return
      end
      
c_Func===1=========2=========3=========4=========5=========6=========712
	logical function invert(msize, thematrix)				!c_Func
c_Func Description:
c_Func	Matrix inversion routine. Assumes square matrix.
c_Func	Returns true if sucessfull, false if not.
c_Func.................................................................
c	Tanya Riseman,	Aug 18, 1997

	implicit none

c	passed variables
	integer		 msize
	real 		 thematrix(3,3)

c	local variables
        integer		maxerrors
	parameter	(maxerrors = 3)
	double precision akj, hold, pivot
	integer		 ISW(maxerrors)
	integer		 i, j, k, ii, jj
	double precision matrix(maxerrors, maxerrors)

	if (msize .gt. maxerrors) then
	  write (*,*) 'invert: array size too large for ', 
     &		'dimensioned arrays:', msize, '>',  maxerrors
	  invert = .false.
	  return
	endif

	do i = 1, msize
	  do j = 1, msize
	    matrix(i,j) = dble(thematrix(i,j))
	  enddo
	enddo

	invert = .true.
	do k = 1, msize						! 11
C	  FIND MAX OF REMAINDER OF COLUMN K FOR USE AS PIVOT
	  ii = k
	  do I = k, msize					! 21
	    if (abs(matrix(i,k)) .gt. abs(matrix(ii,k))) ii = i
	  enddo							! 21

	  isw(k) = ii
C	  INTERCHANGE ROWS IF NECESSARY
	  if (ii .ne. k) then
	      do j = 1, msize					! 22
		hold = matrix(ii,j)
		matrix(ii,j) = matrix(k,j)
		matrix(k,j) = hold
	      enddo						! 22
	  endif

C	  COMMENCE PIVOTING PROCEDURE
	  pivot = matrix(k,k)
	  if (pivot .eq. 0.0d0) then
	      invert = .false.
	      return
	  endif	      
	  do j = 1, msize					! 23
	      if (.not.(j.eq.k.or.matrix(k,j).eq.0.0d0)) then
C     		DIVIDE ROW K SUCH AS TO GIVE matrix(K,K)=1.0
		akj = matrix(k,j)/pivot
		matrix(k,j) = akj

C     		SUBTRACT ROWS SUCH AS TO ZERO matrix(I,K) FOR I.NE.K
		do i = 1, msize					! 31
		  if (i.ne.k) then
		    matrix(i,j) = matrix(i,j) - matrix(i,k)*akj
		  endif
		enddo						! 31
	      endif
	  enddo							! 23

C     	  INSERT TRANSFORMED COLUMN K FROM VIRTUAL UNIT MATRIX
	  do i=1, msize						! 24
	    if (i.ne.k) then
	      matrix(I,K) = -matrix(I,K)/PIVOT
	    endif
	  enddo							! 24

	  matrix(k,k) = 1.0d0/pivot
C         PIVOTING PROCEDURE COMPLETED 

	enddo							! 11

C     	INTERCHANGE COLUMNS TO MATCH THE INTERCHANGE OF ROWS, IN REVERSE Order
	do j =1, msize						! 13
	  k = msize - j + 1
	  jj = isw(k)
	  if (jj .ne. k) then 
	    do i = 1, msize					! 25
	      hold = matrix(i,jj)
	      matrix(i,jj) = matrix(i,k)
	      matrix(i,k) = hold
	    enddo						! 25
	  endif
	enddo							! 13

	do i = 1, msize
	  do j = 1, msize
	    thematrix(i,j) = sngl(matrix(i,j))
	  enddo
	enddo

	return
	end

      subroutine printequiv(fs,ts,ns)
      implicit none
      include 'io_files.inc'
      
c...	passed variables
      double precision fs(3,3,*),ts(3,*)
c01Dec      double precision fs(3,3,ns),ts(3,ns) !! last dimension = 24 in lazy. 
C      real fs(3,3,ns),ts(3,ns)
      integer ns

c...	local variables
      integer i,j,k,length
      character*9 pos(3),old(3)
      character*1 xchar(3)

      data (xchar(i),i=1,3)/1HX,1HY,1HZ/

C  UNIT 7 is structinfo.dat
      write (unitstruct, *) '>> printequiv()'
      write(unitstruct,10) '# of equiv. pos. (not counting ',
     &  'inversion or Bravais lattice symmetry) ',ns
c      write(7,10) '# of equiv. pos. (not counting inversion or',
c     &  ' Bravais lattice symmetry) ',ns
 10   format(2a,i2)

C  trying to save screen space

      do i=1,ns
         do j=1,3
         pos(j)=''
         length=0
         if (ts(j,i).ne.0.0d0) then
           write(pos(j),'(f3.2)') ts(j,i)
           length=3
         endif
           do k=1,3
             old(j)=pos(j)
             if (fs(k,j,i).eq.1.0d0) then
               if (length.eq.0) then
                 pos(j)= old(j)(1:length)//xchar(k)
                 length=length+1
               else  
                 pos(j)= old(j)(1:length)//'+'//xchar(k)
c0111                 pos(j)= old(j)(1:length)//1h+//xchar(k)
                 length=length+2
               endif
             endif
             if (fs(k,j,i).eq.-1.0d0) then
               pos(j)= old(j)(1:length)//'-'//xchar(k)
c0111               pos(j)= old(j)(1:length)//1h-//xchar(k)
               length=length+2
             endif
           enddo
         enddo
         write(unitstruct,11) i,pos(1),pos(2),pos(3)
c         write(7,11) i,pos(1),pos(2),pos(3)
 11      format(1h(,i2,1h),1x,a9,1h,,a9,1h,,a9,$)
         if (float(i)/2.0.eq.int(float(i)/2.0)) write(unitstruct,*)
c         if (float(i)/2.0.eq.int(float(i)/2.0)) write(7,*)
      enddo
      return
      end

      PROGRAM SPURION
C***********************************************************
C* SPURION CALCULATES THE LOCATION OF SPURIOUS NEUTRON 
C* SCATTERING PEAKS
C* WRITTEN BY CARL ADAMS, SEPT. 16, 1998
C***********************************************************

      implicit none
cDec01      IMPLICIT REAL (A-H,O-Z)
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_menu.inc'		
      include 'spur_structmenu.inc'		
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      include 'spur_buf.inc'
      include 'spur_warn.inc'

c...	data statements
cWrong      include 'spur_color_data.inc'

c...	common blocks
      logical noisy
      common /noisy/ noisy
 
      real branchdeg
      common /specparm/ branchdeg
      
      real tol, etol		!! spatial and energy tolerances       
      common /spur/ tol, etol

      integer natoms
      common /atoms/ natoms
      
      integer ntiny, nabsent, npresent, nobserved
      common /nabsences/ ntiny, nabsent, npresent, nobserved

c...	functions
      logical bit_on
      logical read_qbuf, verify_qbuf, write_qbuf
      logical qbuf_consistent
      
c...	local variables
      character*80 version_stamp
      character*20 date_stamp

      real pi
      real ec, es
      integer npts
      real angle, en, ei, ef, fe
      integer nscan, nspurtot
      real a4, a3, a2, a6
      real qmin
      
c...	new variables
      integer m_rlv		! INteded as overrise of m_rlv_max
            
c...	DECLARED VARAIBLES

C  The number of aluminum peaks, the m x m size of the reciprocal 
C  lattice, and the number of n*useDescending-n*kf spurions to calculate.

c...	h(3) is the current h,k,l for point i of npts
c            h(i)=hc(i)+(k-(float(npts)+1.0)/2.0)*hs(i)
c	hc(3) is the center h,k,l of scan 
c	hs(3) is the step h,k,l of scan 

      REAL*4 a(3),aa(3),h(3),hc(3),hs(3),bmat(3,3),bmatuv(3,3),b(3)
      REAL*4 zeta(m_rlv_max,m_rlv_max), eta(m_rlv_max,m_rlv_max)
      real*4 q(3),ki(2),kf(2)
      real sfhkl(m_rlv_max,m_rlv_max)
      logical absent(m_rlv_max,m_rlv_max)
      real*4 qarr(2,maxnpts),kiarr(2,maxnpts),kfarr(2,maxnpts)
      real*4 incohmon(2),incohana(2)
      real*4 incmonarr(2,maxnpts),incanaarr(2,maxnpts)

C  The underlying plot and all calculations are done in AA^-1
C  the actual numbers on the graph may be changed to rlu so
C  that xworld= (x AA^-1)/xstar.  The plot will still be
C  square. 
      real xstar,ystar
      logical rlu,constq
      integer axis
      REAL*4 uu(3),vv(3),uxv(3),uuv(3),vuv(3)
      real qspur(2,n_spur_max,n_spur_max)
      real espur(n_spur_max,n_spur_max)
      real qsparr(2,n_spur_max,n_spur_max, maxnpts)
      real esparr(n_spur_max,n_spur_max,maxnpts)
      real kistrt(2),kistop(2),kfstrt(2),kfstop(2)
cInc      real gal(nal)
      real minq,maxq,magq
      real qlowmin,qlowmax
cInc      integer hklal(3,nal)
cInc      logical alspur
      logical nearby
      INTEGER u(3),v(3),uxvi(3)
      integer hh(m_rlv_max,m_rlv_max)
      integer kk(m_rlv_max,m_rlv_max)
      integer ll(m_rlv_max,m_rlv_max)
      integer hklcen(3)
      integer sp(3)
      integer selct_sp(3)
cInc      integer ispur(n_spur_max*n_spur_max)
cInc      integer jspur(n_spur_max*n_spur_max)
cInc      integer ielst(n_spur_max*n_spur_max)
cInc      integer jelst(n_spur_max*n_spur_max)
cInc      integer hspur(n_spur_max*n_spur_max)
cInc      integer kspur(n_spur_max*n_spur_max)
cInc      integer lspur(n_spur_max*n_spur_max)
      integer nspur
      integer idev
      real phimax,qmax
      CHARACTER*5 mon,scale
      CHARACTER*41 xtitle,ytitle,maintitle
      CHARACTER*41 x2title,y2title
      character*10 zetatitle,etatitle,qztitle,spurtitle
      logical skip,right,gray,struct,fail,incohflag,prev
      logical rainbow
c02Mar      real circsize,c
      real circsize, relcircsize
      real ccircsize		!! Added TR, Nov 2001
      
      real dm,da
C this is an 8-bit binary number...
      integer spurhist,spurbit
      logical replot
      logical over
      logical overridesize
      real pointsize(m_rlv_max,m_rlv_max)

       integer indx1(unique_rlv_max), indx2(unique_rlv_max)
       integer indxunique1(unique_rlv_max)
       integer indxunique2(unique_rlv_max)
       integer multiplicity(unique_rlv_max)
       real	limlo(unique_rlv_max)
       real	limhi(unique_rlv_max)
       integer  nunique
       character*1 uniqueLabel(m_rlv_max,m_rlv_max)
       integer uniqueRank(m_rlv_max,m_rlv_max)
cChanged       real	tolerance
       real	sorttol, base
       logical	sortlogscale, plotunique, useDescending
       real	selct_sfhkl
       integer nincohmon, nincohana
cInc       integer nal_match
       integer  nelastictot
       integer	selected_bit
       logical hide_absences
       integer i, j
       character*1 whichqbuf, whichlpi
       logical showcalls
       parameter (showcalls = .false.) 
c       parameter (showcalls = .true.) 
       logical just_erase
       character*20 junkline

C Code for spurhist: (obsolete)
C     spurion on or off      2^0
C     incoherent on or off   2^1
C     aluminum on or off     2^2
C     prox (0) or all (1)    2^3
C     orient vec on or off   2^4
C     label wavevectors      2^5
C     overwrite (yes/no)     2^6
C     Systematic absences    2^7
cccC     not used               2^7

      logical success, freshplot, reset_freshplot
cNope      real the_magq, temp_magq
cNope      integer iscan
      

c...	Initialization of variables
      data m_rlv /m_rlv_max/
      
      junkline = ' '
      
C  Display program introduction
      if (showcalls) write (*,*) 'main: call intro'
      call intro(version_stamp, date_stamp)

      if (showcalls) write (*,*) 'main: call load_menuitems'
      call load_menuitems()
      if (showcalls) write (*,*) 'main: call load_menu'
      call load_menu()
      if (showcalls) write (*,*) 'main: call load_stndannote' 
      call load_stndannote()

      if (showcalls) write (*,*) 'main: call load_modmenuitems'
      call load_modmenuitems()
      if (showcalls) write (*,*) 'main: call load_modmenu'
      call load_modmenu()

      if (showcalls) write (*,*) 'main: call load_structmenuitems'
      call load_structmenuitems()
      if (showcalls) write (*,*) 'main: call load_structmenu'
      call load_structmenu()

      if (showcalls) write (*,*) 'main: call load_constants'
      call load_constants()
      
c... Get filename base (no extension) for first time (get default values)
 22    continue
      if (showcalls) write (*,*) 'main: call cmd_filenames' 
      call cmd_filenames(version_stamp, struct,
     &		 whichqbuf, whichlpi, .true.)

c03Mar 22      call get_filenames(version_stamp, struct)
c	!! If can't opne LPI file struct=.false. and no intensities have been
c	!! calculated

c	whichqbuf = 'd' from cmd_filenames
      if (whichqbuf .eq. 'd' ) then
        if (showcalls) write (*,*) 'main: call qbuf_default'
        call qbuf_default()      ! default values in case no files read in.
      endif
      file_base = 'SPUR_DEFAULT'
c      file_bufin = file_base(1:ilen(file_base))//ext_bufin
c      file_lpi = file_base(1:ilen(file_base))//ext_lpi
cdebug      success = write_qbuf(0, 'All', junkline)	! to screen
      success = write_qbuf(unitdebug, 'All', junkline)	! debug
cDebug      write (*,*) 'main: Debug: Wrote out default qbuffer OK = ',success

      currentoptions = 0
      addoption = 0
      warn_options = 0
      warnstring = ' '
      current_structop = 0
      add_structop = 0
      noisy = .true.	     ! Extra debuggin info and IO help.
      freshplot = .true.
      just_erase = .false.
      hide_absences = .true.	!! Don't plot location of systematic absences
      scale=' '
      prev=.false.           ! Sfq^2 has not been calculated yet
      rainbow=.false.        ! indicate structure factor by gray or color
      aspect_ratio = ps_height/ ps_width ! set graphics window to 8.5 X 11
      write (*,*) 'main: aspect_ratio =', aspect_ratio
      
      struct = .true.		!! Plot structure factors
            
	nal_match = 0
        nincohmon = 0
	nincohana = 0
	nspurtot = 0
	nelastictot = 0
	
	draw_al_iscan  = 1
           
 24   continue

      do while (.not. bit_on(addoption,bit_quit)) 
      
      if (prev) then
        write (unitdebug,*) 'currentoptions =', currentoptions, 
     &		' addoption=', addoption, freshplot, prev
        if (showcalls) write (*,*) 'main: call load_itemvalue'
c02Mar        call load_itemvalue(tol, etol, c, struct,
        call load_itemvalue(tol, etol, 
cMoved     &		relcircsize, struct,
cMoved     &	    gray, rainbow, plotunique, sortlogscale, tolerance, 
     &      phimax, rlu, right, selct_sp, selct_sfhkl, over,
     &	    m_rlv, nabsent, npresent, nspurtot, nelastictot, 
     &	    nal_match, nincohmon, nincohana, 
     &	    grid_style, grid_size1, grid_size2,hide_absences)
        write (unitdebug, *) 'calling display_menu. Prev scale=', scale
        if (showcalls) write (*,*) 'main: call display_menu'
        call display_menu(version_stamp, scale, spurhist)
        if (showcalls) write (*,*) 'main: call which_bit'
	call which_bit(addoption, selected_bit, 1)
c	Need to close up the graphics windows first before quiting.	
	if (bit_on(addoption,bit_quit)) go to 545

c...	Request to toggle off the option, so need a fresh plot
c...	Works for several options (see routine display_menu)
        if (selected_bit .ge. 1) then
         if (.not. bit_on(currentoptions, selected_bit)) then
           freshplot = .true.
c	  !! turn off this bit, so that the bits match for selected_bit	 
           if (showcalls) write (*,*) 'main: call set_bit'
	   call set_bit(addoption, selected_bit, 0)
           write (*,*) 'Toggle off ', spurmenuitem(selected_bit), ' : ', 
     &	   	spurmenu(selected_bit), ' ', 
     &		bit_on(currentoptions, selected_bit), 
     &      	bit_on(addoption, selected_bit),' ', 
     &		spuritemvalue(selected_bit)
        endif
       else
          go to 555		!! skip unrecognized commands
       endif
cDebug           write (*,*) 'Selected: ', spurmenuitem(selected_bit), ' : ', 
cDebug     &	   	spurmenu(selected_bit), ' ', 
cDebug     &		bit_on(currentoptions, selected_bit), 
cDebug     &      	bit_on(addoption, selected_bit),' ', 
cDebug     &		spuritemvalue(selected_bit)
cDebug           write (*,*) 'main: freshplot =', freshplot, ' prev=', prev

      endif		!!  if (prev) then

c----------------------------------------------------------------------
c 	commands which require that the plot be started over freshly.
c----------------------------------------------------------------------

C  zoom in/out of spurion energy plot on scan's page
      if (bit_on(addoption,bit_zoomspur) ) then 
	call cmd_zoomspur(nscan)
	freshplot = .true.
      endif

C  Rescale the plot
      if (bit_on(addoption,bit_rescale) ) then 
	call cmd_rescaleplot(xstar, ystar, rlu, right, circsize)
	freshplot = .true.
cDebug	write (*,*) 'after cmd_rescale ', xmin, xmax, ymin, ymax
      endif

C  Change the style of the display of the Bragg intensities
      if (bit_on(addoption,bit_structmenu)) then 
        call cmd_structmenu(relcircsize, sorttol, base, 
     &	      struct, gray, rainbow, plotunique, sortlogscale,
     &		hide_absences)
 	freshplot = .true.
      endif

C  Show numbers for the intensities instead of only circles.
cMoved      if (bit_on(addoption,bit_showintensities)) then 
cMoved 	call cmd_showintensities(gray, rainbow)
cMoved 	freshplot = .true.
cMoved       endif

C  Show numbers for the intensities instead of only circles.
cMoved       if (bit_on(addoption,bit_absent)) then 
cMoved 	hide_absences = .not. hide_absences 
cMoved 	freshplot = .true.
cMoved       endif

C  Change the circlesize for the structure factors. IF c=0, disables
C  the structure factor calculation completely in PLOTLATTICE      
cMoved      if (bit_on(addoption,bit_circsize)) then 
cMoved	call cmd_circsize(relcircsize, struct)
c02MarcMoved	call cmd_circsize(c, struct)
cMoved	freshplot = .true.
cMoved      endif
      
C  Sort the structure factors and then bunch by multiplicity 
c  if tolerance = 0.
c If tolerance = base, bunch by base^n (log scale).
cMoved      if (bit_on(addoption,bit_sortlog)) then 
cMoved	call cmd_sortlog(sortlogscale, tolerance)
cMoved	freshplot = .true.
cMoved      endif

      
      
C change the device number
      if (bit_on(addoption,bit_device)) then 
        call cmd_printout(idev)
c        write(*,'(a,i3)') 'current spurhist variable: ',spurhist
	just_erase = .false.
	freshplot = .true.
      endif

c...	Been removed from menu and spur_menu.inc
cC toggle the units between rlu and AA^-1
c      if (bit_on(addoption,bit_units)) then 
c         rlu=.not.rlu
c	 freshplot = .true.
c      endif

C modify Q, E, and npts
      if (bit_on(addoption,bit_mod)) then 
         warn_options = 0
	 warnstring = ' '
	 if (.not. qbuf_consistent()) then 
	   write (*,*) 'main: Something is inconsistent in the q-buffer!'
	 endif
         call cmd_modify()
c02mar         call cmd_modify(ec, es, hc, hs, fe, npts, mon)
	 if (.not. qbuf_consistent()) then 
	   write (*,*) 'main: Something is inconsistent in the q-buffer!'
	 endif
	 freshplot = .true.

c...	Eventually only use common block variables qb_*.
c...	For now copy the contents.
      do i = 1, 3
        a(i) =  qb_lattice_a(i)
        aa(i) =  qb_lattice_angle(i)
	hc(i) = qb_space_hc(i)
	hs(i) = qb_space_hs(i)
	u(i) = qb_orient_u(i)
	v(i) = qb_orient_v(i)
      enddo 
      ec = qb_energy_ec
      es = qb_energy_es
      fe = qb_energy_fe
      mon = qb_energy_fix
      dm = qb_energy_dM
      da = qb_energy_dA	
      npts = qb_time_scanpts	

         if (.not. verify_qbuf(a,aa,hc,hs,fe,ec,es,u,v,npts,mon,dm,da, 
     &		 .true.)) then
           write (*,*) 'main: Continuing anyway. #4'
	   stop
         endif

c...	Eventually only use common block variables qb_*.
c...	For now copy the contents. 

c      do i = 1, 3
cc        qb_lattice_a(i) = a(i)
cc        qb_lattice_angle(i) = aa(i)    
c	qb_space_hc(i) = hc(i)
c	qb_space_hs(i) = hs(i)
cc	qb_orient_u(i) = u(i)
cc	qb_orient_v(i) = v(i)
c      enddo 
c      qb_energy_ec = ec
c      qb_energy_es = es
c      qb_energy_fe = fe
c      qb_energy_fix = mon
cc      qb_energy_dM = dm
cc      qb_energy_dA = da	
c      qb_time_scanpts = npts   	
c         if (.not. verify_qbuf(a,aa,hc,hs,fe,ec,es,u,v,npts,mon,dm,da, 
c     &		 .true.)) then
c           write (*,*) 'main: Continuing anyway. #3'
c	   stop
c         endif

c	 !! energy resolution tol for spurion hitting the bragg peak
c	!! Using the step size of the scan is too small, practically
c	!! Not needed anyway, because the zero crossings of the 
c	!! elastic spurions are calculated exactly.
cNope      if (abs(qb_energy_es) .gt. tiny) then
cNope         etol= abs(qb_energy_es)
cNope       else
cNope        etol= 1.0 
cNope       endif

c...	The q tolerance is harder to figure out than the e-tol
c...	 from the scan step size.
c...	The step size is in terms of hkl, but the tolerance is used in
c...	the scattering plane, after bmat has bee used to transform it.
c...	Take out this attemp at cleverness.
cNope        the_magq = 0.0
cNope        do iscan = 1, nscan-1
cNope          temp_magq = sqrt((qarr(1,iscan) - qarr(1,iscan+1))**2 
cNope     &	  	+ (qarr(2,iscan) - qarr(2,iscan+1))**2)	!! in AA^-1
cNope	  if (temp_magq .gt. the_magq)  the_magq = temp_magq 
cNope        enddo
cNope        if (the_magq  .gt. tiny) then
cNope          tol= the_magq
cNope        else
cNope          tol= 0.05 		!! probably qb_space_hs(3) = 0 or nscan=1
cNope        endif

      endif

C set the AA^-1 tolerence for spurion matches
      if (bit_on(addoption,bit_tol)) then 
         call cmd_selecttolerance()
	 freshplot = .true.
      endif

C set the maximum A4 (BUMP, sorry, running out of letters)
      if (bit_on(addoption,bit_bumpA4)) then 
         call cmd_BumpA4( phimax, pi)
	 freshplot = .true.
      endif

C  Toggle Show the sorting of the intensities
cMoved      if (bit_on(addoption,bit_showsort)) then 
cMoved        plotunique = .not. plotunique      
cMovedc	call cmd_showsort(plotunique)
cMoved	freshplot = .true.
cMoved      endif

C  d: start picture over with default values or read in different files.
      if (bit_on(addoption,bit_default)) then 
c02Apr30        call pg_close(idev)  
cccc	just_erase = .true.
        call cmd_filenames(version_stamp, struct,
     &		 whichqbuf, whichlpi, .false.)
	 if (.not. qbuf_consistent()) then 
	   write (*,*) 'main: Something is inconsistent in the q-buffer!'
	 endif
	freshplot = .true.
	currentoptions = 0
	addoption = 0
	warn_options = 0
        warnstring = ' '
cc...	When open a new file, keep the old plotting options.
cNo!        current_structop = 0
        add_structop = 0
	prev = .false.
      endif


c------------------------------------------------------------
c 	prep for a fresh plot graphics
c------------------------------------------------------------

c     !! Only load default values at beginning or when requested by user. 
      if (currentoptions .eq. 0) then
        write (*,*) 'Main: (currentoptions .eq. 0). Start from scratch',
     &		' rainbow = false'
        skip=.false.           ! a leftover system variable
        gray=.true.            ! indicate structure factor by gray scale
        rainbow=.false.        ! indicate structure factor by gray or color
        struct=.true.          ! read in structural data from LPI     
cDebug        idev=2                 ! B&W PS device
        idev=0                 ! xserve device
        rlu=.true.             ! plot labels given in rlu 
        constq=.true.          ! constq or constE
        nearby=.true.          ! only plot Al Ewald spheres near Q
        prev=.false.           ! Sfq^2 has not been calculated yet
        replot=.false.         ! no plot has been made yet
        plotunique = .true.    ! Spots have been sorted by intensity
      			     ! and can be labeled in plot
        useDescending = .true.  
        auto_xmin_sc    = .true.
        auto_xmax_sc    = .true.
        auto_ymin_sc_hs = .true.
        auto_ymax_sc_hs = .true.

        spurhist=0
        xmin=-0.5              ! default plot limits
        xmax= 0.5
        ymin=-0.5
        ymax= 0.5
	
	do i = 1,n_spur_max
          do j = 1,n_spur_max
	     afloat_hkl_start(i,j)  = ''
	     afloat_hkl_end(i,j)  = ''
	  enddo
	enddo

        pi=4.0*atan(1.0)       ! useful for degrees/radians conversion
        phimax=115.0*pi/180    ! max value of a4

        branchdeg=-120.0
        tol= .05  !! rlv resolution tol for spurion hitting the bragg peak
        etol= 1.0 !! energy resolution tol for spurion hitting the bragg peak
	
	nal_match = 0
        nincohmon = 0
	nincohana = 0
	nspurtot = 0
	nelastictot = 0

        selct_sfhkl = 0.0
C  right=.false. for a left-handed spectrometer
        right=.true.
        freshplot = .true.

      if (whichqbuf .eq. 'd' ) then
        if (showcalls) write (*,*) 'main: call qbuf_default'
        call qbuf_default()      ! default values in case no files read in.
        success = .true.
      else if (whichqbuf .eq. 'c' ) then	!! keep current values
        success = .true.
      else 		!! read either from q-buffer file or data file
        success = read_qbuf(whichqbuf)
      endif
c02Mar        CALL QBUFIN(a,aa,hc,hs,fe,ec,es,u,v,npts,mon,dm,da, success)
        if (.not. success) then
	  write (*,*) 'main: Can not open file ',  FILE_BUFIN(1:50)
	  stop
	endif
c...     QBUFIN reports the symmetry, but it is ignored due to LPI file read later.
c        if (noisy) then
c    	    call reportsymmetry(ISYSTM)
c        endif

c	 !! energy resolution tol for spurion hitting the bragg peak
cNope      if (abs(qb_energy_es) .gt. tiny) then
cNope        etol= abs(qb_energy_es)
cNope      else
cNope        etol= 1.0 
cNope      endif

cNope        the_magq = 0.0
cNope        do iscan = 1, nscan-1
cNope          temp_magq = sqrt((qarr(1,iscan) - qarr(1,iscan+1))**2 
cNope     &	  	+ (qarr(2,iscan) - qarr(2,iscan+1))**2)	!! in AA^-1
cNope	  if (temp_magq .gt. the_magq)  the_magq = temp_magq 
cNope        enddo
cNope        if (the_magq  .gt. tiny) then
cNope          tol= the_magq
cNope        else
cNope          tol= 0.05 		!! probably qb_space_hs(3) = 0 or nscan=1
cNope        endif


c...	Eventually only use common block variables qb_*.
c...	For now copy the contents.
      do i = 1, 3
        a(i) =  qb_lattice_a(i)
        aa(i) =  qb_lattice_angle(i)
	hc(i) = qb_space_hc(i)
	hs(i) = qb_space_hs(i)
	u(i) = qb_orient_u(i)
	v(i) = qb_orient_v(i)
      enddo 
      ec = qb_energy_ec
      es = qb_energy_es
      fe = qb_energy_fe
      mon = qb_energy_fix
      dm = qb_energy_dM
      da = qb_energy_dA	
      npts = qb_time_scanpts	

         if (.not. verify_qbuf(a,aa,hc,hs,fe,ec,es,u,v,npts,mon,dm,da, 
     &		 .true.)) then
           write (*,*) 'main: Continuing anyway. #2'
	   stop
         endif

      WRITE(*,313) 'E-range: ',ec-es*(npts-1)/2.0,' to ',
     &              ec+es*(npts-1)/2.0,' with center (hkl): (',
     &              hc(1),hc(2),hc(3),').'
      WRITE(unitlog,313) 'E-range: ',ec-es*(npts-1)/2.0,' to ',
     &              ec+es*(npts-1)/2.0,' with center (hkl): (',
     &              hc(1),hc(2),hc(3),').'
 313  FORMAT(a9,f5.1,a4,f5.1,a21,f4.1,1x,f4.1,1x,f4.1,a2)

        write(unitspur,*)     'SPURION Report File'
        write(unitspur,'(a)') '---------------------'

cMoved        call version(aversion, date_stamp)
        write (unitspur,'(a39, x, a39)')   
     &      FILE_BUFIN, FILE_LPI  
        write (unitdebug,'( a39, x, a39)')
     &		FILE_BUFIN, FILE_LPI  
c        write (unitspur,'(a30, x, a24, x, a24)') version_stamp,  
c     &      FILE_BUFIN, FILE_LPI  
c        write (unitdebug,'(a30, x, a24, x, a24)') version_stamp, 
c     &		FILE_BUFIN, FILE_LPI  

      
        if (showcalls) write (*,*) 'main: call init_vectors'
        call init_vectors(a, aa, bmat, bmatuv, b, 
     &      uu, vv, uxv, uuv, vuv, u, v, uxvi, 
     &	    zetatitle, etatitle, relcircsize, angle, xstar, ystar)
c02Mar     &	    zetatitle, etatitle, c, angle, xstar, ystar)
      
cDebug	write (*,*) 'main: after init_vectors:'
cDebug	do i = 1, 3
cDebug	  write (*,*) 'main: bmat(', i, ', j)=',  (bmat(i,j), j=1,3)
cDebug	enddo
cDebug	do i = 1, 3
cDebug	  write (*,*) 'main: bmatuv(', i, ', j)=',  (bmatuv(i,j), j=1,3)
cDebug	enddo
	
      endif		!! if (currentoptions .eq. 0) 


      if (freshplot) then 
        if (showcalls) write (*,*) 'main: call init_vectorlabels'
 60     call init_vectorlabels(rlu, u, v, zetatitle, etatitle, 
     &	xtitle, ytitle, x2title, y2title,angle, pi)
        if (showcalls) write (*,*) 'main: call init_scanvectorlabels'
 63     call init_scanvectors(constq, ec, es, npts, angle, 
     &      en, ei, ef, fe, h, hc, hs, nscan,
     &      mon, bmatuv, q, ki, kf, a4, a3, phimax, fail, pi, 
     &      qarr, kiarr, kfarr, qspur, 
     &      espur, qsparr, esparr, incohmon, incohana,
     &      incmonarr, incanaarr, prev)
cCommon     &      incmonarr, incanaarr, prev, xmin, xmax, ymin, ymax)
        call prep_elastic_spur(npts, ec, es, fe, hc, hs,  mon)
	
C 	suppose there were no suitable points
        if (nscan.eq.0) then
          write(*,'(2a)') 'PROBLEM: no points in scan!  Review and',
     &     ' modify these values.'
ccc          scale='m'
ccc          go to 781   ! shortcut to modify menu
          scale = char_mod
          addoption = 0
          call set_bit(addoption,bit_mod,1)
          call set_bit(currentoptions,bit_mod,1)
        endif
        if (showcalls) write (*,*) 'main: call init_qrange'
        call init_qrange(qmin, qmax, qlowmin, qlowmax, 
     &	      nscan, kiarr, kfarr, phimax)
        if (showcalls) write (*,*) 'main: call plot_center'
        call plot_center(u, v, uuv, vuv, hklcen)
cCommon        call plot_center(xmin, xmax, ymin, ymax, 
cCommon     &      u, v, uuv, vuv, hklcen)

cDebug	write (*,*) ' q-step from qb_space_hs= ',
cDebug     &	    sqrt( qb_space_hs(1)**2 + qb_space_hs(2)**2  + qb_space_hs(3)**2)
cNope        the_magq = 0.0
cNope        do iscan = 1, nscan-1
cNope          temp_magq = sqrt((qarr(1,iscan) - qarr(1,iscan+1))**2 
cNope     &	  	+ (qarr(2,iscan) - qarr(2,iscan+1))**2)	!! in AA^-1
cNope	   write (*,*) iscan, ' q-step = ', temp_magq
cNope	  if (temp_magq .gt. the_magq) then
cNope	    the_magq = temp_magq 
cNope	  endif
cNope	  	
cNope        enddo
cNope        if (the_magq  .gt. tiny) then
cNope          tol= the_magq
cNope        else
cNope          tol= 0.05 		!! probably qb_space_hs(3) = 0 or nscan=1
cNope        endif


      endif		!! if (freshplot)
       

      
C  Calculate the reciprocal lattice i.e., the (hkl) and the
C  zeta and eta coordinates assigned to each i,j which will be
C  placed in 5  m x m matrices.
      
C  only do these calculations once

      if ( .not.prev) then
c       !! AA^-1 resolution tol for spurion hitting the bragg peak

ccc      if ( (.not.prev) .or. freshplot) then
         if (showcalls) write (*,*) 'main: call calclattice'
         CALL calclattice(uuv,vuv,bmatuv, m_rlv, hh,kk,ll,
     &        zeta,eta, hklcen,u,v)
	  WRITE (unitdebug,*) 'post-calclattice>>'
cDec01         CALL calclattice(uuv,vuv,bmatuv,m,hh,kk,ll,zeta,eta,
cDec01     &        hklcen,u,v)
         if (showcalls) write (*,*) 'main: call fsqlattice'
         call fsqlattice(m_rlv,hh,kk,ll,struct,sfhkl,absent)
cDec01         call fsqlattice(m,hh,kk,ll,qmax,struct,sfhkl,absent)
	  WRITE (unitdebug,*) 'post-fsqlattice>>'
c	   !! Set default value of tolerance after fsqlattice()
c	  !!  because might need the value of natoms. 
c	  tolerance = 4.0	!! should be called base in this context.
	 			!!  Tol for matching intensities
c	  sortlogscale = .true.
	  sorttol = 100.0*tiny *float(natoms)
	  base = 2.0
c02Mar	  tolerance = 100.0*tiny *float(natoms)
	  sortlogscale = .false.
          prev=.true.
      endif

cChanged      if (freshplot .or. bit_on(addoption, bit_sortlog)
cChanged     &      .or. bit_on(addoption, bit_rescale)) then
      if (freshplot .or. bit_on(add_structop, sbit_logsort)
     &      .or. bit_on(addoption, bit_rescale)) then
c	 sorting the intensities in descending order

	  write (*,*) 'calling useDescending2'
          if (showcalls) write (*,*) 'main: call indexx2d'
	  call indexx2d(m_rlv, sfhkl, indx1, indx2, useDescending,
     &	   	qmax, hh, kk, ll, zeta,eta) 
cCommon	  call indexx2d(m_rlv, sfhkl, indx1, indx2, useDescending,
cCommon     &	   	qmax, hh, kk, ll, zeta,eta, xmin, xmax, ymin, ymax) 
c	  write (*,*) 'main: calling unique'
          if (showcalls) write (*,*) 'main: call unique'
	  call unique(m_rlv, sfhkl, absent, indx1, indx2,  
     &	  	indxunique1, indxunique2, multiplicity,  limlo, limhi,
     &		nunique, uniqueLabel,  uniqueRank,  sorttol, base,
c02Mar     &		nunique, uniqueLabel,  uniqueRank,  tolerance, 
     &		sortlogscale, useDescending, hh, kk, ll)
          if ((nabsent .gt. 0) .or. (ntiny .gt. 0)) then
	    spurbit = 1
            call bit(spurhist,7,spurbit,1)
	  else
	    spurbit = 0
            call bit(spurhist,7,spurbit,1)
	  endif
	endif		!! if (freshplot .or. bit_on(addoption, bit_sortlog)) 


cMoved      endif


      if (currentoptions .eq. 0) then
        relcircsize = 1.0
c02Mar        c=1.0
C  	Calculate a reasonable circle size for the reciprocal
C  	lattice points.
        circsize= (xmax-xmin)/120.0
      endif      !!  if (currentoptions .eq. 0) then

C --------------BEGINNING OF PLOTTING LOOP---------------

      if (freshplot)  then
C	  Begin pgplot routine, set character size, and axes.
C 	 Call pg_init with idev=
c		0 for XSERVE
c		1 for XWIN
c		2 for grey PS
c		3 for colour PS
        if (showcalls) write (*,*) 'main: call pg_close'
        call pg_close(idev, just_erase)             ! close PGPLOT
        if (showcalls) write (*,*) 'main: call pg_init'
 68     CALL pg_init(idev, rainbow, just_erase)
cccc 68     call plot_begin(idev)
        just_erase = .true.
      endif 		!! if (freshplot) 
      
C  setup the plot: axes, ticks, tick labels

      if (freshplot) then
	if (showcalls) write (*,*) 'main: calling plot_axes'
cDebug	write (*,*) 'plot_axes range: ', xmin, xmax, ymin, ymax
        if (showcalls) write (*,*) 'main: call plot_axes'
 67     CALL plot_axes(uxvi, qztitle, rlu, right, axis,
cCommon     &      xmin, xmax, ymin, ymax,
     &      xtitle,ytitle, x2title,y2title, maintitle, xstar, ystar, 
     &	    qmin, qmax, qlowmin, qlowmax, version_stamp)
cDebug	write (*,*) 'plot_axes range: ', xmin, xmax, ymin, ymax
      endif
	
      call pgupdt		!! flush the graphics buffer

      if (freshplot) then

c02Mar        ccircsize = c*circsize
        ccircsize = relcircsize*circsize

c        if (makescanplot) then
c          if (showcalls) write (*,*) 'main: call plot_scan'
c          call plot_scan(constq, ec, es, hc, hs, mon, nscan, 
c     &		  esparr, pointsize, relcircsize, ispur, jspur,
c     &		nspurtot, sfhkl, whichqbuf, version_stamp)
cc02Mar          call plot_scan(constq, ec, es, hc, hs, mon, nscan, whichqbuf)
c	endif

C 	 Plot the reciprocal lattice.
        if (showcalls) write (*,*) 'main: call plotlattice'
        CALL plotlattice(ccircsize,m_rlv,zeta,eta,hh,kk,ll,qmax,
     &  	gray, rainbow, struct,sfhkl,absent, 
     &		replot,  overridesize, pointsize, plotunique, uniqueLabel, 
     &  	 hide_absences, nscan, qarr)
cCommon     &  	 hide_absences, xmin, xmax, ymin, ymax)
c01Nov      CALL plotlattice(c*circsize,m,zeta,eta,hh,kk,ll,qmax,
c01Nov     &  gray,struct,sfhkl,absent)

        if (makescanplot) then
          if (showcalls) write (*,*) 'main: call plot_scan'
c	  ! first load in spurion info without plotting on LATTICE page.
	  call cmd_spurion(  m_rlv, npts, nscan, nspurtot, nspur, 
     &      qspur, espur, qsparr, esparr, kiarr, kfarr,
     &      circsize, ki, kf, zeta, eta,
     &      hh, kk, ll, 
     &      absent, replot, sp, spurtitle, 
     &      ec, es, h, hc, hs, constq, nelastictot, .true.,  bmatuv)
cDebug         write (*,*) 'main: returned from cmd_spurion'
         call cmd_aluminum(nscan, npts, minq, maxq, magq, 
     &   	nearby, qarr, kiarr, kfarr, 
     &		h, hc, hs, incmonarr, incanaarr,
     &	 	constq, spurhist, mon, pi, fe, phimax, .false.)
	 call cmd_incoherent(nscan, m_rlv,
     &		zeta,eta, kiarr, kfarr,
     &	 	incohmon,incohana, incmonarr, incanaarr, 
     &  	hh,kk,ll,circsize,ki,kf,constq, h, 
     &  	incohflag, absent, replot, npts, hc, hs,
     &		nincohmon, nincohana, .false.)
          call plot_scan(constq, ec, es, hc, hs, mon, nscan, 
     &		  esparr, pointsize, relcircsize, 
     &		nspurtot, nelastictot, nincohmon, nincohana, 
     &		sfhkl, phimax, whichqbuf, version_stamp)
c02Mar          call plot_scan(constq, ec, es, hc, hs, mon, nscan, whichqbuf)

cDebug         write (*,*) 'main: post plot_scan: nspurtot=', nspurtot
cDebug	 do i = 1, nspurtot
cDebug          write (*,*) 'main: post plot_scan: ', i, scanpt_spot(i),
cDebug     &		  ispot(i), jspot(i), ispur(i), jspur(i)
cDebug         enddo   

	endif

          if ((nabsent .gt. 0) .or. (ntiny .gt. 0)) then
	    spurbit = 1
            call bit(spurhist,7,spurbit,1)
	  else
	    spurbit = 0
            call bit(spurhist,7,spurbit,1)
	  endif

cDebug       write (*,*) 'returned from plotlattice'

C	  Plot Q, ki, kf  with a heavy line.
        if (showcalls) write (*,*) 'main: call plot_Q_ki_kf'
        call plot_Q_ki_kf(qarr, kiarr, nscan)
	
	reset_freshplot = .true.

C	  End of default minimalist plot
      else
	reset_freshplot = .false.
      endif 		!! if (freshplot) 
      call pgupdt		!! flush the graphics buffer

C  Beginning of command sequence

c      call annotate_spurhist(spurhist, annotation, unitdebug) 
cDebug      write (*,*) 'finished calling annotate_spurhist ',unitdebug
c      call annotate_spurhist(spurhist, annotation, 0) 
cDebug      write (*,*) 'finished calling annotate_spurhist ',0

ccc 781   continue


c------------------------------------------------------------
c 	Commands which super-impose on the current graphics
c	The program remembers that these commands have been requested.
c------------------------------------------------------------

C  Plot aluminum Ewald spheres that are within qmax in green      
      if (bit_on(addoption,bit_al) .or. 
     &	      (freshplot .and. bit_on(currentoptions,bit_al))) then 
	 spurbit = 1
         call bit(spurhist,2,spurbit,1)
	 if (bit_on(addoption,bit_al)) then
c           if (.not. constq) then
c             write (*,*) 'For clarity, in case of a q-scan, ', 
c     &		'this routine only reports some of the Al Aleward spheres.'
             write (*,*) 'For clarity, ', 
     &		'this routine only reports some of the Al Aleward spheres.'
120          WRITE (*,'(a, i3, a, $)') 'Enter which scan point: [1-', 
     &		nscan, ', or 0 for all]: '
	     read (*,*, err=120) draw_al_iscan
	     if ((draw_al_iscan .lt. 0) .or. 
     &		 (draw_al_iscan .gt. nscan)) goto 120
c           else
c      	     write (*,*) ' Constant q scan, so only 1 set of ', 
c     &		'Al Alewalds spheres to draw'
c             draw_al_iscan = 1
c           endif      
	 endif
	 
         call cmd_aluminum(nscan, npts, minq, maxq, magq, 
     &   	nearby, qarr, kiarr, kfarr, 
     &		h, hc, hs, incmonarr, incanaarr,
     &	 	constq, spurhist, mon, pi, fe, phimax, .true.)
c         call cmd_aluminum(nscan, npts, gal, minq, maxq, magq, hklal, 
c     &   	alspur,nearby, qarr, kiarr, kfarr, 
c     &		h, hc, hs, incmonarr, incanaarr,
c     &	 	constq, spurhist, mon, pi, fe, nal_match)

      else if (freshplot) then
c...	Refresh the al spurion info for the scan plot but don't plot on Lattice.
         call cmd_aluminum(nscan, npts, minq, maxq, magq, 
     &   	nearby, qarr, kiarr, kfarr, 
     &		h, hc, hs, incmonarr, incanaarr,
     &	 	constq, spurhist, mon, pi, fe, phimax, .false.)

      endif

C  Plot, count, and record spurious Q's
      if ((bit_on(addoption,bit_spur) .and. 
     &		 bit_on(currentoptions,bit_spur)).or. 
     &	      (freshplot .and. bit_on(currentoptions,bit_spur))) then 
	 spurbit = 1
         call bit(spurhist,0,spurbit,1)

cDebug	write (*,*) 'main: before cmd_spur:'
cDebug	do i = 1, 3
cDebug	  write (*,*) 'main: bmatuv(', i, ', j)=',  (bmatuv(i,j), j=1,3)
cDebug	enddo

	 call cmd_spurion(  m_rlv, npts, nscan, nspurtot, nspur, 
     &      qspur, espur, qsparr, esparr, kiarr, kfarr,
     &      circsize, ki, kf, zeta, eta,
     &      hh, kk, ll, 
cInc     &      ispur, jspur, hspur, kspur, lspur, ielst, jelst,
     &      absent, replot, sp, spurtitle, 
     &      ec, es, h, hc, hs, constq, nelastictot, .false.,  bmatuv)
cDebug         write (*,*) 'main: returned from cmd_spurion'
      endif

cDebug      write (*,*) 'main: post cmd_spurion: nspurtot=', nspurtot
cDebug      do i = 1, nspurtot
cDebug        write (*,*) 'main: post cmd_spurion : ', i, scanpt_spot(i),
cDebug     &		  ispot(i), jspot(i), ispur(i), jspur(i)
cDebug      enddo   
cDebug
cDebug	write (*,*) 'main: after cmd_spur:'
cDebug	do i = 1, 3
cDebug	  write (*,*) 'main: bmatuv(', i, ', j)=',  (bmatuv(i,j), j=1,3)
cDebug	enddo
      
C  Plot and report spurious Q's due to incoherent scattering.
      if (bit_on(addoption,bit_incoh) .or. 
     &	      (freshplot .and. bit_on(currentoptions,bit_incoh))) then 
	 spurbit = 1
         call bit(spurhist,1,spurbit,1)
	 call cmd_incoherent(nscan, m_rlv,
     &		zeta,eta, kiarr, kfarr,
     &	 	incohmon,incohana, incmonarr, incanaarr, 
     &  	hh,kk,ll,circsize,ki,kf,constq, h, 
     &  	incohflag, absent, replot, npts, hc, hs,
     &		nincohmon, nincohana, .true.)
      else if (freshplot) then
	 call cmd_incoherent(nscan, m_rlv,
     &		zeta,eta, kiarr, kfarr,
     &	 	incohmon,incohana, incmonarr, incanaarr, 
     &  	hh,kk,ll,circsize,ki,kf,constq, h, 
     &  	incohflag, absent, replot, npts, hc, hs,
     &		nincohmon, nincohana, .false.)
      endif
      
C  Draw the u and v orientation vectors with solid, magenta lines.
      if (bit_on(addoption, bit_orientvec) .or. 
     &	 (freshplot .and. bit_on(currentoptions,bit_orientvec))) then 
	 spurbit = 1
        call bit(spurhist,4,spurbit,1)
	call cmd_orientvecs(uuv, vuv)
      endif

C  label Q, ki, and kf
      if (bit_on(addoption,bit_labelvec) .or. 
     &   (freshplot .and. bit_on(currentoptions,bit_labelvec))) then 
         spurbit = 1
         call bit(spurhist,5,spurbit,1)
         call cmd_labelvec(kiarr, kfarr, kistrt, kistop, kfstrt, kfstop,
     &      nscan, over, spurhist)
cCommon         call cmd_labelvec(kiarr, kfarr, kistrt, kistop, kfstrt, kfstop,
cCommon     &      nscan, over, spurhist, xmin, xmax, ymin, ymax)
      endif

C  place a grid on Lattice plot
      if (bit_on(addoption,bit_grid) ) then 
c	  Ask for style and step size      
         call cmd_grid(.true., .true., uuv, vuv, rlu, xstar, ystar)
      endif
      if (freshplot .and. bit_on(currentoptions,bit_grid)) then 
c	  Keep previous values for style and step size      
         call cmd_grid(.false., .true., uuv, vuv, rlu, xstar, ystar)
      endif
      

C  Add annotation text to graph
      if (bit_on(addoption, bit_annote) .or. 
     &	 (freshplot .and. bit_on(currentoptions,bit_annote))) then 
c02Mar        call load_itemvalue(tol, etol, c, struct,
        call load_itemvalue(tol, etol, 
cMoved     &		relcircsize, struct,
cMoved     &	    gray, rainbow, plotunique, sortlogscale, tolerance, 
     &      phimax, rlu, right, selct_sp, selct_sfhkl, over,
     &	    m_rlv, nabsent, npresent, nspurtot, nelastictot, nal_match,
     &	    nincohmon, nincohana, grid_style, grid_size1, grid_size2,
     &	    hide_absences)
cc	call cmd_annotation(unitdebug, c, version_stamp) !! to the file unitdebug
c	call cmd_annotation(0, c, version_stamp)	 !! to the screen
cc	call cmd_annotation(-1, c, version_stamp)	!! no ASCII printout
cDebug      write (*,*) 'main:1 i, j', indxunique1(1), indxunique2(1)
c02Mar	call cmd_annotation(0, c, version_stamp,
	call cmd_annotation(0, version_stamp,
     &		sfhkl, nunique, uniqueLabel, 
     &      indxunique1, indxunique2, multiplicity, 
     &	    pointsize, circsize, overridesize, rainbow)	 !! to the screen
      endif


c------------------------------------------------------------
c 	Now the plot already has stuff on it, so no longer fresh.
c------------------------------------------------------------
      if (bit_on(currentoptions,bit_al)) then 
	freshplot = .false.
      endif
      if (bit_on(currentoptions,bit_spur)) then 
	freshplot = .false.
      endif
      if (bit_on(currentoptions,bit_incoh)) then 
	freshplot = .false.
      endif
      if (bit_on(currentoptions,bit_orientvec)) then 
	freshplot = .false.
      endif
      if (bit_on(currentoptions,bit_labelvec)) then 
	freshplot = .false.
      endif

      if (reset_freshplot) then		!! basic plot made.
	freshplot = .false.
      endif
c------------------------------------------------------------
c 	commands which only output to TTY or text files
c------------------------------------------------------------

C  Sf^2 printout
      if (bit_on(addoption,bit_reflect)) then 
         call  cmd_selectReflection( selct_sp, spurtitle, m_rlv, 
     &      hh, kk, ll, zeta, eta, absent, sfhkl, selct_sfhkl,
     &		qlowmin, qmax)
cWrong	freshplot = .false.
      endif

C generate angles like an ICP dry run
      if (bit_on(addoption,bit_ICP)) then 
	 call cmd_genICPrun(mon, npts, bmatuv, h, q, hc, hs, ki, 
     &      ec, es, en, ei, ef, fe, da, dm, a2, a3, a4, a6, pi)
cWrong	freshplot = .false.
      endif

C output values to a buffer
      if (bit_on(addoption,bit_qbufout)) then 
c	 Double check that we have not forgotten to update something.
         if (.not. verify_qbuf(a,aa,hc,hs,fe,ec,es,u,v,npts,mon,dm,da, 
     &		 .true.)) then
           write (*,*) 'main: Continuing anyway.'
	   stop
         endif
         success = write_qbuf(unitbufout, 'All', junkline)
         success = write_qbuf(0, 'All', junkline)	! also to screen
	 write (*,*) ' '
c02Mar         CALL QBUFOUT(a,aa,hc,hs,fe,ec,es,u,v,npts,mon,dm,da)
cWrong	freshplot = .false.
      endif


C  HELP!!
      if (bit_on(addoption,bit_help)) then 
c	Now using help-paul-unx.c, and ASCII file spurion.hlp
c  With empty path, use logical MSRHELP to determine where the help file is.
c	On VMS, "assign <helpdir> MSRHELP:"
c	On Unix,"setenv MSRHELP <helpdir>"
c	On Unix, "export MSRHELP='<helpdir>'"
c	 CALL HELP(HLP_PATH, HLP_FIL, KEY_WD)
c		In *.hlp file, spurion is currently only 1 level available.
c		So use key word to skip to it.
c		If have libraries (like ASK, DOPLOT, MINUIT, etc.)
c		then they should all be level 1 and key_wd = ''
	 call help('', 'spurion', 'spurion')
cWrong	freshplot = .false.
      endif

 545  if (bit_on(addoption,bit_quit)) then 
C 	---- closing sequence--------
        if (showcalls) write (*,*) 'main: call pg_close 545'
        call pg_close(idev, .false.)             ! close PGPLOT

        close(unit=unitspur)
        close(unit=unitstruct)
        close(unit=unitlog)
        close(unit=unitdebug)
        WRITE(*,'(a)') 'Ending SPURION.'
      endif	!!  if (bit_on(addoption,bit_quit)) then 

c...	Ignore unrecognised commands.
c...	This piece of code is now complicated by toggling of 
c...	some commands via settting addoption = 0.
c      if ((addoption .eq. 0) .and. (scale .ne. ' ') 
c     &      .and. (.not. bit_on(addoption,bit_default))) then 
c	write (*,*) 'Unrecognized command: "', scale, '"'
c      endif	!! if (addoption .eq. 0) then 

      
C ---- loop back to menu ----

555     continue
cDebug        write (*,*) 'main: end of loop. freshplot =',
cDebug     &		 freshplot, ' prev=', prev
      enddo 		!! do while (.not. bit_on(addoption,bit_quit)) 

      END		!! main

C*******************************************************
C
C      Subroutines
C
C*******************************************************
      
      subroutine intro(version_stamp, date_stamp)
      implicit none

c...	passed variables
      character*(*) version_stamp
      character*(*) date_stamp
      
c...	local variables
      integer i, j 

C     Program introduction

	call version(version_stamp, date_stamp)
	

      WRITE(*,*)
      WRITE(*,105) 
      write(*,110) version_stamp(1:72)
      WRITE(*,110) 'Written by Jeff Lynn, the dark ages, ca. 1970'
      WRITE(*,110) 'Graphical version written by Carl Adams, Feb. 2001'
      WRITE(*,110) 'Modified by Tanya Riseman, Nov, 2001 - May, 2002'
      WRITE(*,105) 
      WRITE(*,*)
      WRITE(*,*)

c      !! To see if screen is set to 80 characters wide
      write (*, *) 'Check that screen is 80 characters wide', 
     &      ' and 24 lines long:'
      WRITE(*,'(80(a1))') ((char(mod(i,10) +ichar('0')), i = 1, 10), 
     &	      j = 1, 8)
      do i = 2, 23
        write (*,*) i, '= line number' 
      enddo
      WRITE(*,'(80(a1))') ((char(mod(i,10) +ichar('0')), i = 1, 10), 
     &	      j = 1, 8)
      

105   format (2x, 76('*'), 2x) 
110   format (2x, '* ', a72, ' *', 2x) 

      return
      end
      
C*******************************************************
      subroutine version(astring, date_stamp)
      implicit none
     
      character*(*) astring
      character*(*) date_stamp

c...			      123456789_123456789_123456789_
      call datestamp(date_stamp)
CCC      write (astring, '(a, a, a, a)') 'spur_0201_$(OS=g77,sgi).'	!! 25
c     &      		     ' V0.4.4 Jan, 2002.',			!! 19
c     &      		     ' Used on ', date_stamp			!! 10+20
      write (astring, 110) date_stamp	
110   format ( 'spur_030115_$(g77,sgi). V0.4.16 Jan, 2003.',
     &		 ' Used on ', a20)
c110   format ( 'spur_020514_$(g77,sgi). V0.4.15 May, 2002.',
c     &		 ' Used on ', a20)
         

      return
      end

C*******************************************************
     

c....	spurion_structmenu.f
c	Routines for the structure intensity command's sub-menu

c=============================================================================

      subroutine load_structmenuitems()
       
      implicit none
      include 'io_files.inc'
      include 'spur_structmenu.inc'

c...	passed variables 
      

      structmenuitem(sbit_bragg) = schar_bragg
      structmenuitem(sbit_num) = schar_num
      structmenuitem(sbit_color) = schar_color
      structmenuitem(sbit_size) = schar_size
      structmenuitem(sbit_uniform) = schar_uniform
      structmenuitem(sbit_label) = schar_label
      structmenuitem(sbit_absences) = schar_absences
      structmenuitem(sbit_logsort) = schar_logsort
      structmenuitem(sbit_tolsort) = schar_tolsort
      structmenuitem(sbit_basesort) = schar_basesort

c...	standard menu items
      structmenuitem(sbit_help) = schar_help
      structmenuitem(sbit_quit) = schar_quit
      
      return
      end

c=============================================================================

      subroutine load_structmenu()
       
      implicit none
      include 'io_files.inc'
      include 'spur_structmenu.inc'

c...	passed variables 
      
      structmenu(sbit_bragg) = 
     & 'Toggle display Bragg intensities' 
      structmenu(sbit_num) = 
     & 'Toggle rep. intensities by circles/numbers' 
      structmenu(sbit_color) = 
     & 'Toggle rep. intensities by color/grey scale' 
      structmenu(sbit_size) = 
     & 'Rel. circle size' 
      structmenu(sbit_uniform) = 
     & 'Toggle circle size uniform or vary with Sf^2' 
      structmenu(sbit_label) = 
     & 'Toggle show/hide sorting labels'
      structmenu(sbit_absences) = 
     & 'Toggle display/hide sysmetatic absences' 

      structmenu(sbit_logsort) = 
     & 'Toggle  bunching sort by S^2= base^n or +- tol' 
      structmenu(sbit_tolsort) = 
     & 'Select sorting tolerance (+- tol)' 
      structmenu(sbit_basesort) = 
     & 'Select sorting base: (base^(n-1) < S^2 < base^n )' 

c...	Standard menu items
      structmenu(sbit_help) = 
     & 'HELP!!'
      structmenu(sbit_quit) =
     & 'to quit'

      
      return
      end

c=============================================================================
      subroutine load_structitemvalue(relcircsize, sorttol, base)
       

      implicit none
      include 'io_files.inc'
      include 'spur_structmenu.inc'
      include 'spur_buf.inc'

c...	functions
      logical bit_on

c...	passed variables
      real	relcircsize		!! in other parts of code = c.
      real	sorttol			!! sorting tolerance (linear scale)
      real	base			!! sorting base (log scale)
       
c...    local variables
      integer i
      
      do i = 1, len_structmenu 
        structitemvalue(i) = ''
      enddo
      
      
       
      if (bit_on(current_structop, sbit_bragg)) then
        write (structitemvalue(sbit_bragg), *) 'Sf^2 not shown'
      else
        write (structitemvalue(sbit_bragg), *) 'Sf^2 shown'
      endif
      
      if (bit_on(current_structop, sbit_num)) then
        write (structitemvalue(sbit_num), *) 'numbers'
      else
        write (structitemvalue(sbit_num), *) 'circles'
      endif
      
      if (bit_on(current_structop, sbit_color)) then
        write (structitemvalue(sbit_color), *) 'color'
      else
        write (structitemvalue(sbit_color), *) 'grey'
      endif
      
      write (structitemvalue(sbit_size), *) abs(relcircsize)

      if (relcircsize .ge. 0.0) then
        write (structitemvalue(sbit_uniform), *) 'uniform'
      else
        write (structitemvalue(sbit_uniform), *) 'varying'
      endif
 
c      if (relcircsize .ge. 0.0) then
c        write (structitemvalue(sbit_size), 90) relcircsize, ' uniform'
c      else
c        write (structitemvalue(sbit_size), 90) 
c     &		abs(relcircsize), ' varying'
c      endif

 90    format( f10.3, a10) 
 
      if (bit_on(current_structop, sbit_label)) then
        write (structitemvalue(sbit_label), *) 'no labels'
      else
        write (structitemvalue(sbit_label), *) 'ABC..cba labels'
      endif
      
      if (bit_on(current_structop, sbit_absences)) then
        write (structitemvalue(sbit_absences), *) 'display absences'
      else
        write (structitemvalue(sbit_absences), *) 'hide absences'
      endif
      
      if (bit_on(current_structop, sbit_logsort)) then
        write (structitemvalue(sbit_logsort), *) 'sort by S^2= base^n'
      else
        write (structitemvalue(sbit_logsort), *) 'sort by +- tol'
      endif
      
      if (bit_on(current_structop, sbit_logsort)) then
        write (structitemvalue(sbit_tolsort), *) ' '
      else
        write (structitemvalue(sbit_tolsort), 90) sorttol, ' = tol'
      endif

      if (bit_on(current_structop, sbit_logsort)) then
        write (structitemvalue(sbit_basesort), 90) base, ' =base'
      else
        write (structitemvalue(sbit_basesort), *) ' '
      endif

      return
      end

c==========================================================================
      subroutine cmd_structmenu(relcircsize, sorttol, base, 
     &	      struct, gray, rainbow, plotunique, sortlogscale,
     &		hide_absences)
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_structmenu.inc'

c...	functions
      logical bit_on

c...	passed variables
      real	relcircsize
      real 	sorttol
      real	base
      logical	struct, gray, rainbow, plotunique, sortlogscale
      logical	hide_absences
c...	local variables
      character*5 key
cUnused      integer i
      character*72 aline
      integer newbit, bit_value

      aline = 'Modify display of Bragg intensities'

cNo!      current_structop = 0	! is reset in main(). Not here.
      add_structop = 0
      call set_bit(current_structop,sbit_quit,0) 
      call set_bit(current_structop,sbit_help,0) 

      do while (.not. bit_on(current_structop,sbit_quit)) 
        call load_structitemvalue(relcircsize, sorttol, base)
c02Mar        call load_mod_itemvalue(ec, es, hc, hs, fe, npts, mon)

        call display_submenu(aline, key, current_structop, add_structop,
     &	      len_structmenu, structmenu, structitemvalue, 
     &		structmenuitem, .false.)

	 call which_bit(add_structop,newbit,1)
 220	 if ((newbit .eq. 0) .or. (newbit .gt. len_structmenu)) then
	   write (*,*) 'cmd_structmenu: newbit is out of range ', newbit
	   goto 555
c	 else
c	   write (*,'(a,a)') structmenu(newbit), ' Enter value(s):'
c	   write (*,'(a,a,$)') structmenu(newbit), ' Enter value(s):'
	 endif
	 call toggle_bit(current_structop, newbit, bit_value)

         if (bit_on(add_structop,sbit_bragg) ) then
	   struct = .not. struct
c	   call toggle_bit(current_structop, sbit_bragg, bit_value)
	   
         else if (bit_on(add_structop,sbit_num) ) then
	   gray = .not. gray		!! gray = .true. use greyscale.
	   				!! gray = .false. use numbers
c	  call toggle_bit(current_structop, sbit_num, bit_value)

         else if (bit_on(add_structop,sbit_color) ) then
           rainbow= .not. rainbow	!! color vs. greyscale
c	   call toggle_bit(current_structop, sbit_color, bit_value)

         else if (bit_on(add_structop,sbit_size) ) then
 230	  write (*,'(a,a,$)')  structmenu(sbit_size), ': '
c 230           call display_submenu(aline, key, 
c     &		current_structop, add_structop, len_structmenu, 
c     &		structmenu, structitemvalue, structmenuitem)
	   read(*,*,err=230) relcircsize
	   if (relcircsize .lt. 0.0) goto 230
c	   if (relcircsize .lt. 0.0) then
c	     write (*,*) 'cmd_structmenu: ', 
c     &	     	'rel. circle size must be positive'
c     	     goto 230
c	   endif
c	   call set_bit(current_structop,sbit_size,1)	!! Not toggled

         else if (bit_on(add_structop,sbit_uniform) ) then
	    relcircsize = -1.0 * relcircsize
c	    call toggle_bit(current_structop, sbit_uniform, bit_value)

c         else if (bit_on(add_structop,sbit_size) ) then
c           call display_submenu(aline, key, 
c     &		current_structop, add_structop, len_structmenu, 
c     &		structmenu, structitemvalue, structmenuitem)
c	   read(*,*,err=220) relcircsize

         else if (bit_on(add_structop,sbit_label) ) then
 	   plotunique = .not. plotunique
c	   call toggle_bit(current_structop, sbit_label, bit_value)

         else if (bit_on(add_structop,sbit_absences) ) then
 	   hide_absences = .not. hide_absences
c	   call toggle_bit(current_structop, sbit_absences, bit_value)

         else if (bit_on(add_structop,sbit_logsort) ) then
	   sortlogscale = .not. sortlogscale
c	   call toggle_bit(current_structop, sbit_logsort, bit_value)

         else if (bit_on(add_structop,sbit_tolsort) ) then
	   if (sortlogscale) then
	      write (*,*) 'cmd_structuremenu: Tolerance won''t show'
	   endif
 240  	   write (*,'(a,a,$)')  structmenu(sbit_tolsort), ': '
c           call display_submenu(aline, key, 
c     &		current_structop, add_structop, len_structmenu, 
c     &		structmenu, structitemvalue, structmenuitem)
	   read(*,*,err=240) sorttol
	   if (sorttol .lt. 0.0) goto 240
	   call set_bit(current_structop,sbit_tolsort,1) !! Not toggled directly.

         else if (bit_on(add_structop,sbit_basesort) ) then
	   if (.not. sortlogscale) then
	      write (*,*) 'cmd_structuremenu: Base won''t show'
	   endif
 250  	   write (*,'(a,a,$)')  structmenu(sbit_basesort), ': '
c           call display_submenu(aline, key, 
c     &		current_structop, add_structop, len_structmenu, 
c     &		structmenu, structitemvalue, structmenuitem)
	   read(*,*,err=250) base
	   if (base .lt. 0.0) goto 240
	   call set_bit(current_structop,sbit_basesort,1) !! Not toggled directly.

  
         else if (bit_on(add_structop, sbit_help) ) then 
	   call set_bit(current_structop,sbit_help,1) 
	   call help('', 'spurion', 
     &	   'spurion MainMenu sm_StrucFactorMenu')
         else if (bit_on(add_structop, sbit_quit) ) then 
	   call set_bit(current_structop,sbit_quit,1) 
	 else
	   write (*,*) 'cmd_modify: Unrecognized command: "', key, '"'
         endif


 555    continue
      enddo
      
      return
      end

      subroutine fsqlattice(m_rlv,h,k,l,struct,sfhkl,absent)
      
C  Calculate the F^2 values and systematic absences for the reciprocal
C  lattice.
C
C  Calls LAZY-PULVERIX code.
C
C  hmax is the maximum (h00) value corresponding to maximum Q for
C  the calculation.

C  natoms_max is the maximum number of atom positions in the unit cell.      
C  natoms is the actual number

C  reflmax is the maximum number of reflections (currently set for
C  a cubic material.
C  nref is the actual number
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      
c...	common blocks
      logical noisy
      common /noisy/ noisy
      
      logical warning
      common /reciplattice/ warning

      integer natoms
      common /atoms/ natoms

c...	passed variables
      integer m_rlv
      logical struct
      integer h(m_rlv_max,m_rlv_max)
      integer k(m_rlv_max,m_rlv_max)
      integer l(m_rlv_max,m_rlv_max)
      logical absent(41,41)
      real sfhkl(41,41)
      
c...	local variables
      integer i,j, o
cDebug      integer ii
      integer nwarn
      real b(natoms_max)
      double precision xyz(natoms_max,3)
      logical absentij
      real sfhklij
      real sfq0
      integer hkl(3)      

C  invoke lazy program to read space group, LPI style system cards,
C  crystal system, Bravais lattice. The number, positions, and
C  scattering lengths of the atoms in the unit cell are returned
C  as variables.  If struct is false then the necessary data for
C  the calculation could not be found.
C  also opens structinfo.out file (unit=7)

C  only do this calculation once
      
C  there are problems with the second time through

C  calls to MULTF and EXTINC
      
      warning=.false.
C set (hkl) to (000) for initial sfq^2 calculation
      do i=1,3
        hkl(i)=0
      enddo
      
C      call pgqch(size)
c      Added noisy=true to lazy parmeneter list, T.R. Nov 26, 2001
      if (struct) call lazy(natoms,b,xyz,struct, noisy)

C for diagnostics
C      write(*,*) 'natoms ',natoms
C      do i=1,natoms
C        write(*,'(i4,3f7.3)') i,(xyz(i,ii),ii=1,3)
C      enddo

      call sfsqd(natoms,b,xyz,hkl,sfq0)
      write (unitstruct,*) '>> fsqlattice():'
      if (struct) then
        write(*,*) 'Q=0 structure factor squared is: ', sfq0
c02Jan        write(*,'(a,f8.2)') 'Q=0 structure factor squared is: ',sfq0
c        write(7,'(a,f8.2)') 'Q=0 structure factor squared is: ',sfq0
c02Jan        write (unitstruct,'(a,f8.2)') 'Q=0 structure factor', 
c01Jan     &		' squared is: ',sfq0
        write (unitstruct,*) 'Q=0 structure factor', 
     &		' squared is: ',sfq0
      else
        write(*,'(a)') 'Not reading in structural information.'
        write(unitlog,'(a)') 'Not reading in structural information.'
      endif

C  Calculate structure factor from struct.dat file

      call conditions

      nwarn=0
      do i=1,m_rlv
        do j=1,m_rlv
          hkl(1)=h(i,j)
          hkl(2)=k(i,j)
          hkl(3)=l(i,j)
cDebug          write(*,'(a,4i5)') 'calc sf^2',m_rlv*(i-1)+j,(hkl(ii),ii=1,3)
          if (struct) then
            call sfsqd(natoms,b,xyz,hkl,sfhklij)
C if I uncomment the next statement it works?
C            write(*,'(a)') 'xx '  ! ,sfhklij
            call pulverix(hkl,absentij)
            sfhkl(i,j)=sfhklij
            absent(i,j)=absentij
C   put in a little check/warning
C   unfortunately a simple number won't work since
C   for a large number of atoms and a large (hkl)
C   the error in the structure factor calculation will
C   increase as the number of summed terms increases.
C   I'll just compensate for atom number.
C            write(*,*) absent,(hkl(o),o=1,3),sfhkl
            if (absent(i,j).and.(sfhkl(i,j)/float(natoms).
     &          gt. tiny)) then
c01Dec     &          gt.1.0e-5)) then
               if (nwarn.le.10) then
	         write(unitstruct,43) (hkl(o),o=1,3),sfhkl(i,j)
	       endif
c               if (nwarn.le.10) write(7,43) (hkl(o),o=1,3),sfhkl(i,j)
               nwarn=nwarn+1
               warning=.true.
            endif
            if ((.not.absent(i,j)).and.(sfhkl(i,j)/float(natoms).
     &            lt. tiny)) then
c01Dec     &            lt.1.0e-5)) then
               if (nwarn.le.10) then
	         write(unitstruct,34) (hkl(o),o=1,3)
	       endif
c               if (nwarn.le.10) write(7,34) (hkl(o),o=1,3)
                nwarn=nwarn+1
               warning=.true.
            endif
          else
C no structural information
            sfhkl(i,j)=1.0
            sfq0=1.0
            absent(i,j)=.false.
          endif

 43       format(28hWARNING: Absent reflection (,3i3,
     &      20h) has non-zero Sf^2:,g9.3)
 34       format(29hWARNING: Allowed reflection (,3i3,
     &      16h) has zero Sf^2.)

        enddo
      enddo
      if (nwarn.gt.10) then
        write(unitstruct,*) '... plus warnings on ', nwarn-10,' others'
      endif
c      if (nwarn.gt.10) write(7,*) '... plus warnings on ',
c     &     nwarn-10,' others'
      return
      end

      subroutine calclattice(u,v,bmat, m_rlv, h,k,l,
     &			zeta,eta,hklcen,uint,vint)
C      CALL rlattice(uuv,vuv,bmatuv,m,hh,kk,ll,zeta,eta)
      
C     Calculate reciprocal lattice after u, v, and bmat have been
C     transformed to u-v space. (i.e. u || x, u x v || z) in terms
C     of h(i,j), k(i,j), l(i,j), zeta(i,j), and eta(i,j).

C     Also want the reciprocal lattice centred about xcen and ycen.
C     Can do this by changing the offset n.

      implicit none
      include 'arraysize.inc'
c...	passed variables
      real u(3),v(3),bmat(3,3)
      integer m_rlv
      integer uint(3),vint(3)
      real zeta(m_rlv_max,m_rlv_max)
      real eta(m_rlv_max,m_rlv_max)
      integer h(m_rlv_max,m_rlv_max)
      integer k(m_rlv_max,m_rlv_max)
      integer l(m_rlv_max,m_rlv_max)
      integer hklcen(3)

c...	local variables
      integer n,i,j
      integer uirr(3),virr(3)
      character*10 inttitle,redtitle
      integer len1,len2

c	November 2001
      real	temp1, temp2, temp3
      
C     The reciprocal lattice in this scattering plane is
C     all combinations of reciprocal lattice vectors such
C     that (h*A + k*B + l*C).(u x v)=0
C     or i*bmatuv(*,1).uxv(*)+j*bmatuv(*,2).uxv(*)+k*bmatuv(*,3).uxv(*)=0
C     A similar result should come from linear,integer, addition of u
C     and v, and contain the reciprocal lattice vectors which both
C     satisfy u.(u x v)=0 and v.(u x v)=0.       
C
C     if u and v are not reduced to the lowest common denominator then
C     those points will be simply skipped      
C     is there any good way to reduce to the shortest vectors that
C     still define this plane and won't miss any points, like an
C     irreducible set ?
      
      call irreduc(uint,vint,uirr,virr)
      if ((uint(1).ne.uirr(1)).or.(uint(2).ne.uirr(2)).or.
     &  (uint(3).ne.uirr(3))) then
        call title(uint,inttitle,len1)
        call title(uirr,redtitle,len2)
        write(*,'(3a)') inttitle(1:len1),' reduces to ',redtitle(1:len2)
      endif
      if ((vint(1).ne.virr(1)).or.(vint(2).ne.virr(2)).or.
     &  (vint(3).ne.virr(3))) then
        call title(vint,inttitle,len1)
        call title(virr,redtitle,len2)
        write(*,'(3a)') inttitle(1:len1),' reduces to ',redtitle(1:len2)
      endif
      
      n=int(m_rlv/2)+1
        do i=1,m_rlv
          do j=1,m_rlv
            h(i,j)=hklcen(1)+(i-n)*uirr(1)+(j-n)*virr(1)
            k(i,j)=hklcen(2)+(i-n)*uirr(2)+(j-n)*virr(2)
            l(i,j)=hklcen(3)+(i-n)*uirr(3)+(j-n)*virr(3)
	    temp1 = float(h(i,j))
	    temp2 = float(k(i,j))
	    temp3 = float(l(i,j))
            call qspace(bmat, temp1, temp2, temp3, 
     &        zeta(i,j),eta(i,j))
c01Nov            call qspace(bmat,float(h(i,j)),float(k(i,j)),
c01Nov     &        float(l(i,j)),zeta(i,j),eta(i,j))
cDEbug	    write (*,*) 'calclattice:', i, j, h(i,j), k(i,j), l(i,j)
          enddo
        enddo


      return
      end
C***************************************************************

      subroutine qspace(bmat,h,k,l,x,y)

C     Gives x,y,z components of reciprocal lattice points for
C     Miller indicies h,k,l and reciprocal lattice vectors
C     bmat(*,1), bmat(*,2), and bmat(*,3).
      
      implicit none
c...	passed variables
      real bmat(3,3),x,y
      real h,k,l
c...	local variables
      real z
      
      x=h*bmat(1,1)+k*bmat(1,2)+l*bmat(1,3)
      y=h*bmat(2,1)+k*bmat(2,2)+l*bmat(2,3)
      z=h*bmat(3,1)+k*bmat(3,2)+l*bmat(3,3)

C     If everything is correct then h,k,l and bmat should be such
C     that there is no z-component to the scattering.

      if (abs(z).gt.1.1e-5) then
        write (*,*)
     &  'Reciprocal lattice point out-of scattering plane'
        write(*,*) x,y,z,h,k,l
      endif
      
      return
      end
C
C*************************************************************      
C
      subroutine irreduc(u,v,uirr,virr)

      implicit none

c...	passed variables
      integer u(3),v(3),uirr(3),virr(3)

c...	local variables
      integer diff(3)
      integer ucoeff,vcoeff
      integer j, k
      integer n, diffsq, vsq
      
C  generate irreducible pair of vectors uirr,virr as close
C  to right angles as possible that are still in the
C  same plane as u and v

C  first check for any common denominators using division by primes

      do j=1,3
        uirr(j)=u(j)
        virr(j)=v(j)
      enddo
      
C      write(*,*) (uirr(i),i=1,3)
      call lcd(uirr,n)
C      write(*,*) (virr(i),i=1,3)      
      call lcd(virr,n)

C what is the possibility that an integer sum of the peaks will yield
C zero for one of the indices?

 11   continue
      do j=1,3
        call mult(uirr(j),virr(j),ucoeff,vcoeff)
C        write(*,*) 'Coefficients are ',ucoeff,vcoeff
        if ((ucoeff.eq.0).or.(vcoeff.eq.0)) goto 25
        do k=1,3
          diff(k)=ucoeff*uirr(k)+vcoeff*virr(k)
        enddo

C        write(*,*) 'Linear combination of u and v ',(diff(k),k=1,3)
        call lcd(diff,n)
C        if (n.ne.1) then
        diffsq=0
        vsq=0
        do k=1,3
          diffsq=diffsq+diff(k)**2
          vsq=vsq+virr(k)**2
        enddo
        if (diffsq.lt.vsq) then
          do k=1,3
            virr(k)=diff(k)
          enddo
          goto 11
        endif
  25  enddo
      
      return
      end
C
C*****************************************************
C      
      subroutine lcd(uirr,fac)
      implicit none

c...	constants
      integer nprime
      parameter (nprime=26)

c...	passed variables
      integer fac,uirr(3)

c...	local variables
      integer i,j
      integer prime(nprime)
      logical comm

      data (prime(j),j=1,nprime)/2,3,5,7,11,13,17,19,23,29,31,37,
     &  41,43,47,53,59,61,67,71,73,79,83,89,97,101/
      
      fac=1

      if ((uirr(1).eq.0).and.(uirr(2).eq.0).and.(uirr(3).eq.0))
     &  goto 16


  10  continue
      do i=1,nprime
        comm=.true.
        do j=1,3
           comm=(prime(i)*(uirr(j)/prime(i)).eq.uirr(j)).and.comm
        enddo
        if (comm) then
C          write(*,*) (uirr(j),j=1,3),' is being divided by ',prime(i)
          do j=1,3
            uirr(j)=uirr(j)/prime(i)
          enddo
          fac=fac*prime(i)
          go to 10
        endif
      enddo

C 16   if (fac.eq.1) write(*,*) 'No common factors for ',(uirr(j),j=1,3)
C include a quick check of negatives
 16   comm=.true.
      do j=1,3
        comm=(-uirr(j).eq.abs(uirr(j))).and.comm
      enddo
      if (comm) then
        do j=1,3
          uirr(j)=-uirr(j)
        enddo
      endif
      
      return
      end

C*******************************************************************
      
      subroutine mult(x,y,a,b)
      implicit none

c...	passed variables
      integer x,y,a,b
c...	local variables
      integer n(3),fac

C find the solution to ax+by=0
C with no common factor between a and b

      if ((x.eq.0).and.(y.eq.0)) then
        a=0                   ! both a and b indeterminant so this
        b=0                   ! really a flag not to do any reduction
        goto 66
      else if (x.eq.0) then
        b=0                   ! a indeterminant
        a=1
        goto 66
      else if (y.eq.0) then
        a=0                   ! b indeterminant
        b=1
        goto 66
      endif

C so a and b are determined up to some multiple and the solution
C a=y, b=-x is fine, dump it into lcd to check for any common
C factors     
      n(1)=y
      n(2)=-x
      n(3)=0
      call lcd(n,fac)
      a=n(1)
      b=n(2)

 66   return
      end

      subroutine transform(ui,vi,bmat,u3,v3,b1mat)

      implicit none
c...	passed variables
      integer ui(3),vi(3)
      real bmat(3,3),b1mat(3,3)
      real u3(3),v3(3)
      
c...	local variables      
      integer i
      real tmat(3,3), b2mat(3,3)
      real u(3),v(3),u1(3),v1(3),u2(3),v2(3)
      real theta,pi
      real temp
      
      pi=4.0*atan(1.0)

C     The desired transformation is to a coordinate system where
C     x or zeta is perpendicular to uu, vv is a postive rotation
C     of A3 away from uu, and z is hence parallel to uu x vv.
C
C     Currently b[1] is parallel to x and b[2] lies in the x-y
C     plane because of the generating routine

C     Generate u and v in the current coordinate system.

      do i=1,3
        u(i)=float(ui(1))*bmat(i,1)+float(ui(2))*bmat(i,2)+
     &    float(ui(3))*bmat(i,3)
        v(i)=float(vi(1))*bmat(i,1)+float(vi(2))*bmat(i,2)+
     &    float(vi(3))*bmat(i,3)
      enddo
      
C     What is one of the transformation matrices that will align
C     u and x?  Will take 2 steps.

C      write(*,18) 'u is now ',u(1),' i+',u(2),' j+',u(3),' k'
C      write(*,18) 'v is now ',v(1),' i+',v(2),' j+',v(3),' k'
      
C     Rotation about z-axis with quadrant conventions.

      call calctheta(u(1),u(2),theta)

C      write(*,*) theta*180/pi
      
C     -theta appears in the transformation matix because we
C     want the transformation rotate the coordinate axies
C     so that u will lie in the x'-z' plane

      temp = -theta
      call rotate(temp,3,tmat)
c01Nov      call rotate(-theta,3,tmat)
      
      call mmmult(tmat,bmat,3,3,3,b1mat)
      call mvmult(tmat,u,3,3,u1)
      call mvmult(tmat,v,3,3,v1)
      
C      write(*,18) 'u is now ',u1(1),' i+',u1(2),' j+',u1(3),' k'
C      write(*,18) 'v is now ',v1(1),' i+',v1(2),' j+',v1(3),' k'


C     Rotation about y1-axis
C     This one is a bit different since with the y1-axis coming
C     out of the page x1-z1 are left-handed.  Best plan is to
C     choose theta such that it is correct for the +z1 axis
C     and then rotate pi/2 further to +x1.

      call calctheta(u1(3),u1(1),theta)

C      write(*,*) theta*180.0/pi
      temp = -theta+pi/2.0
      call rotate(temp, 2,tmat)
c01Nov      call rotate(-theta+pi/2.0,2,tmat)
      
      call mmmult(tmat,b1mat,3,3,3,b2mat)
      call mvmult(tmat,u1,3,3,u2)
      call mvmult(tmat,v1,3,3,v2)
      
C      write(*,18) 'u is now ',u2(1),' i+',u2(2),' j+',u2(3),' k'
C      write(*,18) 'v is now ',v2(1),' i+',v2(2),' j+',v2(3),' k'
 18   format(a9,f6.3,a3,f6.3,a3,f6.3,a2)

C     final rotation about x''-axis
      
      call calctheta(v2(2),v2(3),theta)

      temp = -theta
      call rotate(temp,1,tmat)
c01Nov      call rotate(-theta,1,tmat)

      call mmmult(tmat,b2mat,3,3,3,b1mat)
      call mvmult(tmat,u2,3,3,u3)
      call mvmult(tmat,v2,3,3,v3)

C      write(*,18) 'u is now ',u3(1),' i+',u3(2),' j+',u3(3),' k'
C      write(*,18) 'v is now ',v3(1),' i+',v3(2),' j+',v3(3),' k'

      return
      end

C*************************************************************

      subroutine rotate(theta,i,r)

C     Generates the passive transformation matrix for a 
C     counterclockwise rotation of the axes by theta radians 
C     about the i-th axis.

      implicit none
c...	passed variables
      integer i
      real theta, r(3,3)

c...	local variables
      integer j,k
      
C     j and k are the cyclic indicies from i
C     look for the code in generate.f
      
      call ijk(i,j,k)
      r(i,i)=1.0
      r(i,j)=0.0
      r(i,k)=0.0
      r(j,i)=0.0
      r(j,j)=cos(theta)
      r(j,k)=-sin(theta)
      r(k,i)=0.0
      r(k,j)=sin(theta)
      r(k,k)=cos(theta)

      return
      end

C****************************************************************

      subroutine calctheta(x,y,theta)

C     Find the angle theta from the +x-axis to vector
C     xi + yj over a range of -pi to pi (an extended
C     inverse trig function)

      implicit none
c...	passed variables
      real x,y,theta

      if ((x.eq.0.0).and.(y.eq.0.0)) then
        theta=0.0
        return
      endif

C     use arccosine to avoid any problems with x=0

C     Quadrants I and II are fine as is and theta values
C     will range from 0 to pi
      
      if (y.ge.0.0) then
        theta= acos(x/sqrt(x**2.0+y**2.0))
      else

C     Quadrants III and IV will need a negative sign since transform
C     would go to -x otherwise.

        theta=-acos(x/sqrt(x**2.0+y**2.0))

      endif

      return
      end

c	spurion_grid.f

      subroutine cmd_grid(do_ask, do_grid, uuv, vuv, rlu, xstar, ystar)
      implicit none
      include 'arraysize.inc'
c      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_scan.inc'
      include 'spur_layout.inc'

c...	passed variables
      logical do_ask	!! Only ask for grid size if do_ask is true
      logical do_grid	!! toggle plotting of grid on Lattice plot.
      REAL*4 uuv(3),vuv(3)	!! lattice unit vectors
      logical rlu
      real 	xstar, ystar	!! xstar=uuv(1) and  ystar=vuv(2) in A^-1
      
c...	local variables
      real xline(2), yline(2)
      integer i, iedge, ngridmax
      
      if (do_ask) then
110          WRITE (*,'(a, $)') 'Enter style of grid ', 
     &		'[c: cartesian, o:orientation vectors]: '
	     read (*,'(a1)', err=110) grid_style
cDebug	     write (*,*) 'cmd_grid: grid_style = "', grid_style, '"', 
cDebug     &	        ' "', grid_style_cart,' " ',  grid_style_orient, '"' 
	     if ((grid_style .ne. grid_style_cart) .and. 
     &		 (grid_style .ne. grid_style_orient)) goto 110
c	     if ((grid_style .ne. 'o') .and. 
c     &		 (grid_style .ne. 'c')) goto 110
120          WRITE (*,'(a, $)') 'Enter x/u and y/v grid sizes in rlu: '
	     read (*,*, err=120) grid_size1, grid_size2
	     if ((grid_size1 .lt. 0.0) .or. 
     &		 (grid_size1 .gt. 5.0)) goto 120
c130          WRITE (*,'(a, $)') 'Enter y/v grid size in rlu: '
c	     read (*,*, err=130) grid_size2
	     if ((grid_size2 .lt. 0.0) .or. 
     &		 (grid_size2 .gt. 5.0)) goto 120
      endif

c	Cartesian style      
c      if ((do_grid) .and. (grid_style .eq. 'c')) then
      if ((do_grid) .and. (grid_style .eq. grid_style_cart)) then
        call pgsls(4)          ! dotted line
        call pgsci(color_darkgrey)		!! Override color
c pg_lib.f: 	call pgwnad(xmin,xmax,ymin,ymax)
c...	vertical grid lines
c        !! xmin, xmax in A^-1 always. Convert grid_size1
	ngridmax = nint( ((xmax - xmin) / (grid_size1*xstar)) + 1.0)
	yline(1) = ymin
	yline(2) = ymax
c          if (rlu) then
cMay8	    yline(1) = yline(1) *ystar
cMay8	    yline(2) = yline(2) *ystar
c	  endif
	do i = 1, ngridmax
	  xline(1) = grid_size1*xstar*float(nint(xmin/(grid_size1*xstar))) 
     &		  + float(i)*grid_size1*xstar
          xline(2) = xline(1)
c          if (rlu) then
cMay8	    xline(1) = xline(1) *xstar
cMay8	    xline(2) = xline(2) *xstar
c	  endif
	  call pgline(2, xline, yline)
	enddo

c...	horizontal grid lines
c        !! xmin, xmax in A^-1 always. convert grid_size2
	ngridmax = nint( ((ymax - ymin) / (grid_size2*ystar)) + 1.0)
	xline(1) = xmin
	xline(2) = xmax
c          if (rlu) then
cMay8	    xline(1) = xline(1) *xstar
cMay8	    xline(2) = xline(2) *xstar
c	  endif
	do i = 1, ngridmax
	  yline(1) = grid_size2*ystar*float(nint(ymin/(grid_size2*ystar))) 
     &		  + float(i)*grid_size2*ystar
          yline(2) = yline(1)
c          if (rlu) then
cMay8	    yline(1) = yline(1) *ystar
cMay8	    yline(2) = yline(2) *ystar
c	  endif
	  call pgline(2, xline, yline)
	enddo
      endif      

c	orientation vectors style (diamonds if not cubic)
c      if ((do_grid) .and. (grid_style .eq. 'o')) then
      if ((do_grid) .and. (grid_style .eq. grid_style_orient)) then
        call pgsls(4)          ! dotted line
        call pgsci(color_darkgrey)		!! Override color
c pg_lib.f: 	call pgwnad(xmin,xmax,ymin,ymax)
c...	vertical grid lines
	iedge = (m_rlv_max/2)
	do i = -iedge,  iedge		!! overkill range
	  xline(1) = 0.0 + grid_size1*float(i)*uuv(1) 
     &		 - grid_size2*float(iedge)*vuv(1)
	  xline(2) = 0.0 + grid_size1*float(i)*uuv(1)  
     &		 + grid_size2*float(iedge)*vuv(1)
	  yline(1) = 0.0 + grid_size1*float(i)*uuv(2)  
     &		 - grid_size2*float(iedge)*vuv(2)
	  yline(2) = 0.0 + grid_size1*float(i)*uuv(2)  
     &		 + grid_size2*float(iedge)*vuv(2)
c          if (.not. rlu) then
c	    xline(1) = xline(1) *xstar
c	    xline(2) = xline(2) *xstar
c	    yline(1) = yline(1) *ystar
c	    yline(2) = yline(2) *ystar
c	  endif
	  call pgline(2, xline, yline)
cDebug	  write (*,*) 'cmd_grid: vert ', i, 
cDebug     &	  	('(', xline(j), yline(j), ') ', j=1,2)
	enddo

c...	horizontal grid lines
	do i = -iedge,  iedge		!! overkill range
	  xline(1) = 0.0 - grid_size1*float(iedge)*uuv(1)  
     &		 + grid_size2*float(i)*vuv(1)
	  xline(2) = 0.0 + grid_size1*float(iedge)*uuv(1)  
     &		 + grid_size2*float(i)*vuv(1)
	  yline(1) = 0.0 - grid_size1*float(iedge)*uuv(2)  
     &		 + grid_size2*float(i)*vuv(2)
	  yline(2) = 0.0 + grid_size1*float(iedge)*uuv(2)  
     &		 + grid_size2*float(i)*vuv(2)
c          if (rlu) then
c	S    xline(1) = xline(1) *xstar
c	    xline(2) = xline(2) *xstar
c	    yline(1) = yline(1) *ystar
c	    yline(2) = yline(2) *ystar
c	  endif
	  call pgline(2, xline, yline)
cDebug	  write (*,*) 'cmd_grid: horz ', i, 
cDebug     &	  	('(', xline(j), yline(j), ') ', j=1,2)
	enddo
      endif      

      call pgsls(1)			!! return to solid lines
      
      return
      end

      SUBROUTINE BURZ (ISYSTM,ISYMCE,IBRAVL,NG)
C-----ROUTINE TO INTERPRET HERMANN MAUGUIN SYMBOL FOR SPACE GROUP       BURZ0001
C-----THIS ROUTINE HAS BEEN ADAPTED FROM A PROGRAM SUPPLIED BY          BURZ0002
C-----PROF. BURZLAFF, UNIVERSITY OF ERLANGEN, GERMANY                   BURZ0003
C
C  ISYSTM is the integer which designates the crystal system which
C  is determined by this subroutine (if it was given in the
C  CELL card it will be over written).
C  SYS is the index for ISYS which stores the numbers for ISYSTM      

C modified by CPA for double precision

      implicit none
      include 'io_files.inc'
      
c...	common blocks
      double precision ts(24,3)
      INTEGER SS(24,3,3)
      COMMON /BURC/ TS,SS

      character*1 n3(20)
      COMMON /ND/N3

      double precision RN(3), RD(3), S1(3), S2(3), S3(3)
      COMMON /POSITNUM/ RN,RD,S1,S2,S3 

      character*45 nt
c01Dec      character*1 nt(45)
      common /POSITCHAR/ NT

cNotUsed      COMMON /UNITS/ NRD,NPT,ILU

c...	passed variables
      integer isystm, ISYMCE,NG
      character*1 ibravl

c...	local variables
      double precision te(3),tc,sh(3)
      INTEGER E(3,3), SYS
      integer NMA(3)
c0111      DIMENSION NT(45), NMA(3)
C      DIMENSION RN(3), RD(3), S1(3), S2(3), S3(3)
C      DIMENSION TE(3)
C      real ts(24,3)
      integer isys(7)
      character*1 ibra(7),kxk
      character*1 zei(3,4),mchar,nchar
      integer i,j,k,m
c0111      integer i,j,k,m,sys
      integer nbl, ns, nlq, ic, nbr, ma, L, ne, ind, id

C
C  NT carries the letters in the Hermann Mauguin symbol
C
C  1: monoclinic, 2: orthorhomic, 3: ? 4: tetragonal 5: cubic or isometric
C  6: hexagonal   7: triclinic
C
      DATA ISYS(1)/7/,ISYS(2)/1/,ISYS(3)/2/,ISYS(4)/4/,ISYS(5)/6/,ISYS(6
     1)/5/,ISYS(7)/3/
C
C  options for primitive, A-centred, B-centred, C-centred,
C  face-centred, body-centred, rhombohedral
C      
      DATA IBRA(1)/1HP/,IBRA(2)/1HA/,IBRA(3)/1HB/,IBRA(4)/1HC/,
     &     IBRA(5)/1HF/,IBRA(6)/1HI/,IBRA(7)/1HR/

      DATA NMA/3*0/,SH/3*0.25d0/

 1    NBL=-1           ! index for number of symmetry elements
      NG=1
      NS=1             ! a slash indicator, 1 for none, 0 for some

      DO 2 I=1,24
        DO 2 J=1,3
          TS(I,J)=0.0d0
          DO 2 K=1,3
            E(J,K)=0
            SS(I,J,K)=0
 2    CONTINUE

C  SS seems to be the equvilent of the FS matrix with 1st and 3rd indicies
C  switched, so this means X, Y, Z for the first position
      
      SS(1,1,1)=1
      SS(1,2,2)=1
      SS(1,3,3)=1

      DO 3 I=1,3
        TE(I)=0.0d0
        DO 3 J=1,4
 3        ZEI(I,J)=N3(17)        ! initialize with space characters

      DO 8 I=1,36
        KXK=NT(I:I)                ! move character to KXK
c01Dec        KXK=NT(I)                ! move character to KXK
        IF (KXK.NE.N3(17)) GO TO 4
        NLQ=0                    ! just a space or blank, keep going
        IC=0
        GO TO 8
 4      IF (NBL.GE.0) GO TO 7    ! this is not the first character
        DO 5 J=1,7               ! the first character must be 1 of the 7
          NBR=J
          IF (KXK.EQ.IBRA(J)) GO TO 6
 5      CONTINUE

 6      NBL=0                    ! set IBRAVL to the first character
        IBRAVL=KXK
        GO TO 8                  ! read in next character

 7      IF (NLQ.EQ.0) NBL=NBL+1  ! increase index if previous character
                                 ! was a space or blank
        IC=IC+1                  ! increase IC index for this element of
        ZEI(NBL,IC)=KXK          ! code, write the character in ZEI   
        NLQ=1                    ! next loop default non-space character
        IF (KXK.EQ.N3(15)) NS=0  ! check to see if this was a slash character
 8    CONTINUE

C so right now ZEI should contain the elements of code for the symmetry
C operators following the Bravais lattice indicator (up to 3)
C the second index refers to the character number in each element (up to
C 4 characters)
C IBL is the number of elements that follow the lattice indicator

c      write(7,111) 'Space group is ',ibravl,((zei(j,i),i=1,4),j=1,3)
      write (unitstruct, *) '>> burz():'
      write(unitstruct,111) 'Space group is ',ibravl,
     &		((zei(j,i),i=1,4),j=1,3)
111   format(a15,a1,1x,12a1)
      DO 9 I=1,4
        IF (ZEI(2,I).NE.N3(3)) GO TO 9  ! looking for 3-fold symmetry
                                        ! along the 111 direction implies
        SYS=6                           ! an isometric or cubic system
        GO TO 15
 9    CONTINUE

      DO 11 I=1,4
C  looking at the first symbol if it isn't 3 or 6
        IF (ZEI(1,I).NE.N3(3).AND.ZEI(1,I).NE.N3(6)) GO TO 10
        SYS=5                           ! hexagonal or trigonal                           
        GO TO 15
 10     IF (ZEI(1,I).NE.N3(4)) GO TO 11 ! not 4-fold either
        SYS=4                           ! tetragonal system
        GO TO 15
 11   CONTINUE                          ! keep checking characters

C if the number of elements is greater than 1 cannot be monoclinic
C or triclinic
      IF (NBL.GT.1) GO TO 14

C if the first character of the first element is not 1 or - (which
C preceeds the 1) then the system is monoclinic      
      IF (ZEI(1,1).NE.N3(1).AND.ZEI(1,1).NE.N3(16)) GO TO 12

C TRICLINIC: one symmetry element that is 1 or -1

      SYS=1
      GO TO 15

C MONOCLINIC

 12   SYS=2

C now doing a bit of reassignment to generate equivalent positions
C shift the symmetry symbol to the second row of ZEI
      DO 13 I=1,4
 13     ZEI(2,I)=ZEI(1,I)

C make the first character in the 1st and 3rd row a 1
      ZEI(1,1)=N3(1)
      ZEI(3,1)=N3(1)
C notice that we now continue into the orthorhombic system

C ORTHORHOMBIC
      
 14   SYS=3

C check that it isn't really monoclinic
      IF (ZEI(1,1).EQ.N3(1).OR.ZEI(2,1).EQ.N3(1)) SYS=2

 15   GO TO (16,17,22,46,58,68), SYS   ! Main branch

C-----TRICLINIC                                                         BURZ0079
 16   IF (ZEI(1,1).EQ.N3(16)) NS=0     ! P -1
      GO TO 76

C-----MONOCLINIC                                                        BURZ0082
 17   NG=2                  ! one equiv. pos. beyond inversion
C looking through the first characters of the elements
      DO 18 I=1,3
 18     IF (ZEI(I,1).NE.N3(1)) IND=I  ! record row of non-1 index

      ID=1                            ! default ID is 1
      IF (ZEI(IND,1).EQ.N3(2)) ID=-1  ! if element begins with 2

C  construct the second symmetry element, if two-fold axis then change
C  the sign, otherwise leave it the same
      DO 19 I=1,3
 19     SS(2,I,I)=SS(1,I,I)*ID

      SS(2,IND,IND)=-SS(2,IND,IND)    ! reverse the sign for the unique axis

      DO 21 I=1,3
        IF (ZEI(I,1).EQ.N3(2).AND.ZEI(I,2).EQ.N3(1)) TS(2,I)=0.5d0
        DO 21 J=1,4
          IF (ZEI(I,J).EQ.N3(7)) TS(2,1)=0.5d0
          IF (ZEI(I,J).EQ.N3(8)) TS(2,2)=0.5d0
          IF (ZEI(I,J).EQ.N3(9)) TS(2,3)=0.5d0
          IF (ZEI(I,J).EQ.N3(12)) GO TO 20
          GO TO 21
 20       K=I+1
          IF (K.GT.3) K=K-3
          TS(2,K)=0.5d0
          TS(2,6-K-I)=0.5d0
 21   CONTINUE
      GO TO 76

C-----ORTHORHOMBIC                                                      BURZ0105
 22   NG=4
      IC=0
      IND=1
      IF (ZEI(1,1).NE.N3(2).AND.ZEI(2,1).NE.N3(2).AND.ZEI(3,1).NE.N3(2))
     1IND=-1
      IF (IND.EQ.-1) NS=0
      DO 24 I=1,3
      ID=1
      IF (ZEI(I,1).EQ.N3(2)) ID=-1
      DO 23 J=1,3
 23   SS(1+I,J,J)=SS(1,J,J)*ID*IND
 24   SS(1+I,I,I)=-SS(1+I,I,I)
      DO 28 I=1,3
      IF (ZEI(I,1).EQ.N3(2).AND.ZEI(I,2).EQ.N3(1)) TS(1+I,I)=0.5d0
      DO 28 J=1,4
      IF (ZEI(I,J).EQ.N3(7)) TS(1+I,1)=0.5d0
      IF (ZEI(I,J).EQ.N3(8)) TS(1+I,2)=0.5d0
      IF (ZEI(I,J).EQ.N3(9)) TS(1+I,3)=0.5d0
      IF (ZEI(I,J).EQ.N3(12).OR.ZEI(I,J).EQ.N3(10)) GO TO 25
      GO TO 28
 25   K=I+1
      IF (K.GT.3) K=K-3
      IF (ZEI(I,J).EQ.N3(10)) GO TO 26
      TS(1+I,K)=0.5d0
      TS(1+I,6-K-I)=0.5d0
      GO TO 28
 26   IC=1
      IF (NS.EQ.1) GO TO 27
      TS(1+I,K)=0.25d0
      TS(1+I,6-K-I)=0.25d0
      GO TO 28
 27   TS(1+I,1)=0.25d0
      TS(1+I,2)=0.25d0
      TS(1+I,3)=0.25d0
 28   CONTINUE
      IF (IC.EQ.1) GO TO 76
      IF (NS.EQ.1) GO TO 36
      DO 29 I=1,3
      K=1+I
      IF (K.GT.3) K=K-3
      TC=TS(1+K,I)+TS(1+6-I-K,I)
      IF (TC.EQ.1.0d0) TC=0.0d0
 29   TS(1+I,I)=TC
C-----SPECIAL TREATMENT OF C M M A, C M C A, I M M A                    BURZ0149
      IF (NBR.EQ.1.OR.NBR.EQ.5) GO TO 76
      MA=0
      DO 31 I=1,3
      DO 30 J=1,4
 30   IF (ZEI(I,J).EQ.N3(11)) NMA(I)=1
 31   MA=MA+NMA(I)
      IF (NBR.EQ.6.AND.MA.EQ.2) GO TO 33
      IF (MA.EQ.0.OR.MA.EQ.3.OR.NBR.EQ.6) GO TO 76
      DO 32 I=1,3
      IF (NMA(NBR-1).EQ.1) GO TO 76
 32   SH(NBR-1)=0.0d0
C-----ORIGIN SHIFT                                                      BURZ0161
 33   DO 35 I=1,NG
      DO 35 J=1,3
      DO 34 K=1,3
      ID=1
      IF (J.NE.K) ID=0
 34   TS(I,J)=TS(I,J)+dble(ID-SS(I,J,K))*SH(K)
      IF (TS(I,J).GT.1.0d0) TS(I,J)=TS(I,J)-1.0d0
 35   IF (TS(I,J).LT.1.0d0) TS(I,J)=TS(I,J)+1.0d0
      GO TO 76
 36   IC=0
      DO 37 I=1,3
 37   IF (SS(1+I,1,1)*SS(1+I,2,2)*SS(1+I,3,3).EQ.-1) IC=1
      IF (IC.EQ.1) GO TO 41
      TC=TS(2,1)+TS(3,2)+TS(4,3)
      IF (TC.EQ.0.0d0) GO TO 76
      DO 40 I=1,3
      K=I+1
      IF (K.GT.3) K=K-3
      IF (TC.GT.0.5d0) GO TO 38
      IF (TS(1+I,I).EQ.0.0d0) GO TO 40
      M=I-1
      IF (M.EQ.0) M=M+3
      TS(1+M,I)=0.5d0
      GO TO 40
 38   IF (TC.GT.1.0d0) GO TO 39
      IF (TS(1+I,I).NE.0.0d0) GO TO 40
      L=K+1
      IF (L.GT.3) L=L-3
      TS(1+K,L)=0.5d0
      TS(1+L,K)=0.5d0
      GO TO 40
 39   TS(1+I,K)=0.5d0
 40   CONTINUE
      GO TO 76
 41   DO 42 I=1,3
 42   IF (SS(1+I,1,1)*SS(1+I,2,2)*SS(1+I,3,3).EQ.1) ID=I
      DO 45 I=1,3
      TC=TS(2,I)+TS(3,I)+TS(4,I)
      IF (TC.EQ.0.0d0.OR.TC.EQ.1.0d0) GO TO 45
      IF (ZEI(1,1).EQ.N3(11).AND.ZEI(2,1).EQ.N3(12).OR.ZEI(2,1).EQ.
     1N3(11).AND.ZEI(3,1).EQ.N3(12).OR.ZEI(3,1).EQ.N3(11).AND.ZEI(1,1)
     2.EQ.N3(12)) GO TO 44
      DO 43 J=1,3
      IF (ID.EQ.J) GO TO 43
      IF (TS(1+J,I).EQ.0.5d0) GO TO 43
      TS(1+J,I)=0.5d0
 43   CONTINUE
      GO TO 45
 44   K=I-1
      IF (K.EQ.0) K=K+3
      TS(1+K,I)=0.5d0
 45   CONTINUE
      GO TO 76

C-----TETRAGONAL                                                        BURZ0215
 46   NG=4
      IF (NBL.EQ.3) NG=8
      SS(2,1,2)=-1
      SS(2,2,1)=1
      SS(2,3,3)=1
C
C  Try replacing obvious character variables with mchar and nchar
C
      MCHAR=ZEI(1,1)
      NCHAR=ZEI(1,2)
C      M=ZEI(1,1)
C      N=ZEI(1,2)
      DO 47 I=1,3
      DO 47 J=1,3
 47   IF (MCHAR.EQ.N3(16)) SS(2,I,J)=-SS(2,I,J)
      IF (MCHAR.EQ.N3(16)) GO TO 50
      IF (NCHAR.EQ.N3(1)) TS(2,3)=0.25d0
      IF (NCHAR.EQ.N3(2)) TS(2,3)=0.5d0
      IF (NCHAR.EQ.N3(3)) TS(2,3)=0.75d0
      IF (ZEI(1,3).EQ.N3(12).OR.(ZEI(1,4).EQ.N3(12).AND.NBL.EQ.3))
     1TS(2,1)=0.5d0
      IF ((ZEI(1,4).EQ.N3(12).AND.NBL.EQ.1).OR.(NCHAR.EQ.N3(1).AND.
     1NS.EQ.1.AND.NBR.EQ.6)) TS(2,2)=0.5d0
      IF (NCHAR.EQ.N3(1).AND.NS.EQ.0.AND.NBR.EQ.6) GO TO 48
      IF (ZEI(2,2).EQ.N3(1).OR.(ZEI(1,4).NE.N3(12).AND.ZEI(2,1).EQ.
     1N3(12).AND.ZEI(3,1).EQ.N3(11))) GO TO 49
      GO TO 50
 48   TS(2,1)=0.25d0
      TS(2,2)=0.75d0
      IF (NBL.EQ.1) TS(2,1)=0.75d0
      IF (NBL.EQ.1) TS(2,2)=0.25d0
      GO TO 50
 49   TS(2,1)=0.5d0
      TS(2,2)=0.5d0
 50   SS(3,1,1)=-1
      SS(3,2,2)=-1
      SS(3,3,3)=1
      TS(3,1)=dble(SS(2,1,2))*TS(2,2)+TS(2,1)
      TS(3,2)=dble(SS(2,2,1))*TS(2,1)+TS(2,2)
      TS(3,3)=dble(SS(2,3,3))*TS(2,3)+TS(2,3)
      DO 51 I=1,3
 51   IF (NBR.EQ.6.AND.TS(3,1).EQ.0.5.AND.TS(3,2).EQ.0.5.AND.TS(3,3).EQ.
     10.5) TS(3,I)=0.0d0
      DO 52 I=1,3
      TS(4,I)=TS(2,I)
      DO 52 J=1,3
      TS(4,I)=TS(4,I)+dble(SS(2,I,J))*TS(3,J)
      DO 52 K=1,3
 52   SS(4,I,J)=SS(4,I,J)+SS(2,I,K)*SS(3,K,J)
      IF (NBL.EQ.1) GO TO 76
      IF (NS.EQ.0) GO TO 56
      MCHAR=ZEI(2,1)
      NCHAR=ZEI(3,1)
      IF (MCHAR.NE.N3(2).AND.NCHAR.NE.N3(2)) GO TO 55
      IF (MCHAR.EQ.N3(2).AND.NCHAR.EQ.N3(2)) GO TO 54
      IF (MCHAR.EQ.N3(2)) GO TO 53
      IF (MCHAR.EQ.N3(9).OR.MCHAR.EQ.N3(12)) TE(3)=0.5d0
      E(1,1)=-1
      E(2,2)=1
      E(3,3)=1
      IF (MCHAR.NE.N3(12).AND.MCHAR.NE.N3(8)) GO TO 57
      TE(1)=0.5d0
      TE(2)=0.5d0
      GO TO 57
 53   E(1,1)=1
      E(2,2)=-1
      E(3,3)=-1
      IF (NCHAR.EQ.N3(9)) TE(3)=0.5d0
      IF (NCHAR.EQ.N3(10)) TE(3)=0.25d0
      IF (NCHAR.EQ.N3(10)) TE(2)=0.5d0
      IF (ZEI(2,2).NE.N3(1)) GO TO 57
      TE(1)=0.5d0
      TE(2)=0.5d0
      GO TO 57
 54   E(1,2)=1
      E(2,1)=1
      E(3,3)=-1
C  Changed a .ne.0 to a ne.n3(17)
      IF (ZEI(2,2).NE.N3(17).OR.NBR.EQ.6.OR.ZEI(1,2).EQ.
     1N3(17)) GO TO 57
      IF (ZEI(1,2).EQ.N3(1)) TE(3)=0.75d0
      IF (ZEI(1,2).EQ.N3(2)) TE(3)=0.5d0
      IF (ZEI(1,2).EQ.N3(3)) TE(3)=0.25d0
      GO TO 57
 55   MCHAR=ZEI(2,1)
      E(1,1)=-1
      E(2,2)=1
      E(3,3)=1
      IF (MCHAR.EQ.N3(9).OR.MCHAR.EQ.N3(12)) TE(3)=0.5d0
      IF (MCHAR.EQ.N3(12).OR.MCHAR.EQ.N3(8)) TE(1)=0.5d0
      IF (MCHAR.EQ.N3(12).OR.MCHAR.EQ.N3(8)) TE(2)=0.5d0
      GO TO 57
 56   E(1,1)=-1
      E(2,2)=1
      E(3,3)=1
      IF (ZEI(2,1).EQ.N3(9).OR.ZEI(2,1).EQ.N3(12)) TE(3)=0.5d0
      IF (ZEI(2,1).EQ.N3(8).OR.ZEI(2,1).EQ.N3(12)) TE(2)=0.5d0
      IF (ZEI(2,1).EQ.N3(8).OR.ZEI(2,1).EQ.N3(12)) TE(1)=0.5d0
      IF (ZEI(1,3).EQ.N3(12).OR.ZEI(1,4).EQ.N3(12)) TE(1)=TE(1)+0.5d0
 57   NE=4
      GO TO 74

C-----HEXAGONAL                                                         BURZ0310
 58   NG=3
      MCHAR=ZEI(1,1)
      NCHAR=ZEI(1,2)
      IF (MCHAR.EQ.N3(16).AND.NCHAR.EQ.N3(3)) NS=0
      IF (MCHAR.EQ.N3(6)) GO TO 61
      SS(2,1,2)=-1
      SS(2,2,1)=1
      SS(2,2,2)=-1
      SS(2,3,3)=1
      IF (NCHAR.EQ.N3(1)) TS(2,3)=1.0d0/3.0d0
      IF (NCHAR.EQ.N3(2)) TS(2,3)=2.0d0/3.0d0
      SS(3,1,1)=-1
      SS(3,2,1)=-1
      SS(3,1,2)=1
      SS(3,3,3)=1
      TS(3,3)=2.0d0*TS(2,3)
      IF (TS(3,3).GE.1.0d0) TS(3,3)=TS(3,3)-1.0d0
      IF (NBL.EQ.1.AND.NCHAR.NE.N3(6)) GO TO 76
      IF (NCHAR.NE.N3(6)) GO TO 60
      NG=NG+NG
      DO 59 I=1,3
      DO 59 J=1,3
      DO 59 K=1,3
      SS(3+I,J,K)=SS(I,J,K)
 59   SS(3+I,3,3)=-1
 60   IF (NBL.EQ.1) GO TO 76
      IF (ZEI(2,1).NE.N3(9).AND.ZEI(3,1).NE.N3(9)) GO TO 63
      TS(4,3)=0.5d0
      TS(5,3)=0.5d0
      TS(6,3)=0.5d0
      GO TO 63
 61   NG=NG+NG
      SS(2,1,1)=1
      SS(2,1,2)=-1
      SS(2,2,1)=1
      SS(2,3,3)=1
      IF (NCHAR.EQ.N3(1)) TS(2,3)=1.0d0/6.0d0
      IF (NCHAR.EQ.N3(2)) TS(2,3)=2.0d0/6.0d0
      IF (NCHAR.EQ.N3(3)) TS(2,3)=3.0d0/6.0d0
      IF (NCHAR.EQ.N3(4)) TS(2,3)=4.0d0/6.0d0
      IF (NCHAR.EQ.N3(5)) TS(2,3)=5.0d0/6.0d0
      DO 62 I=1,4
      DO 62 J=1,3
      TS(2+I,J)=TS(2,J)
      DO 62 K=1,3
      TS(2+I,J)=TS(2+I,J)+dble(SS(2,J,K))*TS(1+I,K)
      IF (TS(2+I,J).GT.1.0d0) TS(2+I,J)=TS(2+I,J)-1.0d0
      DO 62 L=1,3
 62   SS(2+I,J,K)=SS(2+I,J,K)+SS(2,J,L)*SS(1+I,L,K)
      IF (NBL.EQ.1) GO TO 76
 63   NG=NG+NG
      MCHAR=ZEI(2,1)
      NCHAR=ZEI(3,1)
      IF (MCHAR.EQ.N3(1)) GO TO 65
      IF (MCHAR.EQ.N3(2)) GO TO 64
      E(1,2)=-1
      E(2,1)=-1
      E(3,3)=1
      IF (MCHAR.EQ.N3(9)) TE(3)=0.5d0
      GO TO 67
 64   E(1,2)=1
      E(2,1)=1
      E(3,3)=-1
      TE(3)=2.0d0*TS(2,3)
C-----GROUP P 31 I 2 AND P 32 I 2                                       BURZ0375
      IF (ZEI(1,1).EQ.N3(3).AND.(ZEI(1,2).EQ.N3(1).OR.ZEI(1,2).EQ.
     1N3(2))) TE(3)=0.0d0
      GO TO 67
 65   IF (NCHAR.EQ.N3(2)) GO TO 66
      E(1,2)=1
      E(2,1)=1
      E(3,3)=1
      IF (NCHAR.EQ.N3(9)) TE(3)=0.5d0
      GO TO 67
 66   E(1,2)=-1
      E(2,1)=-1
      E(3,3)=-1
      TE(3)=2.0d0*TS(2,3)
      IF (TE(3).GT.1.0d0) TE(3)=TE(3)-1.0d0
 67   NE=6
      IF (ZEI(1,1).EQ.N3(3).OR.(ZEI(1,2).EQ.N3(3).AND.ZEI(1,1).EQ.
     1N3(16))) NE=3
      GO TO 74

C-----CUBIC                                                             BURZ0394
 68   NG=12
      IF (NBL.EQ.3) NG=24
      IF (ZEI(1,1).NE.N3(2).AND.ZEI(1,1).NE.N3(4).AND.ZEI(1,1).NE.
     1N3(16)) NS=0
      DO 69 I=1,3
      DO 69 J=1,3
      SS(1+I,J,J)=1
      IF (I.EQ.J) GO TO 69
      SS(1+I,J,J)=-1
      IF (ZEI(1,1).EQ.N3(12)) TS(1+I,J)=0.5d0
      IF (ZEI(1,1).EQ.N3(10)) TS(1+I,J)=0.25d0
 69   CONTINUE
      IF (ZEI(1,1).NE.N3(7).AND.ZEI(3,1).NE.N3(10).AND.ZEI(1,2).NE.N3(3)
     1.AND.ZEI(1,2).NE.N3(1).OR.NBR.EQ.5) GO TO 71
      DO 70 I=1,3
      TS(1+I,I)=0.5d0
      K=I+1
      IF (K.EQ.4) K=1
 70   TS(1+I,K)=0.5d0
 71   DO 72 I=1,4
      DO 72 J=1,3
      DO 72 K=1,3
      L=J+1
      IF (L.EQ.4) L=1
      M=J-1
      IF (M.EQ.0) M=3
      SS(4+I,J,K)=SS(I,L,K)
      SS(8+I,J,K)=SS(I,M,K)
      TS(4+I,J)=TS(I,L)
 72   TS(8+I,J)=TS(I,M)
      IF (NG.EQ.12) GO TO 76
      NE=12
      E(1,2)=1
      E(2,1)=1
      E(3,3)=1
      IF (ZEI(3,1).EQ.N3(2)) E(3,3)=-1
      IF (ZEI(3,1).EQ.N3(9)) TE(3)=0.5d0
      DO 73 I=1,3
      IF (ZEI(3,1).EQ.N3(12).OR.ZEI(1,2).EQ.N3(2)) TE(I)=0.5d0
 73   IF (ZEI(3,1).EQ.N3(10).OR.ZEI(1,2).EQ.N3(1).OR.ZEI(1,2).EQ.N3(3))
     1TE(I)=0.25d0
      IF (ZEI(1,2).EQ.N3(1).AND.NBR.EQ.1) TE(1)=0.75d0
      IF ((ZEI(1,2).NE.N3(1).OR.NBR.NE.6).AND.(ZEI(1,2).NE.N3(3).OR.NBR
     1.NE.1)) GO TO 74
      TE(2)=0.75d0
      TE(3)=0.75d0
 74   DO 75 I=1,NE
      DO 75 J=1,3
      TS(NE+I,J)=TE(J)
      DO 75 K=1,3
      TS(NE+I,J)=TS(NE+I,J)+dble(E(J,K))*TS(I,K)
      DO 75 L=1,3
 75   SS(NE+I,J,K)=SS(NE+I,J,K)+E(J,L)*SS(I,L,K)

C  loop through the equivalent positions to reduce the TS matrix

 76   DO 81 I=1,NG
        DO 81 J=1,3
 77       IF (TS(I,J).GE.1.0d0) GO TO 78
          GO TO 79
 78       TS(I,J)=TS(I,J)-1.0d0
          GO TO 77
 79       IF (TS(I,J).LT.0.0d0) GO TO 80
          GO TO 81
 80       TS(I,J)=TS(I,J)+1.0d0
          GO TO 79
 81   CONTINUE

      ISYSTM=ISYS(SYS)
      IF (NS.EQ.0) ISYMCE=1
      IF (NS.EQ.1) ISYMCE=0
      RETURN
      END

      subroutine conditions
      implicit none
      include 'io_files.inc'

c...	common blocks
      integer ibravl,isystm
      common /cell/ ibravl,isystm

      integer ihoo,ioko,iool,ihko,ihol,iokl,ihhl,ilau,itrig
      COMMON /EXTI/ IHOO,IOKO,IOOL,IHKO,IHOL,IOKL,IHHL,ILAU,ITRIG

c...	local variables

      WRITE (unitstruct,*) '>> conditions():' 
      WRITE (unitstruct,148)                 ! Conditions
      IF(IBRAVL.EQ.1) WRITE(unitstruct,208)  ! P: none
      IF(IBRAVL.EQ.2) WRITE(unitstruct,213)  ! I: h+k+l=2n
      IF(IBRAVL.EQ.3) WRITE(unitstruct,214)  ! R: -h+k+l=3n
      IF(IBRAVL.EQ.4) WRITE(unitstruct,212)  ! F: h,k,l all even or all odd
      IF(IBRAVL.EQ.5) WRITE(unitstruct,209)  ! A: k+l=2n
      IF(IBRAVL.EQ.6) WRITE(unitstruct,215)  ! B: h+l=2n
      IF(IBRAVL.EQ.7) WRITE(unitstruct,211)  ! C: h+k=2n

C  space group conditions

C  l=0 -> h+k=IHKO*n
      IF ((IHKO.EQ.2).OR.(IHKO.EQ.4)) WRITE (unitstruct,176) IHKO

C  l=0 -> k=2n
      IF (IHKO.EQ.3) WRITE (unitstruct,175)

C  l=0 -> h=2n
      IF (IHKO.EQ.5) WRITE (unitstruct,174)

C  h=0 -> k+l=IOKL*n
      IF ((IOKL.EQ.2).OR.(IOKL.EQ.4)) WRITE (unitstruct,178) IOKL

C  h=0 -> l=2n
      IF (IOKL.EQ.3) WRITE (unitstruct,210)

C  h=0 -> k=2n
      IF (IOKL.EQ.5) WRITE (unitstruct,177)

C  k=0 -> h+l=IHOL*n  etc.
      IF ((IHOL.EQ.2).OR.(IHOL.EQ.4)) WRITE (unitstruct,181) IHOL
      IF (IHOL.EQ.3) WRITE (unitstruct,180)
      IF (IHOL.EQ.5) WRITE (unitstruct,179)

C  h=k -> l=2n
      IF (IHHL.EQ.2) WRITE (unitstruct,182)

C  h=k -> 2h+l=4n
      IF (IHHL.EQ.3) WRITE (unitstruct,183)

C  k=0, l=0 -> h=IHOO*n
      IF (IHOO.GT.1) WRITE (unitstruct,184) IHOO

C  h=0, l=0 -> k=2n
      IF (IOKO.GT.1) WRITE (unitstruct,185)

C  h=0, k=0 -> l=2n
      IF (IOOL.GT.1) WRITE (unitstruct,186) IOOL

      write(unitstruct,*)
      return
      
 148  FORMAT (48HGENERAL CONDITIONS LIMITING POSSIBLE REFLECTIONS  )
 174  FORMAT (19H HKO WITH H=2N ONLY)
 175  FORMAT (19H HKO WITH K=2N ONLY)
 176  FORMAT (14H HKO WITH H+K=,I1,6HN ONLY)
 177  FORMAT (19H OKL WITH K=2N ONLY)
 210  FORMAT (19H OKL WITH L=2N ONLY)
 178  FORMAT (14H OKL WITH K+L=,I1,6HN ONLY)
 179  FORMAT (19H HOL WITH H=2N ONLY)
 180  FORMAT (19H HOL WITH L=2N ONLY)
 181  FORMAT (14H HOL WITH H+L=,I1,6HN ONLY)
 182  FORMAT (19H HHL WITH L=2N ONLY)
 183  FORMAT (22H HHL WITH 2H+L=4N ONLY)
 184  FORMAT (12H HOO WITH H=,I1,6HN ONLY)
 185  FORMAT (19H OKO WITH K=2N ONLY)
 186  FORMAT (12H OOL WITH L=,I1,6HN ONLY)
 187  FORMAT (/21H MONOCLINIC STRUCTURE)
 188  FORMAT (/20H TRICLINIC STRUCTURE)
 189  FORMAT (/23H ORTHORHOMBIC STRUCTURE)
 190  FORMAT (/19H TRIGONAL STRUCTURE)
 191  FORMAT (/21H TETRAGONAL STRUCTURE)
 192  FORMAT (/16H CUBIC STRUCTURE)
 193  FORMAT (/20H HEXAGONAL STRUCTURE)
 194  FORMAT(/53H SOMETHING VERY BAD HAPPENED. CALL THE AUTHORS PLEASE)
 208  FORMAT(10H HKL  NONE)
 209  FORMAT(21H HKL WITH K+L=2N ONLY)
 215  FORMAT(21H HKL WITH H+L=2N ONLY)
 211  FORMAT(21H HKL WITH H+K=2N ONLY)
 212  FORMAT(40H HKL WITH H,K,L ALL EVEN OR ALL ODD ONLY )
 213  FORMAT(23H HKL WITH H+K+L=2N ONLY)
 214  FORMAT(24H HKL WITH -H+K+L=3N ONLY)
 220  FORMAT(5I5)

      end

c	test_help.f
c	test program to see how to use help-paul-unx.c from ask library
c	without using the rest of ASK.
	implicit none
	character*80 HLP_PATH, HLP_FIL, KEY_WD
	


c	In *.hlp file, spurion is currently only 1 level available.
c	So use key word to skip to it.
c	If have libraries (like ASK, DOPLOT, MINUIT, etc.)
c	then they should all be level 1 and key_wd = ''

c  With empty path, use logical MSRHELP to determine where the help file is.
c	On VMS, "assign <helpdir> MSRHELP:"
c	On Unix,"setenv MSRHELP <helpdir>"
c	On Unix, "export MSRHELP='<helpdir>'"
 
	HLP_PATH = ''		!! 
	HLP_FIL = 'spurion'
cLater	KEY_WD = ''		!! If more than 1 top level
	KEY_WD = 'spurion'		!! Only 1 Top Level for now
	CALL HELP(HLP_PATH, HLP_FIL, KEY_WD)

c...	 Works when spurion is 1 level
c	HLP_PATH = './'		!! *.hlp file must be in currentl directory.
c	HLP_FIL = 'spurion'
c	KEY_WD = 'spurion'
c	CALL HELP(HLP_PATH, HLP_FIL, KEY_WD)

	end

c...	file spurion_bits.f

C**********************************************************

      subroutine title(a,atitle,len)
      implicit none
c...    passed variables
      integer a(3),len
      character*10 atitle

c...    local variables
      integer la(3), i
      logical neg,ten
      character*3 atxt(3)

 50   format(a1,3i1,a1)
 51   format(a1,i2,1x,i2,1x,i2,a1)
 52   format(a1,a,a1,a,a1,a,a1)

      call checkneg(a,neg)
      call checkten(a,ten)

      if (neg.and.ten) then
         do i=1,3
            if (a(i).le.-10) then
               write(atxt(i),'(i3)') a(i)
               la(i)=3
            else if ((a(i).lt.0).or.(a(i).ge.10)) then
               write(atxt(i),'(i2)') a(i)
               la(i)=2
            else
               write(atxt(i),'(i1)') a(i)
               la(i)=1
            endif
         enddo
         if (la(1)+la(2)+la(3).gt.8) then
           write(atitle,'(a,a,a)') atxt(1)(1:la(1)),
     &      atxt(2)(1:la(2)),atxt(3)(1:la(3))
           len=la(1)+la(2)+la(3)
         else if (la(1)+la(2)+la(3).gt.6) then
           write(atitle,'(a,a1,a,a1,a)') atxt(1)(1:la(1)),',',
     &      atxt(2)(1:la(2)),',',atxt(3)(1:la(3))
           len=la(1)+la(2)+la(3)+2
         else
           write(atitle,52) '(',atxt(1)(1:la(1)),',',
     &      atxt(2)(1:la(2)),',',atxt(3)(1:la(3)),')'
           len=la(1)+la(2)+la(3)+4
         endif

      else if ((neg).neqv.(ten)) then
         write(atitle,51) '(',a(1),a(2),a(3),')'
         len=10
      else
         write(atitle,50) '(',a(1),a(2),a(3),')'
         len=5
      endif

      return
      end


C**********************************************************

      subroutine hkl_int(hh, kk, ll, a_hkl)
      implicit none
c...    passed variables
      integer hh, kk, ll
      character*13 a_hkl

c...    local variables

 10   format ( '(', i3, ',', i3, ',', i3, ')' )
      write (a_hkl, 10)  hh, kk, ll

      return
      end

C**********************************************************

      subroutine hkl_float(q1, q2, bmatuv_inv,  a_hkl)
      implicit none
c...    passed variables
      real q1, q2
      real bmatuv_inv(3,3)
c      integer hh, kk, ll, len
      character*19 a_hkl

c...    local variables
      real qvec(3), h(3)
      integer i
      
      qvec(1) = q1
      qvec(2) = q2
      qvec(3) = 0.0
      
      call mvmult(bmatuv_inv,qvec,3,3,h)

 10   format ( '(', f5.1, ',', f5.1, ',', f5.1, ')' )
      write (a_hkl, 10) (h(i), i= 1, 3)

      return
      end


C******************************************************

      subroutine checkneg(a,neg)

      implicit none
c...    passed variables
      integer a(3)
      logical neg

c...    local variables
      integer i
      
      neg=.false.
      do i=1,3
         if (a(i).lt.0) neg=.true.
      enddo
      return
      end

C******************************************************

      subroutine checkten(a,ten)

      implicit none
c...    passed variables
      integer a(3)
      logical ten
      
c...    local variables
      integer i
      
      ten=.false.
      do i=1,3
         if (abs(a(i)).ge.10) ten=.true.
      enddo
      return
      end

C*******************************************************

      subroutine calcspurious(ki,kf, qspur,espur)
       
      implicit none
      include 'arraysize.inc'
      
c...    passed variables
      real ki(2),kf(2)
      real qspur(2,n_spur_max,n_spur_max)
      real espur(n_spur_max,n_spur_max)

c...    local variables
      integer i,j,k

      do i=1,n_spur_max
        do j=1,n_spur_max
          do k=1,2
            qspur(k,i,j)=float(i)*ki(k)-float(j)*kf(k)
C            write(*,*) k,i,j,qspur(k,i,j)
          enddo
          espur(i,j)= k2_to_E *(float(i**2)*(ki(1)**2.0+ki(2)**2.0)
     &      -float(j**2)*(kf(1)**2.0+kf(2)**2.0))
c02Apr          espur(i,j)=2.072*(float(i**2)*(ki(1)**2.0+ki(2)**2.0)
c02Apr     &      -float(j**2)*(kf(1)**2.0+kf(2)**2.0))
        enddo
      enddo

      return
      end

C*******************************************************

      subroutine load_constants()
       
      implicit none
      include 'arraysize.inc'
      
c...  local variables
      double precision temp
      
      temp = (const_hbar * const_c) **2 / (2.0d0 * const_Mnc2)
c     !! convert from eV- Angstroms^2 to meV- Angstroms^2
      k2_to_E  = sngl(temp* 1.0d+3)
      
      write (*,*) 'load_conts: k2_to_E=', k2_to_E, '  meV- Angstroms^2'

      return
      end

C***********************************************************

      subroutine autoscale(x,y)

      implicit none
      include 'spur_layout.inc'
      
c...    passed variables
      real x,y
      
      if (x.lt.xmin) xmin=1.2*x
      if (x.gt.xmax) xmax=1.2*x
      if (y.lt.ymin) ymin=1.2*y
      if (y.gt.ymax) ymax=1.2*y
      
      return
      end

C*************************************************************

      subroutine square()

      implicit none
      include 'spur_layout.inc'
      
c...    passed variables

      if ((xmax-xmin).gt.2.0*(ymax-ymin)) then
        ymax=2.0*ymax
        ymin=2.0*ymin
      endif
      if ((ymax-ymin).gt.2.0*(xmax-xmin)) then
        xmax=2.0*xmax
        xmin=2.0*xmin
      endif

      return
      end

C**************************************************************

      subroutine arrows(i,j,ki,kf)

       implicit none

c...    passed variables
      integer i,j,k
      real ki(2),kf(2)

c...    local variables
      real temp1, temp2, temp3, temp4
      
C  Provided i does not equal one (primary ki) then plot a new
C  ki beyond the last showing the spurious process.

C  Plot the ki's (although not strictly a sum of wavevectors it
C  may be easier to understand this way.

      if (i.ne.1) then
        do k=2,i
	  temp1 = float(k-1)*ki(1)
	  temp2 = float(k-1)*ki(2)
	  temp3 = float(k)*ki(1)
	  temp4 = float(k)*ki(2)
cDebug	  write (*,*) 'arrow: ->i ', k, temp1, temp2, temp3, temp4
          call pgarro(temp1, temp2, temp3, temp4)
c01Nov          call pgarro(float(k-1)*ki(1),float(k-1)*ki(2),
c01Nov     &         float(k)*ki(1),float(k)*ki(2))
        enddo
      endif
C  Plot the -j*kf added on to the final i*ki
C  No overlap possibility for multiple kf's.

      do k=1,j
	temp1 = float(i)*ki(1)-float(k-1)*kf(1)
	temp2 = float(i)*ki(2)-float(k-1)*kf(2)
	temp3 = float(i)*ki(1)-float(k)*kf(1)
	temp4 = float(i)*ki(2)-float(k)*kf(2)
cDebug	 write (*,*) 'arrow: ->j ', k, temp1, temp2, temp3, temp4
        call pgarro(temp1, temp2, temp3, temp4)
c01Nov        call pgarro(float(i)*ki(1)-float(k-1)*kf(1),
c01Nov     &  float(i)*ki(2)-float(k-1)*kf(2),
c01Nov     &  float(i)*ki(1)-float(k)*kf(1),
c01Nov     &  float(i)*ki(2)-float(k)*kf(2))
      enddo

      return
      end

C----------------------------------------------------------

      subroutine bit(spurhist,power,value,on)

C subroutine for checking and changing the bits of spurhist
C
C spurhist: 8-bit integer
C power: the bit number to be checked/changed
C value: new value of that bit
C on: make that bit =value, 0 return the value
CTR on: make that bit 1, 0 return the value
C bits: reduction of spurhist to bits, runs from 1 to 8 (power+1)
C work: a working value of spurhist

      implicit none
c...	passed variables
      integer spurhist,power,value,on

c...	local variables
      integer bits(8),i
      integer work

      work=spurhist
C      write(*,'(a,i3)') 'starting spurhist= ',work
      do i=8,1,-1
         bits(i)=work/2**(i-1)
         work=work-bits(i)*2**(i-1)
C         write(*,'(a,i1,a,i1)') 'bits(',i-1,') = ',bits(i)
      enddo


      if (on.eq.1) then
C         if (bits(power+1).eq.0) then 
         bits(power+1)=mod(value,2)   !! even-> zero. odd-> 1
cTR         bits(power+1)=1
C            write(*,*) 'setting to 1 bits(power)=',bits(power+1)
C         else
C            bits(power+1)=0
C            write(*,*) 'setting to 0 bits(power)=',bits(power+1)
C         endif
         work=0
         do i=1,8
            work=work+bits(i)*2**(i-1)
         enddo
         spurhist=work
      else
        value=bits(power+1)
      endif

cTR      value=bits(power+1)
      return
      end

C----------------------------------------------------------

      logical function bit_on(longhist,power)

C function that returns true if a bit at position power is on/true (1).
c Returns false if it is off/false/0. 
c
C spurhist: 24-bit integer
C power: the bit number to be checked/changed
C value: new value of that bit
C bits: reduction of spurhist to bits, runs from 1 to maxbit=24 (power)
C work: a working value of spurhist

      implicit none
c...	passed variables
      integer*4 longhist
      integer power

c...	local variables
      integer maxbit
      parameter (maxbit = 24)		!! Used to be 8
      integer bits(maxbit),i
      integer*4 work

      if      (power .lt. 1) then
        write (*,*) 'bit_on: Error, selected neg or zero bit: ', power 
	bit_on = .false.
      else if (power .gt. maxbit) then
        write (*,*) 'bit_on: Error, selected bit > ', maxbit, ':', power 
	bit_on = .false.
      else

        work= longhist
        do i=maxbit,1,-1
           bits(i)=work/2**(i-1)
           work=work-bits(i)*2**(i-1)
        enddo

        bit_on = (bits(power).eq.1)

      endif

      return
      end

C----------------------------------------------------------

      subroutine which_bit(longhist,power,value)

C subroutine returns the position of the first bit in lonhist with value value.
C
C longhist: 24-bit integer
C power: the bit number to be checked/changed
C value: new value of that bit
C bits: reduction of longhist to bits, runs from 1 to maxbit=24 (power)
C work: a working value of longhist

      implicit none
c...	passed variables
      integer*4 longhist
      integer   power,value

c...	local variables
      integer maxbit, nvalue
      parameter (maxbit = 24)		!! Used to be 8
      integer bits(maxbit),i
      integer*4 work



        nvalue = 0
        work= longhist
        do i =maxbit,1,-1
           bits(i)=work/2**(i-1)
	   if (bits(i) .eq. value) then
	     nvalue = nvalue + 1
	   endif
           work=work-bits(i)*2**(i-1)
        enddo

        power = 0
        do i =1, maxbit
	   if (bits(i) .eq. value) then
	     power = i
	     goto 555
	   endif
        enddo

 555    continue
 
       if      (power .lt. 1) then
         write (*,*) 'which_bit: Warning, no bits with value =', value
       else if (nvalue .gt. 1) then
         write (*,*) 'which_bit: Warning: more than one bit', 
     &		' with value=', value
         write (*,*) 'which_bit:   Only returning position of first bit'
       endif


      return
      end

C----------------------------------------------------------

      subroutine set_bit(longhist,power,value)

C subroutine for changing the bits of spurhist
C
C spurhist: 24-bit integer
C power: the bit number to be checked/changed
C value: new value of that bit
CTR on: make that bit 1, 0 return the value
C bits: reduction of spurhist to bits, runs from 1 to maxbit=24 (power)
C work: a working value of spurhist

      implicit none
c...	passed variables
      integer*4 longhist
      integer   power,value

c...	local variables
      integer maxbit
      parameter (maxbit = 24)		!! Used to be 8
      integer bits(maxbit),i
      integer*4 work

      if      (power .lt. 1) then
        write (*,*) 'set_bit: Error, selected neg or zero bit: ', power 
      else if (power .gt. maxbit) then
        write (*,*) 'set_bit: Error, selected bit > ', maxbit, 
     &	':', power 
      else
        work= longhist
        do i =maxbit,1,-1
           bits(i)=work/2**(i-1)
           work=work-bits(i)*2**(i-1)
        enddo


         bits(power)=mod(value,2)   !! even-> zero. odd-> 1
         work=0
         do i = 1, maxbit
            work=work+bits(i)*2**(i-1)
         enddo
         longhist=work

      endif

      return
      end

C----------------------------------------------------------

      subroutine set_warning(power,value, wstring)

C subroutine for changing the bits of warn_options
C
c If value = 1, put wstring sub-string in warnstring in the right place.
c If value = 0, put null sub string in warnstring

      implicit none
      include 'spur_warn.inc'

c..	functions
      integer ilen
            
c...	passed variables
      integer   power,value
      character*(*) wstring

c...	local variables
cUnused      integer i
      integer i1, i2, len
      
      call set_bit(warn_options,power,value)
      i1 = (power-1)*warn_nchar + 1
      i2 = (power)*warn_nchar
      if (value .eq. 0) then
        warnstring(i1:i2) = ' '	! null sub-string. No warning 
c	do i = i1, i2
c          warnstring(i:i) = ' '	! null sub-string. No warning 
c	enddo
      else
        len = ilen(wstring)
        warnstring(i1:i2) = wstring(1:min(len,warn_nchar)) 
      endif

      return
      end

C----------------------------------------------------------

      subroutine toggle_bit(longhist,power,value)

C subroutine for toggling the bits of spurhist
C
C spurhist: 24-bit integer
C power: the bit number to be checked/changed
C value: new value of that bit (returned)
C bits: reduction of spurhist to bits, runs from 1 to maxbit=24 (power)
C work: a working value of spurhist

      implicit none
c...	passed variables
      integer*4 longhist
      integer   power,value

c...	local variables
      integer maxbit
      parameter (maxbit = 24)		!! Used to be 8
      integer bits(maxbit),i
      integer*4 work

      if      (power .lt. 1) then
        write (*,*) 'toggle_bit: Error, selected neg or zero bit: ',
     &	 power 
      else if (power .gt. maxbit) then
        write (*,*) 'toggle_bit: Error, selected bit > ', maxbit, 
     &		':', power 
      else
        work= longhist
        do i = maxbit, 1,-1
           bits(i)=work/2**(i-1)
           work=work-bits(i)*2**(i-1)
        enddo


c	toggle the value at bit power
         bits(power)=mod(bits(power)+1,2)   !! even-> zero. odd-> 1
	 value = bits(power)			!! return the new value
         work=0
         do i = 1, maxbit
            work=work+bits(i)*2**(i-1)
         enddo
         longhist=work
	 
      endif
      
      return
      end

c==================================================================
      subroutine cmd_filenames(version_stamp, struct, 
     &      whichqbuf, whichlpi, firsttime)
c... Get filename base (no extension)
c... IF LPI file does not exist, return struct=.false.

      implicit none      
      include 'io_files.inc'

c...	passed variables
      character*(*)  version_stamp
      logical struct, firsttime
      character*1 whichqbuf, whichlpi

c...	functions
      integer	ilen
      character*80 oldbase

      oldbase = file_base
 100  continue 
      
      if (.not. firsttime) then
       write (*,*) ' Input file names will be of the form '
       write (*,*) '	   <base>.buf 	(Q buffer from experiment)'
       write (*,*) '	or <base>.bt# 	(ICP triple axis data file)'
       write (*,*) '	<base>.lpi 	(Lazy Pulverix input file, optional)'
c       write (*,*)
       write (*,*) ' Output file names will be of the form '
       write (*,*) '	<base>.struct 	(Structure information)'
       write (*,*) '	<base>.spur 	(Spurion information)'
       write (*,*) '	<base>.log 	(Log file, in case program fails)'
       write (*,*) '	<base>.debug 	(Temporary debugging info)'
c       write (*,*)
       write (*,*) ' Optional output file names will be of the form '
       write (*,*) '	<base>.bufout 	(Optional output Q buffer ', 
     &				'from this program)'
       write (*,*) '	<base>.lpiout 	(Optional output Lazy-Pulverix', 
     &				' input file)'
       write (*,*) '	<base>.icp 	', 
     &      '(Optional ICP dry run, contains spect angles)'
       write (*,*) '	<base>_bw.ps	', 
     &		'(Optional B&W postscript file, lattice plot)'
       write (*,*) '	<base>_cl.ps	', 
     &		'(Optional color postscript file, lattice plot)'
       write (*,*) '	<base>_scbw.ps	', 
     &      '(Optional B&W postscript file, scan plot)'
       write (*,*) '	<base>_sccl.ps	', 
     &		'(Optional color postscript file, scan plot)'
       write (*,*)
      endif		!! .not. firsttime
      
c---------------------------------------------------------------------
c...	q-buffer file or data file
 199  continue
      if (firsttime) then
      	whichqbuf = 'd'
      else
 200   write(*,'(a)') 'What sort of q-buf info do you want to input?'
       write(*,'(a)') '	d:   default values set by program'
       write(*,'(a)') '	c:   current values in program'
       write(*,'(a)') '	b:   q buffer file 		<base>.buf' 
       write(*,'(a)') '	0-9: ICP triple axis data file 	<base>.bt#' 
       write(*,'(a)') '	h:   HELP!!' 
c       write(*,'(a)') '	q:   quit this dialog (no changes made)' 
c       write(*,'(a)') '	#: ICP triple axis data file 	<base>.bt#' 
       write (*,'(A,$)') 'Enter q-buf choice (d,c,b,0-9, h): '
c       write (*,'(A,$)') 'Enter q-buf choice (d,c,b,0-9, h,q): '
       read (*,'(A,$)',err=200) whichqbuf
       call lower(whichqbuf)

c      if (whichqbuf .eq. 'q') goto 999
      if (whichqbuf .eq. 'h') then
	   call help('', 'spurion', 
     &	   'spurion MainMenu dm_DefaultMenu')
        goto 100
      endif 

       if (.not. ((whichqbuf .eq. 'd') .or. (whichqbuf .eq. 'c') 
     &      .or. (whichqbuf .eq. 'b') )) then
         if ( (ichar(whichqbuf) .lt. ichar('0')) .or. 
     &		(ichar(whichqbuf) .gt. ichar('9')) ) then
     	   goto 200
	 endif
      endif

       if (.not. ((whichqbuf .eq. 'd') .or. (whichqbuf .eq. 'c') )) then
 202    write(*,'(a,a,$)') 'Input q-buf or data filename base', 
     &		' (no extension): '
        read(*,'(A)',err=202) file_base
       endif
      endif		!! .not. firsttime

      if (whichqbuf .eq. 'd') then
        file_base = 'SPUR_DEFAULT'
        file_bufin = 'SPUR_DEFAULT'//ext_bufin
      else if (whichqbuf .eq. 'c') then
ccc        file_bufin = 'SPUR_CURRENT'//ext_bufin	! Don't change value
      else if (whichqbuf .eq. 'b') then
        file_bufin = file_base(1:ilen(file_base))//ext_bufin
      else
        file_bufin = file_base(1:ilen(file_base))//'.bt'//whichqbuf
      endif


c...	Close the previous files
      if (file_base(1:ilen(file_base)) .ne. 
     &      oldbase(1:ilen(oldbase)) ) then
        if (.not. firsttime) then

          close(unit=unitstruct)
          write(*,*) 'Closed: ', 
     &	  'previous Spurion output structure file: ',
     &		file_structout(1:ilen(file_structout))

          close(unit=unitspur)
          write(*,*) 'Closed: ', 
     &	  'Previous Spurion output spurion file: ',
     &		file_spurout(1:ilen(file_spurout))

          close(unit=unitdebug)
          write(*,*) 'Closed: ', 
     &	  'previous Spurion output debugging file: ',
     &		file_debug(1:ilen(file_debug))

          close(unit=unitdebug)
          write(*,*) 'Closed: ', 'previous Spurion output log file: ',
     &		file_log(1:ilen(file_log))

	endif
      endif

c---------------------------------------------------------------------
c...	LPI file
 211  continue
      if (firsttime) then
      	whichlpi = 'd'
      else
 201   write(*,*) 'What sort of lazy-pulverix info ', 
     &		 'do you want to input?'
       write(*,*) '	d: default values set by program'
       write(*,*) '	c: current values in program'
       write(*,*) '	n: none (only locations marked, no intensities)'
       write(*,*) '	b: lazy-pulverix input file   <base>.lpi' 
       write(*,*) '	l: lazy-pulverix input file   ', 
     &	      '<differentname>.lpi' 
       write(*,*) '     h:   HELP!!' 
c       write(*,'(a)') '	q:   quit this dialog (no changes made to LPI)' 

       write (*,'(A, $)') 'Enter lazy-pulverix choice (d,c,n,b,l, h): '
       read(*,'(A, $)',err=201) whichlpi

       call lower(whichlpi)

c      if (whichqbuf .eq. 'q') goto 999
      if (whichqbuf .eq. 'h') then
	   call help('', 'spurion', 
     &	   'spurion MainMenu dm_DefaultMenus')
        goto 100
      endif 

       if (.not. ((whichlpi .eq. 'd') .or. (whichlpi .eq. 'c') 
     &      .or. (whichlpi .eq. 'n') .or. (whichlpi .eq. 'b') 
     &	    .or. (whichlpi .eq. 'l'))) then
     	goto 201
       endif
      endif		!! .not. firsttime

		
      if (whichlpi .eq. 'd') then
        file_lpi = 'SPUR_DEFAULT'//ext_lpi
      else if (whichlpi .eq. 'c') then
ccc        file_lpi = 'SPUR_CURRENT'//ext_lpi		! Don't change value
      else if (whichlpi .eq. 'n') then
        struct = .false.
        file_lpi = 'SPUR_NONE'//ext_lpi
      else if (whichlpi .eq. 'b') then
        file_lpi = file_base(1:ilen(file_base))//ext_lpi
      else if (whichlpi .eq. 'l')  then
 204    write(*,'(a,a, $)') 'Input Lazy-Pulverix filename base',
     &  ' (with extension): '
        read(*,'(A)',err=204) file_lpi
      endif


c...	Output file names:
      file_bufout = file_base(1:ilen(file_base))//ext_bufout


      file_lpitemp = file_base(1:ilen(file_base))//ext_lpitemp
      file_lpiout = file_base(1:ilen(file_base))//ext_lpiout

      file_structout = file_base(1:ilen(file_base))//ext_structout
      file_spurout = file_base(1:ilen(file_base))//ext_spurout
      file_icp = file_base(1:ilen(file_base))//ext_icp
      file_debug = file_base(1:ilen(file_base))//ext_debug
      file_log = file_base(1:ilen(file_base))//ext_log
      file_ps = file_base(1:ilen(file_base))//ext_ps
      file_cps = file_base(1:ilen(file_base))//ext_cps
      file_scan_ps = file_base(1:ilen(file_base))//ext_scan_ps
      file_scan_cps = file_base(1:ilen(file_base))//ext_scan_cps

c...	open log file so record errors
      open(unit=unitlog,file=file_log,status='unknown',err=666)
      write(*,*) 'Opened: ', 'Spurion output log file: ',
     &		file_log(1:ilen(file_log))
      write (unitlog, *) version_stamp(1:79)
      write (unitlog, *) file_log


c	Check that the files file_bufin and file_lpi exist 
c	before opening new files
      if (.not. ((whichqbuf .eq. 'd') .or. (whichqbuf .eq. 'c') ) ) then
        OPEN(UNIT=unitbufin,FILE=file_bufin,STATUS='OLD',err=661)
cQbufin      write(*,*) 'Opened: ', 'Q buffer input file: ', 
cQbufin     &	file_bufin(1:ilen(file_bufin))
        close (unitbufin)
      endif

      if (.not. ((whichlpi .eq. 'd') .or. (whichlpi .eq. 'c') 
     &      .or. (whichlpi .eq. 'n') )) then
        OPEN(UNIT=unitlpi,FILE=file_lpi,STATUS='OLD',err=662)
cLazyc23456789_123456789_123456789_123456789_123456789_123456789_123456789_12
cLazy      write(*,*) 'Opened: ', 'Lazy-Pulverix input file: ',
cLazy     &		file_lpi(1:ilen(file_lpi))
        close (unitlpi)
      endif

C program output
      open(unit=unitstruct,file=file_structout, status='unknown',
     &		err=663)
      write(*,*) 'Opened: ', 'Spurion output structure file: ',
     &		file_structout(1:ilen(file_structout))
      write (unitstruct, *) version_stamp(1:79)
      write (unitstruct, *) file_structout

      open(unit=unitspur,file=file_spurout,status='unknown',
     &		err=664)
      write(*,*) 'Opened: ', 'Spurion output spurion file: ',
     &		file_spurout(1:ilen(file_spurout))
      write (unitspur, *) version_stamp(1:79)
      write (unitspur, *) file_spurout

      open(unit=unitdebug,file=file_debug,status='unknown',
     &		err=665)
      write(*,*) 'Opened: ', 'Spurion output debugging file: ',
     &		file_debug(1:ilen(file_debug))
      write (unitdebug, *) version_stamp(1:79)
      write (unitdebug, *) file_debug

      open(unit=unitlog,file=file_log,status='unknown',err=666)
      write(*,*) 'Opened: ', 'Spurion output log file: ',
     &		file_log(1:ilen(file_log))
      write (unitlog, *) version_stamp(1:79)
      write (unitlog, *) file_log

      goto 999

 661  write (*,*) 'Can not open file: ', file_bufin(1:ilen(file_bufin))
      write (*,*) 'This may causes an infinite loop. '
      goto 199
c      goto 202

 662  write (*,*) 'Can not open file: ',  file_lpi(1:ilen(file_lpi))
      write (unitlog,*) 'Can not open file: ',  
     &      file_lpi(1:ilen(file_lpi))
      goto 211
c	!! this didn't open *.struct, *.spur and *.debug files.
ccc      struct = .false.
ccc      goto 999

 663  write (*,*) 'Can not open file: ', 
     & file_structout(1:ilen(file_structout))
      write (*,*) '  Instead, will be outputed to unit ', unitstruct
      write (unitlog,*) 'Can not open file: ', 
     & file_structout(1:ilen(file_structout))
      write (unitlog,*) '  Instead, will be outputed to unit ', 
     &      unitstruct
      stop		!! for debugging
      goto 999

 664  write (*,*) 'Can not open file: ', 
     & file_spurout(1:ilen(file_spurout))
      write (*,*) '  Instead, will be outputed to unit ', unitspur
      write (unitlog,*) 'Can not open file: ', 
     & file_spurout(1:ilen(file_spurout))
      write (unitlog,*) '  Instead, will be outputed to unit ', unitspur
      stop		!! for debugging
      goto 999

 665  write (*,*) 'Can not open file: ', 
     & file_debug(1:ilen(file_debug))
      write (*,*) '  Instead, will be outputed to unit ', unitdebug
      write (unitlog,*) 'Can not open file: ', 
     & file_debug(1:ilen(file_debug))
      write (unitlog,*) '  Instead, will be outputed to unit ', 
     & unitdebug      
      stop		!! for debugging
      goto 999

 666  write (*,*) 'Can not open file: ', 
     & file_log(1:ilen(file_log))
      write (*,*) '  Instead, will be outputed to unit ', unitlog
      write (unitlog,*) 'Can not open file: ', 
     & file_log(1:ilen(file_log))
      write (unitlog,*) '  Instead, will be outputed to unit ', unitlog
      stop		!! for debugging
      goto 999


      	      
 999  return
      end

c...	datestamp_g77.f

c_Subr===1=========2=========3=========4=========5=========6=========712
      SUBROUTINE datestamp(date_stamp) 
c  format year-month-day  hour:minutes:seconds
c  That is, 'year-mm-dd hh:mm:ss' (20 charcters)

      IMPLICIT NONE
c...	passed variables
      character*20 date_stamp

c...	Local variables
      CHARACTER*8 T_DATE
        character*10 t_time
        character*5  t_zone
        integer         values(8)

c DATE  must be a scalar character string variable with at least 8 characters
c and it is assigned the value CCYYMMDD  for century, year, month and day. All
c are given numerically, with blanks if the system does not include the date.

c TIME must also be a scalar character string variable with at least 10
c characters and it is assigned a value hhmmss.sss for time in hours, minutes,
c seconds and milliseconds. All are given numerically with blanks if the system
c does not include a clock.

c ZONE must be a scalar character string variable with at least 5 characters and
c it is assigned the value +hhmm for sign, time in hours and minutes for the
c local time difference with UTC (which was previously called Greenwich Mean
c Time). All are given numerically, with blanks if the system does not include a
c clock. In Sweden we therefore get +0100 in winter and +0200 in summer, in
c Novosibirsk we get +0700 .

c The variable VALUES is instead an integer vector with at least 8 elements, it
c gives the easiest way of using the results from DATE_AND_TIME at the
c calculations in a program. If the system does not include the date or the time
c you get the value -HUGE(0), that is the smallest integer number in the model,
c as output. The vector will include the following elements: year, month, day,
c time difference in minutes, hours, minutes, seconds and milliseconds.

      CALL DATE_and_time(T_DATE, t_time, t_zone, values)
      write (date_stamp, 200) t_date(1:4), t_date(5:6), t_date(7:8),
     &      t_time(1:2), t_time(3:4), t_time(5:6) 
 200  format(a4, '-', a2, '-', a2, 2x, a2, ':', a2, ':', a2)      !! 8+6+6 = 20
c      write (date_stamp, 200) t_date, t_time(1:6)
c 200  format(a8, 1x, a6, 1x)      

cDebug      write (*,*) 'datestamp: ', T_DATE, t_time
cDebug      write (*,*) 'datestamp: ',date_stamp
 
      END

     
      

c...	file spurion_scan.f
cc==========================================================================
      subroutine plot_scan(constq, ec, es, hc, hs, mon, nscan,
     &	      esparr, pointsize, relcircsize, nspurtot, nelastictot,   
     &     	 nincohmon, nincohana, 
     &		sfhkl, phimax, whichqbuf, version_stamp)
c     , fresh, addspur, addannote)
     
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      include 'spur_data.inc'		!! contains data and plotdata
      include 'spur_buf.inc'
      include 'spur_warn.inc'

c...	functions
      logical input_data
cNotUsed      integer ilen
      
cc...	passed variables
      logical constq
      real ec, es
      REAL*4 hc(3), hs(3)
      CHARACTER*5 mon
      integer nscan
      real esparr(n_spur_max,n_spur_max,maxnpts)
      real pointsize(m_rlv_max,m_rlv_max)
      real relcircsize
cInc      integer ispur(n_spur_max*n_spur_max)
cInc      integer jspur(n_spur_max*n_spur_max)
      integer nspurtot, nelastictot,  nincohmon, nincohana
      real sfhkl(m_rlv_max,m_rlv_max)
      real phimax
      character*1 whichqbuf
      character*80 version_stamp
c      logical fresh, addspur, addannote
            
c...	local variables
      logical debugthis
      parameter (debugthis = .false.)
c      parameter (debugthis = .true.)
      integer iwhich
cUnused      integer i
      real def_charsize

c      do i = 1, nspurtot
c        write (*,*) 'pre input_data : ', i, scanpt_spot(i),
c     &		  ispot(i), jspot(i), ispur(i), jspur(i)
c      enddo   
        
      plotdata = input_data(whichqbuf)

      if (debugthis) then
	call PGQID (iwhich)
	write (*,*) 'plot_scan: Current window ID =', iwhich
      endif

      call PGSLCT(ipage_scan)

      if (debugthis) then
	write (*,*) 'plot_scan: PGSLCT(ipage_scan)', ipage_scan
	call PGQID (iwhich)
	write (*,*) 'plot_scan: Current window ID =', iwhich
      endif

      call pgpap(0, aspect_ratio)
      call PGVSTD		!! Set the viewport

c      if (fresh) then
        call plot_scan_intensity(nscan, phimax)	!! Plot scan pt v.s data intensity
c      endif

cDebug      do i = 1, nspurtot
cDebug        write (*,*) 'pre plot_scan_intbragg : ', i, 
cDebug     &	  scanpt_spot(i), ispot(i), jspot(i), ispur(i), jspur(i)
cDebug      enddo     

	call PGQCH (def_charSIZE)
        call pgsch(def_charSIZE*2.0)

c	!! Plot scan pt v.s Bragg intensity at spurions
        call plot_scan_intBragg(nscan, nspurtot, sfhkl)
      
c	!! Plot scan pt v.s fake intensity of elastic spurions
        call plot_scan_intElastic(nscan, nelastictot)
      
c	!! Plot scan pt v.s  fake intensity of Al spurions
        call plot_scan_intAl(nscan)

c	!! Plot scan pt v.s  fake intensity of incoherent spurions from 
c	!! monchrometer and analyser
        call plot_scan_intIncoh(nscan, nincohmon, nincohana)

        call pgsch(def_charSIZE)


c      if (fresh) then
        call plot_scan_qaxis(nscan)		!! Extra axis
c      endif

       call plot_scan_a4(nscan, phimax)		!! Extra axis
      

c      if (fresh) then
        call plot_scan_eaxis(nscan)		!! Extra axis
c      endif

       
c	!! Plot Energy vs. scan # for higher order spurions

cDebug      do i = 1, nspurtot
cDebug        write (*,*) 'pre plot_scan_higherspurions : ', i, 
cDebug     &	  scanpt_spot(i), ispot(i), jspot(i), ispur(i), jspur(i)
cDebug      enddo     

      call plot_scan_higherspurions(nscan, nspurtot, esparr, 
cInc     &      ispur, jspur, 
     &	pointsize, relcircsize)	

cDebug      do i = 1, nspurtot
cDebug        write (*,*) 'pre plot_scan_higherbragg : ', i,
cDebug     &	   scanpt_spot(i), ispot(i), jspot(i), ispur(i), jspur(i)
cDebug      enddo  
         
	call PGQCH (def_charSIZE)
        call pgsch(def_charSIZE*2.0)	!! MAKE MARKERS BIGGER
      call plot_scan_higherbragg(nscan, nspurtot, esparr, 
     &	pointsize, relcircsize)

      call plot_scan_higherelastic(nscan, nelastictot, esparr)
        call pgsch(def_charSIZE)

c      if (addannote) then
        call plot_scan_annotate(version_stamp, nspurtot,nelastictot, 
     &      nincohmon, nincohana)	
c      endif
      
c----------------------------------------------
c...	Flush the graphics buffer before switching to other x-window 
      call pgupdt		!! flush the graphics buffer

      if (debugthis) then
	call PGQID (iwhich)
	write (*,*) 'plot_scan: Current window ID =', iwhich
      endif

      call PGSLCT(ipage_lattice)

      if (debugthis) then
	write (*,*) 'plot_scan: PGSLCT(ipage_lattice)', ipage_lattice
	call PGQID (iwhich)
	write (*,*) 'plot_scan: Current window ID =', iwhich
      endif

c      nscan_bragg = 0

      return
      end

c=============================================================
      subroutine plot_scan_intensity(nscan, phimax)
      implicit none

      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      include 'spur_data.inc'		!! contains data and plotdata
      include 'spur_buf.inc'
      include 'spur_warn.inc'

c...	passed variables
      integer nscan
      real	phimax
      
c...	local variables
      real temp1, temp2
      character*80 x_label, y_label
      integer k, i
      real 	x_xaxis(2), y_xaxis(2)
      
      x_label = 'scan point #'
      y_label = 'Intensity [Counts] '
 
      xscan_max = nscan
      xscan_min = 1
      do k = 1, nscan
        xscan(k) = float(k)
        if (plotdata) then
         yscan(k) = float(cnts_data(k))
	else
	 yscan(k) = 1.0
	endif
	 if (k .eq. 1) then
	   yscan_max = yscan(k)
	   yscan_min = yscan(k)
	 else
	   if (yscan(k) .gt. yscan_max) yscan_max = yscan(k)
	   if (yscan(k) .lt. yscan_min) yscan_min = yscan(k)
	 endif
      enddo      

      if (.not. plotdata) then
        yscan_peak = 1.0
      	yscan_max = 1.2
c	yscan_min = 0.0
	yscan_min = -0.35
c	yscan_min = -0.25
      else
c	Plump up the limits by error bars, plus a bit.
        yscan_peak = yscan_max
	yscan_max = yscan_max + sqrt(yscan_max)
	yscan_min = yscan_min - sqrt(yscan_min)
        yscan_max = yscan_max + 0.1*(yscan_max - yscan_min)
c        if (yscan_min .lt. 0.1*(yscan_max - yscan_min) ) then
c      	  yscan_min = 0.0
c        endif
	yscan_min = -0.35 * yscan_peak
c	yscan_min = -0.25 * yscan_peak
      endif

      xscan_max = nscan 
      xscan_min = 1

c----------------------------------------------
c...	Plot the counts in data  vs. scan point #.
        call PGSVP(vxmin_sc_cnts,vxmax_sc_cnts,
     &		      vymin_sc_cnts,vymax_sc_cnts)

      if (auto_xmin_sc)  then 
        xmin_sc = Xscan_MIN
      endif
      if (auto_xmax_sc)  then 
        xmax_sc = Xscan_Max
      endif
        ymin_sc_cnts = yscan_MIN
        ymax_sc_cnts= yscan_Max

c...	Selectplot range
        call PGSWIN (xmin_sc, xmax_sc,  ymin_sc_cnts, ymax_sc_cnts)

c...	Make the regions which have inaccessible angle A4 grey
	call pgsci(color_lightgrey)
	do k = 1, nscan
c	  if (angle4_store(k) .gt. phimax) then
	  if (.not. A4_OK(k)) then
	     temp1 = float(k) - 0.5
	     temp2 = float(k) + 0.5
            call PGRECT (temp1, temp2, ymin_sc_cnts, ymax_sc_cnts)  
cDebug	    write (*,*) 'plot_scan_intensity:gray box at k=', k
cDebug	    write (*,*) 'plot_scan_intensity:', 
cDebug     &	    	temp1, temp2, ymin_sc_cnts, ymax_sc_cnts
	  endif 
	enddo

c...	Draw axes box and number labels
	call pgsci(color_ink)
        call pgbox ('BCNST', 0, 0, 'BCNST', 0, 0)

c...	Make x-axes 
	x_xaxis(1) = xmin_sc
	x_xaxis(2) = xmax_sc
	y_xaxis(1) = 0.0
	y_xaxis(2) = 0.0

c	 write (*,*) 'plot_scan_intensity: xaxis =', 
c     &		 (x_xaxis(i), y_xaxis(i), i =1, 2)
	call pgsci(color_blue)
	call PGSLS (2)		!! Dashed line
	call PGLINE (2, X_xaxis, Y_xaxis)
	call PGSLS (1)		!! solid line
	call pgsci(color_ink)

        call pgpt(nscan, xscan, yscan, 0)

        if (plotdata) then 	!! error bars
          do i = 1, nscan
            call PGERR1 (6, Xscan(i), Yscan(i), sqrt(yscan(i)), 1.0)
          enddo
        endif

c----------------------------------------------
c...	Mark off the temperature values
c...	Put the temperature along the top of the graph
	if (qb_temp_incT .ne. 0.0) then
	  temp1 = qb_temp_T0 + qb_temp_incT*float(nint(xmin_sc)-1)
	  temp2 = qb_temp_T0 + qb_temp_incT*float(nint(xmax_sc)-1)

cDebug	 write (*,*) 'plot_scan_intensity: x,y, min, max=', 
cDebug     &	 xmin_sc, xmax_sc,  ymin_sc_cnts, ymax_sc_cnts
         call pgaxis('N',xmin_sc, ymax_sc_cnts,  xmax_sc, ymax_sc_cnts, 
     &	   temp1, temp2,
     &     0.0, 1, 0.5,0.0, 0.5, -0.5,0.0)
         call PGMTXT ('T', 1.5, 0.5, 0.5, 'Temperature (K)')

	endif  

       call PGLAB (x_label, y_label, ' ')
       call PGMTXT ('T', 2.0, 0.0, 0.0, file_bufin) 
      
      return
      end


c=============================================================
      subroutine plot_scan_intBragg(nscan, nspurtot, sfhkl)
c      Plot the intensity of the Bragg points on top of the data.
 
      implicit none

      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      include 'spur_data.inc'		!! contains data and plotdata
      include 'spur_buf.inc'
      include 'spur_warn.inc'

c...	functions
      integer cycle_marker      

c...	passed variables
      integer nscan
       integer nspurtot
      real sfhkl(m_rlv_max,m_rlv_max)
      
c...	local variables
      integer i, k, ii, jj
      real	yy
      real	ybragg_max

       ybragg_max  = 0.0
        do i=1,nspurtot
          do ii=1,m_rlv_max
            do jj=1,m_rlv_max
 	      if ((ispot(i).eq.ii) .and.(jspot(i).eq.jj)) then
	        if (ybragg_max .lt. sfhkl(ispot(i),jspot(i)) ) then
			 ybragg_max = sfhkl(ispot(i),jspot(i))
		endif
	      endif
	    enddo
	  enddo
	enddo
c	write (*,*) 'plot_scan_intbragg : ybragg_max=',  ybragg_max 
c	write (*,*) 'plot_scan_intbragg : yscan_min, yscan_peak=', 
c     &		yscan_min, yscan_peak 

        do ii=1,m_rlv_max
          do jj=1,m_rlv_max

c	    call pgsci(color_ink)

c            do iscan=1,nscan
c...		Bragg peaks along the scan.  
c                if ((abs(zeta(ii,jj)-qarr(1,iscan)).lt.tol).and.
c     &              (abs(eta(ii,jj)-qspur(2,iscan)).lt.tol).and.
c     &               .not.absent(ii,jj)) then
c                  if (ybragg_max .eq. 0.0) then
c		   yy = yscan_min + 0.1*(yscan_max  - yscan_min )
c		  else
c		   yy = sfhkl(ii,jj) *  yscan_peak /ybragg_max
c		  endif
c		endif
c		call pgpt1(float(iscan), yy, 25)	!! big circle marker
c	    enddo
	    
	    call pgsci(color_yellow)
            do i=1,nspurtot
c...		Bragg peaks at the higher order spurions
	      call pgsci(color_yellow)
 	      if ((ispot(i).eq.ii) .and.(jspot(i).eq.jj)) then
                if (ybragg_max .eq. 0.0) then
		 yy = yscan_min
		else
		 yy = sfhkl(ispot(i),jspot(i)) *  yscan_peak /ybragg_max
		endif
	        k = scanpt_spot(i)
		call pgpt1(float(k), yy, cycle_marker(rankspot(i)+5, 15))
c		write (*,*) 'plot_scan_intbragg :',i,
c     &		 k, yy, cycle_marker(rankspot(i)+5, 15), rankspot(i)
ccc		call pgpt1(float(k), yy, 17)	!! solid circle

c		write (*,*) 'plot_scan_intbragg : ', k, i, ii, jj, 
c     &		  ispot(i), jspot(i), yy

	      endif
	    enddo
	  enddo
	enddo

	call pgsci(color_ink)


      return
      end
      
      
c=============================================================
      subroutine plot_scan_intElastic(nscan, nelastictot)
c      Plot the "intensity" of the higher order elastic spurions 
c	on top of the data. (no ibntensity known, so just make it the minimum.)
c	Because we don't know it's relative intensity, make it negative.
 
      implicit none

      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      include 'spur_data.inc'		!! contains data and plotdata
      include 'spur_buf.inc'
      include 'spur_warn.inc'

c...	functions
      integer cycle_marker, cycle_linestyle

c...	passed variables
      integer nscan
       integer nelastictot
      
c...	local variables
      integer i, k
      real	yy
      real xline(2), yline(2)

	    call pgsci(color_red)
c...		These are the elastic spurions which match a scan point to 
c...		within tolerances.
            do i=1,nelastictot
c		Offset the elastic spurions slightly.	    
ccc	      yy = yscan_min + 0.1 * (yscan_peak-yscan_min)
	      yy = -0.1 * yscan_peak
	      k = scanpt_elst(i)
	      call pgpt1(float(k), yy, cycle_marker(rankelst(i)+10, 15))
c	      call pgpt1(float(k), yy, 13)	!! solid triangle

c		write (*,*) 'plot_scan_intElastic : ', k, i, yy

c		write (*,*) 'plot_scan_intElastic :', i,
c     &		 k, yy, cycle_marker(rankelst(i)+10, 15), rankelst(i)

	    enddo

c....	This are the exact positions of the elastic spurions that 
c....	are within the scan range
cOld        call pgsls(4)          ! dotted line
	do i = 1, n_zeroelst
          call pgsls(cycle_linestyle(i, .false.))	!! non-solid line style
	  xline(1) = iscan_zerospur(i)
	  xline(2) = xline(1)
	  yline(1) = yscan_min
	  yline(2) = yscan_max
	  call pgline(2, xline, yline)
	enddo

	call pgsls(1)				!! return to solid lines
	call pgsci(color_ink)

      return
      end
      
c=============================================================
      subroutine plot_scan_intAl(nscan) 
c      Plot the "intensity" of the Al spurions 
c	on top of the data.
c	Because we don't know it's relative intensity, make it negative.
 
      implicit none

      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      include 'spur_data.inc'		!! contains data and plotdata
      include 'spur_buf.inc'
      include 'spur_warn.inc'
      
c...	functions 
      integer  cycle_marker

c...	passed variables
      integer nscan
      
c...	local variables
      integer i, k, imark
      real	yy

	    call pgsci(color_greencyan)
            do i=1,nal_match
c		Offset the Al spurions slightly.	    
	      yy = -0.2 * yscan_peak
	      k = iqal_iscan(i)
	      imark = cycle_marker(iqal_ial(i), nal_match)
cWrong	      imark = cycle_marker(i, nal_match)
	      call pgpt1(float(k), yy, imark)	!! solid circle
	    enddo

	call pgsci(color_ink)

      return
      end
      
c=============================================================
      subroutine plot_scan_intIncoh(nscan, nincohmon, nincohana)
c      Plot the "intensity" of the incoherent spurions from the 
c	monochrometer and analyzer on top of the data. 
c	Because we don't know it's relative intensity, make it negative.
 
      implicit none

      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      include 'spur_data.inc'		!! contains data and plotdata
      include 'spur_buf.inc'
      include 'spur_warn.inc'

c...	functions
      integer cycle_marker      

c...	passed variables
      integer nscan
       integer nincohmon, nincohana 
      
c...	local variables
      integer i, k
      real	yy

	    call pgsci(color_cyan)
            do i=1, nincohmon
c		Offset the elastic spurions slightly.	    
	      yy = -0.25 * yscan_peak
	      k = scanpt_incmon(i)
	      call pgpt1(float(k), yy, cycle_marker(rankincmon(i), 15))
cDebug	      write (*,*) 'plot_scan_intIncoh: MON', i, k, yy,
cDebug     &		       rankincmon(i), cycle_marker(rankincmon(i), 15)
	    enddo
	call pgsci(color_ink)

	    call pgsci(color_bluecyan)
            do i=1, nincohana
c		Offset the elastic spurions slightly.	    
	      yy = -0.3 * yscan_peak
	      k = scanpt_incana(i)
	      call pgpt1(float(k), yy, cycle_marker(rankincana(i), 15))
	      write (*,*) 'plot_scan_intIncoh: ANA', i, k, yy,
     &		       rankincana(i), cycle_marker(rankincana(i), 15)
	    enddo
	call pgsci(color_ink)

      return
      end
      

c=============================================================
      subroutine plot_scan_qaxis(nscan)
      implicit none

      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      include 'spur_data.inc'		!! contains data and plotdata
      include 'spur_buf.inc'
      include 'spur_warn.inc'

c...  	passed variables
      integer 	nscan
      
c...	local variables
      real def_charSIZE
      real qx, qy, qz
      character*16	qstring
      real	xpos
      integer	nskip
      character*80  y_label
      integer	i

c----------------------------------------------
c...	Mark off the q-values
      vymax_sc_q = vymin_sc_cnts - 0.075
c02Apr      vymax_sc_q = vymin_sc_cnts - 0.1
      if ( (abs(qb_space_hs(1)) .le. 0.1e-7) .and. 
     &     (abs(qb_space_hs(2)) .le. 0.1e-7) .and.  
     &     (abs(qb_space_hs(3)) .le. 0.1e-7)  )then
	vymin_sc_q = vymax_sc_q
      else
	vymin_sc_q = vymax_sc_q - 0.08
c02mar	vymin_sc_q = vymax_sc_q - 0.15        
	call PGQCH (def_charSIZE)
        call pgsch(def_charSIZE*0.5)
        call PGSVP(vxmin_sc_q,vxmax_sc_q,vymin_sc_q,vymax_sc_q)
        call PGSWIN (xmin_sc, xmax_sc,  ymin_sc_q, ymax_sc_q)

c      call PGSVP (0.08, 0.92, 0.35, 0.5)
c      call PGSWIN (Xscan_MIN, Xscan_MAX, 0.0, 1.0) 
CLeaveout?        call pgbox ('BNT', 0, 0, 'B', 0, 0)
        y_label = 'Q(h,k,l)'
        call PGLAB (' ', y_label, ' ')
c02Mar        call PGLAB (x_label, y_label, ' ')
cOld        do i = 1, nscan
        do i = nint(xmin_sc), nint(xmax_sc)
	 nskip = (nint(xmax_sc-xmin_sc+1) - 
     &		   mod(nint(xmax_sc-xmin_sc+1), 5))/5
	 if (nskip .eq. 0) nskip = 1 
	 if (mod(i, nskip) .eq. 0) then
          xpos = xmin_sc + float(i-nint(xmin_sc))
cOld          xpos = xscan_min + xscan_max*(float(i)/(xscan_max- xscan_min))
	  qx = qb_space_hc(1) +
     &	  	(float(i-1)-(float(nscan-1))/2.0)*qb_space_hs(1)
	  qy = qb_space_hc(2) +
     &	 	(float(i-1)-(float(nscan-1))/2.0)*qb_space_hs(2)
	  qz = qb_space_hc(3) +
     &	  	(float(i-1)-(float(nscan-1))/2.0)*qb_space_hs(3)
          write (qstring, 120)  Qx, Qy, Qz
c03Mar          write (qstring, 120)  Qx_data(i), Qy_data(i), Qz_data(i)
 120	  format( '(', f4.2, ',', f4.2, ',', f4.2, ')' )
c          write (*,*) 'q label = ', i, ' "', qstring, '"', e_data(i)
          call PGpTXT (xpos, 0.0, 90.0, 0.0, qstring)
	 endif
        enddo
        call pgsch(def_charSIZE)
      endif

      return
      end


c=============================================================
      subroutine plot_scan_a4(nscan, phimax)
      implicit none

      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      include 'spur_data.inc'		!! contains data and plotdata
      include 'spur_buf.inc'
      include 'spur_warn.inc'
      
c...    passed variables
      integer	nscan
      real	phimax

c...	local variables
c      character*80 x_label, y_label
c      real temp1, temp2
      real def_charsize
      CHARACTER*6 A4STRING
      real xpos, this_a4
      integer nskip, i

c----------------------------------------------
c..	Mark off A4 angle
      vymax_sc_a4 = vymin_sc_q 
      
cDebug	  write (*,*) 'plot_scan_a4: angle4_varies=',angle4_varies
      if (.not. angle4_varies) then
	vymin_sc_a4 = vymax_sc_a4
      else
	vymin_sc_a4 = vymax_sc_a4 - 0.035
c02Apr	vymin_sc_a4 = vymax_sc_a4 - 0.013 
        call PGSVP(vxmin_sc_a4,vxmax_sc_a4,vymin_sc_a4,vymax_sc_a4)
        call PGSWIN (xmin_sc, xmax_sc,  ymin_sc_a4, ymax_sc_a4)

cc...	Put tick marks not but not the numbers on the axes
c        call pgbox ('BT', 0, 0, '', 0, 0)
c        x_label = 'Angle 4 [Degrees]'
c        y_label = ' '
c
c        call pgaxis('N',xmin_sc, ymin_sc_a4,  xmax_sc, ymin_sc_a4, 
c     &	   angle4(1), angle4(nscan),
c     &     0.0, 1, 0.0,0.5, 0.5, 0.5,0.0)
c        call PGMTXT ('B', 2.0, 0.5, 0.5, x_label)
c
c      endif

c...	Must do it a complicated way because Angle4 will not be evenly spaced.
	call PGQCH (def_charSIZE)
        call pgsch(def_charSIZE*0.5)
        call PGSVP(vxmin_sc_a4,vxmax_sc_a4,vymin_sc_a4,vymax_sc_a4)
        call PGSWIN (xmin_sc, xmax_sc,  ymin_sc_a4, ymax_sc_a4)

        call PGLAB (' ', 'A4 [Deg]', ' ')
        do i = nint(xmin_sc), nint(xmax_sc)
	 nskip = (nint(xmax_sc-xmin_sc+1) - 
     &		   mod(nint(xmax_sc-xmin_sc+1), 5))/5
	 if (nskip .eq. 0) nskip = 1 
	 if (mod(i, nskip) .eq. 0) then
          xpos = xmin_sc + float(i-nint(xmin_sc))
	  this_a4 = angle4_store(nint(xpos)) *180.0/acos(-1.0)
          write (a4string, 120) this_a4
 120	  format( f6.2 )
          call PGpTXT (xpos, 0.0, 90.0, 0.0, A4string)
cDebug	  write (*,*) 'plot_scan_a4: ',nskip, i, xpos, this_a4
	 endif
        enddo
        call pgsch(def_charSIZE)
      endif


      return
      end


c=============================================================
      subroutine plot_scan_eaxis(nscan)
      implicit none

      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      include 'spur_data.inc'		!! contains data and plotdata
      include 'spur_buf.inc'
      include 'spur_warn.inc'
      
c...    passed variables
      integer	nscan

c...	local variables
      character*80 x_label, y_label
      real temp1, temp2

c----------------------------------------------
c..	Mark off the energy 
      vymax_sc_de = vymin_sc_A4
c      vymax_sc_de = vymin_sc_q 
      if (abs(qb_energy_es) .le. 0.1e-7) then
	vymin_sc_de = vymax_sc_de
      else
	vymin_sc_de = vymax_sc_de - 0.01 
        call PGSVP(vxmin_sc_de,vxmax_sc_de,vymin_sc_de,vymax_sc_de)
        call PGSWIN (xmin_sc, xmax_sc,  ymin_sc_de, ymax_sc_de)

c...	Put tick marks not but not the numbers on the axes
        call pgbox ('BT', 0, 0, '', 0, 0)
        x_label = 'delta Energy [meV]'
        y_label = ' '

	temp1 = qb_energy_ec + 
     &		  qb_energy_es*((xmin_sc-1.0) - (nscan-1)/2.0)
	temp2 = qb_energy_ec + 
     &		  qb_energy_es*((xmax_sc-1.0) - (nscan-1)/2.0)

        call pgaxis('N',xmin_sc, ymin_sc_de,  xmax_sc, ymin_sc_de, 
     &	   temp1, temp2,
     &     0.0, 1, 0.0,0.5, 0.5, 0.5,0.0)
        call PGMTXT ('B', 2.0, 0.5, 0.5, x_label)


      endif

      return
      end


c=============================================================
      subroutine plot_scan_higherspurions(nscan, nspurtot, esparr, 
cInc     &      ispur, jspur, 
     &	pointsize, relcircsize)
      implicit none
c----------------------------------------------
c..     Plot scan number vs. the energy  for all the higher order spurions.

      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      include 'spur_data.inc'		!! contains data and plotdata
      include 'spur_buf.inc'
      include 'spur_warn.inc'

c...	functions
      integer cycle_linestyle 
      
c...	passed variables
      integer 	nscan
      integer nspurtot
      real esparr(n_spur_max,n_spur_max,maxnpts)
cInc      integer ispur(n_spur_max*n_spur_max)
cInc      integer jspur(n_spur_max*n_spur_max)
      real pointsize(m_rlv_max,m_rlv_max)
      real relcircsize

c...	local variables
      real def_charSIZE
      integer icolor
      character*29 spur_label
      real yhispur_min, yhispur_max
      integer ii, jj, i, k, izero
      real 	x_xaxis(2), y_xaxis(2)

c----------------------------------------------
c..	Plot scan number vs. the energy  for all the higher order spurions.
      vymax_sc_hs = vymin_sc_de - 0.07
c...	Leave at least a certain amount of room for LPI notes
      vymin_sc_hs = max(vymax_sc_hs/2.0, 0.25)
c      vymin_sc_hs = max(vymax_sc_hs/2.0, vymax_sc_hs - 0.15)
cOrig      vymin_sc_hs = vymax_sc_hs /2.0
      
      if (auto_ymin_sc_hs) then
        ymin_sc_hs = qb_energy_ec + 
     &		  qb_energy_es*(float(0-1) - (nscan-1)/2.0)
      endif
      if (auto_ymax_sc_hs) then
        ymax_sc_hs = qb_energy_ec + 
     &		  qb_energy_es*(float(nscan+1-1) - (nscan-1)/2.0)
      endif
      
        do i = 1, nscan
          if (plotdata) then
            yhispur(i) = e_data(i)
	  else
	    yhispur(i) = qb_energy_ec + 
     &		  qb_energy_es*(float(i-1) - (nscan-1)/2.0)
	  endif
	enddo
	
	yhispur_max =  yhispur(1)
	yhispur_min =  yhispur(1)
	if (yhispur_max .lt. yhispur(nscan)) yhispur_max =  yhispur(nscan)
	if (yhispur_min .gt. yhispur(nscan)) yhispur_min =  yhispur(nscan)

        do ii=1,n_spur_max
          do jj=1,n_spur_max
	    if (.not. ((ii .eq. 1) .and. (jj .eq. 1)) ) then
	      k= 1		!! only do endpoints of scan
	        if (yhispur_max .lt. esparr(ii,jj,k)) then
	          yhispur_max =  esparr(ii,jj,k)
	        endif
	        if (yhispur_min .gt. esparr(ii,jj,k)) then
	          yhispur_min =  esparr(ii,jj,k)
	        endif
	      k= nscan		!! only do endpoints of scan
	        if (yhispur_max .lt. esparr(ii,jj,k)) then
	          yhispur_max =  esparr(ii,jj,k)
	        endif
	        if (yhispur_min .gt. esparr(ii,jj,k)) then
	          yhispur_min =  esparr(ii,jj,k)
	        endif
 	    endif
	  enddo
        enddo
	
c	write (*,*) 'plot_scan: Spurion energy range:', 
c     &		yhispur_min, yhispur_max 

      if (auto_ymin_sc_hs) then
	ymin_sc_hs = yhispur_min
      endif
      if (auto_ymin_sc_hs) then
	ymax_sc_hs = yhispur_max 
      endif
	
        call PGSVP(vxmin_sc_hs,vxmax_sc_hs,vymin_sc_hs,vymax_sc_hs)
        call PGSWIN (xmin_sc, xmax_sc,  ymin_sc_hs, ymax_sc_hs)

        call pgbox ('BCNST', 0, 0, 'BCNST', 0, 0)
        call PGLAB ('scan point #. (Q [rlu])', 
     &		'Spur En. [meV]', ' ')
c        call PGLAB ('scan point #', 
c     &		'Spurion Energies [meV] (Q [rlu])', ' ')


c...	x-axis
	x_xaxis(1) = xmin_sc
	x_xaxis(2) = xmax_sc
	y_xaxis(1) = 0.0
	y_xaxis(2) = 0.0
	call pgsci(color_blue)
	call PGSLS (2)		!! Dashed line
	call PGLINE (2, X_xaxis, Y_xaxis)
	call PGSLS (1)		!! solid line
	call pgsci(color_ink)

c...	The scan line
	call PGQCH (def_charSIZE)
        call pgsch(def_charSIZE*0.5)
	icolor = 0
	call cycle_color(icolor, 3)
        call PGSLS (3)		!! dashed
        call pgline(nscan, xscan,  yhispur)
        call PGSLS (1)		!! solid


	if ( ((0.0 .ge. ymin_sc_hs) ) .and.
     &	           ((0.0 .le. ymax_sc_hs) )) then
	  call pgtext(xscan(nint(xmax_sc)), 0.0, 'x-axis')
	endif

	if ( ((yhispur(nint(xmax_sc)) .ge. ymin_sc_hs) ) .and.
     &	           ((yhispur(nint(xmax_sc)) .le. ymax_sc_hs) )) then
	  call pgtext(xscan(nint(xmax_sc)), yhispur(nint(xmax_sc)), 'Scan')
	endif
c	call pgtext(xscan(nscan), yhispur(nscan), 'Scan')

cDebug	write (*,*) 'plot_scan: higher order spurions:'
        do ii=1,n_spur_max
          do jj=1,n_spur_max

	    if (.not. ((ii .eq. 1) .and. (jj .eq. 1)) ) then
              do k = 1, nscan
                 yhispur(k) = esparr(ii,jj,k)
	      enddo
c	      write (*,*) 'plot_scan:  ', ii, jj, 
c     &		      yhispur(1), yhispur(nscan)
	      call cycle_color(icolor, 3)
	      do izero = 1, n_zeroelst
	        if ((ii .eq. ii_zerospur(izero)) .and.
     &		 	(jj .eq. jj_zerospur(izero)) ) then
     		  call pgsci(color_red)
		  call PGSLS (cycle_linestyle(izero, .false.)) !! non-solid lines
     		endif
	      enddo
              call pgline(nscan, xscan,  yhispur)
 110          format(i1, '*Ki-', i1, '*Kf', 1x, a)	      
 	      write (spur_label, 110), ii, jj, afloat_hkl_end(ii,jj)

	      if ( ((yhispur(nint(xmax_sc)) .ge. ymin_sc_hs)) .and.
     &	           ((yhispur(nint(xmax_sc)) .le. ymax_sc_hs))) then
	        call pgtext(xscan(nint(xmax_sc)), yhispur(nint(xmax_sc)),
     &		      spur_label)
     	      endif
     
	      if ( ((yhispur(nint(xmin_sc)) .ge. ymin_sc_hs) ) .and.
     &	           ((yhispur(nint(xmin_sc)) .le. ymax_sc_hs) )) then
	        call pgtext(xscan(nint(xmin_sc)), yhispur(nint(xmin_sc)),
     &		     afloat_hkl_start(ii,jj) )
     	      endif


	    endif
	    call PGSLS (1)		!! solid
	  enddo
        enddo

        call pgsci(color_ink)
        call pgsch(def_charSIZE)	!! restore character size

      return
      end

c=============================================================
      subroutine plot_scan_higherbragg(nscan, nspurtot, esparr, 
     &	pointsize, relcircsize)
c----------------------------------------------
c...    Place the positions of the bragg peaks which intersect with
c        the higher order spurions. 
      implicit none

      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      include 'spur_data.inc'		!! contains data and plotdata
      include 'spur_buf.inc'
      include 'spur_warn.inc'

c...	functions
      integer cycle_marker      
      
c...	passed variables
      integer 	nscan
      integer nspurtot
      real esparr(n_spur_max,n_spur_max,maxnpts)
      real pointsize(m_rlv_max,m_rlv_max)
      real relcircsize

c...	local variables
      real def_charSIZE
c      integer icolor
c      character*29 spur_label
c      real yhispur_min, yhispur_max
cUnused      integer ii, jj
      integer i, k

        call PGSVP(vxmin_sc_hs,vxmax_sc_hs,vymin_sc_hs,vymax_sc_hs)
        call PGSWIN (xmin_sc, xmax_sc,  ymin_sc_hs, ymax_sc_hs)

c----------------------------------------------
c...	Place the positions of the bragg peaks with intersect
c	 the higher order spurions. 
c	write (*,*) 'plot_scan: # of Bragg matches=', nscan_bragg

	call PGQCH (def_charSIZE)
        call pgsch(def_charSIZE*0.5)
	call pgsci(color_yellow)

        do i=1,nspurtot
	  k = scanpt_spot(i)

	  call pgpt1(float(k), esparr(ispur(i),jspur(i),k), 
     &		  cycle_marker(rankspot(i)+5, 15))
c	  call pgpt1(float(k), esparr(ispur(i),jspur(i),k), 17)
	enddo

c555    continue

       call pgsci(color_ink)
       call pgsch(def_charSIZE)	!! restore character size


      return
      end


c=============================================================
      subroutine plot_scan_higherelastic(nscan, nelastictot, esparr)
c----------------------------------------------
c...    Place the positions of the higher order spurions which are elastic. 
      implicit none

      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      include 'spur_data.inc'		!! contains data and plotdata
      include 'spur_buf.inc'
      include 'spur_warn.inc'

c...	functions
      integer cycle_marker
            
c...	passed variables
      integer 	nscan
      integer nelastictot
      real esparr(n_spur_max,n_spur_max,maxnpts)

c...	local variables
      real def_charSIZE
      integer i, k

        call PGSVP(vxmin_sc_hs,vxmax_sc_hs,vymin_sc_hs,vymax_sc_hs)
        call PGSWIN (xmin_sc, xmax_sc,  ymin_sc_hs, ymax_sc_hs)

c	  write (*,*) 'plot_scan_higherelastic: entered'

	call PGQCH (def_charSIZE)
        call pgsch(def_charSIZE*0.5)
	call pgsci(color_red)
        do i=1,nelastictot
	  k = scanpt_elst(i)
c	  call pgpt1(float(k), esparr(ielst(i),jelst(i),k), 16)
c	  write (*,*) 'plot_scan_higherelastic: ', 
c     &		  i, k, esparr(ielst(i),jelst(i),k)
	  call pgpt1(float(k), esparr(ielst(i),jelst(i),k),
     &		  cycle_marker(rankelst(i)+10, 15))
cDebug	  write (*,*) 'plot_scan_higherelastic: elast. matches: ', 
cDebug     &	    'Using symbol ', cycle_marker(rankelst(i)+10, 15), rankelst(i)
	enddo
	

c	The exact placement of zero crossings.
	do i = 1, n_zeroelst 
	  call pgpt1(iscan_zerospur(i), 0.0, 17)	!! filled circle
	  write (*,*) 'plot_scan_higherelastic: zero crossings: ', 
     &	    'Using symbol ', 17
	  
	enddo
	

       call pgsci(color_ink)
       call pgsch(def_charSIZE)	!! restore character size

      return
      end


c=============================================================
      subroutine plot_scan_annotate(version_stamp, nspurtot,nelastictot, 
     &      nincohmon, nincohana)
      implicit none

      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_color.inc'
      include 'spur_layout.inc'
      include 'spur_scan.inc'
      include 'spur_data.inc'		!! contains data and plotdata
      include 'spur_buf.inc'
      include 'spur_warn.inc'
      
c...	functions
      integer cycle_marker, cycle_linestyle
      
c...	passed variables
      character*80 version_stamp
      integer nspurtot, nelastictot, nincohmon, nincohana

c...	Local variables
      real ytop, xch, ych
      real	 yyhere, xxhere, xx2here, yyoff, yytop, yy_sofar
      integer		nuser
      character*20	userstring
      character*(80) aline
      logical moremore
      real def_charSIZE
      integer ial, i, j, ihigh
      character*7	alstring
      character*9	higherstring
      real	xline(2), yline(2)
      

c----------------------------------------------
c...	Put the LPI file on the bottom of the page, if it is being used.
      vymax_sc_lpi = vymin_sc_hs - 0.04
c      vymax_sc_lpi = vymin_sc_hs - 0.07
      vymin_sc_lpi = 0.03
c      vymin_sc_lpi = margin_plot
      call PGSVP(vxmin_sc_hs,vxmax_sc_hs,vymin_sc_lpi,vymax_sc_lpi)
      ytop = ((vymax_sc_lpi-vymin_sc_lpi)/(vxmax_sc_hs- vxmin_sc_hs))
      ytop = ytop *aspect_ratio
      call pgswin( 0.0, 1.0, 0.0, ytop)	!! make commensurate

      call PGQCS(4, XCH, YCH)		!! world units
      yoff_sc = 1.5*ych
      if (warn_options .ne. 0) then	!! Print warning in big red letters
        yhere_sc = vymin_sc_lpi + yoff_sc
        call pgsci(color_red)	
	call pgmtext('LV', -0.1, yhere_sc, 0.0, warnstring)
        call pgsci(color_ink)	
      endif

      call PGQCH (def_charSIZE)
      call pgsch(def_charSIZE*0.55)  !! Shrink the lettering.
      xhere_sc = 0.0
      call PGQCS(4, XCH, YCH)		!! world units
      yoff_sc = 1.5*ych
      
      yhere_sc = vymin_sc_lpi
      call pgqinf('USER', userstring, nuser)
      call pgmtext('RV', -0.1, yhere_sc, 1.0, userstring(1:nuser))
      call pgmtext('LV', -0.1, yhere_sc, 0.0,  version_stamp)

      OPEN(UNIT=unitlpi,FILE=file_lpi,STATUS='OLD',err=622)

      yhere_sc = ytop
      yhere_sc = yhere_sc - yoff_sc
      call pgtext(xhere_sc, yhere_sc, file_lpi)

      moremore = .true.
      do while (moremore)
	read (unitlpi, '(a80)', err=620, end=620) aline
        yhere_sc = yhere_sc - yoff_sc
        if (yhere_sc .gt. 0.05) then
	  call pgtext(xhere_sc, yhere_sc, aline)
	endif	
      enddo

 620  continue
      close (unitlpi)
 622  continue     
      call pgsch(def_charSIZE)	  !! restore the lettering.

c----------------------------------------------
c...	Put the marker labels on the right of the page
      call pgsvp( xmin_label, xmax_label, ymin_label, ymax_label)
      yytop = ((ymax_label-ymin_label)/(xmax_label- xmin_label))
      yytop = yytop *aspect_ratio
      call pgswin( 0.0, 1.0, 0.0, yytop)	!! make commensurate

      call PGQCH (def_charSIZE)
      call pgsch(def_charSIZE*1.0)  !! increase the lettering size.
        yyhere = yytop
c        yyhere = yytop + yyoff
        yy_sofar = yyhere
        call PGQCS(4, XCH, YCH)
        yyoff = 1.5*ych
c        xxhere = yyoff/2.0
        xxhere = yyoff*1.5
        xx2here = yyoff*2.25
	
c...	data
        yyhere = yyhere - yyoff
        call pgsci(color_ink)
 	call pgpt1(xxhere, yyhere, 0)		!! box
	call pgtext(xx2here, yyhere, 'Data')

	if (nspurtot .gt. 0) then
          call pgsci(color_yellow)
          yyhere = yyhere - yyoff
	  call pgtext(xxhere, yyhere, 'Higher Spurs:')
	endif

c...	higher order spurions intersecting Bragg peaks
cc	if (nspurtot .gt. 0) then
c          	call pgsci(color_yellow)
c          	yyhere = yyhere - yyoff
c	  	call pgpt1(xxhere, yyhere, 17)		!! solid circle
c	  	call pgtext(xx2here, yyhere, 'Bragg')
cc	endif

c...	higher order spurions intersecting Bragg peaks
c	ihigh = 0 	
       do ihigh = 1, n_rankspot
	do i = 1, nspurtot
	  if ((ihigh) .eq. rankspot(i)) then
c	  if ((ihigh+1) .eq. rankspot(i)) then
c	    ihigh = ihigh + 1
c	    write (*,*) 'plot_scan_annotate:', i, ihigh, 
c     &		  rankspot(i), cycle_marker(ihigh+5, 15)
            yyhere = yyhere - yyoff
	    write (higherstring, 90) ispur(i), jspur(i)
 90	    format(i1, '*Ki-', i1, '*Kf')		
	    call pgpt1(xxhere, yyhere, cycle_marker(ihigh+5, 15))	!! markers 
	    call pgtext(xx2here, yyhere, higherstring)
	    goto 81
	  endif
	enddo
 81	continue
       enddo

c	ihigh = 0
c	do ii = 1, n_spur_max
c	  do jj = 1, n_spur_max
c	    do i = 1, nspurtot
c	      if ((ii .eq. ispot(i))  .and. (jj .eq. jspot(i)) then
c	        ihigh = ihigh + 1
c          	yyhere = yyhere - yyoff
c          	call pgsci(color_yellow)
c		write (higherstring, 90) ii, jj
c 90		format(i1, '*Ki-', i1, '*Kf')		
c	  	call pgpt1(xxhere, yyhere, cycle_marker(ihigh+5, 15))	!! markers 
c	  	call pgtext(xx2here, yyhere, higherstring)
cc	  	call pgpt1(xxhere, yyhere, 17)		!! solid circle
cc	  	call pgtext(xx2here, yyhere, 'Bragg')
c	  	goto 91			!! Only report 1 label per ii*Ki - jj*Kf
c	      endif
c	    enddo
c	  enddo
c 91	  continue	  
c	enddo
c	endif

	if ((n_zeroelst .gt. 0) .or. (nelastictot .gt. 0)) then
          call pgsci(color_red)
          yyhere = yyhere - yyoff
	  call pgtext(xxhere, yyhere, 'Elst Spurs:')
	endif

	
c02May	if (nelastictot .gt. 0) then
c02May          call pgsci(color_red)
c02May          yyhere = yyhere - yyoff
c02May	  call pgtext(xxhere, yyhere, 'Elst Spurs:')
c02May	endif

c...	Dashed lines for all elastic spurions within scan range,
c...	even if not within tolerance of a scan point
      do i = 1, n_zeroelst
        call pgsls(cycle_linestyle(i, .false.))		!! non-solid line style
        yyhere = yyhere - yyoff
        write (higherstring, 90) ii_zerospur(i), jj_zerospur(i)
	xline(1) = yyoff*1.0		!! xxhere
	xline(2) = xx2here
	yline(1) = yyhere
	yline(2)  = yline(1)
	call pgline(2, xline, yline) 
	call pgtext(xx2here, yyhere, higherstring)
      enddo
      call pgsls(1)          ! solid line

c...	higher order elastic spurions matches to scan points
      do ihigh = 1, n_rankelst
c	ihigh = 0 	
	do i = 1, nelastictot
	  if ((ihigh) .eq. rankelst(i)) then
c	  if ((ihigh+1) .eq. rankelst(i)) then
c	    ihigh = ihigh + 1
            yyhere = yyhere - yyoff
	    write (higherstring, 90) ielst(i), jelst(i)
	    call pgpt1(xxhere, yyhere, cycle_marker(ihigh+10, 15))	!! markers 
	    call pgtext(xx2here, yyhere, higherstring)
	    goto 91
	  endif
	enddo
 91	continue
       enddo

cc	if (nelastic .gt. 0) then
c          yyhere = yyhere - yyoff
c          call pgsci(color_red)
c	  call pgpt1(xxhere, yyhere, 13)		!! solid triangle
c	  call pgtext(xx2here, yyhere, 'elastic')
cc	endif

c...	al spurions
        call pgsci(color_green)
 	do ial = 1, nal
	  do j = 1, nal_match
	    if ( iqal_ial(j) .eq. ial) then
              yyhere = yyhere - yyoff
	      write (alstring, 105 ) (hklal(i,ial), i=1, 3)
c	      write (alstring, 105 ) (hklal(i,j), i=1, 3)
 105 	      format ('Al(', 3i1, ')' )
	      call pgpt1(xxhere, yyhere, cycle_marker(ial, nal_match))	!! a marker
	      call pgtext(xx2here, yyhere, alstring)
cDebug	      write (*,*) 'cmd_al: ial=', ial, j, alstring
	      goto 111			!! Only report 1 label per Al ring
cDebug	    else 
cDebug	      write (*,*) 'cmd_al: skipping ial=', ial, j
	    endif
	  enddo
 111      continue
	enddo

c...	incoherent spurions

	if (nincohmon .gt. 0) then
          call pgsci(color_cyan)
          yyhere = yyhere - yyoff
	  call pgtext(xxhere, yyhere, 'MON Incoh:')
	endif

      do ihigh = 1, n_rankincmon
	do i = 1, nincohmon
	  if ((ihigh) .eq. rankincmon(i)) then
            yyhere = yyhere - yyoff
	    call pgpt1(xxhere, yyhere, cycle_marker(ihigh, 15))	!! markers 
	    call pgtext(xx2here, yyhere, lab_incmon(i)) 
	    goto 121
	  endif
	enddo
121	continue
       enddo

	if (nincohana .gt. 0) then
          call pgsci(color_bluecyan)
          yyhere = yyhere - yyoff
	  call pgtext(xxhere, yyhere, 'ANA Incoh:')
	endif

       do ihigh = 1, n_rankincana
	do i = 1, nincohana
	  if ((ihigh) .eq. rankincana(i)) then
            yyhere = yyhere - yyoff
	    call pgpt1(xxhere, yyhere, cycle_marker(ihigh, 15))	!! markers 
	    call pgtext(xx2here, yyhere, lab_incana(i)) 
	    goto 131
	  endif
	enddo
131	continue
       enddo


      call pgsch(def_charSIZE)	  !! restore the lettering.


      return
      end

      
cc==========================================================================
      logical function input_datahdr(whichqbuf)
           
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_buf.inc'
cObsolete      include 'spur_data.inc'

c...	common blocks
c..	functions
      integer ilen
      
cc...	passed variables
      character*1 whichqbuf
      
cc...	local variables
      character*80 aline
      integer i
cNotUsed      character*40 filename
      real	areal


      OPEN(UNIT=unitdata,FILE=file_bufin,STATUS='OLD',err=661)
cObsolete      OPEN(UNIT=unitdata,FILE=file_data,STATUS='OLD',err=661)
      
c 'PROSS007.BT2' '12-AUG-2001 12:43' 'Q'    1175000.    6  'NEUT'  105  'RAW'
      read (unitdata, *, err=660) qd_filename, qd_date, 
     &      qd_scanstyle,  areal, qd_prefactor, qd_base,  
     &	    qd_scanpts, qd_type
      qd_monitor  = nint(areal)

c      read (unitdata, *, err=660) filename, data_date, 
c     &      data_scantype, areal, data_prf, data_probe, 
c     &	    data_nscan, data_type
c      data_mon = nint(areal)
      
c   Filename         Date            Scan       Mon    Prf  Base   #pts  Type
      read (unitdata, 80, err=663) aline		! Skip labels for previous line
 80   format (a80)      
c02May      read (unitdata, *, err=663) aline		! Skip labels for previous line

c PrOsS  PrOs4Sb12                                  
      read (unitdata, '(a7, a73)', err=662) qd_fileprefix, qd_comment
c02May      read (unitdata, *, err=662) qd_fileprefix, qd_comment
c      read (unitdata, *, err=662) aline		! skip chemical composition
      
c  60 20 40  2       0  0  0         1  0  0   0.000     0  0  1
      read (unitdata, *, err=664) (qd_collimation(i), i=1,4), 
     &	    (qd_mosaic(i), i=1,3), 
     &      (qd_u(i), i=1,3), qd_angle, (qd_v(i), i=1,3)
c      read (unitdata, *, err=664) (collimation(i), i=1,4), 
c     &	    (mosaic(i), i=1,3), 
c     &      (u_data(i), i=1,3), angle_data, (v_data(i), i=1,3)
     
c  Collimation        Mosaic              Xstal Orientation
      read (unitdata, 80, err=662) aline		! Skip labels for previous line
c02May      read (unitdata, *, err=662) aline		! Skip labels for previous line

c      6.283     6.283     6.283    90.000    90.000    90.000
      read (unitdata, *, err=665) (qd_lattice_a(i), i=1,3), 
     &     (qd_lattice_angle(i), i=1,3)
c      read (unitdata, *, err=665) a_data, b_data, c_data, 
c     &      alpha_data, beta_data, gamma_data

c Lattice Parameters in real space
      read (unitdata, 80, err=662) aline		! Skip labels for previous line
c02May      read (unitdata, *, err=662) aline		! Skip labels for previous line

c     11.000    -0.250       14.700        3.354   3.354      6.00000   0.00000
      read (unitdata, *, err=666)  qd_ec, qd_es, qd_fe,  qd_dM, qd_dA,  
     &        qd_temp_T0, qd_temp_incT	
c      read (unitdata, *, err=666)  ec_data, es_data, fe_data
c    &, m_dsp, a_dsp, tmp_srt, tmp_inc

c   E center  Delta E      EA fixed      M-dsp   A-dsp     Tmp strt   Tmp inc
c23456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_
      read (unitdata, 80, err=662) aline		! Skip labels for previous line
cBroken      read (unitdata, *, err=662) aline		! Skip labels for previous line
      qd_ana_or_mon = aline(28:29)
cDebug      write (*,*) 'input_datahdr: aline ='
cDebug      write (*,*) '"', aline(1:50), '"'
cDebug      write (*,*) 'input_datahdr: aline(25:32)="', aline(25:32), '"'
cDebug      write (*,*) 'input_datahdr: qd_ana_or_mon=aline(28:29)="', 
cDebug     &	qd_ana_or_mon , '"'
      if (qd_ana_or_mon .eq. 'EA') then
        qb_energy_fix = '(ANA)'
      else if (qd_ana_or_mon .eq. 'EM') then
        qb_energy_fix = '(MON)'
      else
         write (*,*) 'input_datahdr: qd_ana_or_mon = "', 
     &		 qd_ana_or_mon, '"'
        qb_energy_fix = '(???)'
      endif

      
c   1.800   0.000   0.000    0.0000  0.0000  0.0000      0.0000
      read (unitdata,*,err=667) (qd_space_hc(i),i=1,3), 
     &		      (qd_space_hs(i),i=1,3)
c      read (unitdata,*,err=667) (hc_data(i),i=1,3), (hs_data(i),i=1,3)
c    Q (hkl scan center)        Delta Q (hkl)            Hfield
      read (unitdata, 80, err=662) aline		! Skip labels for previous line
c02May      read (unitdata, *, err=662) aline		! Skip labels for previous line


c     Q(x)    Q(y)    Q(z)     E       T-act    min       Counts
      read (unitdata, 80, err=662) aline		! Skip labels data columns
c02May      read (unitdata, *, err=662) aline		! Skip labels data columns
      

c      constq_data = .true.
c      do i = 1, 3
c        if (hs_data(i) .ne. 0.0) then
c          constq_data = .false.
c        endif
c      enddo
      

      if (qd_scanpts .gt. maxnpts) then
	write (*,*) 'input_data: Change arraysize.inc''s maxnpts ', 
     &    'so that this # of data points can be read in:', qd_scanpts
	stop
      endif

c      if (data_nscan .gt. maxnpts) then
c	write (*,*) 'input_data: Change arraysize.inc''s maxnpts ', 
c     &    'so that this # of data points can be read in:', data_nscan
c	stop
c      endif

      close (UNIT=unitdata)
      
      input_datahdr = .true.

      goto 999
      
 671  write (*,*) 'input_datadhr: Can not open data file: ', 
     &		file_bufin(1:ilen(file_bufin))
      goto 777

 672  write (*,*) 'input_datadhr: Error skipping header, line ', i
      goto 777

 661  write (*,*) 'input_datadhr: Can not open data file: ', 
     &		file_data(1:ilen(file_data))
      goto 777

 660  write (*,*) 'input_datadhr: Error first line'
c      write (*,*) '  =',  filename
c      write (*,*) '  =', data_date
c      write (*,*) '  =', data_scantype
c      write (*,*) '  =',  data_mon
c      write (*,*) '  =', data_prf 
c      write (*,*) '  =',  data_probe
c      write (*,*) '  =',  data_nscan
c      write (*,*) '  =',  data_type
      goto 777

 662  write (*,*) 'input_datadhr: Error reading skipped line "', 
     &		aline(1:ilen(aline)), '"'
      goto 777
      
 663  write (*,*) 'input_datadhr: Error line containing filename'
      goto 777

 664  write (*,*) 'input_datadhr: Error line containing XTL orientation'
      goto 777

 665  write (*,*) 'input_datadhr: ', 
     &	 'Error line containing lattice parameters'
      goto 777

 666  write (*,*) 'input_datadhr: Error line containing ', 
     &		'Energy center and step'
      goto 777

 667  write (*,*) 'input_datadhr: ', 
     &	 'Error line containing Q center and step'
      goto 777


 777  input_datahdr = .false.      	      
 999  return
      end
      
cc==========================================================================
      logical function input_data(whichqbuf)
           
      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
c      include 'spur_color.inc'
c      include 'spur_layout.inc'
c      include 'spur_scan.inc'
      include 'spur_data.inc'
      include 'spur_buf.inc'


c...	common blocks
c..	functions
      integer ilen
      logical extractfirstword
      
cc...	passed variables
      character*1 whichqbuf
      
cc...	local variables
      character*80 aline
      integer i
      character*8    labels(7)
      
cNotused      character*40 filename
cNotUsed      real	areal

c03Mar 202  write(*,'(a,$)') ' Enter name of data file: ' 
c03Mar      read(*,'(A)',err=202) file_data
c03Mar      plotdata = .false.
      if ( (ichar(whichqbuf) .ge. ichar('0')) .and. 
     &		(ichar(whichqbuf) .le. ichar('9')) ) then 
       OPEN(UNIT=unitdata,FILE=file_bufin,STATUS='OLD',err=671)
       do i = 1, 11		!! skip header info.
ccc       do i = 1, 12		!! skip header info.
         read (unitdata, 80, err=672, end=772) aline
80	 format(a80)
c02May         read (unitdata, *, err=672) aline
       enddo
       read (unitdata, 80, err=673, end=772) aline
       do i = 1, 7
          labels(i) = ''
          if (.not. extractfirstword(aline, labels(i), ' ')) goto 222
       enddo
222    continue
      else		!! no data file
	goto 777 
      endif
      
 
c      write (*,*) 'Data file is:', file_data(1:ilen(file_data))
c      write (*,*) 'Buffer files is: ', file_bufin(1:ilen(file_bufin))
      
      
      do i = 1, qd_scanpts
cObsolete      do i = 1, data_nscan
c   1.8000  0.0000  0.0000  24.0000  8.00510    5.95          21
	if (labels(5) .eq. 'T-act') then 
          read (unitdata, *, err=668, end=768)
     &		 qx_data(i), qy_data(i), qz_data(i),
     &		e_data(i), tmp_data(i), minutes_data(i), cnts_data(i)	
        else
          read (unitdata, *, err=668, end=768)
     &		 qx_data(i), qy_data(i), qz_data(i),
     &		e_data(i), minutes_data(i), cnts_data(i)	
	endif
cOK        write (*,*) 'read=', qx_data(i), qy_data(i), qz_data(i),
cOK     &		e_data(i), tmp_data(i), minutes_data(i), cnts_data(i)	
cc            h(i)=hc(i)+(k-(float(npts)+1.0)/2.0)*hs(i)
c        qmag_data(i)=sqrt(qx_data(i)**2 +qy_data(i)**2 +qz_data(i)**2)
        if (i .eq. 1) then
c	  Qdata_max = Qmag_data(i)
c	  Qdata_min = Qmag_data(i)
	  Edata_max = E_data(i)
	  Edata_min = E_data(i)
	else
c	  if (Qdata_max .gt. Qmag_data(i))  Qdata_max = Qmag_data(i)
c	  if (Qdata_min .lt. Qmag_data(i))  Qdata_min = Qmag_data(i)
	  if (Edata_max .lt. E_data(i))  Edata_max = E_data(i)
	  if (Edata_min .gt. E_data(i))  Edata_min = E_data(i)
	endif
cOK        write (*,*) 'read2=', qx_data(i), qy_data(i), qz_data(i),
COK     &		e_data(i), tmp_data(i), minutes_data(i), cnts_data(i)	
      enddo

      close (UNIT=unitdata)
      
      input_data = .true.
      plotdata = .true.

cDebug      do i = 1, data_nscan
cDebug        write (*,*) 'write1:', qx_data(i), qy_data(i), qz_data(i),
cDebug     &		e_data(i), tmp_data(i), minutes_data(i), cnts_data(i)	
cDebug      enddo

cDebug      write (*,*) 'input_data:  Edata_min,Edata_max =', 
cDebug     &	      Edata_min,  Edata_max  

cDebug      do i = 1, data_nscan
cDebug        write (*,*) 'write2:',qx_data(i), qy_data(i), qz_data(i),
cDebug     &		e_data(i), tmp_data(i), minutes_data(i), cnts_data(i)	
cDebug      enddo
cDebug      write (*,*) 'end  of data.'

c      write (*,*) 'input_data:  Edata_min,Edata_max =', 
c     &	      Edata_min,  Edata_max  

      goto 999
      
 668  write (*,*) 'input_data: Error reading data. Line', i
cccc 668  write (*,*) 'input_data: Error line containing data', i
      goto 777

 671  write (*,*) 'input_data: Can not open data file: ', 
     &		file_bufin(1:ilen(file_bufin))
      goto 777

 672  write (*,*) 'input_data: Error skipping header, line ', i
      goto 777

 673  write (*,*) 'input_data: Error reading column labels, line ', 12
      goto 777

 768  write (*,*) 'input_data: Premature end to data, pt=', i,
     &		' Expected # of scanpts=', qd_scanpts 	
      goto 777

 772  write (*,*) 'input_data: Premature end to header line ', i
      goto 777

 777  input_data = .false.      	      
 999  return
      end

      FUNCTION WAVE (SYML)
C-----DERIVES WAVELENGTH FOR RADIATION SYMBOL SYML                      WAVE0001
      COMMON/WAVEL/ CT
C      INTEGER CT,SYML
      character*4 syml,ct(20)
      real w(20)
C      DIMENSION W(20)
      DATA W(1)/2.28970/,W(2)/2.29361/,W(3)/2.0848/,W(4)/2.2909/,W(5)/1.
     193604/,W(6)/1.93998/,W(7)/1.75653/,W(8)/1.9373/,W(9)/1.54056/,W(10
     2)/1.54439/,W(11)/1.39217/,W(12)/1.5418/,W(13)/0.70930/,W(14)/0.713
     359/,W(15)/0.63225/,W(16)/0.7107/,W(17)/0.55941/,W(18)/0.56380/,W(1
     49)/0.49701/,W(20)/0.5608/
      DO 1 I=1,20
C  Changed the following statement:
      IF (SYML.eq.CT(I)) goto 2
C      IF (SYML-CT(I)) 1,2,1
 1    CONTINUE
      WAVE=W(12)
      RETURN
 2    WAVE=W(I)
      RETURN
      END
C
C***************************************************
C
      FUNCTION LP (SYMLP)
C-----ASSIGNS SEQUENCE NUMBER LP TO EACH LOR.POL. SYMBOL SYMLP          LPS00101
      character*2 symlp,cs(6)
      integer lpf(6),lp
      COMMON /FLORNUM/ LPF /FLORCHAR/ CS
C
C  FYI LPF:  0   1   2  3  4   0
C      CS : DS ' 1' NE GN GH '  '
C
      DO 1 I=1,6
      IF (SYMLP.eq.CS(I)) goto 2
C      IF (SYMLP-CS(I)) 1,2,1
 1    CONTINUE
      LP=LPF(1)
      RETURN
 2    LP=LPF(I)
      RETURN
      END
C
C****************************************************
C
      FUNCTION BRA (SYMBR)
C-----ASSIGNS SEQUENCE NUMBER BRA TO BRAVAIS LATTICE SYMBOL SYMBR       BRAS0001
      character*1 ct(8),symbr
      integer ib(8),bra
      COMMON /BRAFNUM/ IB /BRAFCHAR/ CT
C  The 8 symbols in CT are: (blank) P I R F A B C
C  SYMBR could come from LATTICE card or from ISYB in the
C  BURZ subroutine which is assigned to SYMBR and comes from
C  the first character in the Hermann Mauguin symbol
C  the IB which is returned is: 1 1 2 3 4 5 6 7
      DO 1 I=1,8
        if (symbr.eq.ct(i)) goto 2
C      IF (SYMBR-CT(I)) 1,2,1
 1    CONTINUE
      BRA=IB(1)
      RETURN
 2    BRA=IB(I)
      RETURN
      END

c...	file datestamp_sgi.f

c_Subr===1=========2=========3=========4=========5=========6=========712
      SUBROUTINE datestamp(date_stamp) 
c  format year-month-day  hour:minutes:seconds
c  That is, 'year-mm-dd hh:mm:ss' (20 charcters)

      IMPLICIT NONE
c...	passed variables
      character*20 date_stamp

c...	passed variables
      CHARACTER*9 Txt_DATE
        character*8 txt_time

c...	local variables
c      character*20 txt_time, txt_date
      integer i
      character*2 month
      
ccc SGI date_and_time 13:51:02 16-Jan-02
      call time(txt_time) !! 8 characters
      call date(txt_date)!! 9 characters

      month = '??'
      if (txt_date(4:6) .eq. 'Jan') month = '01'
      if (txt_date(4:6) .eq. 'Feb') month = '02'
      if (txt_date(4:6) .eq. 'Mar') month = '03'
      if (txt_date(4:6) .eq. 'Apr') month = '04'
      if (txt_date(4:6) .eq. 'May') month = '05'
      if (txt_date(4:6) .eq. 'Jun') month = '06'
      if (txt_date(4:6) .eq. 'Jul') month = '07'
      if (txt_date(4:6) .eq. 'Aug') month = '08'
      if (txt_date(4:6) .eq. 'Sep') month = '09'
      if (txt_date(4:6) .eq. 'Oct') month = '10'
      if (txt_date(4:6) .eq. 'Nov') month = '11'
      if (txt_date(4:6) .eq. 'Dec') month = '12'

      write (date_stamp, 200) txt_date(8:9), month, txt_date(1:2),
     &      txt_time(1:8)
 200  format('20', a2, '-', a2, '-', a2, 2x, a8)     !! 4+4+4+8

cDebug      write (*,*) 'datestamp_sgi: "', txt_date, '" "', txt_time, '"'
cDebug      write (*,*) 'datestamp_sgi: "', date_stamp, '"'
      return
      END

     
      

c	io.f 
c	string manipulation commands to tame lazy pulverix.
c	Functions from getxyfromdb.f.
c	Tanya Riseman, NIST cebter for Neutron Research. Nov, 2001

c======= extractfirstword ================================
	logical function extractfirstword(aline, aword, adelim)
c	returns true if a word is found, false if empty line.
c	aline is returned with aword removed from the front.
c	aword is ended by a space or a tab or the character in adelim
c	(typically adelim is a comma, colon or equals sign). 
c	Modified from function extractfirstword in getxyfromdb.f.
c	 Tanya Riseman, Univerisity of Birminghman, U.K., 2000. 

	implicit none

c       passed variables
	character*(*) 	aline, aword
	character*1	adelim

c	functions
	logical 	trim_blank
	integer		inotblank

c	internal variables
	integer 	len_aline, len_aword
cUnused	logical		notblank
	integer		i
	integer		iinotblank

c	strip off leading blanks off aline and put in templine
	if (trim_blank(aline)) then
c	 aline is only blank
	 extractfirstword = .false.
	else
	 len_aline = len(aline)
	 len_aword = len(aword)
	

c	 find end of word in string templine (which has leading blanks removed).
	 iinotblank = inotblank(aline, adelim)
c01Dec10	 iinotblank = inotblank(aline, ',')
cDebug	 write (*,*) 'extractfirstword: iinotblank = ', iinotblank, 
cDebug     &		'"', aline(1:iinotblank), 
cDebug     &		'"  space= "', aline(iinotblank+1:iinotblank+1), '"'
	 if (iinotblank .lt. len(aline) ) then
c	 if ( (iinotblank .gt. 1) .and. 
c     &	     (iinotblank .lt. len(aline)) ) then
	   !! Replace tab and ',' by space
	   aline(iinotblank+1:iinotblank+1) = ' '
	 endif
	 
c	put only the first word of aline in aword. Check for overflow.
	 if (iinotblank .le. len_aword) then
	   aword(1:iinotblank) = aline(1:iinotblank)
	   do i = iinotblank+1, len_aword
	    aword(i:i) = ' '
	   enddo
	   extractfirstword = .true.
	 else
	   aword(1:len_aword) = aline(1:len_aword)
	   extractfirstword = .false.
	 endif

c	 remove aword from beginning of aline
	 aline(1:len_aline-iinotblank) = 
     &		aline(iinotblank+1:len_aline)
	 do i = len_aline- iinotblank+1, len_aline
	  aline(i:i) = ' '
	 enddo
	endif

	return
	end


c======= extractfirstfield================================
	logical function extractfirstfield(aline, aword, adelim, alabel, 
     &		labdelim)
c	returns true if a word is found, false if empty line.
c	aline is returned with aword removed from the front.
c	aword is ended by a space or a tab or the character in adelim
c	(typcially colon, comma or equal sign).
c	A label, indicated by ending with a deliminator labdelim 
c	(: or = typcially), is stripped off the front, before aword.
c	The aword is ended by a space, a tab or adelim.

	implicit none

c       passed variables
	character*(*) aline, aword, alabel
	character*1 labdelim, adelim

c	functions
cUnused	logical 	trim_blank
	logical 	extractfirstword
cUnused	integer		inotblank
        integer		ilen
	
c	internal variables
cNotUsed	integer		iinotblank

	if (extractfirstword(aline, aword, labdelim)) then
		if (len(alabel) .lt. ilen(aword)) then
		  extractfirstfield = .false.
		  write (*,*) 'extractfirstfield: Overflow of label'
		  write (*,*) '  aword =', aword
		  write (*,*) '  len(alabel) =', len(alabel)
		else
		  alabel = aword
		endif
		if (.not. extractfirstword(aline, aword, adelim)) then
		  extractfirstfield = .false.
	  	  write (*,*) 'extractfirstfield: failed with aword' 
		  write (*,*) '  aline = ', aline
		  write (*,*) '  aword =', aword
		endif
	else
	  extractfirstfield = .false.
	  aword = ''
	  alabel = ''
	  write (*,*) 'extractfirstfield: failed on reading label'
	endif

	return
	end

c======= inotblank ================================
	integer function inotblank(aline, adelim)
c	returns the position of the last non-blank character before the first
c	blank in string aline.
c	Blank characters may be space or tab or delim
c	(typically colon, comma or equal sign).


	implicit none

c       passed variables
	character*(*) 	aline
	character*1	adelim
	
c	functions
	logical		trim_blank

c	internal variables
	integer 	len_aline
	logical		notblank
	integer		i
	character*1	atab

	atab = char(9)		!! The tab character

	if (trim_blank(aline)) then
c	 aline is only blank
	  inotblank = 0
	  return
	endif
	
	len_aline = len(aline)

c	 find end of word in string templine (which has leading blanks removed).
	 notblank = .true.
	 inotblank = 0
	 i = 0
	 do while ((i .lt. len_aline) .and. (notblank))
	  i = i + 1
c	  Check for space, tab or comma=delim
	  if ((aline(i:i).eq.' ').or.(aline(i:i) .eq. atab) 
     &			.or. (aline(i:i) .eq. adelim)) then 
	    notblank = .false.
	  else 
	    inotblank = inotblank + 1
	  endif
	 enddo
cDebug	  write (*,*) 'inotblank:= ', inotblank, '"', aline, '"'
	return
	end


	
c======= ilen ================================
	integer function ilen(aline)
c	Return the length of the string aline, minus white space at end

	implicit none

c       passed variables
	character*(*) aline
c	character*1	adelim

c	internal variables
	integer len_aline
cNotUsed	integer i
	logical endblank
        character*1	atab
	
	atab = char(9)		!! The tab character

	len_aline = len(aline)

	endblank = .false.
	ilen = len_aline
	do while ((ilen .gt. 1) .and. (.not. endblank))
	  if ((aline(ilen:ilen).eq.' ') .or.
c     &	      (aline(ilen:ilen) .eq. adelim) .or.
c01Dec12     &	      (aline(ilen:ilen) .eq. '	') ) then
     &	      (aline(ilen:ilen) .eq. atab) ) then
	    ilen = ilen - 1
	  else 
	    endblank = .true.
	  endif
	enddo

	if (ilen .eq. 0)  then
	  ilen = 1
	endif

	return
	end


	
c======= trim_blank ================================
	logical function trim_blank(aline)
c	Function from getxyfromdb.f.
c	 Tanya Riseman, Univerisity of Birminghman, U.K., 2000. 
c	return value .true. means completely empty line.
c	Trims off leading blanks (spaces and tabs) and puts 
c	results in aline.

	implicit none

c       passed variables
	character*(*) aline

c	internal variables
	integer len_aline
	integer iblank, i
	logical endblank
        character*1	atab
	
	atab = char(9)		!! The tab character

	len_aline = len(aline)

	endblank = .false.
	iblank = 1
	do while ((iblank .lt. len_aline) .and. (.not. endblank))
	  if ((aline(iblank:iblank).eq.' ') .or.
     &	      (aline(iblank:iblank) .eq. atab)) then 
	    iblank = iblank + 1
	  else 
	    endblank = .true.
	  endif
	enddo
	iblank = iblank -1

c	completely empty line
	if (iblank .eq. len_aline)  then
	  trim_blank = .true.
	else if (iblank .eq. 0) then
c	no blank at the front, so don't shift
	  trim_blank = .false.
	else
c	non-empty line, strip off the blank part in the beginning
	  trim_blank = .false.
	  aline(1:(len_aline-iblank)) = aline(1+iblank:len_aline)
	  do i = len_aline-iblank+1, len_aline
	    aline(i:i)=' '
	  enddo

	endif
cDebug	write (*,*) 'trim_blank: iblank=', iblank, 
cDEbug     &		'"', aline(1:len_aline-iblank), '"'

	return
	end

c======= supper ===================================
	subroutine supper(aword)
c	Modifed function from getxyfromdb.f.
c	 Tanya Riseman, Univerisity of Birminghman, U.K., 2000. 
c	converts string aword into uppercase.
c	Changed name from UPPER so doesn't conflict with function called upper.

	implicit none

c	passed variables
c01Dec	character*80	aword
	character*(*)	aword

c	internal variables
	integer 	i, ia, iz, bigA, iletter
	
	ia = ichar('a')
	iz = ichar('z')
	bigA =ichar('A')
cDebug	write (*,*) 'supper: len, aword=', len(aword), aword
	do i = 1, len(aword)
	  iletter = ichar(aword(i:i))
	  if ((iletter .ge. ia) .and. (iletter.le. iz)) then
	    aword(i:i) = char(bigA - ia + iletter)
	  endif
	enddo

	return
	end

c======= lower ===================================
	subroutine lower(aword)
c	converts string aword into uppercase.

	implicit none

c	passed variables
	character*(*)	aword

c	internal variables
	integer 	i, ia, iz, littleA, iletter
	
	ia = ichar('A')
	iz = ichar('Z')
	littleA =ichar('a')
	do i = 1, len(aword)
	  iletter = ichar(aword(i:i))
	  if ((iletter .ge. ia) .and. (iletter.le. iz)) then
	    aword(i:i) = char(littleA - ia + iletter)
	  endif
	enddo

	return
	end

c======= isblank ===================================
	logical function isblank(aword)

	implicit none

c	passed variables
	character*(*) aword
	
c	local variables
	integer i
	
	if (len(aword) .eq. 0) then
	   isblank = .true.
	else
	  isblank = .true. 
	  do i = 1, len(aword)
	     if (aword(1:i) .ne. ' ') isblank = .false.
	  enddo
	endif
	
	return
	end
	
c============ reportsymmetry ======================================

	subroutine reportsymmetry(ISYSTM)
	implicit none
	integer ISYSTM
	
    	if (ISYSTM .eq. 1) then
	  write(*,*) 'ReportSymmetry: ', ISYSTM, ' is monoclinic'
    	else if (ISYSTM .eq. 2) then
	  write(*,*) 'ReportSymmetry: ', ISYSTM, ' is orthorhombic'
    	else if (ISYSTM .eq. 4) then
	  write(*,*) 'ReportSymmetry: ', ISYSTM, ' is tetragonal'
    	else if (ISYSTM .eq. 5) then
	  write(*,*) 'ReportSymmetry: ', ISYSTM, ' is cubic or isometric'
    	else if (ISYSTM .eq. 6) then
	  write(*,*) 'ReportSymmetry: ', ISYSTM, ' is hexagonal (maybe rhombo)'
    	else if (ISYSTM .eq. 7) then
	  write(*,*) 'ReportSymmetry: ', ISYSTM, ' is triclinic'
    	else 
	  write(*,*) 'ReportSymmetry: ', ISYSTM, ' is unrecognized'
	endif
	
	return
	end


c======== readreal ==================================

	logical function readreal(thereal, 
     &		aline, alabel, labdelim, getlabel, lastOK)
	implicit none
c...	functions
	logical extractfirstfield
	logical extractfirstword
	logical isblank
	integer inotblank
		
c...	passed variables
	real		thereal
	character*(*)	aline, alabel, lastOK
	CHARACTER	labdelim
	logical		getLabel

c...	local variables
	character*80 aword

	
	readreal = .false.
	if (getlabel) then
	 if (extractfirstfield(aline, aword, ',', alabel, labdelim)) then
    	    if (isblank(aword)) then 
	       thereal = 0.0
     	    else 
	       read (aword, *, err=666,end=666) thereal
	    endif
    	    lastOK = 'Last part that was OK areal='//
cccc     &		aword(1:trim_len(aword))// ' with label "'//
cccc     &		alabel(1:trim_len(alabel))// '"' 
     &		aword(1:inotblank(aword, ' '))// ' with label "'//
     &		alabel(1:inotblank(alabel, ' '))// '"' 
	    readreal = .true.
	 endif
	else
	 if (extractfirstword(aline, aword, ' ')) then
    	    if (isblank(aword)) then 
	       thereal = 0.0
     	    else 
	       read (aword, *, err=666,end=666) thereal
	    endif
    	    lastOK = 'Last part that was OK areal='//
     &		aword(1:inotblank(aword, ' '))
cccc     &		aword(1:trim_len(aword))
	    readreal = .true.
	 endif
	
	endif

 666	continue
 
	return
	end
	
c======== readinteger ==================================

	logical function readinteger(theinteger, 
     &		aline, alabel, labdelim, getlabel, lastOK)
	implicit none
c...	functions
	logical extractfirstfield
	logical extractfirstword
	logical isblank
	integer inotblank
	
c...	passed variables
	integer		theinteger
	character*(*)	aline, alabel, lastOK
	CHARACTER	labdelim
	logical		getlabel

c...	local variables
	character*80 aword

	
	readinteger = .false.
	if (getlabel) then
	 if (extractfirstfield(aline, aword, ',', alabel, labdelim)) then
    	    if (isblank(aword)) then 
	       theinteger = 666
     	    else 
	       read (aword, *, err=666,end=666) theinteger
	    endif
    	    lastOK = 'Last part that was OK theinteger='//
     &		aword(1:inotblank(aword, ' '))// ' with label "'//
     &		alabel(1:inotblank(alabel, ' '))// '"' 
ccc     &		aword(1:trim_len(aword))// ' with label "'//
ccc     &		alabel(1:trim_len(alabel))// '"' 
	    readinteger = .true.
	 endif
	else
	 if (extractfirstword(aline, aword, ' ')) then
    	    if (isblank(aword)) then 
	       theinteger = 666
     	    else 
	       read (aword, *, err=666,end=666) theinteger
	    endif
    	    lastOK = 'Last part that was OK theinteger='//
     &		aword(1:inotblank(aword, ' '))
ccc     &		aword(1:trim_len(aword))
	    readinteger = .true.
	 endif
	
	endif

 666	continue
 
	return
	end
	
c======== readstring ==================================

	logical function readstring(thestring, 
     & 		aline, alabel, labdelim, getlabel, lastOK)
	implicit none

c...	functions
	logical extractfirstfield
	logical extractfirstword
	logical isblank
	integer inotblank
	
c...	passed variables
	character*(*)	thestring
	character*(*)	aline, alabel, lastOK
	CHARACTER	labdelim
	logical		getLabel

c...	local variables
	character*80 aword

	
	readstring = .false.
	if (getlabel) then
	 if (extractfirstfield(aline, aword, ',', alabel, labdelim)) then
    	    if (isblank(aword)) then 
	       thestring = '666'
     	    else 
		thestring = aword
	    endif
    	    lastOK = 'Last part that was OK thestring='//
     &		aword(1:inotblank(aword, ' '))// ' with label "'//
     &		alabel(1:inotblank(alabel, ' '))// '"' 
ccc     &		aword(1:trim_len(aword))// ' with label "'//
ccc     &		alabel(1:trim_len(alabel))// '"' 
	    readstring = .true.
	 endif
	else
	 if (extractfirstword(aline, aword, ' ')) then
    	    if (isblank(aword)) then 
	       thestring = '666'
     	    else 
		thestring = aword
	    endif
    	    lastOK = 'Last part that was OK thestring='//
     &		aword(1:inotblank(aword, ' '))
cccc     &		aword(1:trim_len(aword))
	    readstring = .true.
	 endif
	
	endif

 666	continue
 
	return
	end	

      subroutine alewald()

      implicit none
      include 'arraysize.inc'
      include 'spur_scan.inc'
      
c...	constants

c...	passed variables

c...	local variables
c0111Unused      real magq,dum,qdiff(n)
      real a,pi
      integer i, j, h(3,nal)

C  Read in the aluminum peaks to be considered.
C

      data (h(i,1),i=1,3) / 1,1,1 /
      data (h(i,2),i=1,3) / 2,0,0 /
      data (h(i,3),i=1,3) / 2,2,0 /
      data (h(i,4),i=1,3) / 3,1,1 /
      data (h(i,5),i=1,3) / 2,2,2 /
      data (h(i,6),i=1,3) / 4,0,0 /
      data (h(i,7),i=1,3) / 3,3,1 /
      data (h(i,8),i=1,3) / 4,2,0 /
      data (h(i,9),i=1,3) / 4,2,2 /
      data (h(i,10),i=1,3) / 3,3,3 /
      data (h(i,11),i=1,3) / 4,4,0 /
      data (h(i,12),i=1,3) / 5,3,1 /
      data (h(i,13),i=1,3) / 6,0,0 /
      
C     Read in the aluminum lattice constant.

      data a / 4.04096 /

      pi=4.0*atan(1.0)

C  Calculate the aluminum G's.

c01Dec      do i=1,n
      do i=1,nal
         Gal(i)=2*pi/a*sqrt(float(h(1,i)**2+h(2,i)**2+h(3,i)**2))
C         write(*,*) g(i)
         do j=1,3
            hklal(j,i)=h(j,i)
         enddo
      enddo

C      magq=sqrt(q(1)**2.0+q(2)**2.0)

C  Calculate the differences

C      do i=1,n
C          qdiff(i)=abs(magq-g(i))
C      enddo

C  sort in ascending order up to the first 3

C      do k=1,3
C        do i=1+k,n
C           if (qdiff(i).lt.qdiff(k)) then
C  swap 'em and the g values
C             dum=qdiff(i)
C             qdiff(i)=qdiff(k)
C             qdiff(k)=dum
C             dum=g(i)
C             g(i)=g(k)
C             g(k)=dum
C           endif
C        enddo
C      enddo
      
C      do k=1,n
C        write(*,'(1x,f5.2,1x,f5.2)') g(k),qdiff(k)
C      enddo
      
C Right now it just outputs the closest one.

C      write(*,77) 'Closest aluminum Q is ',g(1)
C 77   format(a,f5.2)

      return
      end

      subroutine generateb(a,aa,b,c,BB)

C     Transformation taken from Acta. Cryst. (1967) 22, 457-464
C     by William R. Busing and Henri A. Levy.

      implicit none
c...    passed variables
      real a(3),b(3),aa(3),BB(3,3),c
      
c...	local variables
      real pi
      real cosa(3),sina(3),cosb(3),sinb(3)
      integer i,j,k
      character*1 key
      pi=4.0*atan(1.0)
      
 50   do i=1,3
        cosa(i)=cos(pi*aa(i)/180)
        sina(i)=sin(pi*aa(i)/180)
      enddo
      
      c=sqrt(1-cosa(1)**2-cosa(2)**2-cosa(3)**2+2*cosa(1)*
     &  cosa(2)*cosa(3))

      if ((a(1).eq.0).or.(a(2).eq.0).or.(a(3).eq.0)) then
         write(*,'(a)') 'Lattice parameters are unsuitable!'
         write(*,301) 'Currently a,b,c=',a(1),',',a(2),',',a(3),'.'
 301     format(a,f7.4,a1,f7.4,a1,f7.4,a1)
         write(*,'(a,$)') 'Continue (y)/n? '
         read (*,'(a)') key
         if (key.eq.'n') stop
         write(*,'(a,$)') 'Enter new a,b,c:'
         read(*,*) (a(i),i=1,3)
         goto 50
      endif
      if ((c.eq.0.0).or.
     &   (sina(1).eq.0).or.(sina(2).eq.0).or.(sina(3).eq.0)) then
         write(*,'(a)') 'Lattice angles are unsuitable!'
         write(*,302) 'Alpha,beta,gamma=',aa(1),',',aa(2),',',aa(3),
     &              '.'
 302     format(a,f6.2,a1,f6.2,a1,f6.2,a1)
         write(*,'(a,$)') 'Continue (y)/n? '
         read (*,'(a)') key
         if (key.eq.'n') stop
         write(*,'(a,$)') 'Enter new alpha,beta,gamma:'
         read(*,*) (aa(i),i=1,3)
         goto 50
      endif

      do i=1,3
        call ijk(i,j,k)
        b(i)=2.0*pi*sina(i)/(a(i)*c)
        cosb(i)=(cosa(j)*cosa(k)-cosa(i))/
     &    (sina(j)*sina(k))
        sinb(i)=sqrt(1-cosb(i)**2)
      enddo
      BB(1,1)=b(1)
      BB(2,1)=0
      BB(3,1)=0
      BB(1,2)=b(2)*cosb(3)
      BB(2,2)=b(2)*sinb(3)
      BB(3,2)=0
      BB(1,3)=b(3)*cosb(2)
      BB(2,3)=-b(3)*sinb(2)*cosa(1)
      BB(3,3)=2.0*pi/a(3)
      return
      end

C****************************************************
      
      subroutine generatea(amat,bmat)
      implicit none

c...	passed variables
      real amat(3,3),bmat(3,3)

c...	local variables      
      real a(3),b(3),c(3),pi, d
      integer i, j, k, l
      
      pi=4.0*atan(1.0)
      
C     Calculate b[1].(b[2]xb[3])
      
      d=(bmat(1,1)*bmat(2,2)*bmat(3,3)+bmat(1,2)*bmat(2,3)*bmat(3,1)+
     &  bmat(2,1)*bmat(3,2)*bmat(1,3)-bmat(3,1)*bmat(2,2)*bmat(1,3)-
     &  bmat(2,1)*bmat(1,2)*bmat(3,3)-bmat(1,1)*bmat(3,2)*bmat(2,3))
     & /(2.0*pi)
      
C     i index refers to 

      do i=1,3
        call ijk(i,j,k)
        do l=1,3
          a(l)=bmat(l,j)
          b(l)=bmat(l,k)
        enddo
        call cross(a,b,c)
        do l=1,3
          amat(l,i)=c(l)/d
        enddo
      enddo
      return
      end

C********************************************************************

      subroutine ijk(i,j,k)
      implicit none

c...	passed variables
      integer i,j,k
      
      if (i.eq.1) then
        j=2
        k=3
      else if (i.eq.2) then
        j=3
        k=1
      else
        j=1
        k=2
      endif

      return
      end

c	spur_qbuf.f
c	This is a re-write of files qbufin.f and qbufout.f, using 
c	common block variables in spur_buf.inc. 
c	No other variables are initialized here.
c	Idea: use a naming scheme so that it is obvious when 
c	variables from buffer are being modified.
c	Then we can be more confident that values keep up to date when output.
c	Also, output routine write_qbuf is not changed so that the whole
c	buffer can be written out to any unit number (file or screen)
c	or optionally a single line.

c234567
      subroutine qbuf_default()
c      Fills in qbuffer variables with default values, so
c      no input file is necessary.
 
      implicit none
      include 'spur_buf.inc'

c...	local variables
      integer i
            
600   write(*,*) 'qbuf_default: ',
     & 'Using default values: cubic (hhl) scattering plane'
      write(*,*) 'qbuf_default: ',
     & 'Fixed analyzer ANA, fixed Ei=14.7 meV, a=2*pi'
      write(*,*) 'qbuf_default: ',
     & '3-point scan from E=-1 to 1 at (1.1 1.1 0)'

      do i = 1, 3
	qb_lattice_a(i) = 4.0*atan(1.0)	!! crystal cell lengths = 2 * pi
	qb_lattice_angle(i) = 90.0	!! cubic crystal angles
	qb_space_hc(i) = 1.1		!! h, k, l center 
	qb_space_hs(i) = 0.0		!! h, k, l step
	qb_orient_u(i) = 0		!! Plane of scattering
	qb_orient_v(i) = 0		!! Plane of scattering
      enddo
      qb_space_hc(3) = 0.0	!! Override
      qb_orient_u(1) = 1	!! Override	scattering plane
      qb_orient_u(2) = 1	!! Override	(hkl) =(110)
      qb_orient_v(3) = 1	!! Override	(hkl)' = (001)

      qb_energy_fe = 14.7	!! Fixed energy [meV]
      qb_energy_ec = 14.7	!! scan energy center [meV]
c      qb_energy_ec = 0.0	!! scan energy center [meV]
      qb_energy_es = 1.0	!! scan energy step [meV]
      qb_time_scanpts = 3	!! Number of ponts in scan 
      qb_energy_fix = '(ANA)'   !! Which mono-chrometer e is fixed?
      qb_energy_dM = 3.354	!! xtl spacing on monitor
      qb_energy_dA = 3.354	!! xtl spacing on analyzer
      
c...	Items not currently used by spurion program
      qb_bufnum = 'Qbuffer No:  1   '
      qb_comment = 'Comment: SPURION defaults'
C      qb_comment = 'Comment: SPURION buffer output'
      qb_orient_angle = 0.0	!! Unused by ICP.
      qb_temp_T0 = 300.0	!! Temperature  [K]  
      qb_temp_incT = 0.0	!! Increment temperature [K]
      qb_temp_wait = 10.0	!! Wait time for T to settle down (or less) [min]
      qb_temp_err = 0.2		!! Tolerance for temperature [K]
      qb_temp_hold0 = 0.0	!! Wait time before 1st point [min]
      qb_temp_hold = 0.0	!! Wait time between points [min]
      qb_temp_str1 = 'FIELD'
      qb_time_monitor = 10000	!! Number of monitor events [unitless]
      qb_time_prefact = 1.0	!! Monitor counts prefactor [unitless]
      qb_time_mtype = 'NEUT'	!!Length of run det'd by 'TIME' or mon events 'NEUT'
      qb_time_str1 = 'AMON'
      qb_time_str2 = 'POLA'
      qb_time_str3 = 'PKEY'
      
c...	Also fill in some data file header items
      qd_filename = 'nosample000.btx'
      qd_date = '01-NON-200? 12:00'
      qd_scanstyle = '?'
      qd_TYPE = 'NON'
      qd_fileprefix = 'nosample'
      qd_comment = 'Artifical run'
      do i = 1, 4
        qd_collimation(i) = 0
      enddo
      do i = 1, 3
        qd_mosaic(i) = 0.0
      enddo
      qd_ana_or_mon = 'EM'
      qd_hfield = 0.0
                  
      return
      end
      
c=========================================================================
      logical function read_qbuf(whichqbuf)
c      Reads in qbuffer file from ICP program. 
 
      implicit none
      include 'io_files.inc'
      include 'spur_buf.inc'
      include 'spur_warn.inc'

c...	constants
      logical  noLabel, getLabel
      parameter (getLabel = .true.)
      parameter (noLabel = .false.)

c..	functions
      integer ilen
      logical write_qbuf
      logical input_data, input_datahdr
      logical readreal, readinteger, readstring

c...	passed variables
      character*1 whichqbuf
           
c...	local variables
      integer i
      CHARACTER*9 bufrow		!! Name of the buffer line 
      CHARACTER*24 title(6)		!! temporary storage of labels
      character*80 aline, alabel, lastOK, whichCommand
      character*3 hkl_bits(3)
      character*3 hklprime_bits(3)
      character*1 astring		!! dummy parameter

      read_qbuf = .true.


cDebug      write (*,*) 'read_qbuf: whichqbuf = ', whichqbuf
      if (whichqbuf .eq. 'd') then
cDebug        write (*,*) 'read_qbuf: has qbuf_default() been called?'
        return
      else if (whichqbuf .eq. 'c') then
cDebug        write (*,*) 'read_qbuf: Do nothing, use current values'
	return
      else if (whichqbuf .eq. 'b') then
cDebug         write (*,*) 'read_qbuf: Loading buffer file'
      else if ( (ichar(whichqbuf) .ge. ichar('0')) .and. 
     &		(ichar(whichqbuf) .le. ichar('9')) ) then
cDebug	 write (*,*) 'read_qbuf: Loading data file.'
cObsolete	 read_qbuf = .false.
cObsolete	 return
      else
	 write (*,*) 'read_qbuf: Unrecognized option'
         stop
      endif
            

c===================================================
c...	read from a triple axis file
      if ( (ichar(whichqbuf) .ge. ichar('0')) .and. 
     &		(ichar(whichqbuf) .le. ichar('9')) ) then
        if (.not. input_datahdr(whichqbuf)) goto 680
        if (.not. input_data(whichqbuf)) goto 682

      endif

c===================================================
c...	read from a q-buffer
      if (whichqbuf .eq. 'b') then
      OPEN(UNIT=unitbufin,FILE=file_bufin,STATUS='OLD',err=661)
      write(*,*) 'Opened: ', 'Q buffer input file: ', 
     &	file_bufin(1:ilen(file_bufin))


C     Opening line:
 209  READ(unitbufin,210) qb_bufnum, qb_comment
 210  FORMAT(A17,A60)
c      write(unitspur,210) qb_bufnum, qb_comment
      if (.not. write_qbuf( unitspur, 'Qbuffer', astring)) goto 670	!! Echo to file
      if (.not. write_qbuf( 0, 'Qbuffer', astring)) goto 670	!! Echo to screen

C     Lattice:
      whichCommand = 'Lattice: '
      lastOK = 'Last part that was OK: <NONE>'
      READ (unitbufin,fmt=('(a)'),err=666,end=666) aline
      if (.not. readstring(bufrow, aline, alabel, 
     &		'~', noLabel, lastOK)) goto 666		!! Command Lattice:
c...	Check that command is what we think should be there.
      call supper(bufrow)
      if (bufrow(1:8) .ne. 'LATTICE:') then
      	write (*,*) '"Lattice:" command seems to be mismatched. ', 
     &		'File has "', bufrow(1:8), '"'
      endif

      do i = 1, 3			!! lattice parameters a, b, c
	   if (.not. readreal(qb_lattice_a(i), aline, title(i), 
     &		':', getLabel, lastOK)) then
c		write (*,*) aline
c		write (*,*) title(i)
c		write (*,*) lastOK
c		write (*,*) getlabel
     		goto 666
	   endif
      enddo
      do i = 1, 3			!! lattice angles alpha, beta, gamma
	   if (.not. readreal(qb_lattice_angle(i), aline, title(i+3), 
     &		':', getLabel, lastOK)) goto 666
      enddo
      if (.not. write_qbuf( unitspur, 'Lattice', astring)) goto 670	!! Echo to file
      if (.not. write_qbuf( 0, 'Lattice', astring)) goto 670	!! Echo to screen


C     Energy:
      whichCommand = 'Energy: '
      lastOK = 'Last part that was OK: <NONE>'
      READ (unitbufin,fmt=('(a)'),err=666,end=666) aline
      if (.not. readstring(bufrow, aline, alabel, 
     &		'~', noLabel, lastOK)) goto 666		!! Command Lattice:
c...	Check that command is what we think should be there.
      call supper(bufrow)
      if (bufrow(1:7) .ne. 'ENERGY:') then
      	write (*,*) '"Energy:" command seems to be mismatched. ', 
     &		'File has "', bufrow(1:7), '"'
      endif

      if (.not. readreal(qb_energy_ec, aline, title(1), 
     &		':', getLabel, lastOK)) goto 666	!! Ec and label
      if (.not. readreal(qb_energy_es, aline, title(2), 
     &		':', getLabel, lastOK)) goto 666	!! Es and label
      if (.not. readreal(qb_energy_fe, aline, title(3), 
     &		':', getLabel, lastOK)) goto 666	!! Fs and label
      if (.not. readstring(qb_energy_fix, aline, alabel, !! Monitor
     &		'~', noLabel, lastOK)) goto 666
      if (.not. readreal(qb_energy_dm, aline, title(4), 
     &		'=', getLabel, lastOK)) goto 666	!! dM and label
      if (.not. readreal(qb_energy_da, aline, title(5), 
     &		'=', getLabel, lastOK)) goto 666	!! dA and label

      if (.not. write_qbuf( unitspur, 'Energy', astring)) goto 670	!! Echo to file
      if (.not. write_qbuf( 0, 'Energy', astring)) goto 670	!! Echo to screen

C     Space (reciprocal lattice):
      whichCommand = 'Space: '
      lastOK = 'Last part that was OK: <NONE>'
      READ (unitbufin,fmt=('(a)'),err=666,end=666) aline
c      READ (2,fmt=('(a)'),err=666,end=666) aline
      if (.not. readstring(bufrow, aline, alabel, 
     &		'~', noLabel, lastOK)) goto 666		!! Command Space:
c...	Check that command is what we think should be there.
      call supper(bufrow)
      if (bufrow(1:6) .ne. 'SPACE:') then
      	write (*,*) '"SPACE:" command seems to be mismatched. ', 
     &		'File has "', bufrow(1:6), '"'
      endif

      do i = 1, 3			!! Reciprocal lattice Hc, Kc, Lc
	   if (.not. readreal(qb_space_hc(i), aline, title(i), 
     &		':', getLabel, lastOK)) goto 666
      enddo
      do i = 1, 3			!! Reciprocal lattice Hs, Ks, Ls
	   if (.not. readreal(qb_space_hs(i), aline, title(i+3), 
     &		':', getLabel, lastOK)) goto 666
      enddo
      if (.not. write_qbuf( unitspur, 'Space', astring)) goto 670	!! Echo to file
      if (.not. write_qbuf( 0, 'Space', astring)) goto 670	!! Echo to screen

C     Orient:
      whichCommand = 'Orient: '
      lastOK = 'Last part that was OK: <NONE>'
      READ (unitbufin,fmt=('(a)'),err=666,end=666) aline
c      READ (2,fmt=('(a)'),err=666,end=666) aline
      if (.not. readstring(bufrow, aline, alabel, 
     &		'~', noLabel, lastOK)) goto 666		!! Command Orient:
c...	Check that command is what we think should be there.
      call supper(bufrow)
      if (bufrow(1:7) .ne. 'ORIENT:') then
      	write (*,*) '"ORIENT:" command seems to be mismatched. ', 
     &		'File has "', bufrow(1:7), '"'
      endif

      do i = 1, 3			!! strings  "(h k l):"
	   if (.not. readstring(hkl_bits(i), aline, title(i), 
     &		'~', noLabel, lastOK)) goto 666
      enddo
      do i = 1, 3			!! Orientation hkl
	   if (.not. readinteger(qb_orient_u(i), aline, title(i), 
     &		'~', noLabel, lastOK)) goto 666
      enddo
      if (.not. readreal(qb_orient_angle, aline, title(1),
     &		':', getLabel, lastOK)) goto 666
      do i = 1, 3			!! strings  "(h k l)':"
	   if (.not. readstring(hklprime_bits(i), aline, title(i), 
     &		'~', noLabel, lastOK)) goto 666
      enddo
      do i = 1, 3			!! Orientation hkl
	   if (.not. readinteger(qb_orient_v(i), aline, title(i), 
     &		'~', noLabel, lastOK)) goto 666
      enddo
      if (.not. write_qbuf( unitspur, 'Orient', astring)) goto 670	!! Echo to file
      if (.not. write_qbuf( 0, 'Orient', astring)) goto 670		!! Echo to screen


C     Temp/H:  (not used)
      whichCommand = 'Temp/H: '
      lastOK = 'Last part that was OK: <NONE>'
      READ (unitbufin,fmt=('(a)'),err=666,end=666) aline
      if (.not. readstring(bufrow, aline, alabel, 
     &		'~', noLabel, lastOK)) goto 666		!! Command Temp/H:
c...	Check that command is what we think should be there.
      call supper(bufrow)
      if (bufrow(1:7) .ne. 'TEMP/H:') then
      	write (*,*) '"TEMP/H:" command seems to be mismatched. ', 
     &		'File has "', bufrow(1:7), '"'
      endif

      if (.not. readreal(qb_temp_T0, aline, title(i), 
     &		':', getLabel, lastOK)) goto 666
      if (.not. readreal(qb_temp_T0, aline, title(i), 
     &		'T', getLabel, lastOK)) goto 666  !!  neither space nor : as delim
      if (.not. readreal(qb_temp_wait, aline, title(i), 
     &		':', getLabel, lastOK)) goto 666  
      if (.not. readreal(qb_temp_err, aline, title(i), 
     &		':', getLabel, lastOK)) goto 666  
      if (.not. readreal(qb_temp_hold0, aline, title(i), 
     &		':', getLabel, lastOK)) goto 666  
      if (.not. readreal(qb_temp_hold, aline, title(i), 
     &		':', getLabel, lastOK)) goto 666  
      if (.not. readstring(qb_temp_str1, aline, title(i), 
     &		':', noLabel, lastOK)) goto 666  

      if (.not. write_qbuf( unitspur, 'Temp/H', astring)) goto 670	!! Echo to file
      if (.not. write_qbuf( 0, 'Temp/H', astring)) goto 670		!! Echo to screen

C     Time:
      whichCommand = 'Time: '
      lastOK = 'Last part that was OK: <NONE>'
      READ (unitbufin,fmt=('(a)'),err=666,end=666) aline
      if (.not. readstring(bufrow, aline, alabel, 
     &		'~', noLabel, lastOK)) goto 666		!! Command Temp/H:
c...	Check that command is what we think should be there.
      call supper(bufrow)
      if (bufrow(1:5) .ne. 'TIME:') then
      	write (*,*) '"TIME:" command seems to be mismatched. ', 
     &		'File has "', bufrow(1:5), '"'
      endif

      if (.not. readinteger(qb_time_monitor, aline, title(1), 
     &		':', getLabel, lastOK)) goto 666
      if (.not. readreal(qb_time_prefact, aline, title(2), 
     &		':', getLabel, lastOK)) goto 666
      if (.not. readstring(qb_time_mtype, aline, title(3), 
     &		':', getLabel, lastOK)) goto 666
      if (.not. readinteger(qb_time_scanpts, aline, title(4), 
     &		':', getLabel, lastOK)) goto 666
      if (.not. readstring(qb_time_str1, aline, title(3), 
     &		'~', noLabel, lastOK)) goto 666
      if (.not. readstring(qb_time_str2, aline, title(3), 
     &		'~', noLabel, lastOK)) goto 666
      if (.not. readstring(qb_time_str3, aline, title(3), 
     &		'~', noLabel, lastOK)) goto 666

      if (.not. write_qbuf( unitspur, 'Time', astring)) goto 670	!! Echo to file
      if (.not. write_qbuf( 0, 'Time', astring)) goto 670	!! Echo to screen

      write(unitspur,*)

      CLOSE(unitbufin)
      endif 		!! (whichqbuf .eq. 'b') then

      goto 999
 661  write (*,*) 'Can not open file: ', file_bufin(1:ilen(file_bufin))
      goto 699
      
 666  write (*,*) 'read_qbuf: Error: ', 
     &		whichCommand(1:ilen(whichcommand)), ' ', 
     &		lastOK(1:ilen(lastOK))

      goto 699      
 670  write (*,*) 'read_qbuf: Error: Failed to echo to unit ', unitspur,
     &		whichCommand(1:ilen(whichcommand)), ' ', 
     &		lastOK(1:ilen(lastOK))

      goto 699      
 680  write (*,*) 'read_qbuf: Error reading data file header ', unitdata

      goto 699      
 682  write (*,*) 'read_qbuf: Error reading data in data file ',unitdata

 699  read_qbuf = .false.
c...		 			 123456789_123456789_
      call set_warning(wbit_other, 1,   'buf/data file error ')	 
 
 999  return 
      end      
      
c=========================================================================
      logical function write_qbuf(whichunit, selection, astring)
c      writes out either 1 line of qbuffer stored in memory, 
c	For qbuffer format:
c	  Write when selection = 'Qbuffer', 'Lattice', 'Energy', 'Sapce', 
c		'Orient', 'Temp/H' or 'Time'
c	  or the whole thing (selection = 'All').
c	For header of *.BT* data file format:
c	  Write when selection = 'hdrRun', 'hdrRunInfo', 
c		'hdrSample', ''hdrSampleInfo', 'hdrOrient', 'hdrOrientInfo',
c		'hdrLattice', 'hdrLatticeInfo', 'hdrEnergy', hdrEnergyInfo',
c		'hdrSpace', or 'hdrSpaceInfo' 
c	  or the whole thing (selection = 'HeaderAll').
c	If whichunit = 0, then to standard output.
c	If whichunit is neg, output to astring (not OK for 'All' or 'hdrAll')
c	Returns true if successful
 
      implicit none
      include 'io_files.inc'
      include 'spur_buf.inc'
      include 'spur_warn.inc'
      
c...	passed variables
      integer	whichunit	!! 0 is standard out. 
      character*(*) selection	!! 'All' special case
c      character*20 selection	!! 'All' special case
      character*(*) astring	!!if whichunit is neg, output to string instead.

c...	local variables
      integer thisunit, nlines
      
      write (*,*) 'write_qbuf: ', whichunit, ' "', selection, 
     &      '" "', astring, '"'
      write_qbuf = .true.
      nlines = 0
      
      thisunit = whichunit
      if (thisunit .eq. 0) thisunit = 6		!! Standard output.

      if ((thisunit .lt. 0) .and. 
     &    ((selection(1:3) .eq. 'All') .or. 
     &	   (selection(1:6) .eq. 'hdrAll')) ) then 
     	write (*,*) 'write_hdr: Error: Can only output 1 line ', 
     &	' at a time into a string.'
        return
      endif

c------------------------------------------------------------------------------
c...	qbuffer data file style from ICP

c...	Only open file in this case. Otherwise, assume the unit is already opened.
      if ((selection(1:3) .eq. 'All') .and. 
     &    (thisunit .eq.unitbufout )) then
        OPEN(UNIT=thisunit,FILE=file_bufout,STATUS='UNKNOWN', err=660)
        write(unitspur,'(2a)')
     &		'write_qbuf: Spurion output buffer file: ',
     &		file_bufout
cDebug        write(*,'(2a)')'write_qbuf: Spurion output buffer file: ',
cDebug     &		file_bufout
      else
cDebug          write(*,*) 'write_qbuf: Spurion output buffer unit #: ',
cDebug     &		thisunit
cDebug          write (*,*) 'write_qbuf: Selection = "', selection, '"'
      endif

c------------------------------------------------------------------------------
c...	Data file header style for files *.BT*, not implimented yet.
c...	Note: no unit number and file name yet for *.BT* files
c      if ((selection .eq. 'hdrAll') .and. (thisunit .eq.unitdatout )) then
c        OPEN(UNIT=thisunit,FILE=file_datout,STATUS='UNKNOWN', err=660)
c        write(unitspur,'(2a)') 'Spurion output data file: ',file_datout
c      endif

c------------------------------------------------------------------------------
c...	qbuffer data file style from ICP

C     Opening line:
      if ((selection(1:3) .eq. 'All') .or. 
     &    (selection(1:7) .eq. 'Qbuffer')) then
	nlines = nlines + 1
	if (thisunit .lt. 0) then
	  if (warn_options .ne. 0) then
            write(astring,210, err=666) qb_bufnum, qb_comment, 
     &		' output buffer with WARNINGS'
	  else
            write(astring,210, err=666) qb_bufnum, qb_comment, 
     &		' output buffer'
	  endif
	else
	  if (warn_options .ne. 0) then
            write(thisunit,210, err=666) qb_bufnum, qb_comment, 
     &		' output buffer with WARNINGS'
	  else
            write(thisunit,210, err=666) qb_bufnum, qb_comment, 
     &		' output buffer'
	  endif
	endif
 210    FORMAT(A17,A30, A)
      endif

C     Lattice:
      if ((selection(1:3).eq. 'All') .or. 
     &    (selection(1:7) .eq. 'Lattice')) then
	nlines = nlines + 1
	if (thisunit .lt. 0) then
          write(astring,211, err=666) 'Lattice: ',
     &   ' a:', qb_lattice_a(1),
     &   ' b:', qb_lattice_a(2),
     &	 ' c:', qb_lattice_a(3),
     &   'aa:', qb_lattice_angle(1),
     &   'bb:', qb_lattice_angle(2),
     &   'cc:', qb_lattice_angle(3)
	else
          write(thisunit,211, err=666) 'Lattice: ',
     &   ' a:', qb_lattice_a(1),
     &   ' b:', qb_lattice_a(2),
     &	 ' c:', qb_lattice_a(3),
     &   'aa:', qb_lattice_angle(1),
     &   'bb:', qb_lattice_angle(2),
     &   'cc:', qb_lattice_angle(3)
 211    FORMAT(a9,a3,f7.4,1x,a3,f7.4,1x,a3,f7.4,2x,
     &          a3,f7.3,2x,a3,f7.3,2x,a3,f7.3)
        endif
      endif

C     Energy:
      if ((selection(1:3) .eq. 'All') .or.
     &    (selection(1:6) .eq. 'Energy')) then
	nlines = nlines + 1
	if (thisunit .lt. 0) then
          write(astring,212, err=666) 'Energy:  ',
     &		'EC:', qb_energy_ec,
     &		'ES:', qb_energy_es,
     &		'FE:', qb_energy_fe,
     &           qb_energy_fix, 
     &		'dM=',qb_energy_dM,
     &		'dA=',qb_energy_dA
	else
          write(thisunit,212, err=666) 'Energy:  ',
     &		'EC:', qb_energy_ec,
     &		'ES:', qb_energy_es,
     &		'FE:', qb_energy_fe,
     &           qb_energy_fix, 
     &		'dM=',qb_energy_dM,
     &		'dA=',qb_energy_dA
     	endif
 212    FORMAT(a9,a3,f7.3,1x,a3,f6.3,1x,a3,f7.3,1x,
     &          a5,2x,a3,f7.4,2x,a3,f7.4)
c 212    FORMAT(a9,a3,f7.3,1x,a3,f7.4,1x,a3,f7.3,1x,
c     &          a5,2x,a3,f7.4,3x,a3,f7.4)
      endif

C     Space (reciprocal lattice):
      if ((selection(1:3) .eq. 'All') .or. 
     &    (selection(1:5) .eq. 'Space')) then
	nlines = nlines + 1
	if (thisunit .lt. 0) then
          write(astring,213, err=666) 'Space:   ',
     &		'HC:',qb_space_hc(1),
     &		'KC:',qb_space_hc(2),
     &  	'LC:',qb_space_hc(3),
     &		'HS:',qb_space_hs(1),
     &		'KS:',qb_space_hs(2),
     &		'LS:',qb_space_hs(3)
	else
          write(thisunit,213, err=666) 'Space:   ',
     &		'HC:',qb_space_hc(1),
     &		'KC:',qb_space_hc(2),
     &  	'LC:',qb_space_hc(3),
     &		'HS:',qb_space_hs(1),
     &		'KS:',qb_space_hs(2),
     &		'LS:',qb_space_hs(3)
        endif
 213    FORMAT(a9,a3,f7.4,1x,a3,f7.4,1x,a3,f7.4,2x,
     &          a3,f7.4,2x,a3,f7.4,2x,a3,f7.4)
      endif

C     Orient:
      if ((selection(1:3) .eq. 'All') .or. 
     &    (selection(1:6) .eq. 'Orient')) then
	nlines = nlines + 1
	if (thisunit .lt. 0) then
          write(astring,214, err=666) 'Orient:  ','(h k l):',
     &    qb_orient_u(1), qb_orient_u(2), qb_orient_u(3),
     &	 'Angl:',qb_orient_angle,
     &   '(h k l)', qb_orient_v(1), qb_orient_v(2), qb_orient_v(3)
	else
          write(thisunit,214, err=666) 'Orient:  ','(h k l):',
     &    qb_orient_u(1), qb_orient_u(2), qb_orient_u(3),
     &	 'Angl:',qb_orient_angle,
     &   '(h k l)', qb_orient_v(1), qb_orient_v(2), qb_orient_v(3)
        endif
 214    FORMAT(a9,a8,i2,1h,, i2,1h,, i2,2x,a5, f7.3, 4x,a7,2h':,
     &	 	i2, 1h,,i2,1h,,i2)
	ENDIF

C     Temp/H:
      if ((selection(1:3) .eq. 'All') .or. 
     &    (selection(1:6) .eq. 'Temp/H')) then
	nlines = nlines + 1
	if (thisunit .lt. 0) then
          write(astring, 215, err=666) qb_temp_T0, qb_temp_incT, 
     &		qb_temp_wait, qb_temp_err, 
     &		qb_temp_hold0, qb_temp_hold, qb_temp_str1
	else
          write(thisunit, 215, err=666) qb_temp_T0, qb_temp_incT, 
     &		qb_temp_wait, qb_temp_err, 
     &		qb_temp_hold0, qb_temp_hold, qb_temp_str1
        endif
c 215    format ( 'Temp/H:  T0:', f7.3, 1x, 'Inc-T', f6.4, 2x, 
 215    format ( 'Temp/H:  T0:', f7.3, 1x, 'Inc-T', f6.2, 2x, 
     &		'Wait:', f4.1, 1x, 'Err:', f4.2, 1x, 
     &         'Hld0:', f4.1, 1x, 'Hld:', f4.1, 1x, a) 
c 215    format ( 'Temp/H:  T0:', f7.3, 2x, 'Inc-T', f5.3, 2x, 
c     &		'Wait:', f4.1, 'Err:', f4.1, 1x, 
c     &         'Hld0:', f4.1, 1x, 'Hld:', f4.1, 1x, a) 
c      write(thisunit,'(2a)', err=666) 
c     &	'Temp/H:  T0:12.000  Inc-T.00000', 
c     &     '  Wait:  0  ', 'Err:2.0  Hld0:  0  Hld:  0 Field'
c                   12345        1234x     1234x    123x
      endif

C     Time:
      if ((selection(1:3) .eq. 'All') .or. 
     &    (selection(1:4) .eq. 'Time')) then
	nlines = nlines + 1
	if (thisunit .lt. 0) then
          write(astring, 216, err=666) qb_time_monitor, qb_time_prefact,
     &		qb_time_mtype, qb_time_scanpts,
     &		qb_time_str1, qb_time_str2, qb_time_str3
	else
          write(thisunit,216, err=666) qb_time_monitor, qb_time_prefact,
     &		qb_time_mtype, qb_time_scanpts,
     &		qb_time_str1, qb_time_str2, qb_time_str3
cDebug        write (*,*) 'write_qbuf: debug qb_time_prefact=',qb_time_prefact    
	endif
 216    format('Time:    Monit:', i8, 1x, 'Prefac:', f4.1, 1x, 
     &      'M-typ:', a4, 2x, '#pts:', i6,
     &     2x, a4, 4x, a4, 1x, a4)
c 216    format('Time:    Monit:', i8, 1x, 'Prefac:', i4, 1x, 
c     &      'M-typ:', a4, 2x, '#pts:', i4,
c     &     2x, a4, 4x, a4, 1x, a4)
c        write(unitbufout,'(3a,i3,a)', err=666) 'Time:    Monit:  10000  ', 
c     &	   'M-typ:NEUT  #pts: ',npts,'   AMON    POLA '
      endif

c------------------------------------------------------------------------------
c...	Data file header style for files *.BT*

c------------------------------------------------------------------------------
c...	Error handling.

      go to 999
 660  write (*,*) 'qbufout: Error opening file:', file_bufout

      go to 699
 666  write (*,*) 'qbufout: Error writing to unit number:', whichunit
      write (*,*) 'qbufout: Selection = ', selection

 699  write_qbuf = .false.
 
 999  continue

cDebug      WRITE (*,*) 'write_qbuf: debug # of lines proceesed = ', nlines

      if ((selection(1:3) .eq. 'All') .and. 
     &	  (thisunit .eq. unitbufout )) then
	write (thisunit, *) ' '
        close (thisunit)
      endif

      write (*,*) 'write_qbuf: end', whichunit, ' "', selection, 
     &      '" "', astring, '"'

      return
      end
      
      
c====================================================================
      logical function qbuf_consistent()
c	 Double check that contents of q-buffer are consistent,
c	 especially after being modified.

      implicit none
      include 'arraysize.inc'
      include 'io_files.inc'
      include 'spur_buf.inc'
      include 'spur_warn.inc'

c...	local variables
      character*20 subwarn
      integer i
            
      qbuf_consistent = .true.
         do i = 1, 3
           if (qb_lattice_a(i) .lt. 1.0e-5) then 
	     qbuf_consistent = .false.
c....			123456789_123456789_
	     subwarn = 'Lattice parm not +  '
	     call set_warning(wbit_other, 1, subwarn)	 
	   endif
           if ((qb_lattice_angle(i) .ge. 180.0) .or.
     &	       (qb_lattice_angle(i) .lt. 0.0) ) then 
	     qbuf_consistent = .false.
c....			123456789_123456789_
	     subwarn = 'Lattice angle silly '
	     call set_warning(wbit_other, 1, subwarn)	 
	   endif
	 enddo

         if ((qb_time_scanpts .le. 0) .or. 
     &	     (qb_time_scanpts .gt. maxnpts)) then 
	     qbuf_consistent = .false.
c....			123456789_123456789_
	     subwarn = '# of scan pts silly '
	   call set_warning(wbit_npts, 1, subwarn)	 
	 endif

	 if ((abs(qb_space_hs(1)) .le. 1.0e-7) .and. 
     &	     (abs(qb_space_hs(2)) .le. 1.0e-7) .and.
     &	     (abs(qb_space_hs(3)) .le. 1.0e-7) ) then 
     	   if ((abs(qb_energy_es)  .le. 1.0e-7) .and. 
     &	       (abs(qb_temp_incT) .le. 1.0e-7) ) then
	     qbuf_consistent = .false.
c....			123456789_123456789_
	     subwarn = 'Nothing is stepped! '
	     call set_warning(wbit_step, 1, subwarn)	 
	   endif
	 endif

      return
      end
      
c====================================================================
      logical function verify_qbuf(a,aa,hc,hs,fe,ec,es,u,v,npts,mon,
     &      dm,da, updatebuf)
c	 Double check that we have not forgotten to update something
c	in qbuffer. 
c	updatebuf = true means copy passed variables to qb_* common block vars.
c	updatebuf = false means copy qb_* common block variables to passed vars

      implicit none
      include 'io_files.inc'
      include 'spur_buf.inc'

c...	passed variables
      REAL*4 a(3),aa(3),hc(3),hs(3)
      real fe, ec, es, dm, da
      INTEGER u(3),v(3), npts
      CHARACTER*5 mon !,monochromator
      logical updatebuf

c...      local variables
      integer i
      
      verify_qbuf = .true.

c	 Double check that we have not forgotten to update something.
         do i = 1, 3
           if (a(i) .ne. qb_lattice_a(i)) then 
	     if (updatebuf) then
	       qb_lattice_a(i) = a(i)
	     else
	       a(i) = qb_lattice_a(i)
	     endif
	     verify_qbuf = .false.
	     write (*,*) 'verify_qbuf: Hey programmer! Update qb_lattice_a', i  
	   endif
           if (aa(i) .ne. qb_lattice_angle(i)) then 
	     if (updatebuf) then
	       qb_lattice_angle(i) = aa(i)
	     else
	       aa(i) = qb_lattice_angle(i)
	     endif
	     verify_qbuf = .false.
	     write (*,*) 'verify_qbuf: Hey programmer! Update qb_lattice_angle', i  
	   endif
           if (hc(i) .ne. qb_space_hc(i)) then 
	     if (updatebuf) then
	       qb_space_hc(i) = hc(i)
	     else
	       hc(i) = qb_space_hc(i) 
	     endif
	     verify_qbuf = .false.
	     write (*,*) 'verify_qbuf: Hey programmer! Update qb_space_hc', i  
	   endif
           if (hs(i) .ne. qb_space_hs(i)) then 
	     if (updatebuf) then
	       qb_space_hs(i) = hs(i)
	     else
	       hs(i) = qb_space_hs(i)
	     endif
	     verify_qbuf = .false.
	     write (*,*) 'verify_qbuf: Hey programmer! Update qb_space_hs', i  
	   endif
           if (u(i) .ne. qb_orient_u(i)) then 
	     if (updatebuf) then
	       qb_orient_u(i) = u(i)
	     else
	       u(i) = qb_orient_u(i) 
	     endif
	     verify_qbuf = .false.
	     write (*,*) 'verify_qbuf: Hey programmer! Update qb_orient_u', i  
	   endif
           if (v(i) .ne. qb_orient_v(i)) then 
	     if (updatebuf) then
	       qb_orient_v(i) = v(i)
	     else
	       v(i) = qb_orient_v(i) 
	     endif
	     verify_qbuf = .false.
	     write (*,*) 'verify_qbuf: Hey programmer! Update qb_orient_v', i  
	   endif
	 enddo

         if (ec .ne. qb_energy_ec) then 
	     if (updatebuf) then
	        qb_energy_ec = ec
	     else
	       ec = qb_energy_ec 
	     endif
	     verify_qbuf = .false.
	   write (*,*) 'verify_qbuf: Hey programmer! Update qb_energy_ec'
	 endif
         if (es .ne. qb_energy_es) then 
	     if (updatebuf) then
	       qb_energy_es = es
	     else
	       es = qb_energy_es 
	     endif
	     verify_qbuf = .false.
	   write (*,*) 'verify_qbuf: Hey programmer! Update qb_energy_es'
	 endif
         if (fe .ne. qb_energy_fe) then 
	     if (updatebuf) then
	       qb_energy_fe = fe
	     else
	       fe = qb_energy_fe 
	     endif
	     verify_qbuf = .false.
	   write (*,*) 'verify_qbuf: Hey programmer! Update qb_energy_fe'
	 endif
         if (mon .ne. qb_energy_fix) then 
	     if (updatebuf) then
	       qb_energy_fix = mon
	     else
	       mon = qb_energy_fix 
	     endif
	     verify_qbuf = .false.
	   write (*,*) 'verify_qbuf: Hey programmer! Update qb_energy_fix'
	 endif
         if (dm .ne. qb_energy_dM) then 
	     if (updatebuf) then
	       qb_energy_dM  = dm
	     else
	      dm = qb_energy_dM 
	     endif
	     verify_qbuf = .false.
	   write (*,*) 'verify_qbuf: Hey programmer! Update qb_energy_dM' 
	 endif
         if (da .ne. qb_energy_dA) then 
	     if (updatebuf) then
	       qb_energy_dA  = da
	     else
	       da = qb_energy_dA  
	     endif
	     verify_qbuf = .false.
	   write (*,*) 'verify_qbuf: Hey programmer! Update qb_energy_dA' 
	 endif
         if (npts.ne. qb_time_scanpts) then 
	     if (updatebuf) then
	       qb_time_scanpts  = npts
	     else
	       npts = qb_time_scanpts 
	     endif
	     verify_qbuf = .false.
	   write (*,*) 'verify_qbuf: Hey programmer! Update qb_time_scanpts' 
	 endif

      return
      end

      subroutine calcki(bmat,h,ei,ef,q,ki,fail,phi,psi,pn)
      implicit none
      include 'spur_warn.inc'
      include 'arraysize.inc'
      include 'spur_scan.inc'
            
c...	common blocks
      real branchdeg
      common/specparm/ branchdeg
      
c...	functions
      real dot
      
c...	passed variables
      real bmat(3,3),h(3),q(3),ei,ef
      real phi,psi
      real ki(2)
      logical fail
      integer pn

c...	local variables      
      real magki,magkf,magq
      real alpha,beta,pi
      real kf(2)
      real cosphi
      logical cross
      real branch
      integer i, j
      
      
      
      pi=4.0*atan(1.0)
      fail=.false.
      cross=.false.
C     How are hc, kc, lc resolved in terms of zeta and eta?
C     Q= h*A + k*B + l*C, in terms of (hkl) and recip vec A,B,C
C     Q= h(1)*bmatuv(*,1)+h(2)*bmatuv(*,2)+h(3)+bmatuv(*,3)

      call mvmult(bmat,h,3,3,q)
      magq=sqrt(dot(q,q))

cDebug      write (*,*) 'calcki: ei, ef =', ei, ef
cDebug      write (*,*) 'calcki: q=', (q(i), i=1,3)
cDebug      write (*,*) 'calcki: magq=', magq

c...	Looks like some memory is getting stomped on.
c...	If change a4 to 115., then get q(3) ne 0 errors

cDebug      if (pn .eq. 1) then
cDebug	do i = 1, 3
cDebug	  write (*,*) 'calcki: bmat(', i, ', j)=',  (bmat(i,j), j=1,3)
cDebug	enddo
cDebug	write (*,*) 'calcki: H,K,L=',  (h(i), i=1,3)
cDebug        write (*,*) 'calcki: q=', (q(i), i=1,3), ' magq = ', magq
cDebug      endif

      if (abs(q(3)).gt.1e-5) then
         write(*,'(a,i2)')'calcki: Q out of scattering plane! Point#',pn
c...		 			 123456789_123456789_
	 call set_warning(wbit_qout, 1, 'Q out of plane!     ')	 
         fail=.true.
         if (pn .eq. 1) then
	   do i = 1, 3
	    write (*,*) 'calcki: bmat(', i, ', j)=',  (bmat(i,j), j=1,3)
	   enddo
	   write (*,*) 'calcki: H,K,L=',  (h(i), i=1,3)
           write (*,*) 'calcki: q=', (q(i), i=1,3), ' magq = ', magq
         endif
         return
      endif

C      write(*,'(a,f5.1,1x,f5.1)') 'Incident and final energies: ',ei,ef

C     Calculate the lengths of the scattering vectors.
C     ei and ef are already positive      

      magki=sqrt(ei/k2_to_E)
      magkf=sqrt(ef/k2_to_E)
c      magki=sqrt(ei/2.07213)
c      magkf=sqrt(ef/2.07213)

C      write(*,'(a,f5.2,1x,f5.2,1x,f5.2)')
C     &  'Incident, final, and Q wavevectors: ',magki,magkf,magq


C     Scattering angle phi can be calculated simply from the
C     cosine law applied to the three scattering vectors.
      
C  check to make sure the triangle can be closed

      cosphi=(magki**2+magkf**2-magq**2)/(2.0*magki*magkf)
      if(abs(cosphi).gt.1.0) then
         write(*,'(2a,i2)') 'Unable to close scattering triangle! ',
     &    'Point #',pn
c...		 			 123456789_123456789_
	 call set_warning(wbit_qout, 1, 'Can''t close triangl ')	 
         fail=.true.
         a4_ok(pn) = .false.
         return
      else
        a4_ok(pn) = .true.
      endif

      phi=acos(cosphi)
C      write(*,*) 'cos(phi), phi are ',cosphi,phi*180/pi,cos(phi)

C     Once phi is known then the sine law can be used to
C     calculate the angle between from Q to ki which I have
C     called alpha.
C     Alpha will be positive in the sense of the positive
C     angle of the spectrometer but in the u-v RH coordinate
C     system it will be a negative (CCW) angle.
      
C changed this because range of asin does not allow for obtuse angles
C      alpha=asin(magkf*sin(phi)/magq)
      alpha=acos((magki**2+magq**2-magkf**2)/(2.0*magki*magq))
C this will give the other orientation
C      alpha=-acos((magki**2+magq**2-magkf**2)/(2.0*magki*magq))
C      write(*,'(a,f7.3)') 'Alpha-angle is ',alpha*180/pi

C     The next unknown is the angle between Q and u which
C     is obtained from the expression cos beta = a.b/|a||b|.
C     Since we now have the reciprocal lattice vectors in
C     a space where u // x -> cos beta = Qzeta/magQ.
C     This will return values between 0 and pi (quadrants
C     1 and 2) but will either need a negative sign or a
C     shift by pi in quadrants 3 and 4.

      call calctheta(q(1),q(2),beta)

C      write(*,'(a,f8.3)') 'Beta-angle is ',beta*180/pi
      
C     to calculate ki in the RH u-v coordinate system it
C     is a vector with length ki and angle beta-alpha wrt u

C      write(*,'(a,f8.3)') 'Beta-alpha angle is ',(beta-alpha)*180/pi

      ki(1)=magki*cos(beta-alpha)
      ki(2)=magki*sin(beta-alpha)
      kf(1)=ki(1)-q(1)
      kf(2)=ki(2)-q(2)

      if (abs(kf(1)**2.0+kf(2)**2.0-magkf**2).gt.4.0e-4) then
         write(*,'(a)')'Problem with kf calculation.'
         write(*,'(a,i2)') 'Result is likely incorrect at point# ',pn
         write(*,*) 'calc, actual ',kf(1)**2.0+kf(2)**2.0,magkf**2
         write(*,*) 'diff ',kf(1)**2.0+kf(2)**2.0-magkf**2
c...		 			 123456789_123456789_
	 call set_warning(wbit_qout, 1, 'Problem with kf calc')	 
         fail=.true.
C         return
      endif
      
C     A3 on the other hand is really pi/2 plus this angle
C     modulo "branch cut" conventions to prevent A3 wrapping.
C     The current range of psi is perhaps ill-defined since
C     it depends on the quadrant of Q and then switches dis-
C     continuously by -2 pi. 

      psi=beta-alpha+pi/2

C     branch set to 360 will have no effect in this config

      branch=pi/180.0*(branchdeg)
c01Dec      branch=pi/180*(branchdeg)
      if ((psi.le.branch).and.(.not.cross)) then
         write(*,'(a,f6.2,a,i2)') 'A3 has crossed a branch cut at',
     &        branchdeg,' at point #',pn
         cross=.true.
         psi=2*pi-psi
      endif

C      write(*,'(a,f7.3,a,f8.3,a1)') 'A4 (phi) is ',phi*180/pi,
C     &  ' and A3 (psi) is ',psi*180/pi,'.'
      
      return
      end
